<?php
/**
 * class/adr.class.php -  Address class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  2005-03-09
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class adr extends abstractData {
  
  function adr() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['adr_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['adr_street'] = '';
    $this->_data['adr_number'] = '';
    $this->_data['adr_number_ad1'] = '';
    $this->_data['adr_number_ad2'] = '';
    $this->_data['adr_postal'] = '';
    $this->_data['adr_city'] = '';
    $this->_data['adr_municipal'] = '';
    $this->_data['adr_state'] = '';
    $this->_data['cou_id'] = (int) 0;
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'adr_id';
    $this->_table   = 'adr';
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Deletes the instance. 
   * By  default a soft delete will be performed, which means the data is not
   * actually  deleted from the database, but merely flagged as 'inactive'.
   *
   * @param    boolean $soft    Soft delete (default) or record delete (false) 
   * @return   boolean
   * @access   public
   */
  function delete($soft=true) {
    
    // When performing a record delete, check references to this object
    if (!$soft) {
      // If any of these references exist, abort and return false
    }
    
    // Delete the record
    if (parent::delete($soft)) {
      // When deleting is succesfull, delete al related information as well
      return (bool) true;
    }
    else {
      return (bool) false;
    }
  }


  //=========================================================================
  // Private methods
  //=========================================================================

}

?>