<?php
/**
 * Applicability class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: apl.class.php,v 1.5 2006/03/08 16:58:04 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class apl extends abstractData {
  
  function apl() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['apl_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['apl_parent'] = '';
    $this->_data['parent_id'] = (int) 0;
    $this->_data['apl_child'] = '';
    $this->_data['child_id'] = (int) 0;
    $this->_data['apl_sequence'] = (int) 0;
    $this->_data['apl_code'] = '';
    $this->_data['apl_valid_from'] = (int) 0;        
    $this->_data['apl_valid_until'] = (int) 4294967295;        
    $this->_data['is_active'] = (bool) true;
    
    // Register the required class properties
    $this->_primary = 'apl_id';
    $this->_table   = 'apl';
    $this->_name    = 'apl_code';
    
    // Register properties that must have a value
    $this->_required[] = 'apl_parent';
    $this->_required[] = 'parent_id';
    $this->_required[] = 'apl_child';
    $this->_required[] = 'child_id';

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Sets the instance property with the given value
   *
   * @param  string  $property The name of the property to be set
   * @param  string  $value    The data to bet set
   * @return boolean
   * @access public
   */
  function setProperty($property, $value) {
    
    // Valid from
    if ($property=='apl_valid_from'){
      if (!empty($value)){
        $value = strtotime($value);
      }
    }
    
    // Valid until
    if ($property=='apl_valid_until'){
      if (!empty($value)){
        $value = strtotime($value);
      }
    }

    parent::setProperty($property, $value);
  }
  
  //=========================================================================
  // Private methods
  //=========================================================================

}

?>