<?php
/**
 * Country class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: cou.class.php,v 1.6 2006/08/08 05:55:14 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');


//=========================================================================
// Class definition
//=========================================================================

class cou extends abstractData {
  
  function cou() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['cou_id'] = (int) 0;
    $this->_data['cou_name'] = '';
    $this->_data['cou_code'] = '';
    $this->_data['cou_streetformat'] = 'SN';
    $this->_data['cou_cityformat'] = 'PC';
    $this->_data['cou_phoneprefix'] = ''; 
    $this->_data['cou_valid_from'] = (int) 0;
    $this->_data['cou_valid_until'] = (int) 4294967295;
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'cou_id';
    $this->_table   = 'cou';
    $this->_name    = 'cou_name';
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;

    // Set user permissions for this type of data
    if (!isset($_SESSION[$this->_table.'_permission'])) {
      $_SESSION[$this->_table.'_permission'] = $this->_getPermissions();
    }

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Deletes the instance. 
   * By  default a soft delete will be performed, which means the data is not
   * actually  deleted from the database, but merely flagged as 'inactive'.
   *
   * @param    boolean $soft    Soft delete (default) or record delete (false) 
   * @return   boolean
   * @access   public
   */
  function delete($soft=true) {
    
    global $SPL_CFG;
    
    // When performing a record delete, check references to this object
    if (!$soft) {

      // Check the addresses
      include_once($SPL_CFG['dirroot'].'/class/adr.class.php');
      $adr = new adr();
      if ($adr->isUsed('cou_id',$this->_data['cou_id'])){
        return (bool)false;
      }
    }
    
    // Delete the record
    if (parent::delete($soft)) {
      // When deleting is succesfull, delete al related information as well
      return (bool) true;
    }
    else {
      return (bool) false;
    }
  }


  //=========================================================================
  // Private methods
  //=========================================================================

}

?>