<?php
/**
 * class/fmt.class.php -  Suggestion formats class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  2005-03-09
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class fmt extends abstractData {
  
  function fmt() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['fmt_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['fmt_name'] = '';
    $this->_data['fmt_short'] = '';
    $this->_data['fmt_code'] = '';
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'fmt_id';
    $this->_table   = 'fmt';
    $this->_name    = 'fmt_short';
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Deletes the instance. 
   * By  default a soft delete will be performed, which means the data is not
   * actually  deleted from the database, but merely flagged as 'inactive'.
   *
   * @param    boolean $soft    Soft delete (default) or record delete (false) 
   * @return   boolean
   * @access   public
   */
  function delete($soft=true) {
    
    global $SPL_CFG;
    
    // When performing a record delete, check references to this object
    if (!$soft) {

      // Check the catalog
      include_once($SPL_CFG['dirroot'].'/class/cat.class.php');
      $cat = new cat();
      if ($cat->isUsed('fmt_id',$this->_data['fmt_id'])){
        return (bool)false;
      }
    }
    
    // Delete the record
    if (parent::delete($soft)) {
      // When deleting is succesfull, delete al related information as well
      return (bool) true;
    }
    else {
      return (bool) false;
    }
  }

  //=========================================================================
  // Private methods
  //=========================================================================

}

?>