<?php
/**
 * Institution class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: ins.class.php,v 1.10 2006/03/08 16:58:04 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class ins extends abstractData {
  
  function ins() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['ins_id']               = (int) 0;
    $this->_data['adm_id']               = $_SESSION['adm_id'];
    $this->_data['ins_name']             = '';
    $this->_data['ins_short']            = '';
    $this->_data['ins_code']             = '';
    $this->_data['ins_schoolyear_start'] = (int) 0;
    $this->_data['ins_schoolyear_end']   = (int) 0;
    $this->_data['ins_methodology']      = 'traditional';
    $this->_data['is_active']            = (bool) true;
    $this->_data['create_date']          = time();
    $this->_data['create_usr_id']        = $_SESSION['usr_id'];
    $this->_data['create_src_id']        = $_SESSION['native_id'];
    $this->_data['update_date']          = time();
    $this->_data['update_usr_id']        = $_SESSION['usr_id'];
    $this->_data['update_src_id']        = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'ins_id';
    $this->_table   = 'ins';
    $this->_name    = 'ins_short';

    // Set field types
    $this->_type['ins_schoolyear_start'] = array('type'=>'timestamp');
    $this->_type['ins_schoolyear_end']   = array('type'=>'timestamp');
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /**
   * Returns an array containing address data
   * 
   * @param  string $type (optional) The address type
   * @access public
   */
  function getAddress($type='mail'){
    // SPL_TODO: return the address
    /*
    $query = 'SELECT adr_id FROM '.$SPL_CFG['prefix'].'ins WHERE ins_id = "'.$this->_data['ins_id'].'" AND ina_type = "'.$type.'" AND adm_id = "'.$_SESSION['adm_id'].'" AND is_active'; 
    $result = db_retrieve(db_query($query));
    if (isset($result['adr_id'])){
    }
    */
    return (bool)false;
  } 

  /** 
   * Sets the instance property with the given value.
   * This overrides the function in data.abstract.php, because in case of
   * an 'is_active' property all 'referees' will have their state switched as well
   *
   * @param  string  $property The name of the property to be set
   * @param  string  $value    The data to bet set
   * @return boolean Succes or Failure
   * @access public
   */
  function setProperty($property, $value) {
    
    global $SPL_CFG;
    
    $succes = parent::setProperty($property, $value); 
    
    if ($succes){

      // Switch state in the catalog
      $query  = 'UPDATE '.$SPL_CFG['prefix'].'cat';
      $query .= ' SET is_active = "'.$value.'" WHERE';
      $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' ins_id = "'.$this->_data['ins_id'].'"';
      $result = db_query($query);

    }
  }


  //=========================================================================
  // Private methods
  //=========================================================================

  /** 
   * Deletes a row from the database.
   * Override the default behaviour by adding the removal of child records
   * 
   * @return boolean Success or Failure
   * @access protected
   * @uses   array   $SPL_CFG Global configuration data
   */
  function _delete() {
    
    global $SPL_CFG;
    
    $succes = parent::_delete();
    
    if ($succes) {
      $query  = 'DELETE FROM '.$SPL_CFG['prefix'].'cat WHERE';
      $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' ins_id = "'.$this->_data['ins_id'].'"';
      $result = db_query($query);
    }
    
    return $succes;
  }

}

?>