<?php
/**
 * Person class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: per.class.php,v 1.6 2006/03/08 16:58:04 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class per extends abstractData {
  
  function per() {
    
    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['per_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['per_firstname'] = '';
    $this->_data['per_usualname'] = '';
    $this->_data['per_initials'] = '';
    $this->_data['per_insertion'] = '';
    $this->_data['per_surname'] = '';
    $this->_data['per_titles'] = '';
    $this->_data['per_birthdate'] = '0000-00-00';
    $this->_data['per_birthcity'] = '';
    $this->_data['cou_id_birth'] = (int) 0;
    $this->_data['per_gender'] = 'Unknown';
    $this->_data['cou_id_nationality1'] = (int) 0;
    $this->_data['cou_id_nationality2'] = (int) 0;
    $this->_data['per_nationalitydate'] = '0000-00-00';
    $this->_data['lan_id'] = (int) 0;
    $this->_data['dnm_id'] = (int) 0;
    $this->_data['per_ssn'] = '';
    $this->_data['per_en'] = '';
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'per_id';
    $this->_table   = 'per';
    $this->_required[] = 'per_firstname';
    $this->_required[] = 'per_surname';
        
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Returns a set of keys and values for all occurrences in the table
   * 
   * @param $parent   string (optional) The name of the parent table (ex:'ina')
   * @param $restrict string (optional) SQL restriction (ex:'ina_id = "1"')
   * @param $orderBy  string (optional) Alternative ordering (ex:ina_sequence)
   * @param $orderDir string (optional) 'ASC' or 'DESC'
   * @return array 
   * @access public
   * 
   * Please not that when a restriction has been passed without a parent
   * identifier ($parent=false), the restriction is assumed to be applicable to
   * the table itself. In that case, specify the column name and the value. For
   * example: $restrict = 'ina_id = "1"'.
   * 
   * When a parent table has been passed, a 'applicability' relationship will be
   * assumed. The applicable rows will be looked up in the 'apl' table. In this
   * case, do not specify column names in the restrictions, just the key value
   * (for example: $parent='ina', $restrict='1')
   */
  function getKeyValues($parent=false,$restrict=false,$orderBy=false,$orderDir='ASC'){
    
    global $SPL_CFG;
    
    $values = array();
    // Table(s)
    $query = 'SELECT '.$this->_table.'.'.$this->_primary.' as "key",'.$this->_table.'.per_usualname,'.$this->_table.'.per_firstname,'.$this->_table.'.per_initials,'.$this->_table.'.per_insertion,'.$this->_table.'.per_surname';
    if ($restrict && $parent) {
      $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].$this->_table.' '.$this->_table.' ON '.$this->_table.'.'.$this->_primary.' = apl.child_id';
    }
    else {
      $query .= ' FROM '.$SPL_CFG['prefix'].$this->_table.' '.$this->_table;
    }
    // Columns
    $query .= ' WHERE '.$this->_table.'.adm_id = "'.$_SESSION['adm_id'].'" AND '.$this->_table.'.is_active';
    if ($restrict) {
      if ($parent){
        $query .= ' AND apl.adm_id = "'.$_SESSION['adm_id'].'"';
        $query .= ' AND apl.is_active';
        $query .= ' AND apl.apl_parent = "'.$parent.'"';
        $query .= ' AND apl.parent_id = "'.$restrict.'"';
        $query .= ' AND apl.apl_child = "'.$this->_table.'"';
        $query .= ' AND apl.apl_valid_from <= "'.time().'"';
        $query .= ' AND apl.apl_valid_until >= "'.time().'"';
      }
      else {
        $query .= ' AND '.$restrict;
      }
    }
    // Ordering
    if ($restrict){
      if ($parent){
        $query .= ' ORDER BY apl.apl_sequence '.$orderDir;
      }
    }
    else if ($orderBy){
      $query .= ' ORDER BY '.($orderBy?$orderBy:$this->_name).' '.$orderDir;
    }
    $result = db_query($query);
    while ($row = db_fetch_array($result)) {
      switch ($_SESSION['usp_nameformat']) {
        case 'UIS':
          $name = $row['per_usualname'].' '.($row['per_insertion']?$row['per_insertion'].' ':'').$row['per_surname'];
          break;
        case 'FIS':
          $name = $row['per_firstname'].' '.($row['per_insertion']?$row['per_insertion'].' ':'').$row['per_surname'];
          break;
        case 'NIS':
          $name = $row['per_initials'].' '.($row['per_insertion']?$row['per_insertion'].' ':'').$row['per_surname'];
          break;
        case 'SNI':
          $name = $row['per_surname'].', '.($row['per_initials']?$row['per_initials'].' ':'').$row['per_insertion'];
          break;
        case 'SUI':
          $name = $row['per_surname'].', '.($row['per_usualname']?$row['per_usualname'].' ':'').$row['per_insertion'];
          break;
        case 'SFI':
          $name = $row['per_surname'].', '.($row['per_firstname']?$row['per_firstname'].' ':'').$row['per_insertion'];
          break;
        default:
          $name = $row['per_initials'].' '.($row['per_insertion']?$row['per_insertion'].' ':'').$row['per_surname'];
          break;
      }
      $values[] = array($row['key']=>$name);
    }
    return $values;
  }


  /** 
   * Returns the name of the person
   *
   * @return string The (formatted) name
   * @access public
   */
  function getName() {

    global $SPL_CFG, $SPL_TXT;
    
    // Make sure session information exists
    if (!isset($_SESSION['usp_nameformat'])) {
      $_SESSION['usp_nameformat'] = $SPL_CFG['nameformat'];
    }

    // This will only work on a correctly instantiated object
    if ($this->_status['is_loaded']) {
      switch ($_SESSION['usp_nameformat']) {
        case 'UIS':
          $name = $this->_data['per_usualname'].' '.($this->_data['per_insertion']?$this->_data['per_insertion'].' ':'').$this->_data['per_surname'];
          break;
        case 'FIS':
          $name = $this->_data['per_firstname'].' '.($this->_data['per_insertion']?$this->_data['per_insertion'].' ':'').$this->_data['per_surname'];
          break;
        case 'NIS':
          $name = $this->_data['per_initials'].' '.($this->_data['per_insertion']?$this->_data['per_insertion'].' ':'').$this->_data['per_surname'];
          break;
        case 'SNI':
          $name = $this->_data['per_surname'].', '.($this->_data['per_initials']?$this->_data['per_initials'].' ':'').$this->_data['per_insertion'];
          break;
        case 'SUI':
          $name = $this->_data['per_surname'].', '.($this->_data['per_usualname']?$this->_data['per_usualname'].' ':'').$this->_data['per_insertion'];
          break;
        case 'SFI':
          $name = $this->_data['per_surname'].', '.($this->_data['per_firstname']?$this->_data['per_firstname'].' ':'').$this->_data['per_insertion'];
          break;
        default:
          $name = $this->_data['per_initials'].' '.($this->_data['per_insertion']?$this->_data['per_insertion'].' ':'').$this->_data['per_surname'];
          break;
      }
      return $name;
    }
    else {
      $_dbg['query'] = 'formatting name for id '.$this->_data[$this->_primary];
      $_dbg['result'] = $this->_status['is_loaded'];
      $_dbg['method'] = 'getName';
      $_dbg['error'] = $SPL_TXT['db_instance_not_loaded'];
      array_push($this->_debug, $_dbg);
      return (bool) false;
    }
    
  }

  /** 
   * Returns the name of the person for sorting purposes
   *
   * @return string The (formatted) name
   * @access public
   */
  function getNameSorting() {
    
    // SPL_TODO: Sorting name for person
    return $this->getName();
  }
  
  //=========================================================================
  // Private methods
  //=========================================================================

}

?>