<?php
/**
 * Source class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: src.class.php,v 1.4 2006/03/08 16:58:04 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

/**
 * Source
 * An application being the source of data used by studiewijzer. Data from
 * this source can be synchronized with studiewijzer using the definition
 * supplied in this class
 */
class src extends abstractData {
  
  function src() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['src_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['src_name'] = '';
    $this->_data['src_desc'] = '';
    $this->_data['src_login'] = (bool) true;
    $this->_data['src_cache'] = (bool) false;
    $this->_data['src_flush'] = (bool) false;
    $this->_data['src_is_native'] = (bool) false;
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'src_id';
    $this->_table   = 'src';
    $this->_name    = 'src_name';
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;

  }

  //=========================================================================
  // Public methods
  //=========================================================================


  //=========================================================================
  // Private methods
  //=========================================================================

}

?>