<?php
/**
 * Status class.
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/08/28 09:12:45 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');


//=========================================================================
// Class definition
//=========================================================================

/**
 * Status
 * The suggestion status 
 */
class sts extends abstractData {
  
  function sts() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['sts_id']              = (int) 0;
    $this->_data['adm_id']              = $_SESSION['adm_id'];
    $this->_data['sts_name']            = '';
    $this->_data['sts_short']           = '';
    $this->_data['sts_id_next']         = (int) 0;
    $this->_data['sts_teacher_action']  = (bool) false;
    $this->_data['sts_student_allowed'] = (bool) true;
    $this->_data['sts_teacher_allowed'] = (bool) true;
    $this->_data['is_done']             = (bool) false;
    $this->_data['is_active']           = (bool) true;
    $this->_data['create_date']         = time();
    $this->_data['create_usr_id']       = $_SESSION['usr_id'];
    $this->_data['create_src_id']       = $_SESSION['native_id'];
    $this->_data['update_date']         = time();
    $this->_data['update_usr_id']       = $_SESSION['usr_id'];
    $this->_data['update_src_id']       = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'sts_id';
    $this->_table   = 'sts';
    $this->_name    = 'sts_short';
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;
    
    // Set field types
    $this->_type['sts_teacher_action']  = array('type'=>'boolean');
    $this->_type['sts_student_allowed'] = array('type'=>'boolean');
    $this->_type['is_done']             = array('type'=>'boolean');

    // Set user permissions for this type of data
    if (!isset($_SESSION[$this->_table.'_permission'])) {
      $_SESSION[$this->_table.'_permission'] = $this->_getPermissions();
    }

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Deletes the instance. 
   * By  default a soft delete will be performed, which means the data is not
   * actually  deleted from the database, but merely flagged as 'inactive'.
   *
   * @param   (boolean) $soft Soft delete (default) or record delete (false) 
   * @return  (boolean)       Succes of Failure
   * @public
   */
  function delete($soft=true) {
    
    global $SPL_CFG;
    
    // When performing a record delete, check references to this object
    if (!$soft) {

      // Check the guide
      include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
      $sgd = new sgd();
      if ($sgd->isUsed('sts_id',$this->_data['sts_id'])){
        return (bool)false;
      }
    }
    
    // Delete the record
    if (parent::delete($soft)) {
      // When deleting is succesfull, delete al related information as well
      return (bool) true;
    }
    else {
      return (bool) false;
    }
  }


  //=========================================================================
  // Private methods
  //=========================================================================

}

/**
 * $Log: sts.class.php,v $
 * Revision 1.10  2006/08/28 09:12:45  jebbol
 * Added sts_teacher_allowed
 *
 * Revision 1.9  2006/08/08 06:05:52  jebbol
 * *** empty log message ***
 *
 * Revision 1.6  2006/04/14 11:00:34  jebbol
 * *** empty log message ***
 */

?>