<?php
/**
 * Abstract class for suggestions
 *
 * $Author: jebbol $
 * $Revision: 1.7 $
 * $Date: 2006/08/24 17:32:00 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

//=========================================================================
// Class definition
//=========================================================================

/**
 * Abstract class for suggestions
 * 
 * All methodology specific suggestions are derived from this class.
 *
 * @abstract
 */
class abstractSug extends abstractData {
  
  function abstractSug() {
    
    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['sug_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['sug_title'] = '';
    $this->_data['sug_short'] = '';
    $this->_data['sug_code'] = '';
    $this->_data['sug_description'] = '';
    $this->_data['sug_description_fmt'] = '';
    $this->_data['sug_knowledge'] = '';
    $this->_data['sug_knowledge_fmt'] = '';
    $this->_data['sug_directions'] = '';
    $this->_data['sug_directions_fmt'] = '';
    $this->_data['sug_prerequisites'] = '';
    $this->_data['sug_prerequisites_fmt'] = '';
    $this->_data['sug_materials'] = '';
    $this->_data['sug_materials_fmt'] = '';
    $this->_data['fmt_id'] = (int) 0;
    $this->_data['sug_do_schedule'] = (bool) false;
    $this->_data['sug_do_portfolio'] = (bool) false;
    $this->_data['sug_url_test'] = '';
    $this->_data['sug_url_elo'] = '';
    $this->_data['sug_id_parent'] = (int) 0;
    $this->_data['sug_required'] = (bool) false;
    $this->_data['sug_signout'] = (bool) false;
    $this->_data['sug_type'] = '';
    $this->_data['sug_alert_days'] = (int) 0;
    $this->_data['sug_sequence'] = (int) 0;
    $this->_type['sug_sequence']['type'] = 'integer';
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'sug_id';
    $this->_table   = 'sug';
    $this->_name    = 'sug_short';
    
    // Register properties that must have a value
    $this->_required[] = 'sug_title';
    $this->_required[] = 'sug_short';
    
    // Set user permissions for this type of data
    if (!isset($_SESSION[$this->_table.'_permission'])) {
      $_SESSION[$this->_table.'_permission'] = $this->_getPermissions();
    }
    
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /**
   * Determines if this suggestion has activities attached
   * 
   * @return (boolean) Yes or No
   * @public
   */
  function hasActivities(){
    
    global $SPL_CFG;
    
    $query = 'SELECT COUNT(*) FROM '.$SPL_CFG['prefix'].'sug WHERE sug_id_parent="'.$this->_data['sug_id'].'" AND sug_type="A" AND is_active';
    $result = db_retrieve(db_query($query));
    return ($result['COUNT(*)']>0);
  }

  //=========================================================================
  // Private methods
  //=========================================================================

}

/**
 * $Log: sug.abstract.php,v $
 * Revision 1.7  2006/08/24 17:32:00  jebbol
 * Added support for alerts
 *
 */

?>
