<?php
/**
 * Userdefaults per script
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: usd.class.php,v 1.2 2006/03/08 16:58:04 jebbol Exp $
 * @package   spl
 * @category  core
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {
  // Automatic test scripts and documentation
  $test_basename = basename(__FILE__);
  $test_filename = __FILE__;
  include_once('../inc/test.inc.php');
}

// Configuration
include_once($SPL_CFG['dirroot'].'/inc/config.php');

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

// Administration settings
include_once($SPL_CFG['dirroot'].'/inc/settings.adm.php');

// System settings
include_once($SPL_CFG['dirroot'].'/inc/settings.sys.php');

// User settings
include_once($SPL_CFG['dirroot'].'/inc/settings.usr.php');

//=========================================================================
// Class definition
//=========================================================================

/*
 * Default settings per user
 */
class usd {
  
  function usd() {
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /**
   * Retrieves a default value
   * 
   * @param  string $script Name of the script for which the default is retrieved
   * @param  string $field  Name of the field
   * @return string The default value (or false)
   * @access public
   */ 
  function getDefault($script,$field) {
    
    global $SPL_CFG;
    
    $query  = 'SELECT usd_value FROM '.$SPL_CFG['prefix'].'usd WHERE ';
    $query .= ' usr_id = "'.$_SESSION['usr_id'].'" AND';
    $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
    $query .= ' usd_script = "'.$script.'" AND usd_field = "'.$field.'" LIMIT 1';
    $result = db_retrieve(db_query($query));
    if (isset($result['usd_value'])){
      return (get_magic_quotes_gpc() ? htmlspecialchars(stripslashes($result['usd_value'])) : $result['usd_value']);
    }
    else {
      return (bool) false;
    } 
    
  }  

  /**
   * Sets a default value
   * 
   * @param  (string) $script Name of the script for which the default is retrieved
   * @param  (string) $field  Name of the field
   * @param  (string) $value  The default value
   * @return (boolean)        Success or failure
   * @public
   */ 
  function setDefault($script,$field,$value) {
    
    global $SPL_CFG;
    
    $id = (bool)false;
    
    // Check for an existing value
    $query  = 'SELECT usd_id FROM '.$SPL_CFG['prefix'].'usd WHERE ';
    $query .= ' usr_id = "'.$_SESSION['usr_id'].'" AND';
    $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
    $query .= ' usd_script = "'.$script.'" AND usd_field = "'.$field.'" LIMIT 1';
    $result = db_retrieve(db_query($query));
    if (isset($result['usd_id'])){
      $id = $result['usd_id'];
    }
    
    if ($id) {
      // Change existing value
      $query  = 'UPDATE '.$SPL_CFG['prefix'].'usd SET ';
      $query .= ' usd_value = "'.db_escape_string($value).'" WHERE';
      $query .= ' usd_id = "'.$id.'"';
      $result = db_query($query);
      if (!$result){
        return (bool)false;
      } 
    }
    else {
      // Add new value
      $query  = 'INSERT INTO '.$SPL_CFG['prefix'].'usd (usd_id,usr_id,adm_id,usd_script,usd_field,usd_value)';
      $query .= ' VALUES (NULL,'.$_SESSION['usr_id'].','.$_SESSION['adm_id'].',"'.$script.'","'.$field.'","'.db_escape_string($value).'")';
      $result = db_query($query);
      if (!$result){
        return (bool)false;
      } 
    }
    return (bool)true;
  }  


  //=========================================================================
  // Private methods
  //=========================================================================

}

?>