<?php
/**
 * Configuration settings.
 *
 * $Author: jebbol $
 * $Revision: 1.11 $
 * $Date: 2006/08/08 06:13:13 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

// Set error reporting to the maximum
error_reporting(E_ALL);

// Configuration data
$SPL_CFG = array ();

//=========================================================================
// Don't modify the data below, change the values in config.php instead
//=========================================================================

// Web site location
// Tell spl where it is located. Specify the full web address to where spl
// has been installed. If your web site is accessible via multiple URLs
// then choose the most natural one that your users would use.
// Do not include a trailing slash
$SPL_CFG['wwwroot'] = isset($wwwroot)?$wwwroot:'http://localhost/studiewijzer';

// Server file location
// Specify the full OS directory path to this same location
// Make sure the upper/lower case is correct.  Some examples:
//
//    $CFG->dirroot = 'c:\program files\php\www\spl';    // Windows
//    $CFG->dirroot = '/var/www/html/spl';     // Redhat Linux
//    $CFG->dirroot = '/home/example/public_html/spl'; // Cpanel host
$SPL_CFG['dirroot'] = isset($dirroot)?$dirroot:'/var/www/html/studiewijzer';

// Type of database to use (currently only 'mysql')
$SPL_CFG['dbtype'] = isset($cfg_dbtype)?$cfg_dbtype:'mysql';

// Help site location
// You can specify you own help system, or use the one we supply
// Do not include a trailing slash
$SPL_CFG['helproot'] = isset($helproot)?$helproot:'http://doc.studiewijzer.org';

// The Electronic Learning Environment to use
// 'moodle' = user Moodle
// 'dokeos' = use Dokeos
// 'none' = no ELO is used
$SPL_CFG['elo'] = isset($cfg_elo)?$cfg_elo:'none';

// The portfolio system to use
// 'none' = don't use a portfolio system
$SPL_CFG['portfolio'] = isset($cfg_portfolio)?$cfg_portfolio:'none';

// The scheduler or roster system to use
// 'none' = don't use a scheduler
$SPL_CFG['scheduler'] = isset($cfg_scheduler)?$cfg_scheduler:'none';

// Make use of the learning style directive?
$SPL_CFG['learning_style'] = isset($cfg_style)?$cfg_style:'false';

// Mention the learning load?
$SPL_CFG['learning_load'] = isset($cfg_load)?$cfg_load:'true';

// Mention the learning reward?
$SPL_CFG['learning_reward'] = isset($cfg_reward)?$cfg_reward:'true';

// Allow assessments?
$SPL_CFG['learning_assessment'] = isset($cfg_assessment)?$cfg_assessment:'true';

// Display weeknumbers relative to period or absolute calendar weeknumbers
// 'period'   = weeknumbers are relative to the period (default)
// 'calendar' = weeknumbers are calendarweeks 
$SPL_CFG['weeknumber_mode'] = isset($cfg_weeknumber_mode)?$cfg_weeknumber_mode:'period';

// Use detailed person data?
$SPL_CFG['person_details'] = isset($cfg_person)?$cfg_person:'false';

// Enable hit counter statistics
$SPL_CFG['hit_statistics'] = isset($cfg_hitstat)?$cfg_hitstat:'true';
// Number of days to keep hit statistics
$SPL_CFG['hit_statistics_days'] = isset($cfg_hitstatdays)?$cfg_hitstatdays:'7';

// Enable hit counter statistics
$SPL_CFG['teacher_statistics'] = isset($cfg_teastat)?$cfg_teastat:'true';

// Preferred language (currently only 'en' and 'nl')
$SPL_CFG['language'] = isset($cfg_lang)?$cfg_lang:'nl';

// Default format for displaying person names:
// UIS = Usualname Insertion Surname (Jan de Groot)
// FIS = Firstname Insertion Suriname (Johannes Petrus de Groot)
// NIS = Initials Insertion Surname (J.P. de Groot)
// SNI = Surname, Initials Insertion (Groot, J.P. de)
// SUI = Surname, Usualname Insertion (Groot, Jan de)
// SFI = Surname, Firstname Insertion (Groot, Johannes Petrus de)
$SPL_CFG['nameformat'] = isset($cfg_nameformat)?$cfg_nameformat:'SUI';

// The default date the password will expire
// Possible values: immediately, day, week, month, quarter, halfyear, year, never
$SPL_CFG['psswd_expires'] = isset($cfg_psswd_expires)?$cfg_psswd_expires:'never';

// The number of login retries allowed when loggin in (0=unlimited)
$SPL_CFG['psswd_retries'] = isset($cfg_psswd_retries)?$cfg_psswd_retries:'0';

// The P3P Policy to use in the heading section of any page
// Generate a policy for your website at http://www.privacycouncil.com/freep3pfix.php
$SPL_CFG['p3p_policy'] = isset($cfg_p3p_policy)?$cfg_p3p_policy:'NOI NID STP';

// Robots meta tag
$SPL_CFG['robots'] = isset($cfg_robots)?$cfg_robots:'noindex';

// Keywords meta tag
$SPL_CFG['keywords'] = isset($cfg_keywords)?$cfg_keywords:'';

// The default skin
$SPL_CFG['skin'] = isset($cfg_skin)?$cfg_skin:'default';

// The markup version to use. Leave it emtpy to use the browsers preference.
// You can force a specific markup by entering these values:
// doctype:     'html4','xhtml1'
// doctype_dtd: 'strict', 'transitional','frameset'
$SPL_CFG['doctype']     = isset($cfg_doctype)?$cfg_doctype:'';
$SPL_CFG['doctype_dtd'] = isset($cfg_doctype_dtd)?$cfg_doctype_dtd:'';

// The characterset to use
$SPL_CFG['charset'] = isset($cfg_charset)?$cfg_charset:'UTF-8';

// RC4  encryption key
$SPL_CFG['rc4key'] = isset($cfg_rc4key)?$cfg_rc4key:'JGBNsO6jrYQMiCHQ';

// Token time, used to validate an input form
$SPL_CFG['token_time'] = isset($cfg_tokentime)?$cfg_tokentime:'300';

// The type of popups to use
// 'winlike' = use the WinLIKE popups
// 'none'    = don't use any popups (display in the same window)
$SPL_CFG['popup'] = isset($cfg_popup)?$cfg_popup:'none';

// The editor to use for textareas
// 'tinyMCE' = use the tinyMCE editor
// 'none'    = just the plain textarea
$SPL_CFG['editor'] = isset($cfg_editor)?$cfg_editor:'tinyMCE';

// The helptext system to use
// 'helptip' = use the WebFX helptips
$SPL_CFG['help'] = isset($cfg_help)?$cfg_help:'helptip';

// The maximum number of items in a listbox. Setting this value to
// something higher than 0, will result in reference field being
// visualized as listboxes when they have less than the mentioned
// records.
// '0' = default
$SPL_CFG['max_listitems'] = isset($cfg_max_listitems)?$cfg_max_listitems:'100';

// The number of rows to display in a table
$SPL_CFG['numrows'] = isset($cfg_numrows)?$cfg_numrows:'15';

// Setting this to "true" will result in displaying the time
// used to generate a page. You can use this for performance tuning.
$SPL_CFG['show_generation_time'] = isset($cfg_show_generation_time)?$cfg_show_generation_time:'false';

// Client-side field validation
// 'default' = use the default validation mechanism
// 'none' = use no client-side validation at all
$SPL_CFG['client_validate'] = isset($cfg_client_validate)?$cfg_client_validate:'default';

//=========================================================================
// Better not modify the code below this line
//=========================================================================

// Translations
$SPL_TXT = array();

// Metadata
$SPL_META = array();

// UI element definitions
$SPL_UI = array();

// Database settings
$SPL_CFG['dbhost'] = isset($dbhost)?$dbhost:'localhost';
$SPL_CFG['dbname'] = isset($dbname)?$dbname:'spl';
$SPL_CFG['dbuser'] = isset($dbuser)?$dbuser:'root';
$SPL_CFG['dbpass'] = isset($dbpass)?$dbpass:'';
$SPL_CFG['prefix'] = isset($tbprefix)?$tbprefix:'spl_';
// When no db values have been specified in config.php, try database specific configs
if (!isset($dbhost)) {
  if (file_exists($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/config.inc.php')) {
    require_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/config.inc.php');
  }
  if (file_exists($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/default_config.inc.php')) {
    require_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/default_config.inc.php');
  }
}


// Enable databased managed session data.
require_once($SPL_CFG['dirroot'].'/inc/settings.ses.php');

// Preferred language
if (!isset($_SESSION['usp_lang'])){
  $_SESSION['usp_lang'] = $SPL_CFG['language'];
}

/** 
 * $Log: config.set.php,v $
 * Revision 1.11  2006/08/08 06:13:13  jebbol
 * Added helproot and weeknumber-mode
 *
 * Revision 1.10  2006/04/14 13:03:01  jebbol
 * *** empty log message ***
 *
 * Revision 1.9  2006/02/23 18:40:53  jebbol
 * Fixed an issue preventing a fresh install from starting, due to a missing db config file
 */

?>
