<?php
/**
 * Configuration settings
 * 
 * Use this file to customize studyplanners configuration.
 * Remove the // before the desired setting to set a value.
 * 
 * If you are satisfied with the default setting, 
 * leave the // untouched.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: config.php,v 1.15 2005/09/17 15:52:35 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

/* 
 * *********************************************************
 * Server settings
 * *********************************************************
 */

/* Server file location
 * Specify the full OS directory path to this same location
 * Make sure the upper/lower case is correct.  Some examples:
 *
 *    $CFG->dirroot = 'C:\Inetpub\wwwroot\spl';        // Windows
 *    $CFG->dirroot = '/var/www/html/spl';             // Redhat Linux
 *    $CFG->dirroot = '/srv/www/htdocs/spl';           // Suse Linux
 *    $CFG->dirroot = '/home/example/public_html/spl'; // Cpanel host
 */
// $dirroot = '/var/www/html/spl';

/* Web site location
 * Tells spl where it is located. Specify the full web address to where spl
 * has been installed. If your web site is accessible via multiple URLs
 * then choose the most natural one that your users would use.
 * Do not include a trailing slash
 */
// $wwwroot = 'http://localhost/spl';

/* Database host name
 * 'localhost' = default
 */
// $dbhost = 'localhost';

/* Database name
 * 'spl' = default
 */
// $dbname = 'spl';

/* Database user
 * 'root' = default
 */
// $dbuser = 'root';

/* Database password
 * '' = default
 */
// $dbpass = '';

/* Table prefix
 * 'spl_' = default
 */
// $tbprefix = 'spl_';


// Developers please use a local/config.php to set your root.
// PLEASE EXLCUDE THE LOCAL FILE FROM THE CVS
$localconfig = dirname(__FILE__).
               DIRECTORY_SEPARATOR.'..'.
               DIRECTORY_SEPARATOR.'local'.
               DIRECTORY_SEPARATOR.'config.php';
if (file_exists($localconfig)) {
  include_once($localconfig);
}

/* 
 * *********************************************************
 * Application configuration
 * *********************************************************
 */

/* The Electronic Learning Environment to use
 * 'moodle' = user Moodle
 * 'dokeos' = use Dokeos
 * 'none'   = no ELO is used (default)
 */
// $cfg_elo = 'none';

/* Make use of the learning style directive?
 * 'true' = enable this functionality
 * 'false = disable this functionality (default)
 */
// $cfg_style = 'false';

/* Do you use Learning load?
 * 'true'  = yes, enable it (default)
 * 'false' = no, disable it
 */
// $cfg_load = 'true';

/* Dou you use Learning reward
 * 'true'  = yes, enable it (default)
 * 'false' = no, disable it
 */
// $cfg_reward = 'true';

/* 
 * *********************************************************
 * Application behaviour
 * *********************************************************
 */

/* The maximum number of items in a listbox. Setting this value to
 * something higher than 0, will result in reference field being
 * visualized as listboxes when they have less than the mentioned
 * records.
 * '100' = default
 */
// $cfg_max_listitems = '100';

/* The number of rows to display in a table
 * Set this to a low value if you do not want scrollbars to appear in tables
 * '15' = default
 */
// $cfg_numrows = '15';

/* 
 * *********************************************************
 * User interface settings
 * *********************************************************
 */

/* Preferred language (users can override this setting)
 * 'nl' = Nederlands (default)
 * 'en' = English
 */
// $cfg_lang = 'nl';

/* Skin
 */
// $cfg_skin = 'default';

/* 
 * *********************************************************
 * Page generation
 * *********************************************************
 */

/* The P3P Policy to use in the heading section of any page
 * Generate a policy for your website at http://www.privacycouncil.com/freep3pfix.php
 */
// $cfg_p3p_policy ='NOI NID STP';

/* Robots metatag
 */
// $cfg_robots = 'noindex';

/* Keywords metatag
 */
// $cfg_keywords = '';

/* The markup version to use. Leave it emtpy to use the browsers preference.
 * You can force a specific markup by entering these values:
 * doctype:     'html4','xhtml1'
 * doctype_dtd: 'strict', 'transitional','frameset'
 */
// $cfg_doctype = '';
// $cfg_doctype_dtd = '';

/* The character set to use
 */
// $cfg_charset = 'UTF-8'; 
 
/* 
 * *********************************************************
 * Desktop widget support
 * *********************************************************
 */

/* Do you use the Administrator hit statistics widget?
 * 'true'  = yes, enable it (default)
 * 'false' = no, disable it
 */
// $cfg_hitstat = 'true';

/* Do you use the teacher task widget?
 * 'true'  = yes, enable it (default)
 * 'false' = no, disable it
 */
// $cfg_teastat = 'true';

 
require_once($dirroot.'/inc/config.set.php');
?>
