<?php
/**
 * Alerting service
 *
 * $Author: jebbol $
 * $Revision: 1.1 $ 
 * $Date: 2006/08/24 17:33:44 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

include_once ($SPL_CFG['dirroot'].'/class/stu.class.php');

function service_alert() {
  
  global $SPL_CFG;
  
  $numberOfAlerts = 0;
  $studentId      = 0;
  
  // An array of parents to be alerted.
  // $toBeAlerted[parents usr_id][student id](sug_id,sgd_caldate_finish)
  $toBeAlerted = array();
  
  $query  = 'SELECT sgd.usr_id,usr.stu_id,sgd.sug_id,sgd_caldate_finish,(sug_alert_days*86400) as days';
  $query .= ' FROM '.$SPL_CFG['prefix'].'sgd sgd LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = sgd.usr_id LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = sgd.sug_id';
  $query .= ' WHERE sgd.adm_id = "'.$_SESSION['adm_id'].'" AND NOT sgd.is_done AND sgd.is_active AND NOT sgd.is_alerted AND sgd.sgd_caldate_finish >= "('.time().'+days)" AND sug.sug_alert_days > "0"';
  $query .= ' ORDER BY usr_id';
  $result = db_query($query);

  while ($row = db_fetch_array($result)) {
    
    // Send one alert per student
    if ((int)$row['stu_id'] != (int)$studentId) {
      $studentId = (int)$row['stu_id'];
      // Find parent data
      $stu = new stu();
      if ($stu->init($row['stu_id'])) {
        $parents = $stu->getParents();
        foreach ($parents as $parent) {
          foreach ($parent as $key => $value) {
            $query = 'SELECT usr_id,usr_email FROM '.$SPL_CFG['prefix'].'usr WHERE par_id = "'.$key.'" LIMIT 1';
            $parentData = db_fetch_array(db_query($query));
            if (isset($parentData['usr_email'])) {
              if (!in_array($parentData['usr_id'],$toBeAlerted)) {
                $toBeAlerted[$key][$row['stu_id']] = array('sug_id'=>$row['sug_id'],'sgd_caldate_finish'=>$row['sgd_caldate_finish']);
                $numberOfAlerts++;
              }
            }
          }
        }
      }
    }
    
  }

  // Prepare email data
  $inaData = array();
  $query = 'SELECT ina_id,ina_email,ina_alerttext FROM '.$SPL_CFG['prefix'].'ina';
  $result = db_query($query);
  while ($row = db_fetch_array($result)) {
    $inaData[$row['ina_id']] = array('ina_email'=>$row['ina_email'],'ina_alerttext'=>$row['ina_alerttext']);
  }

  // Send each parent one email
  foreach ($toBeAlerted as $parId => $alertData) {
    
  }
  
  return $numberOfAlerts;
  
}

/**
 * $Log: service.alert.inc.php,v $
 * Revision 1.1  2006/08/24 17:33:44  jebbol
 * Added in release 0.15
 *
 */

?>
