<?php
/**
 * Setup Studiewijzer for first time use.
 * Please delete this file after succesfull setup
 *
 * $Author: jebbol $
 * $Revision: 1.8 $
 * $Date: 2006/08/08 08:29:32 $ 
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */
 
// Step 8: Start studiewijzer
if (isset($_POST['page8'])) {
  header('Location: ../index.php');
}

// Language to use
$SPL_TXT = array();
include_once('lang/text.'.get_browser_language().'.php');

// version to be installed
$spl_version_major = 0;
$spl_version_minor = 1;
$spl_version_patch = 5;
$db_version = 25;

// Location of the studiewijzer base library
$base_library = 'http://library.studiewijzer.org/api/ws.php';
//$base_library = 'http://localhost/php/jbl/api/ws.php';

// Status variables
$fatal_error = false;
$config_file_permissions = true;
$config_dir_permissions = true;

// Check if the onfiguration file exists
// If not, check if we can create it
$config_file = '../inc/config.php';
$config_exists = file_exists($config_file);
$config_canwrite = false;
if ($config_exists) {
  $config_canwrite = is_writable($config_file);
}
else {
  // See if we can create a file
  $test_file = '../inc/remove_me.tst';
  $void = @fopen($test_file,"w+b",false);
  if (file_exists($test_file)) {
    $config_canwrite = true;
  }
  @fclose($test_file);
  @unlink($test_file);
}

// Default Configuration settings
$settings['dbtype']   = 'mysql'; 
$settings['dbhost']   = 'localhost'; 
$settings['dbuser']   = 'root'; 
$settings['dbpass']   = ''; 
$settings['dbname']   = 'spl'; 
$settings['tbprefix'] = 'spl_';
$settings['dirroot']  = resolveDocumentRoot();
if (strlen($settings['dirroot'])==0){
  $settings['dirroot']  = '/var/www/html/studiewijzer';
}
$settings['wwwroot']  = 'http://www.mysite.nl/studiewijzer';
if (isset($_SERVER['HTTP_REFERER'])) {
  $settings['wwwroot'] = substr($_SERVER['HTTP_REFERER'],0,strpos($_SERVER['HTTP_REFERER'],'/install/setup.php'));
}

// Build setup page
echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">'."\n";
echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">'."\n";
echo '<head>'."\n";
echo '<title>Studiewijzer Setup</title>'."\n";
echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />'."\n";
echo '<link href="setup.css" type="text/css" rel="stylesheet"/>'."\n";
echo '<script language="JavaScript">function cc() {if (document.cookie == "") {document.getElementById("yes_cookies").style.display="none"; document.getElementById("yes_cookies_icon").style.display="none";document.getElementById("no_cookies").style.display=""; document.getElementById("no_cookies_icon").style.display=""; document.setupform.cookieexists.value ="false";} else {document.setupform.cookieexists.value ="true";}}document.cookie = "killme" + escape("nothing");</script>'."\n";
echo '</head>'."\n";
echo '<body onLoad="cc();">'."\n";
echo '<table class="setupTable" cellspacing="0" cellpadding="0">'."\n";
echo '<tr><td style="width:25%;height:10em"></td><td></td><td class="copyright">Imai BV<br>Hoefbladhof 4a<br>3991 GH HOUTEN<br><br><a href="http://www.studiewijzer.nl">www.studiewijzer.nl</a><br><a href="mailto:info@studiewijzer.nl">support@studiewijzer.nl</a></td></tr>'."\n";

// Step 1: Checking prerequisites
if (empty($_POST) || isset($_POST['page1'])) {
  echo '<tr><td class="steps">'.translate('Step 1 of 7').'<br>'.translate('Checking prerequisites').'</td><td><form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
  echo '<input type="hidden" name="cookieexists" value="false">'."\n";
  echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

  // Browser settings
  echo '<tr><td><table class="section" cellspacing="0" cellpadding="0"><tr><td class="sectionTitle">'.translate('Browser settings').'</td></tr><tr><td><table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
    // Javascript
    echo '<noscript><tr><td class="alert">'.translate('Javascript must be enabled in your browser.').'</td><td class="icon"><img src="stop.png"></td></tr></noscript>'."\n";
    echo '<script type="text/javascript">document.write(\'<tr><td class="normal">'.translate('Javascript is enabled.').'</td><td class="icon"><img src="trust.png"></td></tr>\')</script>';
    // Cookies
    echo '<tr><td class="alert"><div id="no_cookies" style="display:none">'.translate('Cookies must be enabled in your browser.').'</div></td><td class="icon" id="no_cookies_icon" style="display:none"><img src="stop.png"></td></tr>'."\n";
    echo '<tr><td class="normal"><div id="yes_cookies">'.translate('Cookies are enabled.').'</div></td><td class="icon" id="yes_cookies_icon"><img src="trust.png"></td></tr>'."\n";
  echo '</table></td></tr></table></td></tr>';

  // Server
  echo '<tr><td><table class="section" cellspacing="0" cellpadding="0"><tr><td class="sectionTitle">'.translate('Server settings').'</td></tr><tr><td><table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
    // PHP version
    if (phpversion() < '4.1') {
      echo '<tr><td class="alert">'.translate('PHP version must be >= 4.1.0').'</td><td class="icon"><img src="stop.png"></td>'."\n";
      $fatal_error = true;
    }
    else {
      echo '<tr><td class="normal">'.translate('PHP version ').phpversion().'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
    }
    // MySQL
    if (!function_exists('mysql_connect')) {
      echo '<tr><td class="alert">'.translate('Install MySQL before continuing.').'</td><td class="icon"><img src="stop.png"></td>'."\n";
      $fatal_error = true;
    }
    else {
      // Check version
      $db_version = null;
      if (function_exists('mysql_get_server_info')) {
        $db_version = @mysql_get_server_info();
      }
      if ($db_version){
        echo '<tr><td class="normal">MySQL '.$db_version.'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
      }
      else {
        echo '<tr><td class="normal">'.translate('MySQL is available').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
      }
    }
    // Directory write permissions
    if (!$config_dir_permissions){
      echo '<tr><td class="alert">'.translate('Unable to write ').$config_file.translate('. Please change the directory permissions.').'</td><td class="icon"><img src="stop.png"></td>'."\n";
      $fatal_error = true;
    }
    else {
      echo '<tr><td class="normal">'.translate('Include directory is writable').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
    }
    // Configuration file write permissions
    if (!$config_file_permissions){
      echo '<tr><td class="alert">'.translate('Unable to write ').$config_file.translate('. Please change the file permissions.').'</td><td class="icon"><img src="stop.png"></td>'."\n";
      $fatal_error = true;
    }
    else {
      echo '<tr><td class="normal">'.translate('Configuration file is writable').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
    }
  echo '</table></td></tr>';
  echo '</table></td></tr>';
  if (!$fatal_error) {
    echo '<tr><td class="nav"><input name="page2" id="page2" type="submit" size="8" class="button" value="'.translate('Next').'" /></td></tr>'."\n";
  }
  else {
    echo '<tr><td class="nav"><input name="page1" id="page1" type="submit" size="8" class="button" value="'.translate('Retry').'" /></td></tr>'."\n";
  }
  echo '</table></td><td></td></tr>'."\n";
}

// Step 2: Database engine
if (isset($_POST['page2'])) {
  echo '<tr>';
    echo '<td class="steps">'.translate('Step 2 of 7').'<br>'.translate('General information').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

        // Paths
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Paths').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Dirroot
                echo '<tr><td class="normal" style="width:8em">'.translate('Directory').'</td><td class="normal"><input type="text" name="dirroot" id="dirroot" style="width:100%" value="'.(isset($_POST['dirroot'])?$_POST['dirroot']:$settings['dirroot']).'" /></td></tr>'."\n";
                // WWWroot
                echo '<tr><td class="normal">'.translate('Site URL').'</td><td class="normal"><input type="text" name="wwwroot" id="wwwroot" style="width:100%" value="'.(isset($_POST['wwwroot'])?$_POST['wwwroot']:$settings['wwwroot']).'" /></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        // Database engine
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Database engine').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Host
                echo '<tr><td class="normal" style="width:8em">'.translate('Host name').'</td><td class="normal"><input type="text" name="dbhost" id="dbhost" value="'.(isset($_POST['dbhost'])?$_POST['dbhost']:$settings['dbhost']).'" /></td></tr>'."\n";
                // User
                echo '<tr><td class="normal">'.translate('User name').'</td><td class="normal"><input type="text" name="dbuser" id="dbuser" value="'.(isset($_POST['dbuser'])?$_POST['dbuser']:$settings['dbuser']).'" /></td></tr>'."\n";
                // Password
                echo '<tr><td class="normal">'.translate('Password').'</td><td class="normal"><input type="password" name="dbpass" id="dbpass" value="'.(isset($_POST['dbpass'])?$_POST['dbpass']:$settings['dbpass']).'" /></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        // Studiewijzer database
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Studiewijzer database').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Database name
                echo '<tr><td class="normal" style="width:8em">'.translate('Database name').'</td><td class="normal"><input type="text" name="dbname" id="dbname" value="'.(isset($_POST['dbname'])?$_POST['dbname']:$settings['dbname']).'" /></td></tr>'."\n";
                // Table prefix
                echo '<tr><td class="normal">'.translate('Table prefix').'</td><td class="normal"><input type="text" name="tbprefix" id="tbprefix" value="'.(isset($_POST['tbprefix'])?$_POST['tbprefix']:$settings['tbprefix']).'" /></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        echo '<tr><td class="nav"><input name="page1" id="page1" type="submit" size="8" class="button" value="'.translate('Previous').'" /> <input name="page3" id="page3" type="submit" size="8" class="button" value="'.translate('Next').'" /></td></tr>'."\n";

      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

// Step 3: Populating tables
if (isset($_POST['page3'])) {
  
  // Write configuration
  $settings['dbhost']   = $_POST['dbhost']; 
  $settings['dbuser']   = $_POST['dbuser']; 
  $settings['dbpass']   = $_POST['dbpass']; 
  $settings['dbname']   = $_POST['dbname']; 
  $settings['tbprefix'] = $_POST['tbprefix'];
  $settings['dirroot']  = $_POST['dirroot'];
  $settings['wwwroot']  = $_POST['wwwroot'];
  
  $file = @fopen($config_file,"w+b",false);
  $write_ok = true;
  if (empty($file)){
    if (file_exists($config_file)){
      $config_file_permissions = false;
      $write_ok = false;
    }
    else {
      $config_dir_permissions = false;
      $write_ok = false;
    }
  }
  else {
    $write_ok = fwrite($file,"<?php\r\n");
    $write_ok = fwrite($file,"/**\r\n");
    $write_ok = fwrite($file," * Configuration settings\r\n");
    $write_ok = fwrite($file," * Generated by the Studiewijzer setup script.\r\n");
    $write_ok = fwrite($file," */\r\n");
    foreach ($settings as $k=>$v){
      $write_ok = fwrite($file,"$".$k." = '".stripslashes($v)."';\r\n");
    }
    $write_ok = fwrite($file,'include_once($dirroot.\'/inc/config.set.php\');'."\r\n");
    $write_ok = fwrite($file,"?>\r\n");
    fclose($file);
    @chmod($file,644);
  }

  echo '<tr>';
    echo '<td class="steps">'.translate('Step 3 of 7').'<br>'.translate('Creating database and tables').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<input type="hidden" name="dbhost" value="'.$_POST['dbhost'].'">'."\n";
      echo '<input type="hidden" name="dbuser" value="'.$_POST['dbuser'].'">'."\n";
      echo '<input type="hidden" name="dbpass" value="'.$_POST['dbpass'].'">'."\n";
      echo '<input type="hidden" name="dbname" value="'.$_POST['dbname'].'">'."\n";
      echo '<input type="hidden" name="tbprefix" value="'.$_POST['tbprefix'].'">'."\n";
      echo '<input type="hidden" name="dirroot" value="'.$_POST['dirroot'].'">'."\n";
      echo '<input type="hidden" name="wwwroot" value="'.$_POST['wwwroot'].'">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

        // Check username and password
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Creating database').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Writing Configuration
                if ($write_ok){
                  echo '<tr><td class="normal">'.translate('Written configuration file.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                }
                else {
                  echo '<tr><td class="alert">'.translate('Could not write configuration file.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  $fatal_error = true;
                }
                //  Connection
                @mysql_close();
                $db_handle = @mysql_connect($_POST['dbhost'],$_POST['dbuser'],$_POST['dbpass']);
                if (gettype($db_handle)=='resource' && get_resource_type($db_handle)=='mysql link'){
                  echo '<tr><td class="normal">'.translate('Connected to database engine, user ').$_POST['dbuser'].'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                }
                else {
                  echo '<tr><td class="alert">'.translate('Could not connect. Please check username and password').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  $fatal_error = true;
                }
                if (!$fatal_error) {
                  // Database
                  $db = @mysql_select_db($_POST['dbname'],$db_handle);
                  if (!$db){
                    if (@mysql_query('CREATE DATABASE '.$_POST['dbname'].';',$db_handle)) {
                      $db = @mysql_select_db($_POST['dbname'],$db_handle);
                    }
                  }
                  if ($db) {
                    echo '<tr><td class="normal">'.translate('Database ').$_POST['dbname'].translate(' is ready to be set up.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="alert">'.translate('Could not create database ').$_POST['dbname'].': '.@mysql_error($db_handle).'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                    $fatal_error = true;
                  }
                }
                // tables
                if (!$fatal_error){

                  $existing_tables = '';
                  $result = @mysql_list_tables($_POST['dbname'],$db_handle);
                  for ($i = 0; $i < mysql_num_rows($result); $i++) {
                    $existing_tables .= mysql_tablename($result, $i).',';
                  }
                  @mysql_free_result($result);
                  
                  $tablesToCreate = array('adm','adr','ali','apl','ast','cal','cat','cfg','cou','dnm','fmt','grp','ina','ins','lan','lst','men','par','pea','per','prd','roa','rol','ses','sgd','sgn','spt','src','stat','sts','stu','sub','sug','syn','tea','tes','tic','tra','tsu','usa','usd','usl','uso','usp','usr','uss');
                  foreach ($tablesToCreate as $table) {
                    if (strstr($existing_tables,$_POST['tbprefix'].$table)){
                      echo '<tr><td class="normal">'.translate('Table &quot;').translate($table).translate('&quot; already exists. Skipping.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                    }
                    else {
                      $query = @file_get_contents('sql/'.$table.'.sql');
                      if (!$query) {
                        echo '<tr><td class="alert">'.translate('Could not find file &quot;sql/').$table.translate('.sql&quot;.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                        $fatal_error = true;
                        continue;
                      }
                      $result = false;
                      if ($query){
                        if ($_POST['tbprefix']!='spl_') {
                          $query = str_replace('spl_',$_POST['tbprefix'],$query);
                        }
                        $result = @mysql_query($query,$db_handle);
                      }
                      if ($result) {
                        echo '<tr><td class="normal">'.translate('Table &quot;').translate($table).translate('&quot; created successfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="alert">'.translate('Could not create table &quot;').translate($table).translate('&quot;. Aborting setup.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                        $fatal_error = true;
                      }
                    }
                  }
                
                }
                
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        echo '<tr><td class="nav"><input name="page2" id="page2" type="submit" size="8" class="button" value="'.translate('Previous').'" /> ';
        if (!$fatal_error) {
          echo '<input name="page4" id="page4" type="submit" size="8" class="button" value="'.translate('Next').'" /></td></tr>'."\n";
        }
        
      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

// Step 4: Populating tables
if (isset($_POST['page4'])) {
  echo '<tr>';
    echo '<td class="steps">'.translate('Step 4 of 7').'<br>'.translate('Setting up data').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<input type="hidden" name="dbhost" value="'.$_POST['dbhost'].'">'."\n";
      echo '<input type="hidden" name="dbuser" value="'.$_POST['dbuser'].'">'."\n";
      echo '<input type="hidden" name="dbpass" value="'.$_POST['dbpass'].'">'."\n";
      echo '<input type="hidden" name="dbname" value="'.$_POST['dbname'].'">'."\n";
      echo '<input type="hidden" name="tbprefix" value="'.$_POST['tbprefix'].'">'."\n";
      echo '<input type="hidden" name="dirroot" value="'.$_POST['dirroot'].'">'."\n";
      echo '<input type="hidden" name="wwwroot" value="'.$_POST['wwwroot'].'">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

        // Organisation
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Your organisation').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Organisation name
                echo '<tr><td class="normal" style="width:12em">'.translate('Organisation name').'</td><td class="normal"><input type="text" size="40" name="schoolname" id="schoolname" value="'.(isset($_POST['schoolname'])?$_POST['schoolname']:translate('Scholengemeenschap')).'" /></td></tr>'."\n";
                // School within the organisation
                echo '<tr><td class="normal">'.translate('School name').'</td><td class="normal"><input type="text" name="schoolshort" id="schoolshort" value="'.(isset($_POST['schoolshort'])?$_POST['schoolshort']:translate('School')).'" /></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        // Administrator
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Administrator').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Login
                echo '<tr><td class="normal" style="width:12em">'.translate('Login').'</td><td class="normal"><input type="text" name="admin" id="admin" value="'.(isset($_POST['admin'])?$_POST['admin']:'admin').'" /></td></tr>'."\n";
                // Password
                echo '<tr><td class="normal">'.translate('Password').'</td><td class="normal"><input type="password" name="adminpass" id="adminpass" value="'.(isset($_POST['adminpass'])?$_POST['adminpass']:'').'" /></td></tr>'."\n";
                // Again Password
                echo '<tr><td class="normal">'.translate('Password again').'</td><td class="normal"><input type="password" name="adminpass2" id="adminpass2" value="'.(isset($_POST['adminpass2'])?$_POST['adminpass2']:'').'" /></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        echo '<tr><td class="nav"><input name="page3" id="page3" type="submit" size="8" class="button" value="'.translate('Previous').'" /> <input name="page5" id="page5" type="submit" size="8" class="button" value="'.translate('Next').'" /></td></tr>'."\n";

      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

// Step 5: Writing table data
if (isset($_POST['page5'])) {
  $fatal_error = false;
  include_once('../class/rc4crypt.class.php');
  echo '<tr>';
    echo '<td class="steps">'.translate('Step 5 of 7').'<br>'.translate('Writing table data').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<input type="hidden" name="dbhost" value="'.$_POST['dbhost'].'">'."\n";
      echo '<input type="hidden" name="dbuser" value="'.$_POST['dbuser'].'">'."\n";
      echo '<input type="hidden" name="dbpass" value="'.$_POST['dbpass'].'">'."\n";
      echo '<input type="hidden" name="dbname" value="'.$_POST['dbname'].'">'."\n";
      echo '<input type="hidden" name="tbprefix" value="'.$_POST['tbprefix'].'">'."\n";
      echo '<input type="hidden" name="schoolname" value="'.$_POST['schoolname'].'">'."\n";
      echo '<input type="hidden" name="schoolshort" value="'.$_POST['schoolshort'].'">'."\n";
      echo '<input type="hidden" name="admin" value="'.$_POST['admin'].'">'."\n";
      echo '<input type="hidden" name="adminpass" value="'.$_POST['adminpass'].'">'."\n";
      echo '<input type="hidden" name="adminpass2" value="'.$_POST['adminpass2'].'">'."\n";
      echo '<input type="hidden" name="dirroot" value="'.$_POST['dirroot'].'">'."\n";
      echo '<input type="hidden" name="wwwroot" value="'.$_POST['wwwroot'].'">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

        // Writing table data
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('School and administrator data').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

                //  Connection
                @mysql_close();
                $db_handle = @mysql_connect($_POST['dbhost'],$_POST['dbuser'],$_POST['dbpass']);
                if (!gettype($db_handle)=='resource' || !get_resource_type($db_handle)=='mysql link'){
                  echo '<tr><td class="alert">'.translate('Could not connect. Please check username and password').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  $fatal_error = true;
                }

                // Write administration row
                if (!$fatal_error) {
                  $db = @mysql_select_db($_POST['dbname'],$db_handle);
                  if ($db){
                    $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'adm';
                    $result = @mysql_query($query,$db_handle);
                    // Create a new row
                    $query  = 'INSERT INTO '.$_POST['tbprefix'].'adm (adm_id,adm_desc,adm_short,adm_is_default)';
                    $query .= ' VALUES(1,"'.mysql_escape_string($_POST['schoolname']).'","'.mysql_escape_string($_POST['schoolname']).'",1)';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                  }
                }
                // Write institution
                if (!$fatal_error) {
                  $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'ins';
                  $result = @mysql_query($query,$db_handle);
                  // Create a new row
                  $query  = 'INSERT INTO '.$_POST['tbprefix'].'ins (ins_id,adm_id,ins_name,ins_short,ins_code,ins_schoolyear_start,ins_schoolyear_end,ins_methodology,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id)';
                  $query .= ' VALUES(1,1,"'.mysql_escape_string($_POST['schoolshort']).'","'.mysql_escape_string($_POST['schoolshort']).'","",0,0,"traditional",1,'.time().',1,1,'.time().',1,1)';
                  if (!@mysql_query($query,$db_handle)){
                    $fatal_error = true;
                  }
                }
                // Write institution address
                if (!$fatal_error) {
                  $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'ina';
                  $result = @mysql_query($query,$db_handle);
                  // Create a new row
                  $query  = 'INSERT INTO '.$_POST['tbprefix'].'ina (ina_id,adm_id,adr_id,ina_type,ina_code,ina_name,ina_short,ina_schoolyear_start,ina_schoolyear_end,ina_methodology,ina_valid_from,ina_valid_until,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id)';
                  $query .= ' VALUES(1,1,0,"L","","'.mysql_escape_string($_POST['schoolshort']).'","'.mysql_escape_string($_POST['schoolshort']).'",0,0,"traditional",0,4294967295,1,'.time().',1,1,'.time().',1,1)';
                  if (!@mysql_query($query,$db_handle)){
                    $fatal_error = true;
                  }
                }
                // Relate the address to the institution
                if (!$fatal_error) {
                  $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'apl';
                  $result = @mysql_query($query,$db_handle);
                  // Create a new row
                  $query  = 'INSERT INTO '.$_POST['tbprefix'].'apl (apl_id,adm_id,apl_parent,parent_id,apl_child,child_id,apl_sequence,apl_code,apl_valid_from,apl_valid_until,is_active)';
                  $query .= ' VALUES(null,1,"ins",1,"ina",1,10,"",0,4294967295,1)';
                  if (!@mysql_query($query,$db_handle)){
                    $fatal_error = true;
                  }
                }
                if ($fatal_error) {
                  echo '<tr><td class="alert">'.translate('Could not write schoolname.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                }
                else {
                  echo '<tr><td class="normal">'.translate('Schoolname written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                } 
        
                // Write user row
                if (!$fatal_error) {
                  if ($_POST['adminpass']!=$_POST['adminpass2']){
                    echo '<tr><td class="alert">'.translate('Passwords do not match.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                    $fatal_error = true;
                  }
                  // User login data
                  if (!$fatal_error) {
                    $query = 'SELECT usr_login FROM '.$_POST['tbprefix'].'usr WHERE usr_id = 1 LIMIT 1';
                    $result = @mysql_fetch_assoc(@mysql_query($query,$db_handle));
                    if (isset($result['usr_login'])) {
                      // Row already exists
                      $query  = 'UPDATE '.$_POST['tbprefix'].'usr';
                      $query .= ' SET usr_login = "'.mysql_escape_string($_POST['admin']).'", usr_psswd = "'.base64_encode(rc4crypt::encrypt('JGBNsO6jrYQMiCHQ', mysql_escape_string($_POST['adminpass']))).'", usr_name = "'.mysql_escape_string($_POST['admin']).'", adm_id = 1, is_sysadm = 1, usr_log = 0, is_active = 1';
                      $query .= ' WHERE usr_id = 1';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                    }
                    else {
                      // Create a new row
                      $query  = 'INSERT INTO '.$_POST['tbprefix'].'usr (usr_id,usr_login,usr_psswd,usr_name,adm_id,is_sysadm,usr_log,is_active)';
                      $query .= ' VALUES(1,"'.mysql_escape_string($_POST['admin']).'","'.base64_encode(rc4crypt::encrypt('JGBNsO6jrYQMiCHQ', mysql_escape_string($_POST['adminpass']))).'","'.mysql_escape_string($_POST['admin']).'",1,1,0,1)';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                    }
                  }
                  if ($fatal_error) {
                    echo '<tr><td class="alert">'.translate('Could not write administrator login.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="normal">'.translate('Administrator data written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  } 

                  // User permissions
                  if (!$fatal_error) {
                    // Clear old stuff
                    $query = 'DELETE FROM '.$_POST['tbprefix'].'usa WHERE usr_id = 1';
                    $result = @mysql_query($query,$db_handle);
                    // Set admin permissions
                    $query_base  = 'INSERT INTO '.$_POST['tbprefix'].'usa (usa_id,usr_id,adm_id,usa_key,usa_permission)';
                    $tablesToPermit = array('ali','apl','cal','cat','fmt','grp','ina','ins','lst','men','par','prd','sgd','sts','stu','sub','sug','tea','tra','usr');
                    foreach ($tablesToPermit as $table) {
                      $query = $query_base .' VALUES(null,1,1,"'.$table.'",31)';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                    }
                  }
                  if ($fatal_error) {
                    echo '<tr><td class="alert">'.translate('Could not write administrator permissions.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="normal">'.translate('Administrator permissions written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  } 

                  // User preferences
                  if (!$fatal_error) {
                    // Clear old stuff
                    $query = 'DELETE FROM '.$_POST['tbprefix'].'usp WHERE usr_id = 1';
                    $result = @mysql_query($query,$db_handle);
                    // Set admin preferences
                    $query  = 'INSERT INTO '.$_POST['tbprefix'].'usp (usp_id,usr_id,adm_id,usp_lang,usp_nameformat,usp_locale,usp_startpage,usp_startpane,usp_numrows,usp_calmode,usp_menumode)';
                    $query .= ' VALUES(null,1,1,"nl","UIS","nl_NL","ui/menu.php","menu_data.php",20,"calendardate","normal")';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                  }
                  if ($fatal_error) {
                    echo '<tr><td class="alert">'.translate('Could not write administrator preferences.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="normal">'.translate('Administrator preferences written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  } 

                  // Sources
                  if (!$fatal_error) {
                    // Clear old stuff
                    $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'src';
                    $result = @mysql_query($query,$db_handle);
                    $query_base  = 'INSERT INTO '.$_POST['tbprefix'].'src (src_id,adm_id,src_name,src_desc,src_login,src_cache,src_flush,src_is_native,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id)';
                    $query = $query_base.' VALUES(1,1,"spl","Studiewijzer",1,0,0,1,1,'.time().',1,1,'.time().',1,1)';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES(2,1,"jbl","Studiewijzer Global Library",1,0,0,0,1,'.time().',1,1,'.time().',1,1)';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                  }
                  if ($fatal_error) {
                    echo '<tr><td class="alert">'.translate('Could not write data sources.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="normal">'.translate('Data sources written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  } 

                  // Version data
                  if (!$fatal_error) {
                    // Clear old stuff
                    $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'cfg';
                    $result = @mysql_query($query,$db_handle);
                    $query_base  = 'INSERT INTO '.$_POST['tbprefix'].'cfg (cfg_name,cfg_value)';
                    $query = $query_base.' VALUES("spl_version_major",'.$spl_version_major.')';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("spl_version_minor",'.$spl_version_minor.')';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("spl_version_patch",'.$spl_version_patch.')';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("db_version",'.$db_version.')';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("tinymce_version","2.0.6.1")';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("jaxcalendar_version","1.34")';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("ezpdf_version","009e")';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                    $query = $query_base.' VALUES("rc4crypt_version","3.0")';
                    if (!@mysql_query($query,$db_handle)){
                      $fatal_error = true;
                    }
                  }
                  if ($fatal_error) {
                    echo '<tr><td class="alert">'.translate('Could not write version data.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  }
                  else {
                    echo '<tr><td class="normal">'.translate('Version data written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                  } 

                }

              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
      echo '<tr><td class="nav"><input name="page4" id="page4" type="submit" size="8" class="button" value="'.translate('Previous').'" /> <input name="page6" id="page6" type="submit" size="8" class="button" value="'.translate('Next').'" /></td></tr>'."\n";

      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

// Step 6: Getting default data from studiewijzer.nl
if (isset($_POST['page6'])) {
  $fatal_error = false;
  include_once("../ws/nusoap.php");
  $client = new soapclient($base_library);
  $service_running = $client->call('ping');
  $subscriber_id = ''; 
  echo '<tr>';
    echo '<td class="steps">'.translate('Step 6 of 7').'<br>'.translate('Educational data').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<input type="hidden" name="dbhost" value="'.$_POST['dbhost'].'">'."\n";
      echo '<input type="hidden" name="dbuser" value="'.$_POST['dbuser'].'">'."\n";
      echo '<input type="hidden" name="dbpass" value="'.$_POST['dbpass'].'">'."\n";
      echo '<input type="hidden" name="dbname" value="'.$_POST['dbname'].'">'."\n";
      echo '<input type="hidden" name="tbprefix" value="'.$_POST['tbprefix'].'">'."\n";
      echo '<input type="hidden" name="schoolname" value="'.$_POST['schoolname'].'">'."\n";
      echo '<input type="hidden" name="schoolshort" value="'.$_POST['schoolshort'].'">'."\n";
      echo '<input type="hidden" name="admin" value="'.$_POST['admin'].'">'."\n";
      echo '<input type="hidden" name="adminpass" value="'.$_POST['adminpass'].'">'."\n";
      echo '<input type="hidden" name="adminpass2" value="'.$_POST['adminpass2'].'">'."\n";
      echo '<input type="hidden" name="dirroot" value="'.$_POST['dirroot'].'">'."\n";
      echo '<input type="hidden" name="wwwroot" value="'.$_POST['wwwroot'].'">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

      if ($service_running) {

        //  Connection
        @mysql_close();
        $db_handle = @mysql_connect($_POST['dbhost'],$_POST['dbuser'],$_POST['dbpass']);
        if (!gettype($db_handle)=='resource' || !get_resource_type($db_handle)=='mysql link'){
          $fatal_error = true;
        }
        if (!$fatal_error) {
          // Write administration row
          $db = @mysql_select_db($_POST['dbname'],$db_handle);
          if ($db){
            // Check library subscriber id
            $query = 'SELECT cfg_value FROM '.$_POST['tbprefix'].'cfg WHERE cfg_name = "jbl_subscriber_id" LIMIT 1';
            $result = @mysql_fetch_array(@mysql_query($query,$db_handle),MYSQL_ASSOC);
            if (!isset($result['cfg_value'])) {
              // Obtain a subscriber id
              $params = array ('name' => $_POST['schoolname'], 'password' => $_POST['adminpass'], 'url' => $_POST['wwwroot']);
              $response = $client->call('subscribe', $params);
              unset($params);
              // Record the subscriber id in the configuration table
              if (!empty($response)) {
                $subscriber_id = $response;
                $query = 'INSERT INTO '.$_POST['tbprefix'].'cfg (cfg_name,cfg_value) VALUES("jbl_subscriber_id","'.$response.'")';
                @mysql_query($query,$db_handle);
              }
              else {
                $service_running = false;
              }
            }
            else {
              $subscriber_id = $result['cfg_value'];
            }
          }
          else {
            $service_running = false;
          }
        }
        else {
          $service_running = false;
        }
      }

      if ($service_running) {

        // Get default filling from studiewijzer.net
        echo '<input type="hidden" name="subscriber_id" value="'.$subscriber_id.'">'."\n";
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Wanna get a flying start?').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                echo '<tr><td class="normal">';
                  echo translate('Studiewijzer.net hosts a large library containing real data to get you up and running quickly.<br>');
                  echo translate('Using this library, you automatically configure your system for use with the educational system in your country.<br><br>');
                  echo translate('This service is free of charge. There are no hidden conditions, no prerequisites. We do not collect any information from your system, nor do we install any spyware, malware or whatever ware you\'ve got. It is just a free service to help you starting.<br><br>');
                  echo translate('If you want to use our default data, select the appropriate country, your prefferred language and press &quot;Get data!&quot;<br><br>');
                  echo translate('Alternatively, you can skip this step by hitting the &quot;Skip&quot; button. Setup finishes and redirects you to the studiewijzer login page.');
                echo '</td><td style="vertical-align:middle;width:70px;"><img src="book.jpg"></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';

        // Get countries and languages
        $params = array ('id' => $subscriber_id);
        $response = $client->call('signon', $params);
        $ticket = $response;
        unset($params);
        
        if ($ticket) {
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Configure my system for the educational system in').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                // Get countries
                $params = array('ticket'=>$ticket,'request'=>array('type'=>'country'));
                $response = $client->call('getData',$params);
                if (is_array($response)) {
                  echo '<tr><td class="normal" style="width:12em">'.translate('Country').'</td><td><select id="country" name="country">';
                  foreach ($response as $row) {
                    echo '<option value="'.$row['cou_id'].'"'.((int)($row['cou_id'])==1?' selected="selected"':'').'>'.$row['cou_name'].'</option>';
                  }
                  echo '</select></td></tr>'."\n";
                }
                unset($params);
                // Get languages
                $params = array('ticket'=>$ticket,'request'=>array('type'=>'language'));
                $response = $client->call('getData',$params);
                if (is_array($response)) {
                  /*
                  echo '<tr><td class="normal">'.translate('Language').'</td>';
                  echo '<td><ul id="language" name="language" class="checklist" style="width:30em">';
                  foreach ($response as $row) {
                    echo '<li><label for="lan_'.$row['lan_id'].'"><input name="lan_'.$row['lan_id'].'" id="lan_'.$row['lan_id'].'" type="checkbox" /> '.$row['lan_name'].'</label></li>';
                  }
                  echo '</ul></td></tr>'."\n";
                  */
                  echo '<tr><td class="normal">'.translate('Language').'</td><td><select id="language" name="language">';
                  foreach ($response as $row) {
                    echo '<option value="'.$row['lan_id'].'"'.((int)($row['lan_id'])==1?' selected="selected"':'').'>'.$row['lan_name'].'</option>';
                  }
                  echo '</select></td></tr>'."\n";
                }
                unset($params);
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
        }
        else {
        $service_running = (bool)false;
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Library is off-line').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                echo '<tr><td class="alert">'.translate('Sorry, the library seems to be off-line. You cannot use its services at the moment.<br>Studiewijzer, however, is ready to be used although you have to manually add some data.').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
        }

      }
      else {
        // Service is off-line. Finish setup
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Congratulations!').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                echo '<tr><td class="normal">';
                  echo translate('Studiewijzer is now ready to be used. We hope you enjoy it.<br>');
                  echo translate('If you need any assistance, please use our forum at <a href="http://www.studiewijzer.nl">www.studiewijzer.nl</a> or contact us at <a href="mailto:support@studiewijzer.nl">support@studiewijzer.nl</a>.<br><br>');
                  echo translate('Studiewijzer is free, open-source software. If you like to contribute to the development of studiewijzer, visit our project website at <a href="http://sourceforge.net/projects/splanner">sourceforge.net</a>.');
                echo '</td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
      }
      echo '<tr><td class="nav"><input name="page5" id="page5" type="submit" size="8" class="button" value="'.translate('Previous').'" />'.($service_running?'<input name="page8" id="page8" type="submit" size="8" class="button" value="'.translate('Skip').'" />':'').'<input name="page7" id="page7" type="submit" size="8" class="button" value="'.($service_running?translate('Get data!'):translate('Done!')).'" /></td></tr>'."\n";

      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

// Step 7: Getting data from studiewijzer.org
if (isset($_POST['page7'])) {
  $fatal_error = false;
  include_once("../ws/nusoap.php");
  $client = new soapclient($base_library);
  $service_running = $client->call('ping'); 
  echo '<tr>';
    echo '<td class="steps">'.translate('Step 7').'<br>'.translate('Getting educational data').'</td>';
    echo '<td>';
      echo '<form name="setupform" id="setupform" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="cookieexists" value="false">'."\n";
      echo '<input type="hidden" name="dbhost" value="'.$_POST['dbhost'].'">'."\n";
      echo '<input type="hidden" name="dbuser" value="'.$_POST['dbuser'].'">'."\n";
      echo '<input type="hidden" name="dbpass" value="'.$_POST['dbpass'].'">'."\n";
      echo '<input type="hidden" name="dbname" value="'.$_POST['dbname'].'">'."\n";
      echo '<input type="hidden" name="tbprefix" value="'.$_POST['tbprefix'].'">'."\n";
      echo '<input type="hidden" name="schoolname" value="'.$_POST['schoolname'].'">'."\n";
      echo '<input type="hidden" name="schoolshort" value="'.$_POST['schoolshort'].'">'."\n";
      echo '<input type="hidden" name="admin" value="'.$_POST['admin'].'">'."\n";
      echo '<input type="hidden" name="adminpass" value="'.$_POST['adminpass'].'">'."\n";
      echo '<input type="hidden" name="adminpass2" value="'.$_POST['adminpass2'].'">'."\n";
      echo '<input type="hidden" name="country" value="'.$_POST['country'].'">'."\n";
      echo '<input type="hidden" name="language" value="'.$_POST['language'].'">'."\n";
      echo '<input type="hidden" name="dirroot" value="'.$_POST['dirroot'].'">'."\n";
      echo '<input type="hidden" name="wwwroot" value="'.$_POST['wwwroot'].'">'."\n";
      echo '<input type="hidden" name="subscriber_id" value="'.$_POST['subscriber_id'].'">'."\n";
      echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

      if ($service_running) {

        // Get a ticket
        $params = array ('id' => $_POST['subscriber_id']);
        $response = $client->call('signon', $params);
        $ticket = $response;
        unset($params);
        
        if ($ticket) {
        // Writing table data
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">'.translate('Retrieved data').'</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";

                //  Connection
                @mysql_close();
                $db_handle = @mysql_connect($_POST['dbhost'],$_POST['dbuser'],$_POST['dbpass']);
                if (!gettype($db_handle)=='resource' || !get_resource_type($db_handle)=='mysql link'){
                  echo '<tr><td class="alert">'.translate('Could not connect. Please check username and password').'</td><td class="icon"><img src="stop.png"></td></tr>'."\n";
                  $fatal_error = true;
                }
                if (!$fatal_error) {
                  // Write administration row
                  $db = @mysql_select_db($_POST['dbname'],$db_handle);
                  if ($db){

                    // Get languages
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'language','desctype'=>'full'));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'lan';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'lan (lan_id,adm_id,lan_name,lan_short,lan_code,lan_iso,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id,jbl_id)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES("'.$row['lan_id'].'",1,"'.$row['lan_name'].'","'.$row['lan_short'].'","'.$row['lan_code'].'","'.$row['lan_iso'].'",1,'.time().',1,2,'.time().',1,2,"'.$row['lan_id'].'")';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write languages. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Languages written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No languages available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);

                    // Get trainings
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'training','desctype'=>'full','country'=>$_POST['country'],'language'=>$_POST['language']));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'tra';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'tra (tra_id,adm_id,tra_name,tra_short,tra_code,tra_courseyears,tra_load,tra_load_per_year,tra_reward,tra_reward_per_year,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id,jbl_id)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES("'.$row['tra_id'].'",1,"'.$row['tra_name'].'","'.$row['tra_short'].'","'.$row['tra_code'].'","'.$row['tra_courseyears'].'","'.$row['tra_load'].'","'.$row['tra_load_per_year'].'","'.$row['tra_reward'].'","'.$row['tra_reward_per_year'].'",1,'.time().',1,2,'.time().',1,2,"'.$row['tra_id'].'")';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write trainings. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Trainings written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No trainings for the selected country/language available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);

                    // Get alignments
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'alignment','desctype'=>'full','country'=>$_POST['country'],'language'=>$_POST['language']));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'ali';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'ali (ali_id,adm_id,ali_name,ali_short,ali_code,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id,jbl_id)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES("'.$row['ali_id'].'",1,"'.$row['ali_name'].'","'.$row['ali_short'].'","'.$row['ali_code'].'",1,'.time().',1,2,'.time().',1,2,"'.$row['ali_id'].'")';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write alignments. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Alignments written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No alignments for the selected country/language available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);

                    // Get subjects
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'subject','desctype'=>'full','country'=>$_POST['country'],'language'=>$_POST['language']));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'sub';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'sub (sub_id,adm_id,sub_name,sub_short,sub_code,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id,jbl_id)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES("'.$row['sub_id'].'",1,"'.$row['sub_name'].'","'.$row['sub_short'].'","'.$row['sub_code'].'",1,'.time().',1,2,'.time().',1,2,"'.$row['sub_id'].'")';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write subjects. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Subjects written sucessfully.'),'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No subjects for the selected country/language available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);

                    // Get applicability
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'applicability','desctype'=>'full','country'=>$_POST['country'],'language'=>$_POST['language']));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      /* Don't truncate, or we will loose the institution/address relationship
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'apl';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      */
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'apl (apl_id,adm_id,apl_parent,parent_id,apl_child,child_id,apl_sequence,apl_code,apl_valid_from,apl_valid_until,is_active)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES(null,1,"'.$row['apl_parent'].'","'.$row['parent_id'].'","'.$row['apl_child'].'","'.$row['child_id'].'","'.$row['apl_sequence'].'","'.$row['apl_code'].'","'.$row['apl_valid_from'].'","'.$row['apl_valid_until'].'",1)';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write relationships. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Relationships written sucessfully.').'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No relationships for the selected country/language available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);

                    // Get formats
                    $params = array('ticket'=>$ticket,'request'=>array('type'=>'format','desctype'=>'full','country'=>$_POST['country'],'language'=>$_POST['language']));
                    $response = $client->call('getData',$params);
                    if (is_array($response)) {
                      $query = 'TRUNCATE TABLE '.$_POST['tbprefix'].'fmt';
                      if (!@mysql_query($query,$db_handle)){
                        $fatal_error = true;
                      }
                      if (!$fatal_error) {
                        $query_base = ' INSERT INTO '.$_POST['tbprefix'].'fmt (fmt_id,adm_id,fmt_name,fmt_short,fmt_code,is_active,create_date,create_usr_id,create_src_id,update_date,update_usr_id,update_src_id,jbl_id)';;
                        foreach ($response as $row) {
                          $query = $query_base.' VALUES("'.$row['fmt_id'].'",1,"'.$row['fmt_name'].'","'.$row['fmt_short'].'","'.$row['fmt_code'].'",1,'.time().',1,2,'.time().',1,2,"'.$row['fmt_id'].'")';
                          if (!@mysql_query($query,$db_handle)){
                            $fatal_error = true;
                            continue;
                          }
                        }
                      }
                      if ($fatal_error) {
                        echo '<tr><td class="alert">'.translate('Could not write formats. Please add them manually.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                      }
                      else {
                        echo '<tr><td class="normal">'.translate('Formats written sucessfully.'),'</td><td class="icon"><img src="trust.png"></td></tr>'."\n";
                      } 
                    }
                    else {
                      echo '<tr><td class="alert">'.translate('No formats for the selected country/language available.').'</td><td class="icon"><img src="caution.png"></td></tr>'."\n";
                    }
                    unset($params);


                  } // $db
                  
                } // $fatal_error

              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
        }
      }      
      else {
        // Service is off-line. Finish setup
        echo '<tr><td>'."\n";
          echo '<table class="section" cellspacing="0" cellpadding="0">'."\n";
            echo '<tr><td class="sectionTitle">Congratulations!</td></tr>'."\n";
            echo '<tr><td>'."\n";
              echo '<table style="width:100%" cellspacing="0" cellpadding="0">'."\n";
                echo '<tr><td class="normal">';
                  echo translate('Studiewijzer is now ready to be used. We hope you enjoy it.').'<br>';
                  echo translate('If you need any assistance, please use our forum at <a href="http://www.studiewijzer.nl">www.studiewijzer.nl</a> or contact us at <a href="mailto:support@studiewijzer.nl">support@studiewijzer.nl</a>.').'<br><br>';
                  echo translate('Studiewijzer is free, open-source software. If you like to contribute to the development of studiewijzer, visit our project website at <a href="http://sourceforge.net/projects/splanner">sourceforge.net</a>.');
                echo '</td></tr>'."\n";
              echo '</table>';
            echo '</td></tr>';
          echo '</table>';
        echo '</td></tr>';
      }
      echo '<tr><td class="nav"><input name="page6" id="page6" type="submit" size="8" class="button" value="'.translate('Previous').'" /><input name="page8" id="page8" type="submit" size="8" class="button" value="'.translate('Done!').'" /></td></tr>'."\n";
      echo '</table>';
    echo '</td>';
    echo '<td></td>';
  echo '</tr>'."\n";
}

echo '</table>'."\n";
echo '</body>'."\n";
echo '</html>'."\n";

/** 
 * ----------------------------------------------------------------------
 *  Functions
 * ----------------------------------------------------------------------
 */

/**
 * Retrieve the browsers preferred language
 * 
 * @param  string $supported A comma separated list of languages supported by the application
 * @return string            The preferred language
 * @access public
 */ 
function get_browser_language($supported='en,nl') {
  
  // Set default language
  $lang = 'en';
  
  $languages = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
  for ($i=0; $i<count($languages);$i++) {
    $tmp = strtolower(trim(ereg_replace(';.*','',$languages[$i])));
    if (stristr($supported,$tmp)) {
      $lang = $tmp;
      break;
    }
  }
  return $lang;  
}

/**
 * Retrieve the document root
 * 
 * @return string The document root
 */
function resolveDocumentRoot() {
  // By Michele "O-Zone" Pinassi
  // Published on php.net 2005-11-22 

  if (isset($_SERVER['DOCUMENT_ROOT'])) {
    return $_SERVER['DOCUMENT_ROOT'];
  }

  $pathInfo = explode('/',$_SERVER["PATH_INFO"]);
  $pathTransl = explode('/',str_replace('\\','/',$_SERVER["PATH_TRANSLATED"]));

  $fNeedle = $pathInfo[1];

  $docRoot = 'C:\\'; // First part of the path

  for($c=1; $c<count($pathTransl) ;$c++) {
    if($pathTransl[$c] == $fNeedle) {
      break;
    } else if(strlen($pathTransl[$c]) > 0) {
      $docRoot .= $pathTransl[$c].'\\';
    }
  }
  return substr($docRoot,0,strpos($docRoot,'\\install\\setup.php'));
}

/** 
 * Translates the given string and returns the translation
 *
 * @param  string $sProperty the name of the data to be returned
 * @return string the translated property
 * @access public
 */  
function translate($property) {

  global $SPL_TXT;

  if (array_key_exists($property, $SPL_TXT)) {
    return $SPL_TXT[$property];
  } else {
    return $property;
  }
}

/** 
 * $Log: setup.php,v $
 * Revision 1.8  2006/08/08 08:29:32  jebbol
 * Added upgrade to version 0.15
 *
 * Revision 1.7  2006/08/08 06:15:59  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.6  2006/04/17 07:27:39  jebbol
 * Renamed install.php to upgrade.php and updated the tinyMCE version
 *
 * Revision 1.5  2006/04/14 13:21:42  jebbol
 * Added the automatic installation of formats from the studiewijzer.org library
 *
 * Revision 1.4  2006/04/14 12:54:54  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.3  2006/03/14 19:04:16  jebbol
 * Removed authorization for table 'tes' from the administrator setup
 */


?>
