CREATE TABLE `spl_sug` (
  `sug_id` int(10) unsigned NOT NULL auto_increment,
  `adm_id` int(10) unsigned NOT NULL default '1',
  `sug_title` varchar(100) NOT NULL default '',
  `sug_short` varchar(15) NOT NULL default '',
  `sug_code` varchar(10) NOT NULL default '',
  `sug_description` text NOT NULL,
  `sug_description_fmt` text NOT NULL,
  `sug_knowledge` text NOT NULL,
  `sug_knowledge_fmt` text NOT NULL,
  `sug_directions` text NOT NULL,
  `sug_directions_fmt` text NOT NULL,
  `sug_prerequisites` text NOT NULL,
  `sug_prerequisites_fmt` text NOT NULL,
  `sug_materials` text NOT NULL,
  `sug_materials_fmt` text NOT NULL,
  `fmt_id` int(10) unsigned NOT NULL default '0',
  `lst_id` int(10) unsigned NOT NULL default '0',
  `tra_id` int(10) unsigned NOT NULL default '0',
  `ali_id` int(10) unsigned NOT NULL default '0',
  `sub_id` int(10) unsigned NOT NULL default '0',
  `sug_courseyear` tinyint(2) unsigned NOT NULL default '0',
  `sug_do_schedule` tinyint(1) NOT NULL default '0',
  `sug_do_portfolio` tinyint(1) NOT NULL default '0',
  `sug_url_test` varchar(100) NOT NULL default '',
  `sug_url_elo` varchar(100) NOT NULL default '',
  `sug_id_parent` int(10) unsigned NOT NULL default '0',
  `sug_required` tinyint(1) NOT NULL default '0',
  `sug_signout` tinyint(1) NOT NULL default '0',
  `sug_load` smallint(4) NOT NULL default '0',
  `sug_reward` smallint(4) unsigned NOT NULL default '0',
  `sug_type` enum('','A') NOT NULL default '',
  `sug_alert_days` smallint(4) unsigned NOT NULL default '0',
  `sug_sequence` smallint(6) unsigned NOT NULL default '0',
  `is_active` tinyint(1) NOT NULL default '1',
  `create_date` int(10) unsigned NOT NULL default '0',
  `create_usr_id` int(10) unsigned NOT NULL default '0',
  `create_src_id` int(10) unsigned NOT NULL default '1',
  `update_date` int(10) unsigned NOT NULL default '0',
  `update_usr_id` int(10) unsigned NOT NULL default '0',
  `update_src_id` int(10) unsigned NOT NULL default '1',
  `jbl_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sug_id`),
  KEY `sug_short` (`sug_short`),
  KEY `sug_code` (`sug_code`),
  KEY `catalog_children` (`adm_id`,`is_active`,`sug_id_parent`),
  KEY `sug_title` (`sug_title`),
  KEY `tra_id` (`tra_id`),
  KEY `sub_id` (`sub_id`),
  KEY `ali_id` (`ali_id`),
  KEY `jbl_id` (`jbl_id`),
  FULLTEXT KEY `sug_description` (`sug_description`),
  FULLTEXT KEY `sug_prerequisites` (`sug_prerequisites`),
  FULLTEXT KEY `sug_materials` (`sug_materials`),
  FULLTEXT KEY `sug_directions` (`sug_directions`),
  FULLTEXT KEY `sug_knowledge` (`sug_knowledge`)
) TYPE=MyISAM COMMENT='Suggestions';
