<?php
/**
 * Upgrade Studiewijzer
 *
 * $Author: jebbol $
 * $Revision: 1.3 $ 
 * $Date: 2006/08/24 17:34:37 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

// Administration settings
include_once($SPL_CFG['dirroot'].'/inc/settings.adm.php');

// System settings
include_once($SPL_CFG['dirroot'].'/inc/settings.sys.php');

// User settings
include_once($SPL_CFG['dirroot'].'/inc/settings.usr.php');

//=========================================================================
// Get version information 
//=========================================================================

$query = 'SELECT cfg_value FROM '.$SPL_CFG['prefix'].'cfg cfg WHERE cfg_name = "spl_version_major" LIMIT 1';
$result = db_retrieve(db_query($query));
$major = isset($result['cfg_value'])?$result['cfg_value']:0; 

$query = 'SELECT cfg_value FROM '.$SPL_CFG['prefix'].'cfg cfg WHERE cfg_name = "spl_version_minor" LIMIT 1';
$result = db_retrieve(db_query($query));
$minor = isset($result['cfg_value'])?$result['cfg_value']:0; 

$query = 'SELECT cfg_value FROM '.$SPL_CFG['prefix'].'cfg cfg WHERE cfg_name = "spl_version_patch" LIMIT 1';
$result = db_retrieve(db_query($query));
$patch = isset($result['cfg_value'])?$result['cfg_value']:0; 

$version = (int)($major.$minor.$patch);

//=========================================================================
// Upgrade to version 0.12 
//=========================================================================
if ($version < 12) {

  // Set catalog parent id
  echo 'Bijwerken catalogus parent_id... ';
  $query  = 'SELECT cat_id,sug_id_parent,sug_type FROM '.$SPL_CFG['prefix'].'cat cat LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = cat.sug_id';
  $query .= ' WHERE cat_id_parent = "0"';
  $result = db_query($query);
  $cat_id = 0;
  while ($row = db_fetch_array($result)) {
    if ($row['sug_type']!='A'){
      $cat_id = $row['cat_id'];
      continue;
    }  
    $modify  = 'UPDATE '.$SPL_CFG['prefix'].'cat';
    $modify .= ' SET cat_id_parent = "'.$cat_id.'"';
    $modify .= ' WHERE cat_id = "'.$row['cat_id'].'"';
    db_query($modify);
  }
  echo '[klaar]<br>';
  
  // Update catalog schema
  echo 'Bijwerken catalogus tabel definities... ';
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."_cat` ADD INDEX `ins_id` ( `ins_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `ina_id` ( `ina_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `tra_id` ( `tra_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `ali_id` ( `ali_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `sub_id` ( `sub_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `prd_id_start` ( `prd_id_start` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `cat_courseyear_start` ( `cat_courseyear_start` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `cat_week_start` ( `cat_week_start` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cat` ADD INDEX `create_usr_id` ( `create_usr_id` )");
  echo '[klaar]<br>';
  
  // Update suggestion schema
  echo 'Bijwerken suggestie tabel definities... ';
  $query = "ALTER TABLE `".$SPL_CFG['prefix']."sug` 
            ADD `tra_id` INT UNSIGNED NOT NULL COMMENT 'Proposed training' AFTER `lst_id` ,
            ADD `ali_id` INT UNSIGNED NOT NULL COMMENT 'Proposed alignment' AFTER `tra_id`,
            ADD `sub_id` INT UNSIGNED NOT NULL COMMENT 'Proposed subject' AFTER `ali_id` ,
            ADD `sug_courseyear` TINYINT( 2 ) UNSIGNED NOT NULL COMMENT 'Proposed courseyear' AFTER `sub_id`";
  db_query($query);
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD INDEX `tra_id` ( `tra_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD INDEX `ali_id` ( `ali_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD INDEX `sub_id` ( `sub_id` )");
  echo '[klaar]<br>';

  // Update configuration
  echo 'Bijwerken configuratie... ';
  db_query("INSERT INTO `".$SPL_CFG['prefix']."cfg` ( `cfg_name` , `cfg_value` ) VALUES ('tinymce_version', '1.43')");
  db_query("INSERT INTO `".$SPL_CFG['prefix']."cfg` ( `cfg_name` , `cfg_value` ) VALUES ('jaxcalendar_version', '1.34')");
  db_query("INSERT INTO `".$SPL_CFG['prefix']."cfg` ( `cfg_name` , `cfg_value` ) VALUES ('ezpdf_version', '009e')");
  db_query("INSERT INTO `".$SPL_CFG['prefix']."cfg` ( `cfg_name` , `cfg_value` ) VALUES ('rc4crypt_version', '3.0')");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '22' WHERE `cfg_name` = 'db_version' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '0'  WHERE `cfg_name` = 'spl_version_major' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '1'  WHERE `cfg_name` = 'spl_version_minor' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '2'  WHERE `cfg_name` = 'spl_version_patch' LIMIT 1");
  echo '[klaar]<br>';
  
  $major = "0";
  $minor = "1";
  $patch = "2";
  $version = (int)($major.$minor.$patch);

} // End upgrade to version 12

//=========================================================================
// Upgrade to version 0.13 
//=========================================================================
if ($version < 13) {

  echo 'Tabellen klaarmaken voor gebruik van de Studiewijzer Bibliotheek... ';
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tra` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tra` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tra` ADD `tra_code` VARCHAR( 10 ) NOT NULL AFTER `tra_short`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tra` ADD INDEX ( `tra_code` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ali` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ali` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usp` ADD `usp_fontsize` ENUM( 'smallest', 'small', 'normal', 'larger', 'largest', 'huge' ) NOT NULL DEFAULT 'normal' AFTER `usp_menumode` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sub` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sub` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."lan` ADD `jbl_id` INT UNSIGNED NOT NULL COMMENT 'Global Library ID'");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."lan` ADD `lan_iso` VARCHAR( 2 ) NOT NULL AFTER `lan_code`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."lan` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_url_schedule_group` VARCHAR( 100 ) NOT NULL AFTER `ina_methodology`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_url_schedule_teacher` VARCHAR( 100 ) NOT NULL AFTER `ina_url_schedule_group`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_url_schedule_student` VARCHAR( 100 ) NOT NULL AFTER `ina_url_schedule_teacher`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_url_schedule_room` VARCHAR( 100 ) NOT NULL AFTER `ina_url_schedule_student`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."stu` ADD `stu_sisnr` VARCHAR( 25 ) NOT NULL AFTER `stu_dispname`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."stu` ADD `stu_grp_id_schedule` INT UNSIGNED NOT NULL AFTER `stu_sisnr`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tea` ADD `tea_schedulename` VARCHAR( 25 ) NOT NULL AFTER `tea_dispname`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cou` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."cou` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."fmt` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."fmt` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."lst` ADD `jbl_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."lst` ADD INDEX ( `jbl_id` )");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."tes` ADD INDEX ( `tea_id` )");

  echo '[klaar]<br>';

  // Update configuration
  echo 'Bijwerken configuratie... ';
  //db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '2.0.1' WHERE `cfg_name` = 'tinymce_version' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '0'  WHERE `cfg_name` = 'spl_version_major' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '1'  WHERE `cfg_name` = 'spl_version_minor' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '3'  WHERE `cfg_name` = 'spl_version_patch' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '23' WHERE `cfg_name` = 'db_version' LIMIT 1");
  
  echo '[klaar]<br>';
  
  $major = "0";
  $minor = "1";
  $patch = "3";
  $version = (int)($major.$minor.$patch);

} // End of upgrade to 0.13

//=========================================================================
// Upgrade to version 0.14 
//=========================================================================
if ($version < 14) {

  echo 'Tabellen bijwerken... ';
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` CHANGE `adm_desc` `adm_name` VARCHAR( 100 ) NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` CHANGE `adm_short` `adm_short` VARCHAR( 15 ) NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `adm_code` VARCHAR( 10 ) NOT NULL AFTER `adm_short`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `is_active` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1'");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `create_date` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `create_usr_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `create_src_id` INT UNSIGNED NOT NULL DEFAULT '1'");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `update_date` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `update_usr_id` INT UNSIGNED NOT NULL");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."adm` ADD `update_src_id` INT UNSIGNED NOT NULL DEFAULT '1'");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usp` ADD `usp_skin` VARCHAR( 25 ) NOT NULL DEFAULT 'default' AFTER `usp_fontsize` ;");
  db_query("CREATE TABLE `".$SPL_CFG['prefix']."ast` (`ast_id` int(10) unsigned NOT NULL auto_increment,`ast_name` varchar(50) NOT NULL default '',`ast_short` varchar(15) NOT NULL default '',`ast_code` varchar(10) NOT NULL default '',`ast_type` enum('free','text','number','boolean','list') NOT NULL default 'free',`ast_min` int(10) unsigned NOT NULL default '0',`ast_max` int(10) unsigned NOT NULL default '9999999',`ast_values` text NOT NULL,`is_active` tinyint(1) unsigned NOT NULL default '1',`create_date` int(10) unsigned NOT NULL default '0',`create_usr_id` int(10) unsigned NOT NULL default '0',`create_src_id` int(10) unsigned NOT NULL default '1',`update_date` int(10) unsigned NOT NULL default '0',`update_usr_id` int(10) unsigned NOT NULL default '0',`update_src_id` int(10) unsigned NOT NULL default '1', PRIMARY KEY  (`ast_id`), KEY `ast_name` (`ast_name`), KEY `ast_short` (`ast_short`), KEY `ast_code` (`ast_code`)) ENGINE=MyISAM COMMENT='Assessment type'");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sgd` ADD `ast_id` INT UNSIGNED NOT NULL COMMENT 'Assesment type' AFTER `sgd_compliment`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sgd` ADD `sgd_assessment` VARCHAR( 50 ) NOT NULL COMMENT 'Assessment' AFTER `ast_id`");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sgd` ADD `sgd_assessment_date` INT( 10 ) UNSIGNED NOT NULL AFTER `sgd_assessment` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sgd` ADD INDEX ( `sgd_assessment_date` ) ");
  db_query("CREATE TABLE `".$SPL_CFG['prefix']."men` (`men_id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,`adm_id` INT UNSIGNED NOT NULL ,`ins_id` INT UNSIGNED NOT NULL ,`ina_id` INT UNSIGNED NOT NULL ,`men_dispname` VARCHAR( 25 ) NOT NULL ,`men_sortname` VARCHAR( 25 ) NOT NULL ,`men_rebuild_spm` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0',`is_active` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1',`create_date` INT UNSIGNED NOT NULL ,`create_usr_id` INT UNSIGNED NOT NULL ,`create_src_id` INT UNSIGNED NOT NULL DEFAULT '1',`update_date` INT UNSIGNED NOT NULL ,`update_usr_id` INT UNSIGNED NOT NULL ,`update_src_id` INT UNSIGNED NOT NULL DEFAULT '1', KEY `adm_id` (`adm_id`), KEY `ins_id` (`ins_id`), KEY `ina_id` (`ina_id`), KEY `men_sortname` (`men_sortname`), KEY `men_dispname` (`men_dispname`)) TYPE = MYISAM COMMENT = 'Mentor';");
  db_query("CREATE TABLE `".$SPL_CFG['prefix']."par` (`par_id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,`adm_id` INT UNSIGNED NOT NULL ,`par_dispname` VARCHAR( 25 ) NOT NULL ,`par_sortname` VARCHAR( 25 ) NOT NULL ,`is_active` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1',`create_date` INT UNSIGNED NOT NULL ,`create_usr_id` INT UNSIGNED NOT NULL ,`create_src_id` INT UNSIGNED NOT NULL DEFAULT '1',`update_date` INT UNSIGNED NOT NULL ,`update_usr_id` INT UNSIGNED NOT NULL ,`update_src_id` INT UNSIGNED NOT NULL DEFAULT '1', KEY `adm_id` (`adm_id`), KEY `par_sortname` (`par_sortname`), KEY `par_dispname` (`par_dispname`)) TYPE = MYISAM COMMENT = 'Parent';");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usr` ADD `men_id` INT UNSIGNED NOT NULL AFTER `tea_id` , ADD `par_id` INT UNSIGNED NOT NULL AFTER `men_id` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usr` ADD INDEX ( `men_id` ) ");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usr` ADD INDEX ( `par_id` ) ");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."usr` ADD `usr_msn` VARCHAR( 50 ) NOT NULL AFTER `usr_email` , ADD `usr_skype` VARCHAR( 50 ) NOT NULL AFTER `usr_msn` , ADD `usr_phone` VARCHAR( 25 ) NOT NULL AFTER `usr_skype` ;");
  echo '[klaar]<br>';
   
  echo 'Bijwerken configuratie... ';
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '2.0.6.1' WHERE `cfg_name` = 'tinymce_version' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '0'  WHERE `cfg_name` = 'spl_version_major' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '1'  WHERE `cfg_name` = 'spl_version_minor' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '4'  WHERE `cfg_name` = 'spl_version_patch' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '24' WHERE `cfg_name` = 'db_version' LIMIT 1");
  echo '[klaar]<br>';

  $major = "0";
  $minor = "1";
  $patch = "4";
  $version = (int)($major.$minor.$patch);

} // End of upgrade to 0.14

//=========================================================================
// Upgrade to version 0.15 
//=========================================================================
if ($version < 15) {

  echo 'Tabellen bijwerken... ';
  db_query("CREATE TABLE `".$SPL_CFG['prefix']."tsu` (`tsu_id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,`tea_id` INT UNSIGNED NOT NULL ,`adm_id` INT(10) UNSIGNED NOT NULL default '1' ,`ins_id` INT(10) UNSIGNED NOT NULL ,`ina_id` INT(10) UNSIGNED NOT NULL ,`tra_id` INT(10) UNSIGNED NOT NULL ,`ali_id` INT(10) UNSIGNED NOT NULL ,`sub_id` INT(10) UNSIGNED NOT NULL ,`tsu_courseyear` TINYINT( 2 ) UNSIGNED NOT NULL,`is_active` tinyint(1) unsigned NOT NULL default '1',`create_date` int(10) unsigned NOT NULL default '0',`create_usr_id` int(10) unsigned NOT NULL default '0',`create_src_id` int(10) unsigned NOT NULL default '1',`update_date` int(10) unsigned NOT NULL default '0',`update_usr_id` int(10) unsigned NOT NULL default '0',`update_src_id` int(10) unsigned NOT NULL default '1' ,INDEX ( `tea_id` ), INDEX ( `ins_id` ), INDEX ( `ina_id` ), INDEX ( `tra_id` ), INDEX ( `ali_id` ), INDEX ( `sub_id` )) TYPE = MYISAM");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."stu` ADD `stu_entryyear` TINYINT( 4 ) UNSIGNED NOT NULL DEFAULT '1' AFTER `stu_courseyear` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sug` ADD `sug_alert_days` SMALLINT( 4 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `sug_type` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."sgd` ADD `is_alerted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `is_changed` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_email` VARCHAR( 50 ) NOT NULL AFTER `ina_short` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_alerttext` TEXT NOT NULL AFTER `ina_url_schedule_room` ;");
  db_query("ALTER TABLE `".$SPL_CFG['prefix']."ina` ADD `ina_alerttext_fmt` TEXT NOT NULL AFTER `ina_alerttext`  ;");

  echo 'Bijwerken configuratie... ';
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '0'  WHERE `cfg_name` = 'spl_version_major' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '1'  WHERE `cfg_name` = 'spl_version_minor' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '5'  WHERE `cfg_name` = 'spl_version_patch' LIMIT 1");
  db_query("UPDATE `".$SPL_CFG['prefix']."cfg` SET `cfg_value` = '25' WHERE `cfg_name` = 'db_version' LIMIT 1");
  echo '[klaar]<br>';

  $major = "0";
  $minor = "1";
  $patch = "5";
  $version = (int)($major.$minor.$patch);

} // End of upgrade to 0.15

// End of install
echo 'Installatie van versie '.$major.'.'.$minor.$patch.' is voltooid';

/**
 * $Log: upgrade.php,v $
 * Revision 1.3  2006/08/24 17:34:37  jebbol
 * Added support for alerts in release 0.15
 *
 * Revision 1.2  2006/08/08 06:22:34  jebbol
 * Added upgrade to version 0.15
 *
 * Revision 1.1  2006/04/17 07:27:39  jebbol
 * Renamed install.php to upgrade.php and updated the tinyMCE version
 *
 */
 
?>
