<?php
/**
 * Catalog class.
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/08/08 14:19:36 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {$SPL_CFG['dirroot'] = '..';}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class cat extends abstractData {
  
  function cat() {
    
    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['cat_id'] = (int) 0;
    $this->_data['adm_id'] = $_SESSION['adm_id'];
    $this->_data['ins_id'] = $this->_getDefault('ins');
    $this->_data['ina_id'] = $this->_getDefault('ina');
    $this->_data['tra_id'] = $this->_getDefault('tra');
    $this->_data['ali_id'] = $this->_getDefault('ali');
    $this->_data['sub_id'] = $this->_getDefault('sub');
    $this->_data['cat_courseyear_start'] = (int) 0;
    $this->_data['cat_courseyear_end'] = (int) 0;
    $this->_data['prd_id_start'] = (int) 0;
    $this->_data['cat_month_start'] = (int) 0;
    $this->_data['cat_week_start'] = (int) 0;
    $this->_data['cat_day_start'] = (int) 0;
    $this->_data['prd_id_end'] = (int) 0;
    $this->_data['cat_month_end'] = (int) 0;
    $this->_data['cat_week_end'] = (int) 0;
    $this->_data['cat_day_end'] = (int) 0;
    $this->_data['cat_sequence'] = (int) 0;
    $this->_data['sug_id'] = (int) 0;
    $this->_data['fmt_id'] = (int) 0;
    $this->_data['cat_id_parent'] = (int) 0;
    $this->_data['cat_valid_from'] = (int) 0;
    $this->_data['cat_valid_until'] = (int) 4294967295; // Always valid
    $this->_data['show_in_guide'] = (bool) true;
    $this->_data['is_mandatory'] = (bool) false;
    $this->_data['is_active'] = (bool) true;
    $this->_data['create_date'] = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date'] = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'cat_id';
    $this->_table   = 'cat';

    // Set field types
    $this->_type['cat_valid_from'] = array('type'=>'timestamp');
    $this->_type['cat_valid_until'] = array('type'=>'timestamp');

    // Set user permissions for this type of data
    if (!isset($_SESSION[$this->_table.'_permission'])) {
      $_SESSION[$this->_table.'_permission'] = $this->_getPermissions();
    }
        
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /**
   * Retrieve the suggestion from a parent catalog item
   * 
   * @return integer The suggestion id
   * @access public
   */
  function getParentSuggestion() {

    global $SPL_CFG;
    
    if ((int)$this->_data['cat_id_parent']==0){
      return 0;
    }
    
    $query  = 'SELECT sug_id FROM '.$SPL_CFG['prefix'].'cat';
    $query .= ' WHERE adm_id = "'.$_SESSION['adm_id'].'" AND';
    $query .= ' cat_id = "'.$this->_data['cat_id_parent'].'" LIMIT 1';
    $result = db_fetch_array(db_query($query));
    if (isset($result['sug_id'])){
      return (int)$result['sug_id'];
    }
    
    return 0; 

  }
  
  /**
   * Returns data for printing a report
   * 
   * @return (array) The data to print
   * @public
   */
  function getReportData() {
    
    global $SPL_CFG;
    
    // Core objects
    include_once($SPL_CFG['dirroot'].'/class/ins.class.php');
    include_once($SPL_CFG['dirroot'].'/class/ina.class.php');

    // Methodology objects
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');


    // Institution
    $singleIns = false;
    $ins = new ins();
    $singleIns = $ins->isSingle();

    // Institution address
    $singleIna = false;
    $ina = new ina();
    $singleIna = $ina->isSingle();

    // Training
    $singleTra = false;
    $tra = new tra();
    $singleTra = $tra->isSingle();

    // Alignments
    $singleAli = false;
    $ali = new ali();
    $singleAli = $ali->isSingle();


    $query  = 'SELECT '.((!$singleIns)?'ins_code,':'').((!$singleIna)?'ina_code,':'').((!$singleTra)?'tra_code,':'').((!$singleAli)?'ali_code,':'').'sub_code,cat_courseyear_start AS courseyear,prd_id_start AS period,cat_week_start AS week,sug_title';
    $query .= ' FROM '.$SPL_CFG['prefix'].'cat cat'.((!$singleIns)?' LEFT JOIN '.$SPL_CFG['prefix'].'ins ins ON ins.ins_id = cat.ins_id':'').((!$singleIna)?' LEFT JOIN '.$SPL_CFG['prefix'].'ina ina ON ina.ina_id = cat.ina_id':'').((!$singleTra)?' LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = cat.tra_id':'').((!$singleAli)?' LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = cat.ali_id':'').' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = cat.sub_id LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = cat.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = cat.prd_id_start';
    $query .= ' WHERE cat.adm_id = "'.$_SESSION['adm_id'].'"  AND cat.is_active';
    $query .= ' ORDER BY '.((!$singleIns)?'ins_code,':'').((!$singleIna)?'ina_code,':'').((!$singleTra)?'tra_code,':'').((!$singleAli)?'ali_code,':'').'sub_code,cat_courseyear_start,prd_id_start';

    $data = array();
    $result = db_query($query);
    while($data[] = db_retrieve($result)) {}
    return $data;

  }
  

  /** 
   * Saves the instance data to the database
   *
   * @return boolean
   * @access public
   */
  function save() {
    
    global $SPL_CFG;
    
    if (empty($this->_data['cat_courseyear_end'])){
      $this->_data['cat_courseyear_end'] = $this->_data['cat_courseyear_start'];
    }

    if (empty($this->_data['prd_id_end'])){
      $this->_data['prd_id_end'] = $this->_data['prd_id_start'];
    }
    if (empty($this->_data['cat_month_end'])){
      $this->_data['cat_month_end'] = $this->_data['cat_month_start'];
    }
    if (empty($this->_data['cat_week_end'])){
      $this->_data['cat_week_end'] = $this->_data['cat_week_start'];
    }
    if (empty($this->_data['cat_day_end'])){
      $this->_data['cat_day_end'] = $this->_data['cat_day_start'];
    }
    
    // Find out if this item has to be shown in studyguides (default = yes)
    // Set the catalog format to the suggestion format
    $object->_data['show_in_guide'] = (bool) true;
    if (!empty($this->_data['sug_id'])) {
      include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sug.class.php');
      $sug = new sug();
      if ($sug->init($this->_data['sug_id'])) {
        $this->_data['show_in_guide'] = ($sug->show_in_guide());
        $this->_data['fmt_id'] = $sug->getProperty('fmt_id');
      }
    }

    // Prevent double entries
    if ($this->_status['is_new']) {
      if ($this->_exists()) {
        return false;
      }
    }

    parent::save();

    // If the suggestion associated with this catalog item has children,
    // add those children to the catalog as well
    if (!empty($this->_data['sug_id'])) {
      $this->_addChildren();
    }    
  }

  /** 
   * Sets the instance property with the given value.
   * This overrides the function in data.abstract.php, because in case of
   * an 'is_active' property all 'children' will have their state switched as well
   *
   * @param  string  $property The name of the property to be set
   * @param  string  $value    The data to bet set
   * @return boolean Succes or Failure
   * @access public
   */
  function setProperty($property, $value) {
    
    global $SPL_CFG;
    
    $succes = parent::setProperty($property, $value); 
    
    if ($succes){
      
      // Check for is_active
      if ($property=='is_active'){

        // Find all children
        $query  = 'SELECT sug_id FROM '.$SPL_CFG['prefix'].'sug sug WHERE';
        $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
        $query .= ' sug_id_parent = "'.$this->_data['sug_id'].'"';
        $result = db_query($query);
        while ($row = db_fetch_array($result)) {
          // Set catalog children to the same is_active state
          $query  = 'UPDATE '.$SPL_CFG['prefix'].'cat';
          $query .= ' SET is_active = "'.$value.'" WHERE';
          $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
          $query .= ' ins_id = "'.$this->_data['ins_id'].'" AND';
          $query .= ' ina_id = "'.$this->_data['ina_id'].'" AND';
          $query .= ' tra_id = "'.$this->_data['tra_id'].'" AND';
          $query .= ' ali_id = "'.$this->_data['ali_id'].'" AND';
          $query .= ' sub_id = "'.$this->_data['sub_id'].'" AND';
          $query .= ' sug_id = "'.$row['sug_id'].'"';
          $child = db_query($query);
        }
      }
    }

    return $succes;
  }

  //=========================================================================
  // Private methods
  //=========================================================================

  /**
   * Add a suggestions children to the catalog
   */
  function _addChildren() {
    
    global $SPL_CFG;
    
    // Find all children
    $query  = 'SELECT sug_id,sug_type,fmt_id,sug_required FROM '.$SPL_CFG['prefix'].'sug sug WHERE';
    $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
    $query .= ' is_active AND';
    $query .= ' sug_id_parent = "'.$this->_data['sug_id'].'"';
    $query .= ' ORDER BY sug_sequence,sug_title ASC';
    $result = db_query($query);
    while ($row = db_fetch_array($result)) {
      // If there is no catalog entry for this child, add it
      $query  = 'SELECT * FROM  '.$SPL_CFG['prefix'].'cat cat WHERE';
      $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' ins_id = "'.$this->_data['ins_id'].'" AND';
      $query .= ' ina_id = "'.$this->_data['ina_id'].'" AND';
      $query .= ' tra_id = "'.$this->_data['tra_id'].'" AND';
      $query .= ' ali_id = "'.$this->_data['ali_id'].'" AND';
      $query .= ' sub_id = "'.$this->_data['sub_id'].'" AND';
      $query .= ' cat_courseyear_start = "'.$this->_data['cat_courseyear_start'].'" AND';
      $query .= ' cat_courseyear_end = "'.$this->_data['cat_courseyear_end'].'" AND';
      $query .= ' sug_id = "'.$row['sug_id'].'"';
      $existing_rows = db_query($query);
      if (db_num_rows($existing_rows)>0) {
        // SPL_TODO: Modify the existing rows when their dates have not been set
      }
      else {
        // Add a catalog item
        $child = new cat();
        foreach ($this->_data as $property => $value) {
          if ($property != 'cat_id') {
            $child->_data[$property] = $value;
          }
        }
        $child->_data['cat_id_parent'] = $this->_data['cat_id'];
        $child->_data['sug_id']        = $row['sug_id'];
        $child->_data['show_in_guide'] = ($row['sug_type']=='A');
        $child->_data['fmt_id']        = $row['fmt_id'];
        $child->_data['is_mandatory']  = $row['sug_required'];
        $child->_status['is_dirty']    = (bool) true;
        $child->save();
      }
    }
    
  } 

  /** 
   * Deletes a row from the database.
   * Override the default behaviour by adding the removal of child records
   * 
   * @return boolean Success or Failure
   * @access protected
   * @uses   array   $SPL_CFG Global configuration data
   */
  function _delete() {
    
    global $SPL_CFG;
    
    // No need to check if the catalog item is in use. The catalog is used in:
    // - Studyguide to build it initially,
    // - Suggestion to build the unique key list.
    // Both will function correctly without a corresponding catalog row
    
    $succes = parent::_delete();
    
    if ($succes) {
      $query  = 'DELETE FROM '.$SPL_CFG['prefix'].'cat WHERE';
      $query .= ' cat_id_parent = "'.$this->_data['cat_id'].'"'; 
      $result = db_query($query);
    }
    
    return $succes;
  }


  /**
   * Check for double entries in the catalog
   * 
   * @return boolean True if the entry already exists
   */
  function _exists() {
    
    global $SPL_CFG;
    
    $query  = 'SELECT cat_id FROM '.$SPL_CFG['prefix'].'cat WHERE';
    $query .= ' adm_id = "'.$this->_data['adm_id'].'" AND';
    $query .= ' ins_id = "'.$this->_data['ins_id'].'" AND';
    $query .= ' ina_id = "'.$this->_data['ina_id'].'" AND';
    $query .= ' tra_id = "'.$this->_data['tra_id'].'" AND';
    $query .= ' ali_id = "'.$this->_data['ali_id'].'" AND';
    $query .= ' sub_id = "'.$this->_data['sub_id'].'" AND';
    $query .= ' cat_courseyear_start = "'.$this->_data['cat_courseyear_start'].'" AND';
    $query .= ' sug_id = "'.$this->_data['sug_id'].'"';
    $result = db_query($query);
    if (db_num_rows($result)>0) {
      // Catalog entry already exists
      array_push($this->_msg, 'cat_warning_exists');
      return true;
    }
    return false;    
    
  }

  /**
   * Get default settings
   */
  function _getDefault($className) {
    
    global $SPL_CFG;
    
    // Institution
    if ($className=='ins'){
      // User preferences
      if (isset($_SESSION['usp_ins_id']) && $_SESSION['usp_ins_id']>0){
        return $_SESSION['usp_ins_id'];
      }
      // Session
      if (isset($_SESSION['ins_id']) && $_SESSION['ins_id']>0){
        return $_SESSION['ins_id'];
      }
      // First active record in the database
      $query = 'SELECT ins_id FROM '.$SPL_CFG['prefix'].'ins WHERE adm_id = "'.$_SESSION['adm_id'].'" AND is_active LIMIT 1';
      $result = db_retrieve(db_query($query));
      if (isset($result['ins_id'])){
        return $result['ins_id'];
      }
    }

    // Institution address
    if ($className=='ina'){
      // User preferences
      if (isset($_SESSION['usp_ina_id']) && $_SESSION['usp_ina_id']>0){
        return $_SESSION['usp_ina_id'];
      }
      // Session
      if (isset($_SESSION['ina_id']) && $_SESSION['ina_id']>0){
        return $_SESSION['ina_id'];
      }
      // First active record in the database
      $query  = 'SELECT ina_id FROM '.$SPL_CFG['prefix'].'ina ina, '.$SPL_CFG['prefix'].'apl apl WHERE ';
      $query .= 'ina.adm_id = "'.$_SESSION['adm_id'].'" AND ';
      $query .= 'ina.is_active AND ';
      $query .= 'apl.adm_id = "'.$_SESSION['adm_id'].'" AND ';
      $query .= 'apl.is_active AND ';
      $query .= 'apl.apl_parent = "ins" AND ';
      $query .= 'apl.parent_id = "'.$this->_data['ins_id'].'" AND ';
      $query .= 'apl.apl_valid_from <= "'.time().'" AND ';
      $query .= 'apl.apl_valid_until >= "'.time().'" ';
      $query .='ORDER BY apl.apl_sequence ASC LIMIT 1';
      $result = db_retrieve(db_query($query));
      if (isset($result['ina_id'])){
        return $result['ina_id'];
      }
    }

    // Training
    if ($className=='tra'){
      // User preferences
      if (isset($_SESSION['usp_tra_id']) && $_SESSION['usp_tra_id']>0){
        return $_SESSION['usp_tra_id'];
      }
      // Session
      if (isset($_SESSION['tra_id']) && $_SESSION['tra_id']>0){
        return $_SESSION['tra_id'];
      }
    }

    // If none of the above, return zero
    return (int)0;

  }

}

/**
 * $Log: cat.class.php,v $
 * Revision 1.10  2006/08/08 14:19:36  jebbol
 * Added reporting capabilities
 *
 * Revision 1.9  2006/05/30 12:26:12  jebbol
 * Corrected a typo (used cat_day_start twice insetad of cat_day_end
 *
 */
?>