<?php
/**
 * Subjects class.
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: sub.class.php,v 1.4 2005/12/13 20:42:40 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {$SPL_CFG['dirroot'] = '../../..';}

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/data.abstract.php');


//=========================================================================
// Class definition
//=========================================================================

class sub extends abstractData {
  
  function sub() {

    // Call the parent's constructor in order to set the defaults
    parent::abstractData();
    
    // Create an empty instance
    $this->_data['sub_id']        = (int) 0;
    $this->_data['adm_id']        = $_SESSION['adm_id'];
    $this->_data['sub_name']      = '';
    $this->_data['sub_short']     = '';
    $this->_data['sub_code']      = '';
    $this->_data['is_active']     = (bool) true;
    $this->_data['create_date']   = time();
    $this->_data['create_usr_id'] = $_SESSION['usr_id'];
    $this->_data['create_src_id'] = $_SESSION['native_id'];
    $this->_data['update_date']   = time();
    $this->_data['update_usr_id'] = $_SESSION['usr_id'];
    $this->_data['update_src_id'] = $_SESSION['native_id'];
    
    // Register the required class properties
    $this->_primary = 'sub_id';
    $this->_table   = 'sub';
    $this->_name    = 'sub_name';
    
    // Register properties that must have a value
    $this->_required[] = $this->_name;

    // Set user permissions for this type of data
    if (!isset($_SESSION[$this->_table.'_permission'])) {
      $_SESSION[$this->_table.'_permission'] = $this->_getPermissions();
    }

  }
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Sets the instance property with the given value.
   * This overrides the function in data.abstract.php, because in case of
   * an 'is_active' property all 'referees' will have their state switched as well
   *
   * @param  string  $property The name of the property to be set
   * @param  string  $value    The data to bet set
   * @return boolean Succes or Failure
   * @access public
   */
  function setProperty($property, $value) {
    
    global $SPL_CFG;
    
    $succes = parent::setProperty($property, $value); 
    
    if ($succes){

      if ($property=='is_active') {

        // Switch state in the catalog
        $query  = 'UPDATE '.$SPL_CFG['prefix'].'cat';
        $query .= ' SET is_active = "'.$value.'" WHERE';
        $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
        $query .= ' sub_id = "'.$this->_data['sub_id'].'"';
        $result = db_query($query);
      
        // Remove default subject from the suggestion
        if (!$value){
          $query  = 'UPDATE '.$SPL_CFG['prefix'].'sug';
          $query .= ' SET sub_id = 0 WHERE';
          $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
          $query .= ' sub_id = "'.$this->_data['sub_id'].'"';
          $result = db_query($query);
        }

      }

    }
  }

  //=========================================================================
  // Private methods
  //=========================================================================

  /** 
   * Deletes a row from the database.
   * Override the default behaviour by adding the removal of child records
   * 
   * @return boolean Success or Failure
   * @access protected
   * @uses   array   $SPL_CFG Global configuration data
   */
  function _delete() {
    
    global $SPL_CFG;
    
    $succes = parent::_delete();
    
    if ($succes) {
      $query  = 'DELETE FROM '.$SPL_CFG['prefix'].'cat WHERE';
      $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' sub_id = "'.$this->_data['sub_id'].'"';
      $result = db_query($query);

      $query  = 'UPDATE '.$SPL_CFG['prefix'].'sug';
      $query .= ' SET sub_id = 0 WHERE';
      $query .= ' adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' sub_id = "'.$this->_data['sub_id'].'"';
      $result = db_query($query);

    }
    
    return $succes;
  }

}

?>