<?php
/**
 * Teacher class 
 *
 * $Author: jebbol $
 * $Revision: 1.12 $
 * $Date: 2006/08/28 09:14:59 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

if (!isset($SPL_CFG['dirroot'])) {$SPL_CFG['dirroot'] = '../../..';}

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Abstract data class
include_once($SPL_CFG['dirroot'].'/class/tea.abstract.php');

//=========================================================================
// Class definition
//=========================================================================

class tea extends abstractTea {

  function tea() {
    
    // Call the parent's constructor in order to set the defaults
    parent::abstractTea();
  }

  //=========================================================================
  // Public functions
  //=========================================================================

  /** 
   * Adds a group to the teacher
   *
   * @access public
   */
  function addGroup($grpId,$sortName='') {

    global $SPL_CFG;
    
    $query = 'INSERT INTO '.$SPL_CFG['prefix'].'apl';
    $query .= ' (apl_id,adm_id,apl_parent,parent_id,apl_child,child_id,apl_sequence,apl_code,apl_valid_from,apl_valid_until,is_active)';
    $query .= ' VALUES (null,"'.$_SESSION['adm_id'].'","grp","'.$grpId.'","tea","'.$this->_data['tea_id'].'","0","'.$sortName.'","'.time().'","'.(time()+(60*60*24*356)).'","1")';
    $result = db_query($query);

  }

  /** 
   * Adds a student to the teacher
   *
   * @access public
   */
  function addStudent($stuId,$sortName='') {

    global $SPL_CFG;
    
    $query = 'INSERT INTO '.$SPL_CFG['prefix'].'apl';
    $query .= ' (apl_id,adm_id,apl_parent,parent_id,apl_child,child_id,apl_sequence,apl_code,apl_valid_from,apl_valid_until,is_active)';
    $query .= ' VALUES (null,"'.$_SESSION['adm_id'].'","tea","'.$this->_data['tea_id'].'","stu","'.$stuId.'","0","'.$sortName.'","'.time().'","'.(time()+(60*60*24*356)).'","1")';
    $result = db_query($query);

  }

  /** 
   * Ends the teachers group membership
   *
   * @access public
   */
  function deleteGroups() {

    global $SPL_CFG;
    
    $query =  'UPDATE '.$SPL_CFG['prefix'].'apl';
    $query .= ' SET apl_valid_until = "'.time().'", is_active = "0"';
    $query .= ' WHERE adm_id = "'.$_SESSION['adm_id'].'"';
    $query .= ' AND apl_parent = "grp"';
    $query .= ' AND apl_child = "tea"';
    $query .= ' AND child_id = "'.$this->_data['tea_id'].'"';
    $result = db_query($query);

  }

  /** 
   * Deletes the teachers students
   *
   * @access public
   */
  function deleteStudents() {

    global $SPL_CFG;
    
    $query =  'DELETE FROM '.$SPL_CFG['prefix'].'apl';
    $query .= ' WHERE adm_id = "'.$_SESSION['adm_id'].'"';
    $query .= ' AND apl_parent = "tea"';
    $query .= ' AND apl_child = "stu"';
    $query .= ' AND parent_id = "'.$this->_data['tea_id'].'"';
    $result = db_query($query);

  }


  /** 
   * Returns the teachers preferred alignments.
   * If no preferred alignments can be found, all alignments will be returned
   *
   * @param  $valueType string Indicates the type of value to return (long,short,code)
   * @param  $traID     int    Limits the addresses to those associated with this institution
   * @return array A list of addresses (key,value)
   * @access public
   */
  function getAlignments($valueType='long',$traID=0) {

    global $SPL_CFG;
    
    $values = array();
    $field = 'ali_name';
    if ($valueType=='short'){$field = 'ali_short';}
    if ($valueType=='code') {$field = 'ali_code';}

    // Find preferred institution addresses
    $query  = 'SELECT ali.ali_id as "key",ali.'.$field.' as "value"';
    $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = apl.child_id';
    $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active';
    $query .= ' AND apl.apl_parent = "tea"';
    $query .= ' AND apl.parent_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl.apl_child = "ali"';
    $query .= ' AND apl.apl_valid_from <= "'.time().'"';
    $query .= ' AND (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
    $query .= ' ORDER BY apl.apl_sequence ASC';
    $result = db_query($query);
    
    // If no preferred trainings have been found, return all trainings
    if (db_num_rows($result)==0){
      include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
      $ali = new ali();
      $ali->_name = $field;
      return $ali->getKeyValues('tra',($traID>0?$traID:false),false,'ASC');
    }
    
    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;
  }

  /** 
   * Returns the teachers groups
   *
   * @param  $valueType string Indicates the type of value to return (long,short,code)
   * @return array A list of groups (key,value)
   * @access public
   */
  function getGroups($valueType='long') {

    global $SPL_CFG;
    
    $values = array();
    $field = 'grp_name';
    if ($valueType=='short'){$field = 'grp_short';}
    if ($valueType=='code') {$field = 'grp_code';}

    $query  = 'SELECT grp.grp_id as "key",grp.'.$field.' as "value"';
    $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'grp grp ON grp.grp_id = apl.parent_id';
    $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active AND grp.is_active';
    $query .= ' AND apl.apl_parent = "grp"';
    $query .= ' AND apl.apl_child = "tea"';
    $query .= ' AND apl.child_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl.apl_valid_from <= "'.time().'"';
    $query .= ' AND (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
    $query .= ' ORDER BY grp.'.$field.' ASC';
    $result = db_query($query);
    
    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;
  }

  /** 
   * Returns the teachers students
   *
   * @return array A list of students (key,value)
   * @access public
   */
  function getStudents($grp_id=0,$displayField='stu_dispname',$sortField='stu_sortname',$exclude=null) {

    global $SPL_CFG;
    
    $values = array();
    
    $query  = 'SELECT stu.stu_id as "key",stu.'.$displayField.' as "value"';
    $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = apl.child_id';
    $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active AND stu.is_active';
    $query .= ' AND apl.apl_parent = "tea"';
    $query .= ' AND apl.apl_child = "stu"';
    $query .= ' AND apl.parent_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl.apl_valid_from <= "'.time().'"';
    $query .= ' AND (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
    $query .= ' ORDER BY stu.'.$sortField.' ASC';
    $result = db_query($query);

    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;

  }

  /** 
   * Returns the teachers students
   *
   * @param  integer $grp_id Group id. When passed, only students of this group are returned
   * @return array A list of students (key,value)
   * @access public
   */
  function guessStudents($grp_id=0) {

    global $SPL_CFG;
    
    $values = array();
    
    // Get students from group
    if ((int)$grp_id>0) {
      $query  = 'SELECT stu.stu_id as "key",stu.stu_dispname as "value"';
      $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = apl.child_id';
      $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active AND stu.is_active';
      $query .= ' AND apl.apl_parent = "grp"';
      $query .= ' AND apl.apl_child = "stu"';
      $query .= ' AND apl.parent_id = "'.$grp_id.'"';
      $query .= ' AND apl.apl_valid_from <= "'.time().'"';
      $query .= ' AND (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
      $query .= ' ORDER BY stu.stu_sortname ASC';
      $result = db_query($query);
    }
    
    // Get students by examining teachers alignements ans subjects
    else {

      // Retrieve the teachers institutions
      $institutions = '';
      $s = $this->getInstitutions();
      foreach ($s as $record) {
        foreach ($record as $key => $item) {
          $institutions .= (strlen($institutions)?',':'');
          $institutions .= $key;
        }
      }

      // Retrieve the teachers institution addresses
      $addresses = '';
      $s = $this->getInstitutionAddresses();
      foreach ($s as $record) {
        foreach ($record as $key => $item) {
          $addresses .= (strlen($addresses)?',':'');
          $addresses .= $key;
        }
      }

      // Retrieve the teachers trainings
      $trainings = '';

      // Retrieve the teachers alignments
      $alignments = '';

      // Retrieve the teachers courseyears
      $courseyears = '';

      // Retrieve the teachers subjects
      $subjects = '';
      $s = $this->getSubjects();
      foreach ($s as $record) {
        foreach ($record as $key => $item) {
          $subjects .= (strlen($subjects)?',':'');
          $subjects .= $key;
        }
      }

      // Find students with one or more of these subjects
      $query  = 'SELECT DISTINCT stu.stu_id as "key",stu.stu_dispname as "value"';
      $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = apl.parent_id';
      $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND';
      $query .= ' apl.is_active AND';
      $query .= ' apl_parent = "stu" AND'; 
      $query .= ' apl_child = "sub" AND';
      if (strlen($subjects)) {
        if (substr_count($subjects, ',')==0){
          $query .= ' apl.child_id = "'.$subjects.'" AND';
        }
        else {
          $query .= ' apl.child_id IN ('.$subjects.') AND';
        }
      }
      if (strlen($institutions)) {
        if (substr_count($institutions, ',')==0){
          $query .= ' stu.ins_id = "'.$institutions.'" AND';
        }
        else {
          $query .= ' stu.ins_id IN ('.$institutions.') AND';
        }
      }
      if (strlen($addresses)) {
        if (substr_count($addresses, ',')==0){
          $query .= ' stu.ina_id = "'.$addresses.'" AND';
        }
        else {
          $query .= ' stu.ina_id IN ('.$addresses.') AND';
        }
      }
      if (strlen($trainings)) {
        if (substr_count($trainings, ',')==0){
          $query .= ' stu.tra_id = "'.$trainings.'" AND';
        }
        else {
          $query .= ' stu.tra_id IN ('.$trainings.') AND';
        }
      }
      if (strlen($alignments)) {
        if (substr_count($alignments, ',')==0){
          $query .= ' stu.ali_id = "'.$alignments.'" AND';
        }
        else {
          $query .= ' stu.ali_id IN ('.$alignments.') AND';
        }
      }
      if (strlen($courseyears)) {
        if (substr_count($courseyears, ',')==0){
          $query .= ' stu.stu_courseyear = "'.$courseyears.'" AND';
        }
        else {
          $query .= ' stu.stu_courseyear IN ('.$courseyears.') AND';
        }
      }
      $query .= ' apl.apl_valid_from <= "'.time().'" AND'; 
      $query .= ' (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
      $query .= ' ORDER BY stu.stu_sortname';
      $result = db_query($query);
    }

    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;
  }

  /** 
   * Returns the teachers subjects
   *
   * @param  $valueType Indicates the type of value to return (long,short,code)
   * @return array A list of subjects (key,value)
   * @access public
   */
  function getSubjects($valueType='long') {

    global $SPL_CFG;
    
    $values = array();
    $field = 'sub_name';
    if ($valueType=='short'){$field = 'sub_short';}
    if ($valueType=='code') {$field = 'sub_code';}

    $query  = 'SELECT sub.sub_id as "key",sub.'.$field.' as "value"';
    $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = apl.child_id';
    $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active';
    $query .= ' AND apl.apl_parent = "tea"';
    $query .= ' AND apl.parent_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl.apl_child = "sub"';
    $query .= ' AND apl.apl_valid_from <= "'.time().'"';
    $query .= ' AND (apl.apl_valid_until = "0" OR apl.apl_valid_until >= "'.time().'")';
    $query .= ' ORDER BY apl.apl_sequence ASC, sub.'.$field.' ASC';
    $result = db_query($query);

    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;
  }

  /** 
   * Returns the teachers preferred trainings.
   * If no preferred trainings can be found, all trainings will be returned
   *
   * @param  $valueType string Indicates the type of value to return (long,short,code)
   * @param  $inaID     int    Limits the addresses to those associated with this institution
   * @return array A list of addresses (key,value)
   * @access public
   */
  function getTrainings($valueType='long',$inaID=0) {

    global $SPL_CFG;
    
    $values = array();
    $field = 'tra_name';
    if ($valueType=='short'){$field = 'tra_short';}
    if ($valueType=='code') {$field = 'tra_short';}

    // Find preferred institution addresses
    $query  = 'SELECT tra.tra_id as "key",tra.'.$field.' as "value"';
    $query .= ' FROM '.$SPL_CFG['prefix'].'apl apl LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = apl.child_id';
    $query .= ' WHERE apl.adm_id = "'.$_SESSION['adm_id'].'" AND apl.is_active';
    $query .= ' AND apl.apl_parent = "tea"';
    $query .= ' AND apl.parent_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl.apl_child = "tra"';
    $query .= ' AND apl.apl_valid_from <= "'.time().'"';
    $query .= ' AND apl.apl_valid_until >= "'.time().'"';
    $query .= ' ORDER BY apl.apl_sequence ASC';
    $result = db_query($query);
    
    // If no preferred trainings have been found, return all trainings
    if (db_num_rows($result)==0){
      include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');
      $tra = new tra();
      $tra->_name = $field;
      return $tra->getKeyValues('ina',($inaID>0?$inaID:false),false,'ASC');
    }
    
    // Construct the valuelist
    while ($row = db_fetch_array($result)) {
      $values[] = array($row['key']=>$row['value']);
    }
    return $values;
  }
  
    /** 
   * Sets the teachers subjects
   *
   * @param  array $subjects An array of subjects to set for the teacher
   * @return boolean Success or Failure
   * @access public
   */
  function setSubjects($subjects=null) {

    global $SPL_CFG;
    
    if (isset($subjects)){
      
      // First delete old subjects first
      $this->unsetSubjects();
      
      // Than insert the new ones
      $seq = (int)0;
      foreach ($subjects as $id){
        // Find subject code
        $query  = 'SELECT sub_code FROM '.$SPL_CFG['prefix'].'sub sub ';
        $query .= 'WHERE sub.adm_id = "'.$_SESSION['adm_id'].'" ';
        $query .= 'AND sub.sub_id = "'.$id.'" LIMIT 1';
        $result = db_retrieve(db_query($query));
        $code = (isset($result['sub_code'])?$result['sub_code']:'');
        
        $seq = $seq + 100;
        $query  = 'INSERT INTO '.$SPL_CFG['prefix'].'apl ';
        $query .= '(apl_id,adm_id,apl_parent,parent_id,apl_child,child_id,apl_sequence,apl_code,apl_valid_from,apl_valid_until,is_active) ';
        $query .= 'VALUES (NULL,';
        $query .= '"'.$_SESSION['adm_id'].'",';
        $query .= '"tea",';
        $query .= '"'.$this->_data['tea_id'].'",';
        $query .= '"sub",';
        $query .= '"'.$id.'",';
        $query .= '"'.$seq.'",';
        $query .= '"'.$code.'",';
        $query .= '"0",';
        $query .= '"0",';
        $query .= '"1")';
        $result = db_query($query);
      }
      
      // Force a rebuild of the student list
      $this->_data['tea_rebuild_spt'] = (bool)true;
      return $this->save();
    }
    
    return (bool)false;
  }
  
  /** 
   * Unsets the teachers subjects
   *
   * @return boolean Success or Failure
   * @access public
   */
  function unsetSubjects() {

    global $SPL_CFG;

    $query  = 'DELETE FROM '.$SPL_CFG['prefix'].'apl';
    $query .= ' WHERE adm_id = "'.$_SESSION['adm_id'].'"';
    $query .= ' AND apl_parent = "tea"';
    $query .= ' AND parent_id = "'.$this->_data['tea_id'].'"';
    $query .= ' AND apl_child = "sub"';
    $result = db_query($query);
    
    return (bool) true;

  }

  //=========================================================================
  // Private functions
  //=========================================================================

  /** 
   * Inserts a new row in the database.
   * 
   * This function will be called by {@link save()} when adding a new instance to the database.
   * 
   * @access private
   * @return boolean Success or Failure
   * @uses   array   $SPL_CFG Global configuration data
   * @uses   array   $SPL_TXT Human language translations
   */
  function _insert() {
    
    global $SPL_CFG;
    
    if (parent::_insert()) {
      // When insert is succesfull, set default authorization
      include_once($SPL_CFG['dirroot'].'/class/usa.class.php');
      
      // Alignment
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','ali');      
      $usa->setProperty('usa_permission','1');   
      $usa->save();   

      // Applicability
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','apl');      
      $usa->setProperty('usa_permission','11');   
      $usa->save();   

      // Calendar
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','cal');      
      $usa->setProperty('usa_permission','11');   
      $usa->save();   

      // Catalog
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','cat');      
      $usa->setProperty('usa_permission','11');      
      $usa->save();   

      // Institution
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','ins');      
      $usa->setProperty('usa_permission','1');      
      $usa->save();   

      // Institution addresses
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','ina');      
      $usa->setProperty('usa_permission','1');      
      $usa->save();   

      // Learning style
      if ($SPL_CFG['learning_style'] != 'false') {
        $usa = new usa();
        $usa->setProperty('usr_id',$this->associatedUser);      
        $usa->setProperty('usa_key','cat');      
        $usa->setProperty('usa_permission','11');      
        $usa->save();
      }   

      // Period
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','prd');      
      $usa->setProperty('usa_permission','1');   
      $usa->save();   

      // Statusses
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','sts');      
      $usa->setProperty('usa_permission','1');   
      $usa->save();   

      // Studyguide
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','sgd');      
      $usa->setProperty('usa_permission','11');   
      $usa->save();   

      // Subjects
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','sub');      
      $usa->setProperty('usa_permission','1');   
      $usa->save();   

      // Suggestions
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','sug');      
      $usa->setProperty('usa_permission','11');   
      $usa->save();   

      // Teachers
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','tea');      
      $usa->setProperty('usa_permission','11');   
      $usa->save();   

      // Training
      $usa = new usa();
      $usa->setProperty('usr_id',$this->associatedUser);      
      $usa->setProperty('usa_key','tra');      
      $usa->setProperty('usa_permission','1');      
      $usa->save();   

    }

  }  

}

/**
 * $Log: tea.class.php,v $
 * Revision 1.12  2006/08/28 09:14:59  jebbol
 * Added default permissions for 'apl' to _insert()
 *
 * Revision 1.11  2006/08/08 14:19:39  jebbol
 * Added reporting capabilities
 *
 */
 
?>
