<?php
/**
 * User interface for manipulating data in a alignment object
 *
 * $Author: jebbol $
 * $Revision: 1.13 $
 * $Date: 2006/08/08 14:21:31 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

$sanitize = array(
  'ali_id'=>array('type'=>'int'),
  'ali_code'=>array('type'=>'char'),
  'ali_name'=>array('type'=>'char'),
  'ali_short'=>array('type'=>'char'),
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new ali();
$editMode = (bool)false;
$searchscript = $SPL_CFG['wwwroot'].'/methodology/traditional/ui/ali_search.php';

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/ali.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/ali.metadata.php';

//=========================================================================
// Handle events
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from'])){
  $from_id = isset($clean['id'])?$clean['id']:false;
}
    
// Populate the object
if (isset($clean['id'])) {
  if ($object->init($clean['id'])){
    $_SESSION['ali_id'] = $clean['id'];
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION['ali_id'])) {
    $object->init($_SESSION['ali_id']);
  }
  // if there is no current object, start a search
  else  if (!isset($clean['button_action'])) {
    redirect($searchscript);
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      if ($object->delete($object->getProperty('is_active')=='1')) {
        $object = new ali();
        unset($_SESSION['ali_id']);
        redirect($searchscript);
      }
      else {
        $msg = $object->getMessages();
        if (isset($msg[0])) {
          include_once ($m_trans);
          $_SESSION['msg']                 = isset($SPL_TXT[$msg[0]])?$SPL_TXT[$msg[0]]:$msg[0];
          $_SESSION['referred_from']       = $_SERVER['PHP_SELF'];
          $_SESSION['messagebox_icontype'] = 'disappointed';
          redirect($SPL_CFG['wwwroot'].'/ui/message.php');
        }
      }
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($searchscript);
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $object = new ali();
      $editMode = (bool)true;
      unset($_SESSION['ali_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class=ali');
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['ali_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('ali','default','template.htm',true,false,$m_trans,$m_meta);
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('ali_name',$object->getProperty('ali_name'),!$editMode);
      $page->addField('ali_short',$object->getProperty('ali_short'),!$editMode);
      $page->addField('ali_code',$object->getProperty('ali_code'),!$editMode);
      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
      $page->showFormButtons();
    $page->endSubsection();
    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $tabs = array(array('name'=>'apl_tab1','title'=>'sub','tabaction'=>'../../../ui/apl_search.php?parent=ali&parent_id='.$object->getProperty('ali_id').'&child=sub'),
                      array('name'=>'apl_tab2','title'=>'tra','tabaction'=>'../../../ui/apl_search.php?child=ali&child_id='.$object->getProperty('ali_id').'&parent=tra&code='.$object->getProperty('ali_code')));
        $selected = (!isset($clean['selected_tab'])?'apl_tab1':$clean['selected_tab']);
        $page->addTabbar($selected, 'subframe',$tabs,false,'id='.$object->getProperty('ali_id'));
        $page->addIFrame('apl_search.php?parent=ali&parent_id='.$object->getProperty('ali_id').'&child=sub','subframe','default','no','36em');
      $page->endSubsection();
    }
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean;
  
  if (isset ($clean['ali_name']))  {$object->setProperty('ali_name',  $clean['ali_name']);}
  if (isset ($clean['ali_short'])) {$object->setProperty('ali_short', $clean['ali_short']);}
  if (isset ($clean['ali_code']))  {$object->setProperty('ali_code',  $clean['ali_code']);}
  if (isset ($clean['is_active'])) {$object->setProperty('is_active', $clean['is_active']);}
}

function save(){
  
  global $object,$editMode,$clean;

  if (!$editMode){
    return;
  }

  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();

  $_SESSION['ali_id'] = $object->getProperty('ali_id');
}

/** 
 * $Log: ali.php,v $
 * Revision 1.13  2006/08/08 14:21:31  jebbol
 * Added reporting capabilities
 *
 * Revision 1.12  2006/08/08 07:08:58  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.11  2006/02/11 16:34:08  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
