<?php
/**
 * Search the catalog
 *
 * $Author: jebbol $
 * $Revision: 1.16 $
 * $Date: 2006/09/03 19:14:57 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Core objects
include_once($SPL_CFG['dirroot'].'/class/ins.class.php');
include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

// Methodology objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'cat_search_ins'=>array('type'=>'int'),
  'cat_search_ina'=>array('type'=>'int'),
  'cat_search_tra'=>array('type'=>'int'),
  'cat_search_ali'=>array('type'=>'int'),
  'cat_search_sub'=>array('type'=>'int'),
  'cat_search_year'=>array('type'=>'int'),
  'cat_search_prd'=>array('type'=>'int'),
  'cat_search_week'=>array('type'=>'int'),
  'cat_show_type'=>array('type'=>'char'),
  'search_show_inactive'=>array('type'=>'bool'),
  'search_show_mine'=>array('type'=>'bool'),
);
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/cat.lang.php';
include_once($m_trans);

// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/cat.metadata.php';
include_once($m_meta);

//=========================================================================
// Defaults
//=========================================================================

$usd = new usd();
$usd_script = 'cat_search';

$singleIns = false;
$singleIna = false;
$singleTra = false;
$singleAli = false;
$singleSub = false;

$isTeacher = $_SESSION['is_teacher'];
$isAdmin   = $_SESSION['is_admin'];

$tea = new tea();
if ($isTeacher) {
  $tea->init($_SESSION['my_tea_id']);
}

// Preferred Institution
$prefIns = $usd->getDefault($usd_script,'cat_search_ins');
if (isset($clean['cat_search_ins'])){
  $prefIns = $clean['cat_search_ins'];
  $usd->setDefault($usd_script,'cat_search_ins',$prefIns);
}

// Preferred Institution Address
$prefIna = $usd->getDefault($usd_script,'cat_search_ina');
if (isset($clean['cat_search_ina'])){
  $prefIna = $clean['cat_search_ina'];
  $usd->setDefault($usd_script,'cat_search_ina',$prefIna);
}

// Preferred Training
$prefTra = $usd->getDefault($usd_script,'cat_search_tra');
if (isset($clean['cat_search_tra'])){
  $prefTra = $clean['cat_search_tra'];
  $usd->setDefault($usd_script,'cat_search_tra',$prefTra);
}

// Preferred Alignment
$prefAli = $usd->getDefault($usd_script,'cat_search_ali');
if (isset($clean['cat_search_ali'])){
  $prefAli = $clean['cat_search_ali'];
  $usd->setDefault($usd_script,'cat_search_ali',$prefAli);
}

// Preferred Subject
$prefSub = $usd->getDefault($usd_script,'cat_search_sub');
if (isset($clean['cat_search_sub'])){
  $prefSub = $clean['cat_search_sub'];
  $usd->setDefault($usd_script,'cat_search_sub',$prefSub);
}

// Preferred Courseyear
$prefYr = $usd->getDefault($usd_script,'cat_search_year');
if (isset($clean['cat_search_year'])){
  $prefYr = $clean['cat_search_year'];
  $usd->setDefault($usd_script,'cat_search_year',$prefYr);
}

// Preferred period
$prefPrd = $usd->getDefault($usd_script,'cat_search_prd');
if (isset($clean['cat_search_prd'])){
  $prefPrd = $clean['cat_search_prd'];
  $usd->setDefault($usd_script,'cat_search_prd',$prefPrd);
}

// Preferred week
$prefWk = $usd->getDefault($usd_script,'cat_search_week');
if (isset($clean['cat_search_week'])){
  $prefWk = $clean['cat_search_week'];
  $usd->setDefault($usd_script,'cat_search_week',$prefWk);
}

// Preferred show type
$prefTyp = $usd->getDefault($usd_script,'cat_show_type');
if (isset($clean['cat_show_type'])){
  $prefTyp = $clean['cat_show_type'];
  $usd->setDefault($usd_script,'cat_show_type',$prefTyp);
}

// Show only items created by myself?
$prefMine = $clean['search_show_mine']; 

// Only administrator can see inactive items
$prefInactive = false;
// Show inactive items
if ($isAdmin) {
  $prefInactive = $clean['search_show_inactive'];
}

//=========================================================================
// Selections
//=========================================================================

$area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";
  
  // Institution
  $ins = new ins();
  $singleIns = $ins->isSingle();
  if ($singleIns){
    // Bug #1467590: $prefIns = $singleIns;
    $prefIns = 0;
  }
  else {
    if ($isAdmin) {
      $list = $ins->getKeyValues(false,false,'ins_code');
    }
    else {
      $list = $tea->getInstitutions('code');
    }
    $area .= ' '.$SPL_TXT['ins_code'].' <select class="listbox" id="cat_search_ins" name="cat_search_ins" style="width:4em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefIns>0){
          if ((int)$prefIns==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Institution address
  $ina = new ina();
  $singleIna = $ina->isSingle();
  if ($singleIna){
    // Bug #1467590: $prefIna = $singleIna;
    $prefIna = 0;
  }
  else {
    if ($isAdmin) {
      $list = $ina->getKeyValues('ins',$prefIns,'ina_code','ASC',false,'ina_code');
    }
    else {
      $list = $tea->getInstitutionAddresses('code',$prefIns);
    }
    $area .= ' '.$SPL_TXT['ina_code'].' <select class="listbox" id="cat_search_ina" name="cat_search_ina" style="width:4em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefIna>0){
          if ((int)$prefIna==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Training
  $tra = new tra();
  $singleTra = $tra->isSingle();
  if ($singleTra){
    // Bug #1467590: $prefTra = $singleTra;
    $prefTra = 0;
  }
  else {
    if ($isAdmin) {
      $list = $tra->getKeyValues('ina',$prefIna,'tra_short','ASC',false,'tra_short');
    }
    else {
      $list = $tea->getTrainings('short',$prefIna);
    }
    $area .= ' '.$SPL_TXT['tra_code'].' <select class="listbox" id="cat_search_tra" name="cat_search_tra" style="width:7em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefTra>0){
          if ((int)$prefTra==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Alignments
  $ali = new ali();
  $singleAli = $ali->isSingle();
  if ($singleAli){
    // Bug #1467590: $prefAli = $singleAli;
    $prefAli = 0;
  }
  else {
    if ($isAdmin) {
      $list = $ali->getKeyValues('tra',$prefTra,'ali_code','ASC',false,'ali_code');
    }
    else {
      $list = $tea->getAlignments('code',$prefTra);
    }
    $area .= ' '.$SPL_TXT['ali_code'].' <select class="listbox" id="cat_search_ali" name="cat_search_ali" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefAli>0){
          if ((int)$prefAli==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Subjects
  $sub = new sub();
  $singleSub = $sub->isSingle();
  if ($singleSub){
    // Bug #1467590: $prefSub = $singleSub;
    $prefSub = 0;
  }
  else {
    if ($isAdmin) {
      $list = $sub->getKeyValues('ali',$prefAli,'sub_code','ASC',false,'sub_code');
    }
    else {
      $list = $tea->getSubjects('code');
    }
    $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="cat_search_sub" name="cat_search_sub" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefSub>0){
          if ((int)$prefSub==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Courseyear
  $area .= ' '.$SPL_TXT['courseyear'].' <input type="text" name="cat_search_year" id="cat_search_year" value="'.((int)$prefYr>0?$prefYr:'').'" class="text" style="width:2em;padding-bottom:0px;margin-bottom:0px;" onBlur="document.catform.submit();" />'."\r\n";

  // Periods
  $prd = new prd();
  $singlePrd = $prd->isSingle();
  if ($singlePrd){
    // Bug #1467590: $prefPrd = $singlePrd;
    $prefPrd = 0;
  }
  else {
    if ($isAdmin) {
      $list = $prd->getKeyValues(false,false,'prd_code');
    }
    else {
      $list = $prd->getKeyValues(false,$prefIna,'prd_code','ASC','ina');
    }
    $area .= $SPL_TXT['prd_code'].' <select class="listbox" id="cat_search_prd" name="cat_search_prd" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefPrd>0){
          if ((int)$prefPrd==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Week
  $area .= ' '.$SPL_TXT['week'].' <input type="text" name="cat_search_week" id="cat_search_week" value="'.((int)$prefWk>0?$prefWk:'').'" class="text" style="width:2em;padding-bottom:0px;margin-bottom:0px;" onBlur="document.catform.submit();" />'."\r\n";

  // Show type
  $area .= $SPL_TXT['show_type'].' <select class="listbox" id="cat_show_type" name="cat_show_type" style="width:7em" onChange="document.catform.submit();"><option value="0"'.($prefTyp==0?' selected="selected"':'').'>'.$SPL_TXT['show_both'].'</option><option value="1"'.($prefTyp==1?' selected="selected"':'').'>'.$SPL_TXT['show_sug'].'</option><option value="2"'.($prefTyp==2?' selected="selected"':'').'>'.$SPL_TXT['show_act'].'</option></select>';
  
  // Show only items created by me
  $area .= ' '.' <input type="checkbox" class="checkbox" style="padding-bottom:0px;margin-bottom:0px;" name="search_show_mine" id="search_show_mine"'.($prefMine?' checked="checked"':'').' onClick="document.catform.submit();" />'.$SPL_TXT['show_mine']."\r\n";
  
  // Show inactive items
  /*
  if ($isAdmin) {
    $area .= ' '.' <input type="checkbox" class="checkbox" style="padding-bottom:0px;margin-bottom:0px;" name="search_show_inactive" id="search_show_inactive"'.($prefInactive?' checked="checked"':'').' onClick="document.catform.submit();" />'.$SPL_TXT['show_inactive']."\r\n";
  }
  */
    
$area .= '</td></tr></table>'."\r\n";

//=========================================================================
// Query
//=========================================================================

$query['columns']  = 'cat_id AS id,"cat.php'.(isset($clean['from'])?'?from='.$clean['from']:'').'" AS target'.((!$singleIns&&$prefIns==0)?',ins_code':'').((!$singleIna&&$prefIna==0)?',ina_code':'').((!$singleTra&&$prefTra==0)?',tra_code':'').((!$singleAli&&$prefAli==0)?',ali_code':'').(((int)$prefSub==0)?',sub_code':'').',cat_courseyear_start AS courseyear,prd_code AS period,cat_week_start AS week';
$query['tblName']  = 'cat cat'.((!$singleIns)?' LEFT JOIN '.$SPL_CFG['prefix'].'ins ins ON ins.ins_id = cat.ins_id':'').((!$singleIna)?' LEFT JOIN '.$SPL_CFG['prefix'].'ina ina ON ina.ina_id = cat.ina_id':'').((!$singleTra)?' LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = cat.tra_id':'').((!$singleAli)?' LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = cat.ali_id':'').(((int)$prefSub==0)?' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = cat.sub_id':'').' LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = cat.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = cat.prd_id_start';
$query['where']    = 'WHERE cat.adm_id = "'.$_SESSION['adm_id'].'"';
if (!$prefInactive) {
  $query['where']   .= ' AND cat.is_active';
}
if ($prefMine) {
  $query['where']   .= ' AND cat.create_usr_id = "'.$_SESSION['usr_id'].'"';
}
$query['orderBy']  = 'cat_courseyear_start,prd_short,cat_week_start';
$query['orderDir'] = 'ASC';
$query['viewSize'] = (isset($_SESSION['usp_numrows'])?$_SESSION['usp_numrows']:'20');

// Limit the view to a single institution?
if ((int)$prefIns>0){
  $query['where']   .= ' AND cat.ins_id = "'.$prefIns.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ins_id';
}

// Limit the view to a single institution address?
if ((int)$prefIna>0){
  $query['where']   .= ' AND cat.ina_id = "'.$prefIna.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ina_id';
}

// Limit the view to a single training?
if ((int)$prefTra>0){
  $query['where'] .= ' AND cat.tra_id = "'.$prefTra.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.tra_id';
}

// Limit the view to a single alignment?
if ((int)$prefAli>0){
  $query['where'] .= ' AND cat.ali_id = "'.$prefAli.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ali_id';
}

// Limit the view to a single subject?
if ((int)$prefSub>0){
  $query['where'] .= ' AND cat.sub_id = "'.$prefSub.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.sub_id';
}

// Limit the view to a single courseyear?
if ((int)$prefYr>0){
  $query['where'] .= ' AND cat.cat_courseyear_start = "'.$prefYr.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.cat_courseyear_start';
}

// Limit the view to a single period?
if ((int)$prefPrd>0){
  $query['where'] .= ' AND cat.prd_id_start = "'.$prefPrd.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.prd_id_start';
}

// Limit the view to a single week?
if ((int)$prefWk>0){
  $query['where'] .= ' AND cat.cat_week_start = "'.$prefWk.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.cat_week_start';
}

// Show type
if ($prefTyp==0) {
  $query['columns'] .= ',IF(sug_type="A","",sug_title) AS suggestion,IF(sug_type="A",sug_title,"") AS activity';
  $query['orderBy'] = ((int)$prefIns>0?'':((!$singleIns)?'ins.ins_code,':'cat.ins_id,')).((int)$prefIna>0?'':((!$singleIna)?'ina.ina_code,':'cat.ina_id,')).((int)$prefTra>0?'':((!$singleTra)?'tra.tra_code,':'cat.tra_id,')).((int)$prefAli>0?'':((!$singleAli)?'ali.ali_code,':'cat.ali_id,')).((int)$prefSub>0?'':'sub.sub_code,').((int)$prefYr>0?'':'cat.cat_courseyear_start,').((int)$prefPrd>0?'':'cat.prd_id_start,').((int)$prefWk>0?'':'cat.cat_week_start,').'cat_id_parent,cat_sequence';
}
else {
  $query['columns'] .= ',sug_title';
  if ($prefTyp==1) {
    // Suggestion
    $query['where']   .= ' AND sug_type = ""';
    $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'sug_title';
  }
  if ($prefTyp==2) {
    // Suggestion
    $query['where']   .= ' AND sug_type = "A"';
    $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat_id_parent,cat_sequence';
  }
}

// Add a hidden active column
if ($prefInactive){
  $query['columns'] .= ',cat.is_active';
}

if (isset($clean['search_for'])) {
  $query['where'] .= ' AND '.$clean['search_by'].' LIKE "'.$clean['search_for'].'%"';
}

//The column to orderBy
if (isset ($clean['orderBy'])) $query['orderBy'] = $clean['orderBy'];

//The starting offset for record paging 
if (isset ($clean['viewStart'])) $query['viewStart'] = $clean['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($clean['orderDir']))  $query['orderDir'] = $clean['orderDir']; 

// Add show mine switch
if (isset($clean['search_show_mine'])) $query['showMine'] = $clean['search_show_mine'];

// Add inactive switch
if (isset($clean['search_show_inactive'])) $query['showInactive'] = $clean['search_show_inactive'];

// Encode URL
$query['encode'] = false;

//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('cat','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->setMetaOverrule('is_active', array('hidden'=>true));
$table->addNewButton(NULL,$SPL_CFG['wwwroot'].'/methodology/'.$_SESSION['methodology'].'/ui/cat.php?toolbar_button=new&new"');

// Create the page
$page = new page();
$page->init('cat','default','template_search.htm',true,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
  $page->startForm();
  $page->startSection();
  $page->startColumn();
  if (isset($area)){
    $page->startAreaSearch();
    $page->addContent($area);
    $page->endAreaSearch();
  }
  $page->startAreaData();
  $page->addContent($table->getTable());
  $page->endAreaData();
  $page->endColumn();
  $page->endSection();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/**
 * $Log: cat_search.php,v $
 * Revision 1.16  2006/09/03 19:14:57  jebbol
 * Removed is_active
 *
 * Revision 1.15  2006/08/08 07:01:42  jebbol
 * Changed sort order to ins_code, ina_code, tra_code, ali_code, sub_code, cat_courseyear_start, prd_id_start, cat_week_start
 *
 * Revision 1.14  2006/07/04 11:50:24  jebbol
 * Changed the sort order when displaying both suggestions and activities
 *
 * Revision 1.13  2006/04/14 11:27:28  jebbol
 * Bug #1467590: Added check on single instance
 *
 * Revision 1.12  2006/02/11 16:35:46  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
