<?php
/**
 * Include file containing the browse logic for a traditional catalog 
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: cat_browse.inc.php,v 1.11 2005/10/02 11:08:45 jebbol Exp $
 * @package   spl
 * @category  plugin
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================

// Core objects
include_once($SPL_CFG['dirroot'].'/class/ins.class.php');
include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

// Methodology objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');

//=========================================================================
// Defaults
//=========================================================================
$usd = new usd();
$usd_script = 'cat_browse.inc';

// Variables
$singleIns = false;
$singleIna = false;
$singleTra = false;
$singleAli = false;
$singleSub = false;

// Preferred Institution
$prefIns = $usd->getDefault($usd_script,'cat_search_ins');
if (isset($_POST['cat_search_ins'])){
  $prefIns = $_POST['cat_search_ins'];
  $usd->setDefault($usd_script,'cat_search_ins',$prefIns);
}
else if (isset($_GET['cat_search_ins'])){
  $prefIns = $_GET['cat_search_ins'];
  $usd->setDefault($usd_script,'cat_search_ins',$prefIns);
}

// Preferred Institution Address
$prefIna = $usd->getDefault($usd_script,'cat_search_ina');
if (isset($_POST['cat_search_ina'])){
  $prefIna = $_POST['cat_search_ina'];
  $usd->setDefault($usd_script,'cat_search_ina',$prefIna);
}
else if (isset($_GET['cat_search_ina'])){
  $prefIna = $_GET['cat_search_ina'];
  $usd->setDefault($usd_script,'cat_search_ina',$prefIna);
}

// Preferred Training
$prefTra = $usd->getDefault($usd_script,'cat_search_tra');
if (isset($_POST['cat_search_tra'])){
  $prefTra = $_POST['cat_search_tra'];
  $usd->setDefault($usd_script,'cat_search_tra',$prefTra);
}
else if (isset($_GET['cat_search_tra'])){
  $prefTra = $_GET['cat_search_tra'];
  $usd->setDefault($usd_script,'cat_search_tra',$prefTra);
}

// Preferred Alignment
$prefAli = $usd->getDefault($usd_script,'cat_search_ali');
if (isset($_POST['cat_search_ali'])){
  $prefAli = $_POST['cat_search_ali'];
  $usd->setDefault($usd_script,'cat_search_ali',$prefAli);
}
else if (isset($_GET['cat_search_ali'])){
  $prefAli = $_GET['cat_search_ali'];
  $usd->setDefault($usd_script,'cat_search_ali',$prefAli);
}

// Preferred subject
$prefSub = $usd->getDefault($usd_script,'cat_search_sub');
if (isset($_POST['cat_search_sub'])){
  $prefSub = $_POST['cat_search_sub'];
  $usd->setDefault($usd_script,'cat_search_sub',$prefSub);
}
else if (isset($_GET['cat_search_sub'])){
  $prefSub = $_GET['cat_search_sub'];
  $usd->setDefault($usd_script,'cat_search_sub',$prefSub);
}

// Preferred Courseyear
$prefYr = $usd->getDefault($usd_script,'cat_search_year');
if (isset($_POST['cat_search_year'])){
  $prefYr = $_POST['cat_search_year'];
  $usd->setDefault($usd_script,'cat_search_year',$prefYr);
}
else if (isset($_GET['cat_search_year'])){
  $prefYr = $_GET['cat_search_year'];
  $usd->setDefault($usd_script,'cat_search_year',$prefYr);
}

// Preferred period
$prefPrd = $usd->getDefault($usd_script,'cat_search_prd');
if (isset($_POST['cat_search_prd'])){
  $prefPrd = $_POST['cat_search_prd'];
  $usd->setDefault($usd_script,'cat_search_prd',$prefPrd);
}
else if (isset($_GET['cat_search_prd'])){
  $prefPrd = $_GET['cat_search_prd'];
  $usd->setDefault($usd_script,'cat_search_prd',$prefPrd);
}

// Preferred week
$prefWk = $usd->getDefault($usd_script,'cat_search_week');
if (isset($_POST['cat_search_week'])){
  $prefWk = $_POST['cat_search_week'];
  $usd->setDefault($usd_script,'cat_search_week',$prefWk);
}
else if (isset($_GET['cat_search_week'])){
  $prefWk = $_GET['cat_search_week'];
  $usd->setDefault($usd_script,'cat_search_week',$prefWk);
}

//=========================================================================
// Selections
//=========================================================================

$usr = new usr();
$usr->init($_SESSION['usr_id']);

// Teacher
if ($usr->getProperty('tea_id')){
  $tea = new tea();
  $tea->init($usr->getProperty('tea_id'));
  $area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";
  
  // Institution
  $ins = new ins();
  $singleIns = $ins->isSingle();
  if ($singleIns){
    $prefIns = $singleIns;
  }
  else {
    $list = $tea->getInstitutions('code');
    $area .= ' '.$SPL_TXT['ins_code'].' <select class="listbox" id="cat_search_ins" name="cat_search_ins" style="width:4em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefIns>0){
          if ((int)$prefIns==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Institution address
  $ina = new ina();
  $singleIna = $ina->isSingle();
  if ($singleIna){
    $prefIna = $singleIna;
  }
  else {
    $list = $tea->getInstitutionAddresses('code',$prefIns);
    $area .= ' '.$SPL_TXT['ina_code'].' <select class="listbox" id="cat_search_ina" name="cat_search_ina" style="width:4em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefIna>0){
          if ((int)$prefIna==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Training
  $tra = new tra();
  $singleTra = $tra->isSingle();
  if ($singleTra){
    $prefTra = $singleTra;
  }
  else {
    $list = $tea->getTrainings('short',$prefIna);
    $area .= ' '.$SPL_TXT['tra_short'].' <select class="listbox" id="cat_search_tra" name="cat_search_tra" style="width:7em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefTra>0){
          if ((int)$prefTra==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Alignments
  $ali = new ali();
  $singleAli = $ali->isSingle();
  if ($singleAli){
    $prefAli = $singleAli;
  }
  else {
    $list = $tea->getAlignments('code',$prefTra);
    $area .= ' '.$SPL_TXT['ali_short'].' <select class="listbox" id="cat_search_ali" name="cat_search_ali" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefAli>0){
          if ((int)$prefAli==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .='</select>'."\r\n";
  }

  // Subjects
  $sub = new sub();
  $singleSub = $sub->isSingle();
  if ($singleSub){
    $prefSub = $singleSub;
  }
  else {
    $list = $tea->getSubjects('code');
    $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="cat_search_sub" name="cat_search_sub" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefSub>0){
          if ((int)$prefSub==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }
  
  // Courseyear
  $area .= ' '.$SPL_TXT['courseyear'].' <input type="text" name="cat_search_year" id="cat_search_year" value="'.((int)$prefYr>0?$prefYr:'').'" class="text" style="width:2em;" onBlur="document.catform.submit();" />'."\r\n";

  // Periods
  $prd = new prd();
  $singlePrd = $prd->isSingle();
  if ($singlePrd){
    $prefPrd = $singlePrd;
  }
  else {
    $list = $prd->getKeyValues(false,$prefIna,'prd_short','ASC','ina');
    $area .= $SPL_TXT['prd_code'].' <select class="listbox" id="cat_search_prd" name="cat_search_prd" style="width:6em" onChange="document.catform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($list as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefPrd>0){
          if ((int)$prefPrd==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Week
  $area .= ' '.$SPL_TXT['week'].' <input type="text" name="cat_search_week" id="cat_search_week" value="'.((int)$prefWk>0?$prefWk:'').'" class="text" style="width:2em;" onBlur="document.catform.submit();" />'."\r\n";
  
  $area .= '</td></tr></table>'."\r\n";
}

// Catalog
$query['columns']  = 'cat_id AS id,"'.$SPL_CFG['wwwroot'].'/methodology/traditional/ui/cat.php'.'?display'.((int)$prefSub>0?'&cat_search_subjects='.$prefSub:'').((int)$prefIns>0?'&cat_search_ins='.$prefIns:'').((int)$prefIna>0?'&cat_search_ina='.$prefIna:'').'" AS target'.((!$singleIns&&$prefIns==0)?',ins_code':'').((!$singleIna&&$prefIna==0)?',ina_code':'').((!$singleTra&&$prefTra==0)?',tra_short':'').((!$singleAli&&$prefAli==0)?',ali_code':'').(((int)$prefSub==0)?',sub_code':'').',cat_courseyear_start AS courseyear,prd_code AS period,cat_week_start AS week,sug_title';
$query['tblName']  = 'cat cat'.((!$singleIns)?' LEFT JOIN '.$SPL_CFG['prefix'].'ins ins ON ins.ins_id = cat.ins_id':'').((!$singleIna)?' LEFT JOIN '.$SPL_CFG['prefix'].'ina ina ON ina.ina_id = cat.ina_id':'').((!$singleTra)?' LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = cat.tra_id':'').((!$singleAli)?' LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = cat.ali_id':'').(((int)$prefSub==0)?' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = cat.sub_id':'').' LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = cat.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = cat.prd_id_start';
$query['where']    = 'WHERE cat.adm_id = "'.$_SESSION['adm_id'].'" AND cat.is_active';
$query['orderBy']  = '';
$query['orderDir'] = 'ASC';

// Limit the view to a single institution?
if ((int)$prefIns>0){
  $query['where']   .= ' AND cat.ins_id = "'.$prefIns.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ins_id';
}

// Limit the view to a single institution address?
if ((int)$prefIna>0){
  $query['where']   .= ' AND cat.ina_id = "'.$prefIna.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ina_id';
}

// Limit the view to a single training?
if ((int)$prefTra>0){
  $query['where'] .= ' AND cat.tra_id = "'.$prefTra.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.tra_id';
}

// Limit the view to a single alignment?
if ((int)$prefAli>0){
  $query['where'] .= ' AND cat.ali_id = "'.$prefAli.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.ali_id';
}

// Limit the view to a single subject?
if ((int)$prefSub>0){
  $query['where'] .= ' AND cat.sub_id = "'.$prefSub.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.sub_id';
}

// Limit the view to a single courseyear?
if ((int)$prefYr>0){
  $query['where'] .= ' AND cat.cat_courseyear_start = "'.$prefYr.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.cat_courseyear_start';
}

// Limit the view to a single period?
if ((int)$prefPrd>0){
  $query['where'] .= ' AND cat.prd_id_start = "'.$prefPrd.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.prd_id_start';
}

// Limit the view to a single week?
if ((int)$prefWk>0){
  $query['where'] .= ' AND cat.cat_week_start = "'.$prefWk.'"';
}
else {
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'cat.cat_week_start';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($query);
$table->init('cat','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->setKickOut();
$table->addNewButton(NULL,$SPL_CFG['wwwroot'].'/methodology/'.$_SESSION['methodology'].'/ui/cat.php?toolbar_button=new&new" target="_top"');

$page = new page();
$page->init('cat','default','template_iframe.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_cat'],'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->addContent($area);
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->addContent($table->getTable());
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();


?>
