<?php
/**
 * Methodology specific chronicle logic 
 *
 * $Author: jebbol $
 * $Revision: 1.1 $
 * $Date: 2006/08/08 07:03:33 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
include_once($SPL_CFG['dirroot'].'/class/stu.class.php');
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

// Defaults
$usd = new usd();
$usd_script = 'chr_browse.inc';
$prefStu = 0;

// Find the preferred student (just for teachers)
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']) {
  $prefStu = $usd->getDefault($usd_script,'sgd_search_students');
  if (isset($_POST['sgd_search_students'])){
    $prefStu = $_POST['sgd_search_students'];
    $usd->setDefault($usd_script,'sgd_search_students',$prefStu);
  }
  else if (isset($_GET['sgd_search_students'])){
    $prefStu = $_GET['sgd_search_students'];
    $usd->setDefault($usd_script,'sgd_search_students',$prefStu);
  }
}

// Find the preferred subject
$prefSub = $usd->getDefault($usd_script,'sgd_search_subjects');
if (isset($_POST['sgd_search_subjects'])){
  $prefSub = $_POST['sgd_search_subjects'];
  $usd->setDefault($usd_script,'sgd_search_subjects',$prefSub);
}
else if (isset($_GET['sgd_search_subjects'])){
  $prefSub = $_GET['sgd_search_subjects'];
  $usd->setDefault($usd_script,'sgd_search_subjects',$prefSub);
}

// Find the preferred period
$prefPer = $usd->getDefault($usd_script,'sgd_search_periods');
if (isset($_POST['sgd_search_periods'])){
  $prefPer = $_POST['sgd_search_periods'];
  $usd->setDefault($usd_script,'sgd_search_periods',$prefPer);
}
else if (isset($_GET['sgd_search_periods'])){
  $prefPer = $_GET['sgd_search_periods'];
  $usd->setDefault($usd_script,'sgd_search_periods',$prefPer);
}

// Find the preferred week
$prefWk = $usd->getDefault($usd_script,'sgd_search_week');
if (isset($_POST['sgd_search_week'])){
  $prefWk = $_POST['sgd_search_week'];
  $usd->setDefault($usd_script,'sgd_search_week',$prefWk);
}
else if (isset($_GET['sgd_search_week'])){
  $prefWk = $_GET['sgd_search_week'];
  $usd->setDefault($usd_script,'sgd_search_week',$prefWk);
}

// Find the preferred year
$prefYr = $usd->getDefault($usd_script,'sgd_search_years');
if (isset($_POST['sgd_search_years'])){
  $prefYr = $_POST['sgd_search_years'];
  $usd->setDefault($usd_script,'sgd_search_years',$prefYr);
}
else if (isset($_GET['sgd_search_years'])){
  $prefYr = $_GET['sgd_search_years'];
  $usd->setDefault($usd_script,'sgd_search_years',$prefYr);
}

// Page
$page = new page();
$page->init('sgd','default','template_iframe.htm',false,false,$m_trans,$m_meta);


// Selections
$area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";

// Students
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']) {
  $students = '';
  if ($_SESSION['is_teacher']) {
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
    $tea = new tea();
    $tea->init($_SESSION['my_tea_id']);
    $students = $tea->getStudents();
  }
  else if ($_SESSION['is_mentor']) {
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/men.class.php');
    $men = new men();
    $men->init($_SESSION['my_men_id']);
    $students = $men->getStudents();
  }
  else if ($_SESSION['is_parent']) {
    include_once($SPL_CFG['dirroot'].'/class/par.class.php');
    $par = new par();
    $par->init($_SESSION['my_par_id']);
    $students = $par->getChildren();
  }
  if ($students){
    $area .= $SPL_TXT['stu_dispname'].' <select class="listbox" id="sgd_search_students" name="sgd_search_students" style="width:12em" onChange="document.sgdform.submit();">';
    foreach ($students as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefStu>0){
          if ((int)$prefStu==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        else {
          $prefStu = (int)$key;
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }
}
  
// Get student and user
$stu = new stu();
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']){
  $stu->init($prefStu);
  $usr = new usr();
  $tmp_usr_id = $usr->getId($prefStu);
}
else {
  $stu->init($_SESSION['my_stu_id']);
  $tmp_usr_id = $_SESSION['usr_id'];
}

// Find subjects in the chronicle
$query  = 'SELECT DISTINCT sgd.sub_id as "key",sub.sub_short as "value"';
$query .= ' FROM '.$SPL_CFG['prefix'].'sgd sgd LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = sgd.sub_id';
$query .= ' WHERE sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.usr_id = "'.$tmp_usr_id.'" AND sgd.is_active AND sgd.is_done';
$query .= ' ORDER BY sub_short ASC';
$result = db_query($query);
$subjects = array();
while ($row = db_fetch_array($result)) {
  $subjects[] = array($row['key']=>$row['value']);
}

if ($subjects){
  $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="sgd_search_subjects" name="sgd_search_subjects" style="width:6em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($subjects as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefSub>0){
        if ((int)$prefSub==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .= '</select>'."\r\n";
}

// Find courseyears in the chronicle
$query  = 'SELECT DISTINCT sgd_courseyear_start as "key"';
$query .= ' FROM '.$SPL_CFG['prefix'].'sgd sgd';
$query .= ' WHERE sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.usr_id = "'.$tmp_usr_id.'" AND sgd.is_active AND sgd.is_done';
$query .= ' ORDER BY sgd_courseyear_start ASC';
$result = db_query($query);
$years = array();
while ($row = db_fetch_array($result)) {
  $years[] = array($row['key']=>$row['key']);
}

if ($years){
  $area .= $SPL_TXT['sgd_courseyear_start'].' <select class="listbox" id="sgd_search_years" name="sgd_search_years" style="width:6em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($years as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefYr>0){
        if ((int)$prefYr==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .= '</select>'."\r\n";
}
  
// Find periods in the chronicle
$query  = 'SELECT DISTINCT sgd.prd_id_start as "key",prd.prd_short as "value"';
$query .= ' FROM '.$SPL_CFG['prefix'].'sgd sgd LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = sgd.prd_id_start';
$query .= ' WHERE sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.usr_id = "'.$tmp_usr_id.'" AND sgd.is_active AND sgd.is_done';
$query .= ' ORDER BY prd_short ASC';
$result = db_query($query);
$periods=array();
while ($row = db_fetch_array($result)) {
  $periods[] = array($row['key']=>$row['value']);
}
if ($periods) {
  $area .= ' '.$SPL_TXT['prd_short'].' <select class="listbox" id="sgd_search_periods" name="sgd_search_periods" style="width:8em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($periods as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefPer>0){
        if ((int)$prefPer==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .='</select>'."\r\n";
}
// Week
$area .= ' '.$SPL_TXT['sgd_courseweek_start'].' <input type="text" name="sgd_search_week" id="sgd_search_week" value="'.((int)$prefWk>0?$prefWk:'').'" class="text" style="width:2em;" onBlur="document.sgdform.submit();" />'."\r\n";

$area .= '</td>';
  
// Report
//$area .= '<td align="right" style="padding-right:3px;"><a href="sgd_print.php?sgd_search_user='.$tmp_usr_id.'&amp;sgd_search_subjects='.$prefSub.'&amp;sgd_search_periods='.$prefPer.'&amp;sgd_search_week='.$prefWk.'&amp;sgd_search_status='.$prefSts.'"><img src="'.$page->getImageDir().'pdf.gif" title="'.$SPL_TXT['pdf_report'].'" alt=""<!-- {SPL_ENDTAG} -->></a></td>';

$area .= '</tr></table>'."\r\n";

// Build query
$q['columns']  = 'sgd_id AS id,"chr.php'.'?from=menu_chr.php'.((int)$prefSub>0?'&amp;sgd_search_subjects='.$prefSub:'').((int)$prefPer>0?'&amp;sgd_search_periods='.$prefPer:'').'" AS target,sub_short,sug_title,sgd_courseyear_start,prd_short,'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?'sgd_calweek_start':'sgd_courseweek_start').($_SESSION['is_teacher']||$_SESSION['is_mentor']?',if(sgd_actualdate_finish>sgd_caldate_finish,TRUNCATE((sgd_actualdate_finish - sgd_caldate_finish)/(86400),0),"") as too_late':'').($SPL_CFG['learning_load']=='true'?',sgd_load_done':'').($SPL_CFG['learning_reward']=='true'?',sgd_reward_done':'').($SPL_CFG['learning_assessment']=='true'?',sgd_assessment':'');
$q['tblName']  = 'sgd sgd LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = sgd.sub_id LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = sgd.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = sgd.prd_id_start';
$q['where']    = 'WHERE sgd.usr_id = "'.$tmp_usr_id.'" AND sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.is_active AND sgd.is_done AND sug_type = "A"';
$q['orderBy']  = 'sgd_courseyear_start DESC,prd_short'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?',sgd_calweek_start':',sgd_courseweek_start').',sub_short,sug_id_parent,sug_sequence';
$q['orderDir'] = 'ASC';

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Limit the view to a single subject?
if ((int)$prefSub>0){
  $q['where'] .= ' AND sgd.sub_id = "'.$prefSub.'"';
}

// Limit the view to a single courseyear?
if ((int)$prefYr>0){
  $q['where'] .= ' AND sgd.sgd_courseyear_start = "'.$prefYr.'"';
}

// Limit the view to a single period?
if ((int)$prefPer>0){
  $q['where'] .= ' AND sgd.prd_id_start = "'.$prefPer.'"';
}

// Limit the view to a single week?
if ((int)$prefWk>0){
  $q['where'] .= ' AND sgd.'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?'sgd_calweek_start':'sgd_courseweek_start').' = "'.$prefWk.'"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $q['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $q['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $q['orderDir'] = $_GET['orderDir']; 

//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($q);
$table->init('sgd','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_chr'],'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->startAreaSearch();
                  $page->addContent($area);
                  $page->endAreaSearch();
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                $page->addContent($table->getTable());
                /*
                if ((int)$stats['total_items']==0){
                  // No studyguide available for this student
                  $page->addContent($SPL_TXT[$_SESSION['is_teacher']?'sgd_doesnt_exist_teacher':'sgd_doesnt_exist']);
                }
                else {
                  // Show the studyguide
                  $page->addContent($table->getTable());
                }
                */
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
  
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/**
 * $Log: chr_browse.inc.php,v $
 * Revision 1.1  2006/08/08 07:03:33  jebbol
 * Added in version 0.15
 *
 */

?>
