<?php
/**
 * Include file containing the browse logic for a traditional dashboard 
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: dash_browse.inc.php,v 1.8 2006/08/08 07:08:58 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/men.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/dash.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

//=========================================================================
// Defaults
//=========================================================================
$usd = new usd();
$usd_script = 'dash_browse.inc';

// Find the preferred group
$usd_item = 'dash_search_groups';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefGrp = $usd_value;

// Find the preferred subject
$usd_item = 'dash_search_subjects';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefSub = $usd_value;

// Find the preferred student
$usd_item = 'dash_search_students';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefStu = $usd_value;

// Find the preferred period
$usd_item = 'dash_search_periods';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefPer = $usd_value;

// Find the preferred role
$usd_item = 'dash_search_roles';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefRol = $usd_value; // 1=Teacher, 2=Mentor
// Make sure we have a valid default role
if ((int)$prefRol<1 || (int)$prefRol>2) {
  $prefRol = ($_SESSION['is_teacher']?1:2);
}

// Teacher
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor']) {

  if ((int)$prefRol<=1) {
    $myRole = new tea();
    $myRole->init($_SESSION['my_tea_id']);
  }

  if ((int)$prefRol==2) {
    $myRole = new men();
    $myRole->init($_SESSION['my_men_id']);
  }

  // Selection area
  $area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";
  
  // Groups
  $groups = $myRole->getGroups('code');
  if ($groups){
    $area .= $SPL_TXT['grp_short'].' <select class="listbox" id="dash_search_groups" name="dash_search_groups" style="width:5em" onChange="document.dashform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($groups as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefGrp>0){
          if ((int)$prefGrp==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Students
  $students = $myRole->getStudents($prefGrp);
  $studentIds = '';
  if ($students){
    $area .= $SPL_TXT['stu_dispname'].' <select class="listbox" id="dash_search_students" name="dash_search_students" style="width:15em" onChange="document.dashform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($students as $record){
      foreach ($record as $key => $item) {
        $studentIds .= (strlen($studentIds)>0?',':'').$key;
        $area .= '<option value="'.$key.'"';
        if ($prefStu>0){
          if ((int)$prefStu==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Subjects
  if ((int)$prefRol<=1) {
    $subjects = $myRole->getSubjects('short');
  }
  else {
    $sub = new sub();
    $subjects = $sub->getKeyValues(false,false,false,'ASC',false,'sub_code');
  }
  if ($subjects){
    $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="dash_search_subjects" name="dash_search_subjects" style="width:7em" onChange="document.dashform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($subjects as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefSub>0){
          if ((int)$prefSub==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Periods
  $prd = new prd();
  $periodlist = $prd->getKeyValues(false,(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:false),false,'ASC','ina');
  $area .= ' '.$SPL_TXT['prd_short'].' <select class="listbox" id="dash_search_periods" name="dash_search_periods" style="width:8em" onChange="document.dashform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($periodlist as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefPer>0){
        if ((int)$prefPer==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .= '</select>'."\r\n";

  // Select the role
  if ($_SESSION['is_teacher'] && $_SESSION['is_mentor']) {
    $area .= ' '.$SPL_TXT['rol_short'].' <select class="listbox" id="dash_search_roles" name="dash_search_roles" style="width:8em" onChange="document.dashform.submit();">';
      $area .= '<option value="1"';
      if ((int)$prefRol<=1){
        $area .= ' selected="selected"';
      }
      $area .= '>'.$SPL_TXT['rol_teacher'].'</option>';
      $area .= '<option value="1"';
      if ((int)$prefRol==2){
        $area .= ' selected="selected"';
      }
      $area .= '>'.$SPL_TXT['rol_mentor'].'</option>';
    $area .= '</select>'."\r\n";
  }

  $area .= '</td></tr></table>'."\r\n";
}


// Dashboard
$dash = new dash();
$dash->actualize($_SESSION['usr_id']);

$query['columns']  = 'spt_id AS id';
$query['columns'] .= ',"#';
$query['columns'] .= '" AS target';
$query['tblName']  = 'spt spt';
$query['where']    = 'WHERE spt.adm_id = "'.$_SESSION['adm_id'].'" AND spt.is_active';
if ($prefRol<=1) {
  $query['where'] .= ' AND spt.tea_id = "'.$_SESSION['my_tea_id'].'"';
}
$query['orderBy']  = '';
$query['orderDir'] = 'ASC';

// Show student name when 'all students' is selected
if ($prefStu==0){
  $query['columns'] .= ',stu_dispname';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = spt.stu_id';
  $query['orderBy']  = 'stu_sortname';
}
// Show subjects only when one specific student is selected
if ($prefSub==0){
  $query['columns'] .= ',sub_short';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = spt.sub_id';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'sub_short';
}
 
// Show periods only when one student and one subject is selected
if ($prefPer==0){
  $query['columns'] .= ',prd_short';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = spt.prd_id';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'prd_short';
}

$query['columns'] .= ',ROUND(SUM(spt_number_done)/IF(SUM(spt_number_total)>0,SUM(spt_number_total),1)*100) AS spt_perc_complete';
if ($SPL_CFG['learning_load'] == 'true'){
  $query['columns'] .= ',ROUND(SUM(spt_load_done)/IF(SUM(spt_load_total)>0,SUM(spt_load_total),1)*100) AS spt_perc_load';
}
if ($SPL_CFG['learning_reward'] == 'true'){
  $query['columns'] .= ',ROUND(SUM(spt_reward_done)/IF(SUM(spt_reward_total)>0,SUM(spt_reward_total),1)*100) AS spt_perc_reward';
}

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Limit the view to a single group?
if ((int)$prefGrp>0){
  $query['where']   .= ' AND spt.stu_id IN ('.$studentIds.')';
}

// Limit the view to a single student?
if ((int)$prefStu>0){
  $query['where'] .= ' AND spt.stu_id = "'.$prefStu.'"';
}

// Limit the view to a single subject?
if ((int)$prefSub>0){
  $query['where'] .= ' AND spt.sub_id = "'.$prefSub.'"';
}

// Limit the view to a single period?
if ((int)$prefPer>0){
  $query['where'] .= ' AND spt.prd_id = "'.$prefPer.'"';
}

$query['where'] .= ' GROUP BY spt.stu_id';
if ($prefSub==0){
 $query['where'] .= ',spt.sub_id';
}
else{
  $query['where'] .= ',spt.sub_id,spt.prd_id';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($query);
$table->init('spt','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

$page = new page();
$page->init('dash','default','template_iframe.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_dash'],'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->startAreaSearch();
                  $page->addContent($area);
                  $page->endAreaSearch();
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                $page->addContent($table->getTable());
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();


?>
