<?php
/**
 * sgd_browse.inc.php
 * Methodology specific studiguide logic 
 *
 * $Author: jebbol $
 * $Revision: 1.23 $
 * $Date: 2006/08/08 07:04:26 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
include_once($SPL_CFG['dirroot'].'/class/stu.class.php');
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

// Defaults
$usd = new usd();
$usd_script = 'sgd_browse.inc';
$prefStu = 0;

// Find the preferred student (just for teachers, mentors and parents)
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']) {
  $prefStu = $usd->getDefault($usd_script,'sgd_search_students');
  if (isset($_POST['sgd_search_students'])){
    $prefStu = $_POST['sgd_search_students'];
    $usd->setDefault($usd_script,'sgd_search_students',$prefStu);
  }
  else if (isset($_GET['sgd_search_students'])){
    $prefStu = $_GET['sgd_search_students'];
    $usd->setDefault($usd_script,'sgd_search_students',$prefStu);
  }
}

// Find the preferred subject
$prefSub = $usd->getDefault($usd_script,'sgd_search_subjects');
if (isset($_POST['sgd_search_subjects'])){
  $prefSub = $_POST['sgd_search_subjects'];
  $usd->setDefault($usd_script,'sgd_search_subjects',$prefSub);
}
else if (isset($_GET['sgd_search_subjects'])){
  $prefSub = $_GET['sgd_search_subjects'];
  $usd->setDefault($usd_script,'sgd_search_subjects',$prefSub);
}

// Find the preferred period
$prefPer = $usd->getDefault($usd_script,'sgd_search_periods');
$prd = new prd();
$periodlist = $prd->getKeyValues(false,(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:false),false,'ASC','ina');
if (isset($_POST['sgd_search_periods'])){
  $prefPer = $_POST['sgd_search_periods'];
  $usd->setDefault($usd_script,'sgd_search_periods',$prefPer);
}
else if (isset($_GET['sgd_search_periods'])){
  $prefPer = $_GET['sgd_search_periods'];
  $usd->setDefault($usd_script,'sgd_search_periods',$prefPer);
}

// Find the preferred week
$prefWk = $usd->getDefault($usd_script,'sgd_search_week');
if (isset($_POST['sgd_search_week'])){
  $prefWk = $_POST['sgd_search_week'];
  $usd->setDefault($usd_script,'sgd_search_week',$prefWk);
}
else if (isset($_GET['sgd_search_week'])){
  $prefWk = $_GET['sgd_search_week'];
  $usd->setDefault($usd_script,'sgd_search_week',$prefWk);
}

// Find the preferred status
$prefSts = $usd->getDefault($usd_script,'sgd_search_status');
if (isset($_POST['sgd_search_status'])){
  $prefSts = $_POST['sgd_search_status'];
  $usd->setDefault($usd_script,'sgd_search_status',$prefSts);
}
else if (isset($_GET['sgd_search_status'])){
  $prefSts = $_GET['sgd_search_status'];
  $usd->setDefault($usd_script,'sgd_search_status',$prefSts);
}

// Page
$page = new page();
$page->init('sgd','default','template_iframe.htm',false,false,$m_trans,$m_meta);


// Selections
$area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";

// Students
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']) {
  $students = '';
  if ($_SESSION['is_teacher']) {
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
    $tea = new tea();
    $tea->init($_SESSION['my_tea_id']);
    $students = $tea->getStudents();
  }
  else if ($_SESSION['is_mentor']) {
    include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/men.class.php');
    $men = new men();
    $men->init($_SESSION['my_men_id']);
    $students = $men->getStudents();
  }
  else if ($_SESSION['is_parent']) {
    include_once($SPL_CFG['dirroot'].'/class/par.class.php');
    $par = new par();
    $par->init($_SESSION['my_par_id']);
    $students = $par->getChildren();
  }
  if ($students){
    $area .= $SPL_TXT['stu_dispname'].' <select class="listbox" id="sgd_search_students" name="sgd_search_students" style="width:12em" onChange="document.sgdform.submit();">';
    foreach ($students as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        if ($prefStu>0){
          if ((int)$prefStu==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }
}

  
// Subjects
$stu = new stu();
if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']){
  $stu->init($prefStu);
}
else {
  $stu->init($_SESSION['my_stu_id']);
}

$subjects = $stu->getSubjects('short');

if ($subjects){
  $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="sgd_search_subjects" name="sgd_search_subjects" style="width:6em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($subjects as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefSub>0){
        if ((int)$prefSub==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .= '</select>'."\r\n";
}
  
// Periods
$area .= ' '.$SPL_TXT['prd_short'].' <select class="listbox" id="sgd_search_periods" name="sgd_search_periods" style="width:8em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
foreach ($periodlist as $record){
  foreach ($record as $key => $item) {
    $area .= '<option value="'.$key.'"';
    if ($prefPer>0){
      if ((int)$prefPer==(int)$key){
        $area .= ' selected="selected"';
      }
    }
    $area .= '>'.$item.'</option>';
  }
}
$area .='</select>'."\r\n";

// Week
$area .= ' '.$SPL_TXT['sgd_courseweek_start'].' <input type="text" name="sgd_search_week" id="sgd_search_week" value="'.((int)$prefWk>0?$prefWk:'').'" class="text" style="width:2em;" onBlur="document.sgdform.submit();" />'."\r\n";
  
// Status
$sts = new sts();
$statuslist = $sts->getKeyValues(false,($_SESSION['is_teacher']?false:'NOT is_done'));
$area .= ' '.$SPL_TXT['sts_short'].' <select class="listbox" id="sgd_search_status" name="sgd_search_status" style="width:8em" onChange="document.sgdform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
foreach ($statuslist as $record){
  foreach ($record as $key => $item) {
    $area .= '<option value="'.$key.'"';
    if ($prefSts>0){
      if ((int)$prefSts==(int)$key){
        $area .= ' selected="selected"';
      }
    }
    $area .= '>'.$item.'</option>';
  }
}
$area .='</select></td>'."\r\n";

// Find students user id
$tmp_usr_id = $_SESSION['usr_id'];

if ($_SESSION['is_teacher'] || $_SESSION['is_mentor'] || $_SESSION['is_parent']) {
  $usr = new usr();
  $tmp_usr_id = $usr->getId($prefStu);
}

// Report
$area .= '<td align="right" style="padding-right:3px;"><a href="sgd_print.php?sgd_search_user='.$tmp_usr_id.'&amp;sgd_search_subjects='.$prefSub.'&amp;sgd_search_periods='.$prefPer.'&amp;sgd_search_week='.$prefWk.'&amp;sgd_search_status='.$prefSts.'"><img src="'.$page->getImageDir().'pdf.gif" title="'.$SPL_TXT['pdf_report'].'" alt=""<!-- {SPL_ENDTAG} -->></a></td>';

$area .= '</tr></table>'."\r\n";

// Studyguide
$sgd = new sgd();
$sgd->actualize($tmp_usr_id);
$stats = $sgd->getStatistics($tmp_usr_id);

// Build query
$query['columns']  = 'sgd_id AS id,"sgd.php'.'?from=menu_sgd.php'.((int)$prefSub>0?'&amp;sgd_search_subjects='.$prefSub:'').((int)$prefPer>0?'&amp;sgd_search_periods='.$prefPer:'').'" AS target,sub_short,sug_title,prd_short,'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?'sgd_calweek_start':'sgd_courseweek_start').($SPL_CFG['learning_load']=='true'?',sug_load':'').($SPL_CFG['learning_reward']=='true'?',sug_reward':'').',fmt_code,sts_short,is_changed';
$query['tblName']  = 'sgd sgd LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = sgd.sub_id LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = sgd.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'sts sts ON sts.sts_id = sgd.sts_id LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = sgd.prd_id_start LEFT JOIN '.$SPL_CFG['prefix'].'fmt fmt ON fmt.fmt_id = sug.fmt_id';
$query['where']    = 'WHERE sgd.usr_id = "'.$tmp_usr_id.'" AND sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.is_active'.((int)$prefSts==0?' AND NOT sgd.is_done':'').' AND sug_type = "A"';
$query['orderBy']  = 'is_changed DESC,prd_short'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?',sgd_calweek_start':',sgd_courseweek_start').',sub_short,sug_id_parent,sug_sequence';
$query['orderDir'] = 'ASC';

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Limit the view to a single subject?
if ((int)$prefSub>0){
  $query['where'] .= ' AND sgd.sub_id = "'.$prefSub.'"';
}

// Limit the view to a single period?
if ((int)$prefPer>0){
  $query['where'] .= ' AND sgd.prd_id_start = "'.$prefPer.'"';
}

// Limit the view to a single week?
if ((int)$prefWk>0){
  $query['where'] .= ' AND sgd.'.((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?'sgd_calweek_start':'sgd_courseweek_start').' = "'.$prefWk.'"';
}

// Limit the view to a single status?
if ((int)$prefSts>0){
  $query['where'] .= ' AND sgd.sts_id = "'.$prefSts.'"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($query);
$table->init('sgd','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_sgd'],'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->startAreaSearch();
                  $page->addContent($area);
                  $page->endAreaSearch();
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                if ((int)$stats['total_items']==0){
                  // No studyguide available for this student
                  $page->addContent($SPL_TXT[$_SESSION['is_student']?'sgd_doesnt_exist':'sgd_doesnt_exist_teacher']);
                }
                else {
                  // Show the studyguide
                  $page->addContent($table->getTable());
                }
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
  
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/**
 * $Log: sgd_browse.inc.php,v $
 * Revision 1.23  2006/08/08 07:04:26  jebbol
 * Added a switch to display calendar-weeknumbers
 *
 * Revision 1.22  2006/04/17 10:56:53  jebbol
 * When printing, use sgd_print.php instead of sgd_pdf.php (sgd_print displays in a pane)
 *
 * Revision 1.21  2006/04/14 12:52:33  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.20  2006/03/08 16:41:54  jebbol
 * *** empty log message ***
 */

?>
