<?php
/**
 * Include file containing the display logic for a traditional studyguide
 *
 * $Author: jebbol $
 * $Revision: 1.14 $
 * $Date: 2006/08/28 09:16:01 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sgn.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sug.class.php');

//=========================================================================
// Local variables
//=========================================================================

$sgd = new sgd();
$sug = new sug();
$editMode = (bool)false;

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Populate the object
if (isset ($_GET['id'])) {
  if ($sgd->init($_GET['id'])){
    $_SESSION['sgd_id'] = $_GET['id'];
    $sug->init($sgd->getProperty('sug_id'));
  }
  unset ($_GET['id']);
}

// Display additional info
else if (isset($_GET['sug_id'])) {
  $sug->init($_GET['sug_id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['sgd_id'])) {
    $sgd->init($_SESSION['sgd_id']);
    $sug->init($sgd->getProperty('sug_id'));
  }
}

// Action to perform when hitting the 'close' picto in the upper corner
$closeAction=NULL;
if (isset($_GET['from'])) {
  $closeAction = addslashes($_GET['from']);
  $closeAction .= (isset($_GET['sgd_search_subjects'])?'?sgd_search_subjects='.$_GET['sgd_search_subjects']:'');
  $closeAction .= (isset($_GET['sgd_search_periods'])?'?sgd_search_periods='.$_GET['sgd_search_periods']:'');
}
else if (isset($_POST['action_on_close'])) {
  $closeAction = $_POST['action_on_close'];
}

// Handle the test button
if (isset($_POST['sug_url_test'])) {
  redirect($sug->getProperty('sug_url_test'));
}

// Events from the Toolbar buttons
if (count($_POST)||count($_GET)) {
  include_once($SPL_CFG['dirroot'].'/ui/inc/action.php');  
  switch ($action) {
    case 'save':
    case 'list':
      save();
      if ($sgd->_data['is_done']||$action=='save') {
        redirect($closeAction);
      }
      break;
    default:
      break;
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('sgd','default','template_iframeedit.htm',false,false,$m_trans,$m_meta);
//$page->startScrollableArea();
$page->startForm();
  $page->startTable();
      $page->startColumn();
        $page->startPane($SPL_TXT['sug_title'],$closeAction);
          $page->startAreaData();

          // Add a hidden filed to capture the status listbox events
          $page->addField('toolbar_button','',false,false,false,false,null,false,false,true);
          //Add a hidden field to pass on the closeaction
          $page->addField('action_on_close',$closeAction,false,false,false,false,null,false,false,true);
            
          $page->startTable();
          
            include_once($SPL_CFG['dirroot'].'/ui/inc/fontsize.inc.php');
            
            $page->addContent('<tr><td name="sug_title" id="sug_title"'.($customFontSize!='normal'?$customFontSize:'').'><h1>'.$sug->getProperty('sug_title').'</h1></td></tr>');

            // Set tabs only when at least one of them has a value
            $selected = (!isset($_POST['selected_tab'])?'sug_tab1':$_POST['selected_tab']);
            $showtabs = 'no';
            if (!empty($sug->_data['sug_knowledge']) || !empty($sug->_data['sug_directions']) || !empty($sug->_data['sug_prerequisites']) || !empty($sug->_data['sug_materials'])) {
              $showtabs = '';
              // Description
              $tabs[] = array('name'=>'sug_tab1','title'=>'sug_description','widget'=>'tab_description');
              // Knowledge
              if (!empty($sug->_data['sug_knowledge'])) {
                $tabs[] = array('name'=>'sug_tab2','title'=>'sug_knowledge','widget'=>'tab_knowledge');
              }
              else {
                // Make sure the empty tab is not the current one
                if ($selected == 'sug_tab2') {
                  $selected = 'sug_tab3';
                }
              }
              // Directions
              if (!empty($sug->_data['sug_directions'])) {
                $tabs[] = array('name'=>'sug_tab3','title'=>'sug_directions','widget'=>'tab_directions');
              }
              else {
                // Make sure the empty tab is not the current one
                if ($selected == 'sug_tab3') {
                  $selected = 'sug_tab4';
                }
              }
              // Prerequisites
              if (!empty($sug->_data['sug_prerequisites'])) {
                $tabs[] = array('name'=>'sug_tab4','title'=>'sug_prerequisites','widget'=>'tab_prerequisites');
              }
              else {
                // Make sure the empty tab is not the current one
                if ($selected == 'sug_tab4') {
                  $selected = 'sug_tab5';
                }
              }
              // Materials
              if (!empty($sug->_data['sug_materials'])) {
                $tabs[] = array('name'=>'sug_tab5','title'=>'sug_materials','widget'=>'tab_materials');
              }
              // Activities (only when displaying suggestion info)
              if ($sug->hasActivities()) {
                $tabs[] = array('name'=>'sug_tab6','title'=>'activity','widget'=>'tab_activity','tabaction'=>'../methodology/traditional/ui/sug_act_guide.php?parent=sug'.'&parent_id='.$sug->getProperty('sug_id'),'empty'=>!$sug->hasActivities(),'target'=>'tab_activity');
              }
              $page->startAreaTab();
              $page->addTabbar($selected,null,$tabs,true);
              $page->endAreaTab();
            }
            
            $page->addContent('<tr id="'.$showtabs.'tab_description"'.($selected=='sug_tab1'?'':' style="display:none"').'><td class="field"><span name="sug_description" id="sug_description"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_description').'<br<!-- {SPL_ENDTAG} -->><br<!-- {SPL_ENDTAG} -->></span></td></tr>');
            if (!empty($sug->_data['sug_knowledge'])){
              $page->addContent('<tr id="'.$showtabs.'tab_knowledge"'.($selected=='sug_tab2'?'':' style="display:none"').'><td class="field"><span name="sug_knowledge" id="sug_knowledge"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_knowledge').'<br<!-- {SPL_ENDTAG} -->><br<!-- {SPL_ENDTAG} -->></span></td></tr>');
            }
            if (!empty($sug->_data['sug_directions'])){
              $page->addContent('<tr id="'.$showtabs.'tab_directions"'.($selected=='sug_tab3'?'':' style="display:none"').'><td class="field"><span name="sug_directions" id="sug_directions"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_directions').'<br<!-- {SPL_ENDTAG} -->><br<!-- {SPL_ENDTAG} -->></span></td></tr>');
            }
            if (!empty($sug->_data['sug_prerequisites'])){
              $page->addContent('<tr id="'.$showtabs.'tab_prerequisites"'.($selected=='sug_tab4'?'':' style="display:none"').'><td class="field"><span name="sug_prerequisites" id="sug_prerequisites"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_prerequisites').'<br<!-- {SPL_ENDTAG} -->><br<!-- {SPL_ENDTAG} -->></span></td></tr>');
            }
            if (!empty($sug->_data['sug_materials'])){
              $page->addContent('<tr id="'.$showtabs.'tab_materials"'.($selected=='sug_tab5'?'':' style="display:none"').'><td class="field"><span name="sug_materials" id="sug_materials"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_materials').'<br<!-- {SPL_ENDTAG} -->><br<!-- {SPL_ENDTAG} -->></span></td></tr>');
            }
            if (!empty($sug->_data['sug_knowledge']) || !empty($sug->_data['sug_directions']) || !empty($sug->_data['sug_prerequisites']) || !empty($sug->_data['sug_materials'])) {
              $page->addIFrame('wait.php',''.$showtabs.'tab_activity','display:none;width:100%;height:30em');
            }

            if ($_SESSION['sgd_permission']['write']==(bool)true || $_SESSION['sgd_permission']['change']==(bool)true) {
            // Buttons ar valid for activities only
            if ($sug->getProperty('sug_type')=='A') {
              $page->startRow();
                $page->startColumn();
                  $page->addContent($SPL_TXT['sgn_note']);
                $page->endColumn();
              $page->endRow();
              $page->addField('sgn_note');

              $page->addContent('<!-- Start of buttons -->','yes');
              $page->startRow();
                $page->startColumn();
                  $page->startTable();
                    $page->startRow();

                      // Display the status of activities
                      if ($sug->getProperty('sug_type')=='A') {
                        // When students are not allowed to mark this activity 'done', 
                        // skip the relevant statusses
                        $statusses = false;
                        include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
                        $sts = new sts();
                        if ($_SESSION['is_teacher']) {
                          $statusses = $sts->getKeyValues(false,'sts_teacher_allowed');
                        }
                        else if ($sug->getProperty('sug_signout')){
                          $statusses = $sts->getKeyValues(false,'sts_student_allowed AND NOT is_done');
                        }
                        else {
                          $statusses = $sts->getKeyValues(false,'sts_student_allowed');
                        }
                        $page->startColumn('none','style="width:15em"');
                          $page->startTable();
                            $page->addField('sts_id',$sgd->getProperty('sts_id'),false,false,true,$statusses,null,true,false,false);
                          $page->endTable();
                        $page->endColumn();
                      }

                      $page->startColumn();
                        $page->startAreaButton();
                        $page->addButton('save','toolbar_save','submit','default','8','button');
                        if ($sug->getProperty('sug_id_parent')){
                          $page->addButton('sug_id_parent','parent','default','document.location=\'sgd.php?from=menu_sgd.php&amp;sug_id='.$sug->getProperty('sug_id_parent').'\'','8','button');
                        }
                        if ($sug->getProperty('sug_url_elo')){
                          $page->addButton('sug_url_elo','elo','default','document.location=\''.$sug->getProperty('sug_url_elo').'\'','8','button');
                        }
                        if ($sug->getProperty('sug_url_test')){
                          $page->addButton('sug_url_test','test','submit','default','8','button');
                        }
                        if ($sug->getProperty('sug_do_schedule')){
                          $page->addButton('planner','plan','default','default','8','button');
                        }
                        $page->endAreaButton();
                      $page->endColumn();

                      // Make a compliment
                      if ($sgd->getProperty('sgd_compliment')){
                        $page->addContent($SPL_UI['image_compliment']);
                      }

                    $page->endRow();
                  $page->endTable();
                $page->endColumn();
              $page->endRow();
              $page->addContent('<!-- End of buttons -->','yes');
            }
            }
            
            // Diagram
            if ($sug->hasActivities()) {
              $info = $sgd->getInfo($_SESSION['usr_id'], $sug->getProperty('sug_id'));
              //$page->_addDiagram();
              $page->startAreaData();
              $page->startRow();
                $page->startColumn();
                  $page->startChart();
                  $page->addBar(number_format($info['perc_activities_done'],0),'progress');
                  $page->endChart();
                $page->endColumn();
              $page->endRow();
              $page->endAreaData();
            }

          $page->endTable();
          $page->endAreaData();
        $page->endPane();

        $page->startScrollableArea();
        // Add previous notes
        $query  = 'SELECT sgn_id,usr_name,stu_dispname FROM '.$SPL_CFG['prefix'].'sgn sgn LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = sgn.create_usr_id LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = usr.stu_id';
        $query .= ' WHERE sgn.adm_id = "'.$_SESSION['adm_id'].'" AND sgn.sgd_id = "'.$sgd->getProperty('sgd_id').'" AND NOT sgn.is_private';
        $query .= ' ORDER BY sgn.create_date DESC';
        $result = db_query($query);
        if (db_num_rows($result)>0) {
          $page->startPane($SPL_TXT['notes'],'noclose','notes');
            $page->startAreadata();
            $page->startTable('note');
              while ($row = db_fetch_array($result)) {
                $sgn = new sgn();
                $sgn->init($row['sgn_id']);
                $page->startRow('note');
                  $page->startColumn('notelabel');
                    $page->addContent(strftime("%Y-%m-%d %H:%M",$sgn->getProperty('create_date')));
                    $page->addContent('<br />');
                    $page->addContent(isset($row['stu_dispname'])?$row['stu_dispname']:$row['usr_name']);
                  $page->endColumn();
                  $page->startColumn('note');
                    $page->startTable();
                    $page->addField('sgn_note_display',$sgn->getPropertyFormatted('sgn_note'),true);
                    $page->endTable();
                  $page->endColumn();
                $page->endRow();
              }
            $page->endTable();
            $page->endAreaData();
          $page->endPane();
        }
        $page->endScrollableArea();

      $page->endColumn();
  $page->endTable();
$page->endForm();
//$page->endScrollableArea();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Show the page
//=========================================================================
function set(){
  
  global $SPL_CFG,$sgd;
  
  if (isset ($_POST['sts_id'])) {$sgd->setProperty('sts_id', $_POST['sts_id']);}

  // Notes
  if (isset($_POST['sgn_note'])&&(!empty($_POST['sgn_note']))) {
    $sgn = new sgn();
    $sgn->setProperty('sgd_id',$sgd->getProperty('sgd_id'));
    $sgn->setProperty('sgn_note',$_POST['sgn_note']);
    $sgn->save();
  }            
  
  // Get the status defaults
  include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
  $sts = new sts();
  if ($sts->init($_POST['sts_id'])) {
    $sgd->setProperty('is_done',$sts->_data['is_done']);
  }
  
  // Reset compliments
  $sgd->setProperty('sgd_compliment','0');
  
  // Reset the 'is_changed' flag
  $sgd->setProperty('is_changed','0');
  
}

function save(){
  
  global $sgd;
  
  if (isset($_POST['toolbar_button'])){
    if ($_POST['toolbar_button']=='cancel'){
      return;
    }
  }
  set();
  $sgd->save();
}

/** 
 * $Log: sgd_display.inc.php,v $
 * Revision 1.14  2006/08/28 09:16:01  jebbol
 * Changed layout
 *
 * Revision 1.13  2006/08/08 07:05:15  jebbol
 * Added the possibility for teachers to change the status of is_done activities
 *
 * Revision 1.12  2006/04/14 12:52:33  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.11  2006/02/23 19:16:46  jebbol
 * Changed the id of the textrows to 'no' when not showing tabs
 */

?>
