<?php
/**
 * Include file containing the browse logic for a traditional teacher tasklist 
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: tsk_browse.inc.php,v 1.10 2006/08/08 07:08:58 jebbol Exp $
 * @package   spl
 * @category  plugin
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tea.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

// Defaults
$usd = new usd();
$usd_script = 'tsk_browse.inc';

// Find the preferred student
$prefStu = $usd->getDefault($usd_script,'tsk_search_students');
if (isset($_POST['tsk_search_students'])){
  $prefStu = $_POST['tsk_search_students'];
  $usd->setDefault($usd_script,'tsk_search_students',$prefStu);
}
else if (isset($_GET['tsk_search_students'])){
  $prefStu = $_GET['tsk_search_students'];
  $usd->setDefault($usd_script,'tsk_search_students',$prefStu);
}

// Find the preferred subject
$prefSub = $usd->getDefault($usd_script,'tsk_search_subjects');
if (isset($_POST['tsk_search_subjects'])){
  $prefSub = $_POST['tsk_search_subjects'];
  $usd->setDefault($usd_script,'tsk_search_subjects',$prefSub);
}
else if (isset($_GET['tsk_search_subjects'])){
  $prefSub = $_GET['tsk_search_subjects'];
  $usd->setDefault($usd_script,'tsk_search_subjects',$prefSub);
}

// Find the preferred period
$prefPer = $usd->getDefault($usd_script,'tsk_search_periods');
$prd = new prd();
$periodlist = $prd->getKeyValues(false,(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:false),false,'ASC','ina');
if (isset($_POST['tsk_search_periods'])){
  $prefPer = $_POST['tsk_search_periods'];
  $usd->setDefault($usd_script,'tsk_search_periods',$prefPer);
}
else if (isset($_GET['tsk_search_periods'])){
  $prefPer = $_GET['tsk_search_periods'];
  $usd->setDefault($usd_script,'tsk_search_periods',$prefPer);
}

// Find the preferred week
$prefWk = $usd->getDefault($usd_script,'tsk_search_week');
if (isset($_POST['tsk_search_week'])){
  $prefWk = $_POST['tsk_search_week'];
  $usd->setDefault($usd_script,'tsk_search_week',$prefWk);
}
else if (isset($_GET['tsk_search_week'])){
  $prefWk = $_GET['tsk_search_week'];
  $usd->setDefault($usd_script,'tsk_search_week',$prefWk);
}

// Find the preferred status
$prefSts = $usd->getDefault($usd_script,'tsk_search_status');
if (isset($_POST['tsk_search_status'])){
  $prefSts = $_POST['tsk_search_status'];
  $usd->setDefault($usd_script,'tsk_search_status',$prefSts);
}
else if (isset($_GET['tsk_search_status'])){
  $prefSts = $_GET['tsk_search_status'];
  $usd->setDefault($usd_script,'tsk_search_status',$prefSts);
}

// Teacher
if ($_SESSION['is_teacher']) {
  $tea = new tea();
  $tea->init($_SESSION['my_tea_id']);
  $area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";
  
  // Subjects
  $subjects = $tea->getSubjects('short');
  $subjectList = '';
  if ($subjects){
    $area .= $SPL_TXT['sub_short'].' <select class="listbox" id="tsk_search_subjects" name="tsk_search_subjects" style="width:6em" onChange="document.tskform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($subjects as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        $subjectList .= strlen($subjectList)>0?',"'.$key.'"':'"'.$key.'"';
        if ($prefSub>0){
          if ((int)$prefSub==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }
  
  // Students
  $students = $tea->getStudents();
  $studentList = '';
  if ($students){
    $area .= $SPL_TXT['stu_sortname'].' <select class="listbox" id="tsk_search_students" name="tsk_search_students" style="width:12em" onChange="document.tskform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($students as $record){
      foreach ($record as $key => $item) {
        $area .= '<option value="'.$key.'"';
        $studentList .= strlen($studentList)>0?',"'.$key.'"':'"'.$key.'"';
        if ($prefStu>0){
          if ((int)$prefStu==(int)$key){
            $area .= ' selected="selected"';
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
  }

  // Periods
  $area .= ' '.$SPL_TXT['prd_short'].' <select class="listbox" id="tsk_search_periods" name="tsk_search_periods" style="width:8em" onChange="document.tskform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($periodlist as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefPer>0){
        if ((int)$prefPer==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .='</select>'."\r\n";

  // Week
  $area .= ' '.$SPL_TXT['sgd_courseweek_start'].' <input type="text" name="tsk_search_week" id="tsk_search_week" value="'.((int)$prefWk>0?$prefWk:'').'" class="text" style="width:2em;" onBlur="document.tskform.submit();" />'."\r\n";
  
  // Status
  $sts = new sts();
  $statuslist = $sts->getKeyValues(false,'sts_teacher_action AND NOT is_done');
  $area .= ' '.$SPL_TXT['sts_short'].' <select class="listbox" id="tsk_search_status" name="tsk_search_status" style="width:8em" onChange="document.tskform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
  foreach ($statuslist as $record){
    foreach ($record as $key => $item) {
      $area .= '<option value="'.$key.'"';
      if ($prefSts>0){
        if ((int)$prefSts==(int)$key){
          $area .= ' selected="selected"';
        }
      }
      $area .= '>'.$item.'</option>';
    }
  }
  $area .='</select>'."\r\n";


  $area .= '</td></tr></table>'."\r\n";
}


$query['columns']  = 'sgd_id AS id';
$query['columns'] .= ',"tsk.php'.'?from=menu_tsk.php'.((int)$prefSub>0?'&tsk_search_subjects='.$prefSub:'').((int)$prefStu>0?'&dash_search_students='.$prefStu:'').((int)$prefPer>0?'&tsk_search_periods='.$prefPer:'').'" AS target';
$query['tblName']  = 'sgd sgd';
$query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = sgd.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = sgd.usr_id LEFT JOIN '.$SPL_CFG['prefix'].'sts sts ON sts.sts_id = sgd.sts_id';
$query['where']    = 'WHERE sgd.adm_id = "'.$_SESSION['adm_id'].'" AND sgd.is_active AND NOT sgd.is_done AND sug_type = "A" AND sts_teacher_action';
$query['orderBy']  = '';
$query['orderDir'] = 'ASC';

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Show subjects only when no specific student is selected
if ($prefSub==0){
  $query['columns'] .= ',sub_short';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = sgd.sub_id';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'sub_short';
}

// Show student name when no students is selected
if ($prefStu==0){
  $query['columns'] .= ',stu_sortname';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = usr.stu_id';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'stu_sortname';
}

// Always show activity
if ($prefSub==0 && $prefStu==0){
  $query['columns'] .= ',sug_short';
}
else {
  $query['columns'] .= ',sug_title';
}
$query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'sug_id_parent,sug_sequence';

// Show periods when no period is selected
if ($prefPer==0){
  $query['columns'] .= ',prd_short';
  $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = sgd.prd_id_start';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'prd_short';
}

// Show weeks when no week is selected
if ($prefWk==0){
  $query['columns'] .= ((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?',sgd_calweek_start':',sgd_courseweek_start');
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').((isset($SPL_CFG['weeknumber_mode'])&&$SPL_CFG['weeknumber_mode']=='calendar')?'sgd_calweek_start':'sgd_courseweek_start');
}

// If we've got enough space on the screen, add some information
if ($prefSub&&$prefStu) {
  $query['columns'] .= ',IF(sgd_actualdate_start>0,FROM_UNIXTIME(sgd_actualdate_start),"") AS actualdate_start';
}

// Show status when no status is selected
if ($prefSts==0){
  $query['columns'] .= ',sts_short';
  $query['orderBy'] .= (strlen($query['orderBy'])>0?',':'').'sts_short';
}

// Limit the view to a single student?
if ((int)$prefStu>0){
  $query['where'] .= ' AND usr.stu_id = "'.$prefStu.'"';
}
else if (!empty($studentList)) {
  $query['where'] .= ' AND usr.stu_id IN ('.$studentList.')';
}


// Limit the view to a single subject?
if ((int)$prefSub>0){
  $query['where'] .= ' AND sgd.sub_id = "'.$prefSub.'"';
}
else if (!empty($subjectList)){
  $query['where'] .= ' AND sgd.sub_id IN ('.$subjectList.')';
}

// Limit the view to a single period?
if ((int)$prefPer>0){
  $query['where'] .= ' AND sgd.prd_id_start = "'.$prefPer.'"';
}

// Limit the view to a single week?
if ((int)$prefWk>0){
  $query['where'] .= ' AND sgd.sgd_courseweek_start = "'.$prefWk.'"';
}

// Limit the view to a single status?
if ((int)$prefSts>0){
  $query['where'] .= ' AND sgd.sts_id = "'.$prefSts.'"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

// Always show the oldest tasks first
$query['orderBy'] .= ',sgd.update_date';

//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($query);
$table->init('sgd','',$m_trans,$m_meta);
$table->setEmptyText('empty tasklist');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

$page = new page();
$page->init('tsk','default','template_iframe.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_tsk'],'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->startAreaSearch();
                  $page->addContent($area);
                  $page->endAreaSearch();
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                $page->addContent($table->getTable());
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();


?>
