<?php
/**
 * Include file containing the display logic for a traditional teacher tasklist
 *
 * $Author: jebbol $
 * $Revision: 1.7 $
 * $Date: 2006/08/28 09:16:01 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/sgd.class.php');
include_once($SPL_CFG['dirroot'].'/class/sgn.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sug.class.php');

//=========================================================================
// Local variables
//=========================================================================

$sgd = new sgd();
$sug = new sug();
$editMode = (bool)false;

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Populate the object
if (isset ($_GET['id'])) {
  if ($sgd->init($_GET['id'])){
    $_SESSION['sgd_id'] = $_GET['id'];
    $sug->init($sgd->getProperty('sug_id'));
  }
  unset ($_GET['id']);
}

// Display additional info
else if (isset($_GET['sug_id'])) {
  $sug->init($_GET['sug_id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['sgd_id'])) {
    $sgd->init($_SESSION['sgd_id']);
    $sug->init($sgd->getProperty('sug_id'));
  }
}

// Action to perform when hitting the 'close' picto in the upper corner
$closeAction=NULL;
if (isset($_GET['from'])) {
  $closeAction = addslashes($_GET['from']);
  $closeAction .= (isset($_GET['tsk_search_subjects'])?'?tsk_search_subjects='.$_GET['tsk_search_subjects']:'');
  $closeAction .= (isset($_GET['tsk_search_periods'])?'?tsk_search_periods='.$_GET['tsk_search_periods']:'');
}
else if (isset($_POST['action_on_close'])) {
  $closeAction = $_POST['action_on_close'];
}

// Handle the test button
if (isset($_POST['sug_url_test'])) {
  redirect($sug->getProperty('sug_url_test'));
}

// Events from the Toolbar buttons
if (count($_POST)||count($_GET)) {
  include_once($SPL_CFG['dirroot'].'/ui/inc/action.php');  
  switch ($action) {
    case 'save':
    case 'list':
      save();
      redirect($closeAction);
      break;
    default:
      break;
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('sgd','default','template_iframeedit.htm',false,false,$m_trans,$m_meta);
$page->startForm();
//$page->startScrollableArea();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($sug->getProperty('sug_title'),$closeAction);
          $page->startTable();
            // Add a hidden field to capture the status listbox events
            $page->addField('toolbar_button','',false,false,false,false,null,false,false,true);
            // Add a hidden field to pass on the closeaction
            $page->addField('action_on_close',$closeAction,false,false,false,false,null,false,false,true);

            $page->startRow();
              $page->startColumn('none','colspan="2"');
              $page->startAreaText();
                $page->startTable();
                  include_once($SPL_CFG['dirroot'].'/ui/inc/fontsize.inc.php');
                  $page->addContent('<tr><td class="textarea_viewport"><span name="sug_description" id="sug_description"'.($customFontSize!='normal'?$customFontSize:'').'>'.$sug->getPropertyFormatted('sug_description').'<br /><br /></span></td></tr>');
                $page->endTable();
              $page->endAreaText();
              $page->endColumn();
            $page->endRow();
            $page->endAreaText();
          
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                $page->startTable();
                  $page->addField('sgd_caldate_start',$sgd->getProperty('sgd_caldate_start'),true);
                  $page->addField('sgd_actualdate_start',$sgd->getProperty('sgd_actualdate_start'),true);
                  $page->startRow();
                    $page->startColumn('label_readonly');
                      $page->addContent($page->translate('sgn_note'));
                    $page->endColumn();
                    $page->startColumn();
                    $page->endColumn();
                    $page->startColumn();
                      $page->startTable();
                        $page->addField('is_private');
                      $page->endTable();
                    $page->endColumn();
                  $page->endRow();
                $page->endTable();
                $page->endAreaData();
              $page->endColumn();
              $page->startColumn('none','style="vertical-align:top"');
                $page->startAreaData();
                $page->startTable();
                  $statusses = false;
                  include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
                  $sts = new sts();
                  $statusses = $sts->getKeyValues(false,'sts_teacher_allowed');
                  $page->addField('sts_id',$sgd->getProperty('sts_id'),false,false,true,$statusses,null,false);
                  if (isset($SPL_CFG['learning_assessment'])&&$SPL_CFG['learning_assessment']){
                    $page->addField('sgd_assessment',$sgd->getProperty('sgd_assessment'),false);
                  }
                  $page->addField('sgd_compliment');
                $page->endTable();
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn('none','colspan="2"');
                $page->startAreaData();
                $page->startTable();
                  $page->addField('sgn_note');
                $page->endTable();
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn('none','colspan="2"');
                $page->startAreaButton();
                $page->addButton('save','toolbar_save','submit','default','8','button');
                $page->endAreaButton();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
        
        $page->startScrollableArea();
        // Add previous notes
        $query  = 'SELECT sgn_id,usr_name,stu_dispname FROM '.$SPL_CFG['prefix'].'sgn sgn LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = sgn.create_usr_id LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = usr.stu_id';
        $query .= ' WHERE sgn.adm_id = "'.$_SESSION['adm_id'].'" AND sgn.sgd_id = "'.$sgd->getProperty('sgd_id').'"';
        $query .= ' ORDER BY sgn.create_date DESC';
        $result = db_query($query);
        if (db_num_rows($result)>0) {
          $page->startPane($SPL_TXT['notes'],'noclose','notes');
            $page->startAreadata();
            $page->startTable('note');
              while ($row = db_fetch_array($result)) {
                $sgn = new sgn();
                $sgn->init($row['sgn_id']);
                $page->startRow('note');
                  $page->startColumn('notelabel');
                    $page->addContent(strftime("%Y-%m-%d %H:%M",$sgn->getProperty('create_date')));
                    $page->addContent('<br />');
                    $page->addContent(isset($row['stu_dispname'])?$row['stu_dispname']:$row['usr_name']);
                  $page->endColumn();
                  $page->startColumn('note');
                    $page->startTable();
                    $page->addField('sgn_note_display',$sgn->getPropertyFormatted('sgn_note'),true);
                    $page->endTable();
                  $page->endColumn();
                $page->endRow();
              }
            $page->endTable();
            $page->endAreaData();
          $page->endPane();
        }
        $page->endScrollableArea();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
//$page->endScrollableArea();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Show the page
//=========================================================================
function set(){
  
  global $SPL_CFG,$sgd;
  
  // Status
  if (isset ($_POST['sts_id'])) {
    $sgd->setProperty('sts_id', $_POST['sts_id']);
    $sgd->setProperty('is_changed', '1');
  }
  
  // Compliment
  if (isset ($_POST['sgd_compliment'])) {
    $sgd->setProperty('sgd_compliment', '1');
    $sgd->setProperty('is_changed', '1');
  }
  else {
    $sgd->setProperty('sgd_compliment', '0');
  }

  // Notes
  if (isset($_POST['sgn_note'])&&(!empty($_POST['sgn_note']))) {
    $sgn = new sgn();
    $sgn->setProperty('sgd_id',$sgd->getProperty('sgd_id'));
    $sgn->setProperty('sgn_note',$_POST['sgn_note']);
    if (isset ($_POST['is_private'])) {
      $sgn->setProperty('is_private', '1');
    }
    else {
      $sgn->setProperty('is_private', '0');
    }
    $sgn->save();
    $sgd->setProperty('is_changed', '1');
  }            
  
  // Assessment
  if (isset ($_POST['sgd_assessment'])) {
    $sgd->setProperty('sgd_assessment', $_POST['sgd_assessment']);
    $sgd->setProperty('is_changed', '1');
  }
  
  // Get the status defaults
  include_once($SPL_CFG['dirroot'].'/class/sts.class.php');
  $sts = new sts();
  if ($sts->init($_POST['sts_id'])) {
    $sgd->setProperty('is_done',$sts->_data['is_done']);
  }
  
  
}

function save(){
  
  global $SPL_CFG,$sgd;
  
  if (isset($_POST['toolbar_button'])){
    if ($_POST['toolbar_button']=='cancel'){
      return;
    }
  }
  
  // Set values
  set();
  
  // Save row
  $sgd->save();
  
  // Clear notifications for this activity
  if (isset($SPL_CFG['teacher_statistics']) && $SPL_CFG['teacher_statistics']=='true'){
    $sgd->clearNotification();
  }
}

/** 
 * $Log: tsk_display.inc.php,v $
 * Revision 1.7  2006/08/28 09:16:01  jebbol
 * Changed layout
 *
 * Revision 1.6  2006/03/08 16:41:54  jebbol
 * *** empty log message ***
 */

?>
