<?php
/**
 * User interface for manipulating data in a format object
 *
 * $Author: jebbol $
 * $Revision: 1.8 $
 * $Date: 2006/02/11 16:41:58 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: lst.php,v $
 * Revision 1.8  2006/02/11 16:41:58  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/lst.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new lst();
$editMode = (bool)false;

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/lst.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/lst.metadata.php';

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($_GET['from'])){
  $from_id = $_GET['id'];
  unset ($_GET['id']);
}
    
// Populate the object
if (isset($_GET['id']) || isset($_POST['id'])) {
  if ($object->init(isset($_GET['id'])?$_GET['id']:$_POST['id'])){
    $_SESSION['lst_id'] = isset($_GET['id'])?$_GET['id']:$_POST['id'];
  }
  unset ($_GET['id']);
  unset ($_POST['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['lst_id'])) {
    $object->init($_SESSION['lst_id']);
  }
  // if there is no current object, start a search
  else  if (!isset($_REQUEST['toolbar_button'])) {
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/lst_search.php');
  }
}

// Events from the Toolbar buttons
if (count($_POST)||count($_GET)) {
  include_once($SPL_CFG['dirroot'].'/ui/inc/action.php');  
  switch ($action) {
    case 'cancel':
      break;
    case 'del':
      $object->setProperty('is_active', false);
      $object->save();
      $object = new lst();
      unset($_SESSION['lst_id']);
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/lst_search.php');
      break;
    case 'new':
      $object = new lst();
      $editMode = (bool)true;
      unset($_SESSION['lst_id']);
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    default:
      break;
  }
  unset($_POST['toolbar_button']);
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['lst_id']){
    $object->setProperty($_GET['from'],$from_id);
  }
  unset($_GET['from']);
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('lst','default','template.htm',true,false,$m_trans,$m_meta);
$page->startForm(null,'default',true);
  $page->startAreaData();
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode,$editMode,!$editMode);
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('lst_name',$object->getProperty('lst_name'),!$editMode);
      $page->addField('lst_short',$object->getProperty('lst_short'),!$editMode);
      $page->addField('lst_code',$object->getProperty('lst_code'),!$editMode);
      $page->addField('is_active',$object->getProperty('is_active'),!$editMode);
      $page->showFormButtons();
    $page->endSubsection();
  $page->endSection();
  $page->endAreaData();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object;
  
  if (isset ($_POST['lst_name'])) {$object->setProperty('lst_name', $_POST['lst_name']);}
  if (isset ($_POST['lst_short'])) {$object->setProperty('lst_short', $_POST['lst_short']);}
  if (isset ($_POST['lst_code'])) {$object->setProperty('lst_code', $_POST['lst_code']);}
  if (isset ($_POST['is_active'])) {$object->setProperty('is_active', '1');}
  else {$object->setProperty('is_active', '0');}
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }

  if (isset($_POST['toolbar_button'])){
    if ($_POST['toolbar_button']=='cancel'){
      return;
    }
  }
  set();
  $object->save();

  $_SESSION['lst_id'] = $object->getProperty('lst_id');
}

?>
