<?php
/**
 * User interface for manipulating data in a subject object
 *
 * $Author: jebbol $
 * $Revision: 1.11 $
 * $Date: 2006/08/08 14:21:32 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

$sanitize = array(
  'sub_id'=>array('type'=>'int'),
  'sub_code'=>array('type'=>'char'),
  'sub_name'=>array('type'=>'char'),
  'sub_short'=>array('type'=>'char'),
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new sub();
$editMode = (bool)false;
$searchscript = $SPL_CFG['wwwroot'].'/methodology/traditional/ui/sub_search.php';

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/sub.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/sub.metadata.php';

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from'])){
  $from_id = $clean['id'];
}
    
// Populate the object
if (isset($clean['id'])) {
  if ($object->init($clean['id'])){
    $_SESSION['sub_id'] = $clean['id'];
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION['sub_id'])) {
    $object->init($_SESSION['sub_id']);
  }
  // if there is no current object, start a search
  else  if (!isset($clean['button_action'])) {
    redirect($searchscript);
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      if ($object->delete($object->getProperty('is_active')=='1')) {
        $object = new sub();
        unset($_SESSION['sub_id']);
        redirect($searchscript);
      }
      else {
        $msg = $object->getMessages();
        if (isset($msg[0])) {
          include_once ($m_trans);
          $_SESSION['msg']                 = isset($SPL_TXT[$msg[0]])?$SPL_TXT[$msg[0]]:$msg[0];
          $_SESSION['referred_from']       = $_SERVER['PHP_SELF'];
          $_SESSION['messagebox_icontype'] = 'disappointed';
          redirect($SPL_CFG['wwwroot'].'/ui/message.php');
        }
      }
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($searchscript);
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $object = new sub();
      $editMode = (bool)true;
      unset($_SESSION['sub_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class=sub');
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['sub_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('sub','default','template.htm',true,false,$m_trans,$m_meta);
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('sub_name',$object->getProperty('sub_name'),!$editMode);
      $page->addField('sub_short',$object->getProperty('sub_short'),!$editMode);
      $page->addField('sub_code',$object->getProperty('sub_code'),!$editMode);
      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
      $page->showFormButtons();
    $page->endSubsection();
    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $selected = (!isset($_POST['selected_tab'])?'apl_tab1':$_POST['selected_tab']);
        $page->addTabbar($selected, 'subframe',NULL,false,'id='.$object->getProperty('sub_id'));
        $page->addIFrame('apl_search.php?child=sub&id='.$object->getProperty('sub_id').'&parent=ali&code='.$object->getProperty('sub_code'),'subframe','default','no','36em');
      $page->endSubsection();
    }
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean;
  
  if (isset ($clean['sub_name'])) {$object->setProperty('sub_name', $clean['sub_name']);}
  if (isset ($clean['sub_short'])) {$object->setProperty('sub_short', $clean['sub_short']);}
  if (isset ($clean['sub_code'])) {$object->setProperty('sub_code', $clean['sub_code']);}
  if (isset ($clean['is_active'])) {$object->setProperty('is_active', $clean['is_active']);}
}

function save(){
  
  global $object,$clean,$editMode;

  if (!$editMode){
    return;
  }

  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();

  $_SESSION['sub_id'] = $object->getProperty('sub_id');
}

/** 
 * $Log: sub.php,v $
 * Revision 1.11  2006/08/08 14:21:32  jebbol
 * Added reporting capabilities
 *
 * Revision 1.10  2006/08/08 07:08:58  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.9  2006/02/11 16:45:19  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
