<?php
/**
 * Suggestions
 *
 * $Author: jebbol $
 * $Revision: 1.16 $
 * $Date: 2006/08/24 17:36:33 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */ 

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sug.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

$sanitize = array(
  'sug_id'=>array('type'=>'int'),
  'sug_title'=>array('type'=>'char'),
  'sug_short'=>array('type'=>'char'),
  'sug_code'=>array('type'=>'char'),
  'sug_description'=>array('type'=>'char'),
  'sug_knowledge'=>array('type'=>'char'),
  'sug_directions'=>array('type'=>'char'),
  'sug_prerequisites'=>array('type'=>'char'),
  'sug_materials'=>array('type'=>'char'),
  'fmt_id'=>array('type'=>'int'),
  'lst_id'=>array('type'=>'int'),
  'tra_id'=>array('type'=>'int'),
  'ali_id'=>array('type'=>'int'),
  'sub_id'=>array('type'=>'int'),
  'sug_courseyear'=>array('type'=>'int'),
  'sug_do_schedule'=>array('type'=>'bool'),
  'sug_do_portfolio'=>array('type'=>'bool'),
  'sug_url_test'=>array('type'=>'url'),
  'sug_url_elo'=>array('type'=>'url'),
  'sug_id_parent'=>array('type'=>'int'),
  'sug_required'=>array('type'=>'bool'),
  'sug_signout'=>array('type'=>'bool'),
  'sug_load'=>array('type'=>'int'),
  'sug_reward'=>array('type'=>'int'),
  'sug_type'=>array('type'=>'enum','values'=>',A'),
  'sug_alert_days'=>array('type'=>'int'),
  'sug_sequence'=>array('type'=>'int'),
  'has_parent'=>array('type'=>'int'),
  'parent_id'=>array('type'=>'int'),
  'my_id'=>array('type'=>'int'),
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new sug();
$parent = new sug();
$editMode = (bool)false;
$searchscript = $SPL_CFG['wwwroot'].'/methodology/traditional/ui/sug_search.php';
$usd = new usd();
$usd_script = 'sug';

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/sug.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/sug.metadata.php';

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from'])){
  $from_id = $clean['id'];
}
    
// Get the parent
$parent_id=0;
if (isset($clean['parent_id'])) {
  if (is_numeric($clean['parent_id'])) {
    $parent_id = $clean['parent_id'];
  }
}
else if (isset($clean['has_parent'])&&$clean['has_parent']>0) {
  $parent_id = $clean['has_parent'];
}

// Populate the object
if (isset($clean['id'])) {
  $id = $clean['id'];
  if ($object->init($id)){
    // Only set the global suggestion for main suggestions
    if (!$parent_id){
      $_SESSION['sug_id'] = $id;
    }
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION['sug_id'])&&!$parent_id) {
    $object->init($_SESSION['sug_id']);
  }
  else if (isset($clean['has_parent'])) {
    if ($clean['has_parent']>0) {
      $object->init($clean['my_id']);
    }
  }
  // if there is no current object, start a search
  else  if (!isset($clean['button_action'])) {
    redirect($searchscript);
  }
}

// Capture the search on reference fields
if (isset($clean['search_button'])) {
  // Save the form data
  save();
  // Redirect browser to the search page
  if ($clean['search_button']=='sug_id_parent'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/sug_search.php?from=sug_id_parent');
  }
  if ($clean['search_button']=='tra_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php?from=tra_id');
  }
  if ($clean['search_button']=='ali_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/ali_search.php?from=ali_id');
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      if ($object->delete($object->getProperty('is_active')=='1')) {
        $object = new sug();
        unset($_SESSION['sug_id']);
        redirect($searchscript);
      }
      else {
        $msg = $object->getMessages();
        if (isset($msg[0])) {
          include_once ($m_trans);
          $_SESSION['msg']                 = isset($SPL_TXT[$msg[0]])?$SPL_TXT[$msg[0]]:$msg[0];
          $_SESSION['referred_from']       = $_SERVER['PHP_SELF'];
          $_SESSION['messagebox_icontype'] = 'disappointed';
          redirect($SPL_CFG['wwwroot'].'/ui/message.php');
        }
      }
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($searchscript);
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $object = new sug();
      if ($parent_id>0) {
        // The only other type available is 'activity'
        $object->setProperty('sug_type', 'A');
      }
      $editMode = (bool)true;
      unset($_SESSION['sug_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class=sug');
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['sug_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

// Determine the type
$isSuggestion = empty($object->_data['sug_type']);
$isActivity   = $object->_data['sug_type']=='A';
$new          = $object->isNew();

$page = new page();
$page->init('sug','default',($isActivity?'template_iframeplain.htm':'template.htm'),$isSuggestion,false,$m_trans,$m_meta);
$page->startForm(null,'default',false,$isActivity);
  if ($isSuggestion) {
    $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode,$editMode,!$editMode);
    $page->startAreaData();
  }
  else { 
    $page->startAreaTabSheet();
  }

  // Type == Suggestion
  if ($isSuggestion) {
    $page->startSection();
      $page->startSubsection('subsection1');
        $page->addField('sug_title',$object->getProperty('sug_title'),!$editMode);
        $page->addField('sug_short',$object->getProperty('sug_short'),!$editMode);
        $page->addField('sug_code',$object->getProperty('sug_code'),!$editMode);
        // Portfolio
        if ($SPL_CFG['portfolio']!='none'){
          $page->addField('sug_do_portfolio',$object->getProperty('sug_do_portfolio'),!$editMode);
        }
        // Active
        require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
        $page->showFormButtons();
      $page->endSubSection();
      $page->startSubsection('subsection2');
        if ($_SESSION['methodology']=='traditional'){
          $tra = new tra();
          if (!$tra->isSingle()) {
            // Training
            if ($editMode){
              if ($new&&!isset($clean['tra_id'])) {
                // Find user defaults
                $tmp = $usd->getDefault($usd_script,'tra_id');
                if ($tmp) {
                  $object->setProperty('tra_id',$tmp);
                }
              }
              $page->addField('tra_id',$object->getProperty('tra_id'),!$editMode,false,false,$tra->getKeyValues('ina',$_SESSION['usp_ina_id']));
            }
            else {
              $page->addField('tra_id',$object->getProperty('tra_id'),!$editMode);
            }
          }
        }
        // Alignment
        require ($SPL_CFG['dirroot'].'/ui/inc/field.ali_id.inc.php');
        // Subject
        require ($SPL_CFG['dirroot'].'/ui/inc/field.sub_id.inc.php');
        $page->addField('sug_courseyear',$object->getProperty('sug_courseyear'),!$editMode);
      $page->endSubsection();
    $page->endSection();
    $page->startSection();
      if ($object->isLoaded()){
        $page->startSubsection('subsection3');
        $tabs = array(array('name'=>'sug_tab1','title'=>'sug_description','widget'=>'tab_description','empty'=>empty($object->_data['sug_description'])),
                      array('name'=>'sug_tab2','title'=>'sug_knowledge','widget'=>'tab_knowledge','empty'=>empty($object->_data['sug_knowledge'])),
                      array('name'=>'sug_tab3','title'=>'sug_directions','widget'=>'tab_directions','empty'=>empty($object->_data['sug_directions'])),
                      array('name'=>'sug_tab4','title'=>'sug_prerequisites','widget'=>'tab_prerequisites','empty'=>empty($object->_data['sug_prerequisites'])),
                      array('name'=>'sug_tab5','title'=>'sug_materials','widget'=>'tab_materials','empty'=>empty($object->_data['sug_materials'])),
                      array('name'=>'sug_tab6','title'=>'activity','widget'=>'tab_activity','tabaction'=>'sug_act_search.php?parent=sug'.'&parent_id='.$object->getProperty('sug_id'),'empty'=>!$object->hasActivities(),'target'=>'tab_activity')
                     );
        $selected = (!isset($clean['selected_tab'])?'sug_tab1':$clean['selected_tab']);
        $page->addTabbar($selected,NULL,$tabs,true,null,($isSuggestion?null:'sub'));
        $page->addField('sug_description',$object->getPropertyFormatted('sug_description'),!$editMode,false,false,false,NULL,true,' id="tab_description"'.($selected=='sug_tab1'?'':' style="display:none"'));
        $page->addField('sug_knowledge',$object->getPropertyFormatted('sug_knowledge'),!$editMode,false,false,false,NULL,true,' id="tab_knowledge"'.($selected=='sug_tab2'?'':' style="display:none"'));
        $page->addField('sug_directions',$object->getPropertyFormatted('sug_directions'),!$editMode,false,false,false,NULL,true,' id="tab_directions"'.($selected=='sug_tab3'?'':' style="display:none"'));
        $page->addField('sug_prerequisites',$object->getPropertyFormatted('sug_prerequisites'),!$editMode,false,false,false,NULL,true,' id="tab_prerequisites"'.($selected=='sug_tab4'?'':' style="display:none"'));
        $page->addField('sug_materials',$object->getPropertyFormatted('sug_materials'),!$editMode,false,false,false,NULL,true,' id="tab_materials"'.($selected=='sug_tab5'?'':' style="display:none"'));
        $page->addIFrame('wait.php','tab_activity','display:none;width:100%;height:'.($isSuggestion?'30':'15').'em');
        $page->endSubsection();
      }
    $page->endSection();
  }
  // End type = Suggestion
  
  // Type == Activity
  if ($isActivity) {
    $page->startSection();
      $page->startSubsection('subsection1','width:15em');
        // Hidden fields
        $page->addField('has_parent',$parent_id,false,false,false,false,null,false,false,true);
        $page->addField('my_id',$object->_data['sug_id'],false,false,false,false,null,false,false,true);
        // end of hidden fields
        
        $page->addField('sug_title',$object->getProperty('sug_title'),!$editMode,false,false,false,null,true,false,false,1,20);
        $page->addField('sug_short',$object->getProperty('sug_short'),!$editMode,false,false,false,null,true,false,false,2);
        $page->addField('fmt_id',$object->getProperty('fmt_id'),!$editMode,false,false,false,null,true,false,false,3);
        //$page->addField('sug_required',$object->getProperty('sug_required'),!$editMode,false,false,false,null,true,false,false,4);
        $page->addField('sug_signout',$object->getProperty('sug_signout'),!$editMode,false,false,false,null,true,false,false,5);
        if ($SPL_CFG['learning_style']!='false'){
          $page->addField('lst_id',$object->getProperty('lst_id'),!$editMode,false,false,false,null,true,false,false,6);
        }
        if ($SPL_CFG['scheduler']!='none'){
          $page->addField('sug_do_schedule',$object->getProperty('sug_do_schedule'),!$editMode,false,false,false,null,true,false,false,7);
        }
        if ($SPL_CFG['learning_load']!='false'){
          $page->addField('sug_load',$object->getProperty('sug_load'),!$editMode,false,false,false,null,true,false,false,8);
        }
        if ($SPL_CFG['learning_reward']!='false'){
          $page->addField('sug_reward',$object->getProperty('sug_reward'),!$editMode,false,false,false,null,true,false,false,9);
        }
        $page->addField('sug_url_test',$object->getProperty('sug_url_test'),!$editMode,false,false,false,null,true,false,false,10,20);
        if ($SPL_CFG['elo']!='none'){
          $page->addField('sug_url_elo',$object->getProperty('sug_url_elo'),!$editMode,false,false,false,null,true,false,false,11,20);
        }
        $page->addField('sug_alert_days',$object->getProperty('sug_alert_days'),!$editMode,false,false,false,null,true,false,false,12);
        $page->addField('sug_sequence',$object->getProperty('sug_sequence'),!$editMode,false,false,false,null,true,false,false,13);
        //$page->showFormButtons();
      // Start buttons
      $page->endTable();
      $page->startTable();
      $page->startRow();
      $page->startColumn();
      if ($editMode){
        $page->addButton('save','toolbar_save','submit','default','8','button');
        if (!$isSuggestion){
          $page->addButton('cancel','toolbar_cancel','submit','default','8','button');
        }
        else {
          $page->addButton('cancel','toolbar_cancel','button','window.history.back()','8','button');
        }
      }
      else {
        if ($_SESSION['sug_permission']['write']) {
          $page->addButton('new','toolbar_new','submit','default','8','button');
        }
        if ($_SESSION['sug_permission']['change']) {
          $page->addButton('edit','toolbar_edit','submit','default','8','button');
        }
        if ($_SESSION['sug_permission']['delete']) {
          $page->addButton('del','toolbar_del','submit','default','8','button');
        }
      }
      $page->endColumn();
      $page->endRow();
      $page->endSubSection();

      $page->startSubsection('subsection2');
      $tabs = array(array('name'=>'sug_tab1','title'=>'sug_description_short','widget'=>'subtab_description','empty'=>empty($object->_data['sug_description'])),
                    array('name'=>'sug_tab2','title'=>'sug_knowledge_short','widget'=>'subtab_knowledge','empty'=>empty($object->_data['sug_knowledge'])),
                    array('name'=>'sug_tab3','title'=>'sug_directions_short','widget'=>'subtab_directions','empty'=>empty($object->_data['sug_directions'])),
                    array('name'=>'sug_tab4','title'=>'sug_prerequisites_short','widget'=>'subtab_prerequisites','empty'=>empty($object->_data['sug_prerequisites'])),
                    array('name'=>'sug_tab5','title'=>'sug_materials_short','widget'=>'subtab_materials','empty'=>empty($object->_data['sug_materials']))
                   );
      // Add an activity tab when this is not an activity itself
      if ($isSuggestion && $object->isLoaded()) {
        $tabs[] = array('name'=>'sug_tab6','title'=>'activity','widget'=>'subtab_activity','tabaction'=>'sug_act_search.php?parent=sug'.'&parent_id='.$object->getProperty('sug_id'),'empty'=>!$object->hasActivities(),'target'=>'tab_activity');
      }
      $selected = (!isset($clean['selected_tab'])?'sug_tab1':$clean['selected_tab']);
      $page->addTabbar($selected,NULL,$tabs,true,null,($isSuggestion?null:'tabsheetsub'));
      $page->addField('sug_description',$object->getPropertyFormatted('sug_description'),!$editMode,false,false,false,NULL,true,' id="subtab_description"'.($selected=='sug_tab1'?'':' style="display:none"'),false,13);
      $page->addField('sug_knowledge',$object->getPropertyFormatted('sug_knowledge'),!$editMode,false,false,false,NULL,true,' id="subtab_knowledge"'.($selected=='sug_tab2'?'':' style="display:none"'),false,14);
      $page->addField('sug_directions',$object->getPropertyFormatted('sug_directions'),!$editMode,false,false,false,NULL,true,' id="subtab_directions"'.($selected=='sug_tab3'?'':' style="display:none"'),false,15);
      $page->addField('sug_prerequisites',$object->getPropertyFormatted('sug_prerequisites'),!$editMode,false,false,false,NULL,true,' id="subtab_prerequisites"'.($selected=='sug_tab4'?'':' style="display:none"'),false,16);
      $page->addField('sug_materials',$object->getPropertyFormatted('sug_materials'),!$editMode,false,false,false,NULL,true,' id="subtab_materials"'.($selected=='sug_tab5'?'':' style="display:none"'),false,17);
      $page->addIFrame('wait.php','subtab_activity','display:none;width:100%;height:'.($isSuggestion?'30':'15').'em');
    $page->endSubsection();
  $page->endSection();
  }
  // End type = Activity  

  $page->endAreaData();
  if (!$isActivity) {
    $page->addFootbar();
  }
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean,$SPL_CFG;

  if (isset ($clean['sug_title']))         {$object->setProperty('sug_title', $clean['sug_title']);}
  if (isset ($clean['sug_short']))         {$object->setProperty('sug_short', $clean['sug_short']);}
  if (isset ($clean['sug_code']))          {$object->setProperty('sug_code', $clean['sug_code']);}
  if (isset ($clean['sug_description']))   {$object->setProperty('sug_description', $clean['sug_description']);}
  if (isset ($clean['sug_knowledge']))     {$object->setProperty('sug_knowledge', $clean['sug_knowledge']);}
  if (isset ($clean['sug_directions']))    {$object->setProperty('sug_directions', $clean['sug_directions']);}
  if (isset ($clean['sug_prerequisites'])) {$object->setProperty('sug_prerequisites', $clean['sug_prerequisites']);}
  if (isset ($clean['sug_materials']))     {$object->setProperty('sug_materials', $clean['sug_materials']);}
  if (isset ($clean['lst_id']))            {$object->setProperty('lst_id', $clean['lst_id']);}
  if (isset ($clean['fmt_id']))            {$object->setProperty('fmt_id', $clean['fmt_id']);}
  if (isset ($clean['tra_id']))            {$object->setProperty('tra_id', $clean['tra_id']);}
  if (isset ($clean['ali_id']))            {$object->setProperty('ali_id', $clean['ali_id']);}
  if (isset ($clean['sub_id']))            {$object->setProperty('sub_id', $clean['sub_id']);}
  if (isset ($clean['sug_courseyear']))    {$object->setProperty('sug_courseyear', $clean['sug_courseyear']);}
  if (isset ($clean['sug_url_test']))      {$object->setProperty('sug_url_test', $clean['sug_url_test']);}
  if (isset ($clean['sug_load']))          {$object->setProperty('sug_load', $clean['sug_load']);}
  if (isset ($clean['sug_reward']))        {$object->setProperty('sug_reward', $clean['sug_reward']);}
  if (isset ($clean['sug_sequence']))      {$object->setProperty('sug_sequence', $clean['sug_sequence']);}
  if (isset ($clean['sug_required']))      {$object->setProperty('sug_required', $clean['sug_required']);}
  if (isset ($clean['sug_signout']))       {$object->setProperty('sug_signout', $clean['sug_signout']);}
  if (isset ($clean['sug_alert_days']))    {$object->setProperty('sug_alert_days', $clean['sug_alert_days']);}
  
  // Set active only on suggestion, not on activities
  if (empty($object->_data['sug_type'])) {
    if (isset ($clean['is_active']))         {$object->setProperty('is_active', $clean['is_active']);}
  }
  
  if ($SPL_CFG['scheduler']!='none'){
    if (isset ($clean['sug_do_schedule'])) {$object->setProperty('sug_do_schedule', $clean['sug_do_schedule']);}
  }
  if ($SPL_CFG['portfolio']!='none'){
    if (isset ($clean['sug_do_portfolio'])){$object->setProperty('sug_do_portfolio', $clean['sug_do_portfolio']);}
  }
  if ($SPL_CFG['elo']!='none'){
    if (isset ($clean['sug_url_elo']))     {$object->setProperty('sug_url_elo', $clean['sug_url_elo']);}
  }

}

function save(){
  
  global $object,$clean,$editMode,$parent_id;

  if (!$editMode){
    return;
  }
  
  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  
  set();

  // Assign parent id, when applicable
  $object->setProperty('sug_id_parent', $parent_id);
  
  // Set type
  if ($parent_id>0) {
    // The only other type available is 'activity'
    $object->setProperty('sug_type', 'A');
  }

  $object->save();

  if (!$parent_id) {
    $_SESSION['sug_id'] = $object->getProperty('sug_id');
  }
}

/** 
 * $Log: sug.php,v $
 * Revision 1.16  2006/08/24 17:36:33  jebbol
 * Added support for alerts
 *
 * Revision 1.15  2006/08/08 14:21:33  jebbol
 * Added reporting capabilities
 *
 * Revision 1.14  2006/08/08 07:08:58  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.13  2006/04/14 11:27:28  jebbol
 * Bug #1467590: Added check on single instance
 *
 * Revision 1.12  2006/03/08 16:41:10  jebbol
 * *** empty log message ***
 *
 * Revision 1.11  2006/02/23 19:18:28  jebbol
 * Prefixeed the id of subtab rows with 'sub'
 *
 * Revision 1.10  2006/02/11 17:52:05  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

?>