<?php
/**
 * User interface for displaying activities in the studyguide
 *
 * $Author: jebbol $
 * $Revision: 1.3 $
 * $Date: 2006/02/11 16:48:58 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: sug_act_guide.php,v $
 * Revision 1.3  2006/02/11 16:48:58  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');


//=========================================================================
// Check POST and Get
//=========================================================================
$parent = 0;
if (isset($_GET['parent_id'])) {
  if (is_numeric($_GET['parent_id'])) {
    $parent = $_GET['parent_id'];
  }
}

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/sug.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/sug.metadata.php';

//=========================================================================
// Local variables
//=========================================================================

$query['columns']  = 'sug.sug_id AS id,"#" AS target,sug_title,fmt_short,sts_short';
$query['tblName']  = 'sug sug RIGHT JOIN '.$SPL_CFG['prefix'].'sgd sgd ON sgd.sug_id = sug.sug_id LEFT JOIN '.$SPL_CFG['prefix'].'fmt fmt ON fmt.fmt_id = sug.fmt_id LEFT JOIN '.$SPL_CFG['prefix'].'sts sts ON sts.sts_id = sgd.sts_id';
$query['where']    = 'WHERE sug.adm_id = "'.$_SESSION['adm_id'].'" AND sug.is_active AND sgd.usr_id = "'.$_SESSION['usr_id'].'"';
$query['orderBy']  = 'sug_sequence,sug_title';
$query['orderDir'] = 'ASC';

// Get the parent
if ($parent) {
  $query['where'] .= ' AND sug_id_parent = "'.$parent.'" AND sug_type = "A"';
  $query['parentChild'] = 'parent_id='.$parent;
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = 'sug_sequence,'.$_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 


//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('sug','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

// Create the page
$page = new page();
$page->init('sug','default','template_search.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
  $page->startForm("sugactsearchform");
  $page->startAreaData();
  $page->startSection();
  $page->startColumn();
  $table->setImageDir($page->getImageDir());
  $page->addContent($table->getTable());
  $page->endColumn();
  $page->endSection();
  $page->endAreaData();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

?>
