<?php
/**
 * User interface for searching activities in the sug table
 *
 * $Author: jebbol $
 * $Revision: 1.6 $
 * $Date: 2006/08/24 17:36:33 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: sug_act_search.php,v $
 * Revision 1.6  2006/08/24 17:36:33  jebbol
 * Added support for alerts
 *
 * Revision 1.5  2006/08/08 07:08:58  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.4  2006/03/08 16:41:10  jebbol
 * *** empty log message ***
 *
 * Revision 1.3  2006/02/11 16:50:39  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');


//=========================================================================
// Check POST and Get
//=========================================================================
$parent = 0;
if (isset($_GET['parent_id'])) {
  if (is_numeric($_GET['parent_id'])) {
    $parent = $_GET['parent_id'];
  }
}

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/sug.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/sug.metadata.php';

//=========================================================================
// Local variables
//=========================================================================

$query['columns']  = 'sug_id AS id,"sug.php'.($parent?'?parent_id='.$parent:'').'" AS target,sug_title,fmt_short,sug_signout'.($SPL_CFG['learning_load']!='false'?',sug_load':'').($SPL_CFG['learning_reward']!='false'?',sug_reward':'');
$query['tblName']  = 'sug sug LEFT JOIN '.$SPL_CFG['prefix'].'fmt fmt ON fmt.fmt_id = sug.fmt_id';
$query['where']    = 'WHERE sug.adm_id = "'.$_SESSION['adm_id'].'" AND sug.is_active';
$query['orderBy']  = 'sug_sequence,sug_title';
$query['orderDir'] = 'ASC';

// Get the parent
if ($parent) {
  $query['where'] .= ' AND sug_id_parent = "'.$parent.'" AND sug_type = "A"';
  $query['parentChild'] = 'parent_id='.$parent;
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = 'sug_sequence,'.$_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

// Small view
$query['viewSize'] = 13;

//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('sug','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->addNewButton(NULL,$SPL_CFG['wwwroot'].'/methodology/'.$_SESSION['methodology'].'/ui/sug.php?toolbar_button=new&new'.($parent?'&parent_id='.$parent:'').'"');

// Create the page
$page = new page();
$page->init('sug','default','template_searchtabbed.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
  $page->startForm("sugactsearchform",'default',false,true);
  $page->startAreaGrid();
  //$page->startSection();
  //$page->startColumn();
  $table->setImageDir($page->getImageDir());
  $page->addContent($table->getTable());
  //$page->endColumn();
  //$page->endSection();
  $page->endAreaGrid();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

?>
