<?php
/**
 * Training
 *
 * $Author: jebbol $
 * $Revision: 1.13 $
 * $Date: 2006/08/08 14:21:34 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new tra();
$editMode = (bool)false;

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'tra_id'=>array('type'=>'int'),
  'tra_name'=>array('type'=>'char'),
  'tra_short'=>array('type'=>'char'),
  'tra_code'=>array('type'=>'char'),
  'tra_courseyears'=>array('type'=>'int'),
  'tra_load'=>array('type'=>'int'),
  'tra_load_per_year'=>array('type'=>'char'),
  'tra_reward'=>array('type'=>'int'),
  'tra_reward_per_year'=>array('type'=>'char')
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Methodology
//=========================================================================

// Human language translations
$m_trans = $SPL_CFG['dirroot'].'/methodology/traditional/ui/lang/'.$_SESSION['usp_lang'].'/tra.lang.php';
// Metadata
$m_meta = $SPL_CFG['dirroot'].'/methodology/traditional/ui/meta/tra.metadata.php';

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from']) && isset($clean['id'])){
  $from_id = $clean['id'];
}
    
// Populate the object
if (isset($clean['id'])) {
  if ($object->init($clean['id'])){
    $_SESSION['tra_id'] = $clean['id'];
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION['tra_id'])) {
    $object->init($_SESSION['tra_id']);
  }
  // if there is no current object, start a search
  else if (!isset($clean['button_action']))  {
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php');
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      $object->delete($object->getProperty('is_active')=='1');
      $object = new tra();
      unset($_SESSION['tra_id']);
      redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php');
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php');
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $object = new tra();
      $editMode = (bool)true;
      unset($_SESSION['tra_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class=tra');
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['tra_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('tra','default','template.htm',true,false,$m_trans,$m_meta);
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('tra_name',$object->getProperty('tra_name'),!$editMode);
      $page->addField('tra_short',$object->getProperty('tra_short'),!$editMode);
      $page->addField('tra_code',$object->getProperty('tra_code'),!$editMode);
      $page->addField('tra_courseyears',$object->getProperty('tra_courseyears'),!$editMode);
      if ($SPL_CFG['learning_load']=='true') {
        $page->addField('tra_load',$object->getProperty('tra_load'),!$editMode);
        $page->addField('tra_load_per_year',$object->getProperty('tra_load_per_year'),!$editMode);
      }
      if ($SPL_CFG['learning_reward']=='true') {
        $page->addField('tra_reward',$object->getProperty('tra_reward'),!$editMode);
        $page->addField('tra_reward_per_year',$object->getProperty('tra_reward_per_year'),!$editMode);
      }
      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
      $page->showFormButtons();
    $page->endSubsection();
    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $selected = (!isset($clean['selected_tab'])?'apl_tab1':$clean['selected_tab']);
        $page->addTabbar($selected, 'subframe',NULL,false,'id='.$object->getProperty('tra_id'));
        $page->addIFrame('apl_search.php?child=tra&id='.$object->getProperty('tra_id').'&parent=ina&code='.$object->getProperty('tra_code'),'subframe','default','no','36em');
      $page->endSubsection();
    }
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean;

  if (isset ($clean['tra_name']))            {$object->setProperty('tra_name', $clean['tra_name']);}
  if (isset ($clean['tra_short']))           {$object->setProperty('tra_short', $clean['tra_short']);}
  if (isset ($clean['tra_code']))            {$object->setProperty('tra_code', $clean['tra_code']);}
  if (isset ($clean['tra_courseyears']))     {$object->setProperty('tra_courseyears', $clean['tra_courseyears']);}
  if (isset ($clean['tra_load']))            {$object->setProperty('tra_load', $clean['tra_load']);}
  if (isset ($clean['tra_load_per_year']))   {$object->setProperty('tra_load_per_year', $clean['tra_load_per_year']);}
  if (isset ($clean['tra_reward']))          {$object->setProperty('tra_reward', $clean['tra_reward']);}
  if (isset ($clean['tra_reward_per_year'])) {$object->setProperty('tra_reward_per_year', $clean['tra_reward_per_year']);}
  if (isset ($clean['is_active']))           {$object->setProperty('is_active', $clean['is_active']);}
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }

  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();

  $_SESSION['tra_id'] = $object->getProperty('tra_id');
}

/**
 * $Log: tra.php,v $
 * Revision 1.13  2006/08/08 14:21:34  jebbol
 * Added reporting capabilities
 *
 * Revision 1.12  2006/08/08 07:08:58  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.11  2006/07/04 12:39:41  jebbol
 * Added tra_code
 *
 * Revision 1.10  2006/04/14 12:51:21  jebbol
 * *** empty log message ***
 *
 * Revision 1.9  2006/02/11 17:56:00  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
