<?php
/**
 * Manipulate subjects per teacher
 *
 * $Author: jebbol $
 * $Revision: 1.2 $
 * $Date: 2006/08/31 06:37:46 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tsu.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

$sanitize = array(
  'parent'=>array('type'=>'int'),
  'tea_id'=>array('type'=>'int'),
  'ins_id'=>array('type'=>'int'),
  'ina_id'=>array('type'=>'int'),
  'tra_id'=>array('type'=>'int'),
  'ali_id'=>array('type'=>'int'),
  'sub_id'=>array('type'=>'int'),
  'tsu_courseyear'=>array('type'=>'int','min'=>0,'max'=>99),
);
/*
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
*/
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object   = new tsu();
$editMode = (bool)false;
$myclass  = 'tsu';

// Defaults
$usd = new usd();
$usd_script = 'tsu';

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from'])){
  $from_id = isset($clean['id'])?$clean['id']:false;
}

// Populate the object
if (isset($clean['id'])) {
  if ($object->init($clean['id'])){
    $_SESSION['tsu_id'] = $clean['id'];
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION['tsu_id'])) {
    $object->init($_SESSION['tsu_id']);
  }
}

// Capture the search on reference fields
if (isset($clean['search_button'])) {
  // Save the form data
  save();
  // Redirect browser to the search page
  if ($clean['search_button']=='ins_id'){
    redirect($SPL_CFG['wwwroot'].'/ui/ins_search.php?from=ins_id');
  }
  if ($clean['search_button']=='ina_id'){
    redirect($SPL_CFG['wwwroot'].'/ui/ina_search.php?from=ina_id');
  }
  if ($clean['search_button']=='tra_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php?from=tra_id');
  }
  if ($clean['search_button']=='ali_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/ali_search.php?from=ali_id');
  }
  if ($clean['search_button']=='sub_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/sub_search.php?from=sub_id');
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      $object->delete($object->getProperty('is_active')=='1');
      $evalstr = "\$object = new ".$myclass."();";
      @eval("$evalstr");
      unset($_SESSION[$myclass.'_id']);
      redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/'.$myclass.'_search.php');
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/'.$myclass.'_search.php');
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $evalstr = "\$object = new ".$myclass."();";
      @eval("$evalstr");
      $object->setProperty('tea_id',$clean['parent']);
      $editMode = (bool)true;
      unset($_SESSION[$myclass.'_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class='.$myclass);
      break;
    case 'save':
      $editMode = (bool)true;
      if (!save()) {
        // Retrieve message
        $tmp = $object->getMessages();
        if (is_array($tmp)&&count($tmp)>0) {
          $_SESSION['msg']                 = array_pop($tmp);
          $_SESSION['referred_from']       = $_SERVER['PHP_SELF'];
          $_SESSION['messagebox_icontype'] = 'disappointed';
          redirect($SPL_CFG['wwwroot'].'/ui/message.php');
        }
      }
      $editMode = (bool)false;
      redirect($SPL_CFG['wwwroot'].'/ui/tea_subjects.php?id='.$clean['tea_id']);
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION[$myclass.'_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

// Is this a new object?
$new = $object->isNew();

// Use teacher authorization instead of the default tsu authorization
$overrule = 'tea';


//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('tsu','default','template_iframetabbed.htm',false);
$page->startForm(null,'default',false,true);
  $page->startAreaTabSheet();
    $page->startTable('none','style="width:100%"');
    $page->addTabRuler();
    $page->endTable();
    $page->startTable('detail');
    
      // Add a hidden field to capture the listbix events
      $page->addContent('<div class="hidden"><input type="hidden" name="toolbar_button" id="toolbar_button" value=""<!-- {SPL_ENDTAG} -->></div>','yes');

      // Teacher id
      if (isset($clean['parent'])) {
        $page->addContent('<div class="hidden"><input type="hidden" name="parent" id="parent" value="'.$clean['parent'].'"<!-- {SPL_ENDTAG} -->></div>','yes');
      }
      if (isset($clean['tea_id'])) {
        $page->addContent('<div class="hidden"><input type="hidden" name="tea_id" id="tea_id" value="'.$clean['parent'].'"<!-- {SPL_ENDTAG} -->></div>','yes');
      }
      // Institution
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ins_id.inc.php');
      // Institution address
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ina_id.inc.php');
      // Training
      require ($SPL_CFG['dirroot'].'/ui/inc/field.tra_id.inc.php');
      // Alignment
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ali_id.inc.php');
      // Subject
      require ($SPL_CFG['dirroot'].'/ui/inc/field.sub_id.inc.php');
      $page->addField('tsu_courseyear',($new?'1':$object->getProperty('tsu_courseyear')),false,false,$overrule);
      // Start buttons
      $page->startRow();
        // Label
        $page->startColumn();
        $page->endColumn();
        // Sign
        $page->startColumn();
        $page->endColumn();
        // Buttons
        $page->startColumn();
          if ($editMode){
            $page->addButton('save','toolbar_save','submit','default','8','button');
            $page->addButton('cancel','toolbar_cancel','submit','default','8','button');
          }
          else {
            if ($_SESSION['usr_permission']['admin']) {
              $page->addButton('new','toolbar_new','submit','default','8','button');
            }
            if ($_SESSION['usr_permission']['admin']) {
              $page->addButton('edit','toolbar_edit','submit','default','8','button');
            }
            if ($_SESSION['usr_permission']['admin']) {
              $page->addButton('del','toolbar_del','submit','default','8','button');
            }
          }
        $page->endColumn();
      $page->endRow();
      // End buttons
    $page->endTable();
  $page->endAreaTabSheet();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean;
  
  foreach ($clean as $key => $value) {
    // Ignore the housekeeping stuff
    if ($key=='id'||$key=='button_action'||$key=='toolbar_button'||$key=='search_show_inactive') {
      continue;
    }
    $object->setProperty($key, $clean[$key]);
  }
  // Force teacher id (is not in $clean)
  $object->setProperty('tea_id', $_SESSION['my_tea_id']);
}

function save(){
  
  global $clean,$object,$editMode;

  if (!$editMode){
    return;
  }
  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  if ($object->save()){
    //$_SESSION['tsu_id'] = $object->getProperty('tsu_id');
  }
  else {
    if (isset($object->_debug)&&count($object->_debug)>0&&!empty($object->_debug[count($object->_debug)-1]['result'])){
      $org = $object->_debug[count($object->_debug)-1]['result'];
      $object->init($org);
    }
  }
}

/**
 * $Log: tsu.php,v $
 * Revision 1.2  2006/08/31 06:37:46  jebbol
 * Added forced setting of tea_id
 *
 * Revision 1.1  2006/08/08 06:57:47  jebbol
 * Added in version 0.15
 *
 */
 
?>
