<?php
/**
 * Show subjects per teacher
 *
 * $Author: jebbol $
 * $Revision: 1.1 $
 * $Date: 2006/08/08 06:57:47 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../../../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Translations
if (!isset($_SESSION['usp_lang'])) {$_SESSION['usp_lang'] = 'en';}
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/tsu.lang.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Must be authorized to view this information
if (!isset($_SESSION['usr_permission'])){
  return (bool) false;
}
if ($_SESSION['usr_permission']['read']==(bool)false) {
  return (bool) false;
}


//=========================================================================
// Local variables
//=========================================================================
$query['columns']  = 'tsu_id AS id,"tsu.php" AS target,sub_id,tsu_courseyear';
$query['tblName']  = 'tsu';
$query['where']    = 'WHERE '.$SPL_CFG['prefix'].'tsu.adm_id = "'.$_SESSION['adm_id'].'"';
$query['orderBy']  = 'sub_id';
$query['orderDir'] = 'ASC';
$query['viewSize'] = (isset($_SESSION['usp_numrows'])&&(int)$_SESSION['usp_numrows']<=20?$_SESSION['usp_numrows']:'20');

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Data to link to the child data
if (isset ($_GET['id'])){
  $query['where'] .= ' AND tea_id = "'.addslashes($_GET['id']).'"';
  $query['parentChild'] = 'id='.$_GET['id'];
}

if (isset($_POST['search_for'])) {
  $query['where'] .= ' AND '.$_POST['search_by'].' LIKE "'.$_POST['search_for'].'%"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 


//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('stu');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->addNewButton(NULL,'tsu.php?parent='.$_GET['id'].'&amp;new');

// Create the page
$page = new page();
$page->init('tsu','default','template_iframetabbed.htm',false);
$page->setHeadScripts($table->getScripts());
$page->startForm("tsusearchform",'default',false,true);
  $page->startAreaGrid();
  $page->startSection('','content_start');
  $page->addTabRuler();
  $page->startColumn();
  $table->setImageDir($page->getImageDir());
  $page->addContent($table->getTable());
  $page->endColumn();
  $page->endSection('content_end');
  $page->endAreaGrid();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/**
 * $Log: tsu_search.php,v $
 * Revision 1.1  2006/08/08 06:57:47  jebbol
 * Added in version 0.15
 *
 */

?>
