<?php
/**
 * User interface for manipulating data in a applicability object
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/class/apl.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object = new apl();

/**
 * Operate in Editmode or Display
 * 
 * When operating in Editmode, authorized fields are enabled for input
 */
$editMode = (bool)false;

/**
 * Operate in childmode or in parentmode
 * 
 * When operating in childmode, the resulset shows the parents.
 * When in parentmode (childmode==false), the resultset shows the children.
 * The default setting is 'childmode'. It will switch to 'parentmode' upon detecting
 * the 'parent_id' parameter.
 */
$childMode = (bool)true;
if (isset($_GET['parent_id'])||isset($_POST['parent_mode'])){
  $childMode = (bool)false;
}

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($_GET['from'])){
  $from_id = $_GET['id'];
  unset ($_GET['id']);
}
    
// Populate the object
if (isset ($_GET['id'])) {
  if ($object->init($_GET['id'])){
    $_SESSION['apl_id'] = $_GET['id'];
  }
  unset ($_GET['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['apl_id'])) {
    $object->init($_SESSION['apl_id']);
  }
}

// Delete
if (isset($_POST['del'])) {
  $object->setProperty('is_active', false);
  $object->save();
  $object = new apl();
  unset($_SESSION['apl_id']);
}
// Edit
if (isset($_POST['edit'])) {
  $editMode = (bool)true;
}
// New
if (isset($_REQUEST['new'])) {
  $object = new apl();
  if (isset($_GET['parent']) || isset($_POST['apl_parent'])){
    if (isset($_GET['parent'])){
      $object->setProperty('apl_parent',$_GET['parent']);
    }
    else if (isset($_POST['apl_parent'])){
      $object->setProperty('apl_parent',$_POST['apl_parent']);
    }
  }
  if (isset($_GET['child']) || isset($_POST['apl_child'])){
    if (isset($_GET['child'])){
      $object->setProperty('apl_child',$_GET['child']);
    }
    else if (isset($_POST['apl_child'])){
      $object->setProperty('apl_child',$_POST['apl_child']);
    }
  }
  // Child_id
  if (isset($_REQUEST['child_id']) && $childMode){
    $object->setProperty('child_id',$_REQUEST['child_id']);
  }
  // Parent_id
  if (isset($_REQUEST['parent_id'])){
    $object->setProperty('parent_id',$_GET['parent_id']);
  }

  if (isset($_GET['code']) || isset($_POST['apl_code'])){
    if (isset($_GET['code'])){
      $object->setProperty('apl_code',$_GET['code']);
    }
    else if (isset($_POST['apl_code'])){
      $object->setProperty('apl_code',$_POST['apl_code']);
    }
  }
  $editMode = (bool)true;
  unset($_SESSION['apl_id']);
}
// Save
if (isset($_POST['save'])) {
  $editMode = (bool)true;
  save();
  $editMode = (bool)false;
}
// Cancel
if (isset($_POST['cancel'])) {
  $editMode = (bool)false;
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['apl_id']){
    $object->setProperty($_GET['from'],$from_id);
  }
  unset($_GET['from']);
}

//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('apl','default','template_iframetabbed.htm',false);
$page->setAjaxLists();
$page->startForm();
  $page->startAreaTabSheet();
  $page->startTable('none','style="width:100%"');
  $page->addTabRuler();
  $page->endTable();
  $page->startTable('detail');
    // Child mode
    if ($childMode){
      $page->addField('apl_parent',$object->getProperty('apl_parent'),!$editMode);
      $tmpMeta = $SPL_META['parent_id'];
      if ($object->getProperty('apl_parent')=='ali'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'ali','referencekey'=>'ali_id','referencedisplay'=>'ali_name','referencescript'=>'ali_search.php','size'=>'20','label'=>'ali_id','required'=>true);
      }
      if ($object->getProperty('apl_parent')=='ina'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'ina','referencekey'=>'ina_id','referencedisplay'=>'ina_name','referencescript'=>'ina_search.php','size'=>'20','label'=>'ina_id','required'=>true);
      }
      if ($object->getProperty('apl_parent')=='ins'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'ins','referencekey'=>'ins_id','referencedisplay'=>'ins_short','referencescript'=>'ins_search.php','size'=>'15','label'=>'ins_id','required'=>true);
      }
      if ($object->getProperty('apl_parent')=='grp'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'grp','referencekey'=>'grp_id','referencedisplay'=>'grp_name','referencescript'=>'','size'=>'20','label'=>'grp_id','required'=>true);
      }
      if ($object->getProperty('apl_parent')=='tra'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'tra','referencekey'=>'tra_id','referencedisplay'=>'tra_name','referencescript'=>'tra_search.php','size'=>'20','label'=>'tra_id','required'=>true);
      }
      if ($object->getProperty('apl_parent')=='prd'){
        $SPL_META['parent_id'] = array('type'=>'reference','referencetable'=>'prd','referencekey'=>'prd_id','referencedisplay'=>'prd_name','referencescript'=>'prd_search.php','size'=>'20','label'=>'prd_id','required'=>true);
      }
      $page->addField('parent_id',$object->getProperty('parent_id'),!$editMode);
      $SPL_META['parent_id'] = $tmpMeta;
      $page->addField('apl_child',$object->getProperty('apl_child'),!$editMode);
      $page->addField('child_id',$object->getProperty('child_id'),!$editMode);
    }
    // Parent mode
    else {
      $page->addContent('<div class="hidden"><input type="hidden" name="parent_mode" id="parent_mode" value="1" /></div>');
      $page->addField('apl_parent',$object->getProperty('apl_parent'),!$editMode);
      $page->addField('parent_id',$object->getProperty('parent_id'),!$editMode,false,false,false,NULL,true,false,true);
      $page->addField('apl_child',$object->getProperty('apl_child'),!$editMode);
      $tmpMeta = $SPL_META['child_id'];
      if ($object->getProperty('apl_child')=='ali'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'ali','referencekey'=>'ali_id','referencedisplay'=>'ali_name','referencescript'=>'ali_search.php','size'=>'20','label'=>'ali_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='ina'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'ina','referencekey'=>'ina_id','referencedisplay'=>'ina_name','referencescript'=>'ina_search.php','size'=>'20','label'=>'ina_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='ins'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'ins','referencekey'=>'ins_id','referencedisplay'=>'ins_short','referencescript'=>'ins_search.php','size'=>'15','label'=>'ins_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='men'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'men','referencekey'=>'men_id','referencedisplay'=>'men_dispname','referencescript'=>'','size'=>'20','label'=>'men_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='par'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'par','referencekey'=>'par_id','referencedisplay'=>'par_dispname','referencescript'=>'','size'=>'20','label'=>'par_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='stu'){
        $SPL_META['child_id'] = array('type'=>'dynamiclist','referencetable'=>'stu','referencekey'=>'stu_id','referencedisplay'=>'stu_dispname','referencescript'=>'','size'=>'20','label'=>'stu_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='tea'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'tea','referencekey'=>'tea_id','referencedisplay'=>'tea_dispname','referencescript'=>'','size'=>'20','label'=>'tea_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='tra'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'tra','referencekey'=>'tra_id','referencedisplay'=>'tra_name','referencescript'=>'tra_search.php','size'=>'20','label'=>'tra_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='prd'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'prd','referencekey'=>'prd_id','referencedisplay'=>'prd_name','referencescript'=>'prd_search.php','size'=>'20','label'=>'prd_id','required'=>true);
      }
      if ($object->getProperty('apl_child')=='sub'){
        $SPL_META['child_id'] = array('type'=>'reference','referencetable'=>'sub','referencekey'=>'sub_id','referencedisplay'=>'sub_name','referencescript'=>'sub_search.php','size'=>'20','label'=>'sub_id','required'=>true);
      }
      
      // Add the field
      $page->addField('child_id',$object->getProperty('child_id'),!$editMode);
      
      // Restore original meta data
      $SPL_META['child_id'] = $tmpMeta;
    }
    $page->addField('apl_code',$object->getProperty('apl_code'),!$editMode);
    /* RFE #1326550 Klaartje
    $page->addField('apl_sequence',$object->getProperty('apl_sequence'),!$editMode);
    */
    $page->addField('apl_valid_from',$object->getProperty('apl_valid_from'),!$editMode);
    $page->addField('apl_valid_until',$object->getProperty('apl_valid_until'),!$editMode);
    $page->addField('is_active',$object->getProperty('is_active'),!$editMode);
    // Start buttons
    $page->startRow();
      // Label
      $page->startColumn();
      $page->endColumn();
      // Sign
      $page->startColumn();
      $page->endColumn();
      // Buttons
      $page->startColumn();
        if ($editMode){
          $page->addButton('save','toolbar_save','submit','default','8','button');
          $page->addButton('cancel','toolbar_cancel','submit','default','8','button');
        }
        else {
          if ($_SESSION['apl_permission']['write']) {
            $page->addButton('new','toolbar_new','submit','default','8','button');
          }
          if ($_SESSION['apl_permission']['change']) {
            $page->addButton('edit','toolbar_edit','submit','default','8','button');
          }
          if ($_SESSION['apl_permission']['delete']) {
            $page->addButton('del','toolbar_del','submit','default','8','button');
          }
        }
      $page->endColumn();
    $page->endRow();
    // End buttons
  $page->endTable();
  $page->endAreaTabSheet();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object;
  
  if (isset ($_POST['apl_parent'])) {$object->setProperty('apl_parent', $_POST['apl_parent']);}
  if (isset ($_POST['parent_id'])) {$object->setProperty('parent_id', $_POST['parent_id']);}
  if (isset ($_POST['apl_child'])) {$object->setProperty('apl_child', $_POST['apl_child']);}
  if (isset ($_POST['child_id'])) {$object->setProperty('child_id', $_POST['child_id']);}
  if (isset ($_POST['apl_sequence'])) {$object->setProperty('apl_sequence', $_POST['apl_sequence']);}
  if (isset ($_POST['apl_code'])) {$object->setProperty('apl_code', $_POST['apl_code']);}
  if (isset ($_POST['apl_valid_from'])) {$object->setProperty('apl_valid_from', $_POST['apl_valid_from']);}
  if (isset ($_POST['apl_valid_until'])) {$object->setProperty('apl_valid_until', $_POST['apl_valid_until']);}
  if (isset ($_POST['is_active'])) {$object->setProperty('is_active', '1');}
  else {$object->setProperty('is_active', '0');}
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }
  set();
  $object->save();
  $_SESSION['apl_id'] = $object->getProperty('apl_id');
}

/**
 * $Log: apl.php,v $
 * Revision 1.10  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.9  2006/03/08 16:30:34  jebbol
 * *** empty log message ***
 *
 * Revision 1.8  2006/02/11 18:03:08  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */
?>
