<?php
/**
 * User interface for searching items in the applicability table
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/08/28 09:19:27 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Must be authorized to view this information
if (!isset($_SESSION['apl_permission'])){
  return (bool) false;
}
if ($_SESSION['apl_permission']['read']==(bool)false) {
  return (bool) false;
}

//=========================================================================
// Local variables
//=========================================================================

/**
 * Operate in childmode or in parentmode
 * 
 * When operating in childmode, the resulset shows the parents.
 * When in parentmode (childmode==false), the resultset shows the children.
 * The default setting is 'childmode'. It will switch to 'parentmode' upon detecting
 * the 'parent_id' parameter.
 */
$childMode = (bool)true;

$args = isset($_GET['child'])?'?child='.$_GET['child']:'?';
$query['parentChild'] = isset($_GET['child'])?'child='.$_GET['child']:'';
if (isset($_GET['child_id'])){
  $args .= '&child_id='.$_GET['child_id'];
  $query['parentChild'] .= '&child_id='.$_GET['child_id'];
}
else if (isset($_GET['id'])){
  $args .= '&child_id='.$_GET['id'];
  $query['parentChild'] .= '&child_id='.$_GET['id'];
}
$args .= isset($_GET['parent'])?'&parent='.$_GET['parent']:'';
$query['parentChild'] .= isset($_GET['parent'])?'&parent='.$_GET['parent']:'';
if (isset($_GET['parent_id'])){
  $args .= '&parent_id='.$_GET['parent_id'];
  $query['parentChild'] .= '&parent_id='.$_GET['parent_id'];
  $childMode = (bool)false;
}
$args .= isset($_GET['code'])?'&code='.$_GET['code']:'';
$args .= isset($_GET['from'])?'&from='.$_GET['from']:'';

$query['tblName']  = 'apl';
$query['where']    = 'WHERE '.$SPL_CFG['prefix'].'apl.adm_id = "'.$_SESSION['adm_id'].'" AND '.$SPL_CFG['prefix'].'apl.is_active';
$query['orderBy']  = 'sequence';
$query['orderDir'] = 'ASC';
$query['viewSize'] = (isset($_SESSION['usp_numrows'])&&(int)$_SESSION['usp_numrows']<=20?$_SESSION['usp_numrows']:'20');

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Child mode
if ($childMode){

  $query['columns']  = 'apl_id AS id,"apl.php'.$args.'" AS target,apl_sequence AS sequence,apl_parent AS parent,parent_id AS parentid';
  
  // Data to link to the child data
  if (isset ($_GET['child'])){
    $query['where'] .= ' AND apl_child = "'.addslashes($_GET['child']).'"';
    if (isset($_GET['parent'])){
      switch ($_GET['parent']) {
        case 'ali':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "ali"';
          $query['columns'] .= ',ali_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'ali_name';
          break;
        case 'grp':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'grp grp ON grp.grp_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "grp"';
          $query['columns'] .= ',grp_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'grp_name';
          break;
        case 'ina':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ina ina ON ina.ina_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "ina"';
          $query['columns'] .= ',ina_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'ina_name';
          break;
        case 'ins':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ins ins ON ins.ins_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "ins"';
          $query['columns'] .= ',ins_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'ins_name';
          break;
        case 'prd':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "prd"';
          $query['columns'] .= ',prd_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'prd_name';
          break;
        case 'tra':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = '.$SPL_CFG['prefix'].'apl.parent_id AND '.$SPL_CFG['prefix'].'apl.apl_parent = "tra"';
          $query['columns'] .= ',tra_name AS applicable,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'tra_name';
          break;
        default:
          break;
      }
      $query['where'] .= ' AND apl_parent = "'.addslashes($_GET['parent']).'"';
    }
     
    if (isset ($_GET['id'])||isset($_GET['child_id'])){
      $query['where'] .= ' AND child_id = "'.addslashes(isset($_GET['id'])?$_GET['id']:$_GET['child_id']).'"';
    }
    else {
      if (isset($_SESSION[$_GET['child'].'_id'])) {
        $query['where'] .= ' AND child_id = "'.addslashes($_SESSION[$_GET['child'].'_id']).'"';
      }
    }
  }

  // Limit to a specific type of parent
  if (isset ($_GET['parent'])){
    $query['where'] .= ' AND apl_parent = "'.addslashes($_GET['parent']).'"';
  }
}

// Parent mode
else {
  $query['columns']  = 'apl_id AS id,"apl.php'.$args.'" AS target,apl_sequence AS sequence,apl_child AS parent,child_id AS parentid';
  // Data to link to the parent data
  if (isset ($_GET['parent'])){
    $query['where'] .= ' AND apl_parent = "'.addslashes($_GET['parent']).'"';
    if (isset($_GET['child'])){
      switch ($_GET['child']) {
        case 'ali':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ali ali ON ali.ali_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "ali"';
          $query['columns'] .= ',ali_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'ali_name';
          break;
        case 'ina':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ina ina ON ina.ina_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "ina"';
          $query['columns'] .= ',ina_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          break;
        case 'ins':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'ins ins ON ins.ins_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "ins"';
          $query['columns'] .= ',ins_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          break;
        case 'men':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'men men ON men.men_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "men"'; 
          $query['columns'] .= ',men_dispname AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'men_dispname';
          break;
        case 'par':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'par par ON par.par_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "par"'; 
          $query['columns'] .= ',par_dispname AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'par_dispname';
          break;
        case 'prd':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'prd prd ON prd.prd_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "prd"';
          $query['columns'] .= ',prd_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          break;
        case 'sub':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "sub"';
          $query['columns'] .= ',sub_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'sub_name';
          break;
        case 'stu':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "stu"';
          $query['columns'] .= ',stu_dispname AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'stu_dispname';
          break;
        case 'tea':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'tea tea ON tea.tea_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "tea"'; 
          $query['columns'] .= ',tea_dispname AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'tea_dispname';
          break;
        case 'tra':
          $query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'tra tra ON tra.tra_id = '.$SPL_CFG['prefix'].'apl.child_id AND '.$SPL_CFG['prefix'].'apl.apl_child = "tra"'; 
          $query['columns'] .= ',tra_name AS parts,apl_valid_from AS valid_from,apl_valid_until AS valid_until';
          $query['orderBy']  = 'tra_name';
          break;
        default:
          break;
      }
      $query['where'] .= ' AND apl_child = "'.addslashes($_GET['child']).'"';
    }

    if (isset($_GET['parent_id'])){
      $query['where'] .= ' AND parent_id = "'.addslashes($_GET['parent_id']).'"';
    }
    else {
      if (isset($_SESSION[$_GET['parent'].'_id'])) {
        $query['where'] .= ' AND parent_id = "'.addslashes($_SESSION[$_GET['parent'].'_id']).'"';
      }
    }
  }
}

if (isset($_POST['search_for'])) {
  $query['where'] .= ' AND '.$_POST['search_by'].' LIKE "'.$_POST['search_for'].'%"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

// Limit the height
$query['fixedHeight'] = 16;


//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('apl');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->setDateUntil('valid_until');
$table->addNewButton(NULL,'apl.php'.$args.'&new');

// Create the page
$page = new page();
$page->init('apl','default','template_iframetabbed.htm',false);
$page->setHeadScripts($table->getScripts());
$page->startForm('aplsearchform','default',false,true);
  $page->startSection('','content_start');
  $page->startColumn();
  $table->setImageDir($page->getImageDir());
  $page->startAreaGrid();
  $page->addContent($table->getTable());
  $page->endAreaGrid();
  $page->endColumn();
  $page->endSection('content_end');
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/** 
 * $Log: apl_search.php,v $
 * Revision 1.10  2006/08/28 09:19:27  jebbol
 * *** empty log message ***
 *
 * Revision 1.9  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.8  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.7  2006/02/11 18:01:39  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
