<?php
/**
 * assessment.class.php
 * 
 * $Author: jebbol $
 * $Revision: 1.2 $
 * $Date: 2006/09/03 16:00:36 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
if (!isset($SPL_CFG['dirroot'])) {include_once('../inc/config.php');}

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

//=========================================================================
// Class definition
//=========================================================================

/**
 * Assessments
 */
class assessment {

  function assessment() {
  }
  
  /**
   * Retrieves the lastest assessments for a given user
   * 
   * @param (integer) $usr    The usr id (default=current user)
   * @param (string)  $format The desired format of the return value ('array' or 'xml')
   * @return (array)          The users latest assessments
   * @public
   */
  function init($assessmentUsr=null,$format='array') {
    
    global $SPL_CFG;
    
    $values = array();
    $xml    = '<response>';
    
    // If the usr id has not been passed, use the session
    if (!isset($assessmentUsr) || empty($assessmentUsr) || (isset($assessmentUsr)&&(int)$assessmentUsr==0)) {
      $assessmentUsr = $_SESSION['usr_id'];
    }
    
    $query  = 'SELECT sgd.sub_id,sub_short,sgd.sug_id,sug_short,sgd_assessment,sgd_compliment';
    $query .= ' FROM '.$SPL_CFG['prefix'].'sgd sgd';
    $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = sgd.sub_id'; 
    $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sug sug ON sug.sug_id = sgd.sug_id'; 
    $query .= ' WHERE sgd.usr_id = "'.$assessmentUsr.'"';
    $query .= ' AND sgd.adm_id = "'.$_SESSION['adm_id'].'"';
    $query .= ' AND CHAR_LENGTH(TRIM(sgd_assessment))>0';
    $query .= ' ORDER BY sgd_assessment_date DESC';
    $query .= ' LIMIT 0,10';
    $result = db_query($query);
    
    while ($row = db_fetch_array($result)) {
      switch ($format) {
        case 'array':
          $values[] = array('sub_id'=>$row['sub_id'],'sub_short'=>$row['sub_short'],'sug_id'=>$row['sug_id'],'sug_short'=>$row['sug_short'],'sgd_assessment'=>$row['sgd_assessment'],'sgd_compliment'=>$row['sgd_compliment']);
          break;
        case 'xml':
          $xml = '<assessment><sub_id>'.$row['sub_id'].'</sub_id><sub_short>'.$row['sub_short'].'</sub_short><sug_id>'.$row['sug_id'].'</sug_id><sug_short>'.$row['sug_short'].'</sug_short><sgd_assessment>'.$row['sgd_assessment'].'</sgd_assessment><sgd_compliment>'.$row['sgd_compliment'].'</sgd_compliment></assessment>';
        break;
        default:
        break;
      }
    }
    
    if ($format == 'array') {
      return $values;
    }

    if ($format == 'xml') {
      return $xml;
    }

  }

}

/** 
 * $Log: assessment.class.php,v $
 * Revision 1.2  2006/09/03 16:00:36  jebbol
 * Added sgd_compliment
 *
 * Revision 1.1  2006/03/08 16:32:39  jebbol
 * *** empty log message ***
 */

?>