<?php
/**
 * Calendar
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: calendar.class.php,v 1.4 2006/01/02 18:52:22 jebbol Exp $
 * @package   spl
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
if (!isset($SPL_CFG['dirroot'])) {include_once('../inc/config.php');}

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

// System setting
include_once($SPL_CFG['dirroot'].'/inc/settings.sys.php');

// Human language translations
if (!isset($_SESSION['usp_lang'])) {$_SESSION['usp_lang'] = 'en';}
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/spl.lang.php');

// Calendar data class
include_once($SPL_CFG['dirroot'].'/class/cal.class.php');

// UI elements
if (!isset($_SESSION['usp_skin'])) {$_SESSION['usp_skin'] = 'default';}
include_once($SPL_CFG['dirroot'].'/ui/skin/'.$_SESSION['usp_skin'].'/elements.php');

//=========================================================================
// Class definition
//=========================================================================

class calendar {

  var $_type;       // M=Month

  var $_nowdate;       // Current date
  var $_nowday;        // Current day
  var $_nowmonth;      // Current month
  var $_nowyear;       // Current year
  
  var $_caldate;       // Calendar date
  var $_calday;        // Calendar day
  var $_calmonth;      // Calendar month
  var $_calyear;       // Calendar year
  
  var $_calprevmonth;
  var $_calprevyear;
  
  var $_calnextmonth;
  var $_calnextyear;

 
  function calendar() {
    
    // Set the default type of calendar
    $this->_type = (isset($SPL_CFG['calendar_type'])?$SPL_CFG['calendar_type']:'M');
    
    // Set default date
    $this->_nowdate  = time();
    $this->_nowday   = gmdate( "j", $this->_nowdate);
    $this->_nowmonth = gmdate("m", $this->_nowdate);
    $this->_nowyear  = gmdate("Y", $this->_nowdate);
    
    $this->_caldate  = $this->_nowdate;
    $this->_calday   = $this->_nowday;
    $this->_calmonth = $this->_nowmonth;
    $this->_calyear  = $this->_nowyear;
    
    // calc following month and year
    $this->_calnextyear = $this->_calyear;
    if ($this->_calmonth < 12) {
      $this->_calnextmonth = $this->_calmonth + 1;
    } 
    else {
      $this->_calnextmonth = 1;
      $this->_calnextyear = $this->_calyear + 1;
    }
  
    // calc previous month and year
    $this->_calprevyear = $this->_calyear;
    if ($this->_calmonth > 1) {
      $this->_calprevmonth = $this->_calmonth - 1;
    } 
    else  {
      $this->_calprevmonth = 12;
      $this->_calprevyear = $this->_calyear - 1;
    } 
    
    
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /**
   * Displays a calendar
   */
  function display(){
    
    global $SPL_TXT,$SPL_UI;
    
    $html = "";
    
    switch ($this->_type) {
      
      // Monthly view
      case 'M':
      default:
        $events = array();
        $cal = new cal();
        $events = $cal->getEventsForMonth($this->_caldate);
        
        // Start the calendar
        $html .= $SPL_UI['calendar_start'];

        // Create the day header
        $html .= $SPL_UI['calendar_dayheader_start'];
        $html .= '<td></td>'; // Display no header for the weeknumber
        for ($i=1;$i<=7;$i++ ){
          $html .= str_replace('{DAYNAME}',$SPL_TXT['calendar_days'][$i],$SPL_UI['calendar_dayheader']);
        }  
        $html .= $SPL_UI['calendar_dayheader_end'];
        
        // Display the days
        if (($this->_calyear == $this->_nowyear) && ($this->_calmonth == $this->_nowmonth)) {
          $today_day = $this->_nowday;
        }
        else {
          $today_day = 0;
        }

        $days_last_month = gmdate( "d", gmmktime(0,0,0,$this->_calmonth,0,$this->_calyear ) );
        $days_this_month = gmdate( "d", gmmktime(0,0,0,$this->_calnextmonth, 0, $this->_calnextyear ) );
        $first_day_this_month = gmmktime( "0","0","0",$this->_calmonth, "1", $this->_calyear );
        $l_tm = localtime( $first_day_this_month, 1);
        $weeknumber = date("W",$first_day_this_month);
        if ($weeknumber>53){
          $weeknumber = 1;
        }
  
        // what's the weekday of the 1st day of this month?
        $first_day_pos = $l_tm[ "tm_wday" ];
  
        if ($first_day_pos == 0) $first_day_pos = 7; // convert to Mo=1 to Su=7

        $day_num = $days_last_month - ($first_day_pos-2); 
        $class=' class="last_month"'; 
        
        for ( $y=1; $y<=6; $y++ ) {
          $html .= '<tr>';
    
          // Set weeknumber
          $html .= '<td class="weeknumber">'.$weeknumber.'</td>';
          $weeknumber++;
          if ($weeknumber>53){
            $weeknumber = 1;
          }

          for ( $x=1; $x<=7; $x++ ) {
            if (($y==1) && ($x==$first_day_pos)) { 
              $day_num = 1; 
              $class="";
            }
      
            if (($y >1) && ($day_num==$days_this_month+1) ) { 
              $day_num = 1; 
              $class=' class="next_month"'; 
            }
      
            if (($class=="") && ($day_num == $today_day)) $id=' id="today"'; else $id="";
            if (($id!=' id="today"') && ($class=="") && ($day_num == $this->_calday )) $id=' id="selected"';

            if ( $class != "" ) { 
              $ap1 = ""; 
              $ap2 = ""; 
            }
            else {
              $ap1 = '<a href="#?Y=$cal_year&m=$cal_month&d=$day_num&$ox_tail" target="">'; 
              $ap2 = '</a>'; 
            }
        
            if (isset($events[$day_num]) && $class=="") { 
              $title = "";
              foreach ($events[$day_num] as $event) {
                $title .= gmdate("H:i",$event['cal_event_start']).' '.$event['cal_event_title'];
              }
              $html .= '<td'.$class.$id.'>'.'<a href="#" onclick="showHelpTip(event, \''.addslashes($title).'\'); return false;">'.'<span class="reserved" title="'.$title.'">'.$day_num.'</span>'.'</a>'.'</td>';
            }
            else {
              $html .='<td'.$class.$id.'>'.$day_num.'</td>';
            }
      
            $day_num++;               
          }
          $html .= '</tr>';
        }  
        
        // End the calendar
        $html .= $SPL_UI['calendar_end'];
        break;
    }
    return $html;
  }
  

  /**
   * Returns a caption for the calendar
   * 
   */
  function getCaption(){
    
    global $SPL_TXT, $SPL_UI;
    
    switch ($this->_type) {
      
      // Monthly view
      case 'M':
      default:
        $caption = str_replace('{CALENDAR_DATE}',$this->getDate(),$SPL_UI['calendar_month_header']);
        return str_replace('{CALENDAR_TITLE}',$SPL_TXT['calendar_months'][(int)$this->_calmonth].' '.$this->_calyear,$caption);
    }
    
  }

  /**
   * Retrieves the calendar date
   * 
   * @return timestamp
   */
  function getDate() {
    return $this->_caldate;
  }

  /**
   * Retrieves the calendar day (monday=1, sunday=7)
   * 
   * @return integer
   */
  function getWeekDay() {
    $day = gmdate( "w", $this->_nowdate);
    if ($day==0) $day=7;
    return $day;
  }

  /**
   * Sets the calendar date one month ahead
   * 
   */
  function setNextMonth(){
    $this->setDate(strtotime('+1 month',$this->_caldate));
  }

  /**
   * Sets the calendar date one year ahead
   * 
   */
  function setNextYear(){
    $this->setDate(strtotime('+1 year',$this->_caldate));
  }

  /**
   * Sets the calendar date one month back
   * 
   */
  function setPrevMonth(){
    $this->setDate(strtotime('-1 month',$this->_caldate));
  }

  /**
   * Sets the calendar date one year back
   * 
   */
  function setPrevYear(){
    $this->setDate(strtotime('-1 year',$this->_caldate));
  }

  /**
   * Sets the calendar date
   * 
   * @param $date integer A unix timestamp
   */
  function setDate($date){
    
    $this->_caldate = $date;
    $this->_calday   = gmdate( "j", $this->_caldate);
    $this->_calmonth = gmdate("m", $this->_caldate);
    $this->_calyear  = gmdate("Y", $this->_caldate);

    // calc following month and year
    $this->_calnextyear = $this->_calyear;
    if ($this->_calmonth < 12) {
      $this->_calnextmonth = $this->_calmonth + 1;
    } 
    else {
      $this->_calnextmonth = 1;
      $this->_calnextyear = $this->_calyear + 1;
    }
  
    // calc previous month and year
    $this->_calprevyear = $this->_calyear;
    if ($this->_calmonth > 1) {
      $this->_calprevmonth = $this->_calmonth - 1;
    } 
    else  {
      $this->_calprevmonth = 12;
      $this->_calprevyear = $this->_calyear - 1;
    } 
  } 

  //=========================================================================
  // Private methods
  //=========================================================================


}
?>