<?php
/**
 * schedule.class.php
 *
 * $Author: jebbol $
 * $Revision: 1.3 $
 * $Date: 2006/03/08 16:32:39 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: schedule.class.php,v $
 * Revision 1.3  2006/03/08 16:32:39  jebbol
 * *** empty log message ***
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
if (!isset($SPL_CFG['dirroot'])) {include_once('../inc/config.php');}

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

//=========================================================================
// Class definition
//=========================================================================

/**
 * Schedule
 */
class schedule {
  
  var $_hoursPerDay;            // The maximum number of hours in a day

  function schedule() {
    
    // Set the default number of hours per day
    $this->_hoursPerDay = 8;
    
  }

  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Prepares the schedule object for use
   * 
   * @param (integer) $scheduleUsr  The user for whom the schedule has to be shown (default=current user)
   * @param (enum)    $scheduleMode The schedule mode: student, teacher or group (default=best guess)
   * @public
   */
  function init($scheduleUsr=null,$scheduleMode=null) {
    
    global $SPL_CFG;
    
    $rawScheduleUrl = '';
    $scheduleUrl    = '';
    
    // If the schedule is already in the cache, do noting
    if (!isset($scheduleUsr) && isset($_SESSION['my_schedule'])) {
      return $_SESSION['my_schedule'];
    }
    
    // Else, build the schedule url fo the current user
    if (!isset($scheduleUsr)) {
      
      // Session must be setup properly
      if (!isset($_SESSION['usr_id'])) {
        // No user available
        return false;
      }
      $scheduleUsr = $_SESSION['usr_id'];
      
      // Determin the schedule mode
      if (!isset($scheduleMode)){
        if (isset($_SESSION['my_stu_id'])&&$_SESSION['my_stu_id']>0) {
          $scheduleMode = 'student';
        }
        else if (isset($_SESSION['my_tea_id'])&&$_SESSION['my_tea_id']>0) {
          $scheduleMode = 'teacher';
        }
        else {
          $scheduleMode = 'group';
        }
      }

      // Find users institution address to collect the urls
      if (!isset($_SESSION['usp_ina_id'])) {
        // No default address known
        return false;
      }
      $query  = 'SELECT ina_id,ina_url_schedule_group,ina_url_schedule_teacher,ina_url_schedule_student';
      $query .= ' FROM '.$SPL_CFG['prefix'].'ina';
      $query .= ' WHERE ina_id = "'.$_SESSION['usp_ina_id'].'" LIMIT 1';
      $result = db_retrieve(db_query($query));

      // When a student schedule is requested and we have a valid url, use it
      // otherwise switch back to group scheduling
      if ($scheduleMode=='student') {
        if (!empty($result['ina_url_schedule_student'])) {
          $rawScheduleUrl = $result['ina_url_schedule_student'];
        }
        else if (!empty($result['ina_url_schedule_group'])) {
          $rawScheduleUrl = $result['ina_url_schedule_group'];
          $scheduleMode = 'group';
        }
      }

      // Student mode can only be used in combination with a valid sisnr
      if ($scheduleMode=='student' && isset($_SESSION['my_stu_id'])) {
        $query = 'SELECT stu_sisnr FROM '.$SPL_CFG['prefix'].'stu WHERE stu_id = "'.$_SESSION['my_stu_id'].'" LIMIT 1';
        $sturesult = db_retrieve(db_query($query));

        if (!empty($sturesult['stu_sisnr'])) {
          $scheduleUrl = str_replace('{id}',$sturesult['stu_sisnr'],$rawScheduleUrl);
          $s = $this->_parse($scheduleUrl);
          if ($s) $_SESSION['my_schedule'] = $s;
          return $s;
        }
        else if (!empty($result['ina_url_schedule_group'])) {
          $rawScheduleUrl = $result['ina_url_schedule_group'];
          $scheduleMode = 'group';
        }
      }
      else if ($scheduleMode=='student' && !empty($result['ina_url_schedule_group'])) {
        $rawScheduleUrl = $result['ina_url_schedule_group'];
        $scheduleMode = 'group';
      }

      // When a teacher schedule is requested, check the url
      if ($scheduleMode=='teacher' && isset($_SESSION['my_tea_id'])) {
        if (!empty($result['ina_url_schedule_teacher'])) {
          $rawScheduleUrl = $result['ina_url_schedule_teacher'];
          $query = 'SELECT tea_schedulename FROM '.$SPL_CFG['prefix'].'tea WHERE tea_id = "'.$_SESSION['my_tea_id'].'" LIMIT 1';
          $result = db_retrieve(db_query($query));
          if (!empty($result['tea_schedulename'])) {
            $scheduleUrl = str_replace('{id}',$result['tea_schedulename'],$rawScheduleUrl);
            $s = $this->_parse($scheduleUrl);
            if ($s) $_SESSION['my_schedule'] = $s;
            return $s;
          }
        }
      }
            
      // Find the users schedule group
      if ($scheduleMode=='group' && !empty($rawScheduleUrl)) {
        if (!isset($_SESSION['my_grp_id_schedule'])) {
          $query = 'SELECT stu_grp_id_schedule FROM '.$SPL_CFG['prefix'].'stu WHERE stu_id = "'.$_SESSION['my_stu_id'].'" LIMIT 1';
          $result = db_retrieve(db_query($query));
          if (!empty($result['stu_grp_id_schedule'])) {
            $query = 'SELECT grp_code FROM '.$SPL_CFG['prefix'].'grp WHERE grp_id = "'.$result['stu_grp_id_schedule'].'" LIMIT 1';
            $result = db_retrieve(db_query($query));
            if (!empty($result['grp_code'])) {
              $_SESSION['my_grp_id_schedule'] = $result['grp_code'];
            }
          }
        }
        if (isset($_SESSION['my_grp_id_schedule'])) {
          $scheduleUrl = str_replace('{id}',$_SESSION['my_grp_id_schedule'],$rawScheduleUrl);
          $s = $this->_parse($scheduleUrl);
          if ($s) $_SESSION['my_schedule'] = $s;
          return $s;
        }
      }
      
    }

  }

  //=========================================================================
  // Private methods
  //=========================================================================

  /**
   * Parses a url
   * 
   * @param  (string) $url The url to parse
   * @return (bool)        Succes or Failure
   * @private
   */
  function _parse($url) {
    
    global $SPL_CFG;
    
    $content = '';
    if (function_exists('file_get_contents')) {
      $content = @file_get_contents($url);
    }
    else {
      $handle = @fopen($url,'rb');
      $content = '';
      if ($handle) {
        while (!@feof($handle)) {
          $content .= @fread($handle,8192);
        }
        @fclose($handle);
      }
    }
    if (empty($content)) {
      return false;
    }

    // Convert character set
    if (stristr($content, 'charset=iso-8859-1')) {
      $content = utf8_encode($content);
    }

    // Convert to lowercase
    $content = strtolower($content);

    // Determine the type and version
    $type = false;
    if (stristr($content,strtolower('"GENERATOR" content="gp-Untis 2005"'))) {
      $type = 'untis2005';
    }

    switch ($type) {
      case 'untis2005':
        $tags['row_start']  = '<tr>';
        $tags['row_end']    = '</tr>';
        $tags['hour_start'] = '<b>';
        $tags['hour_end']   = '</b>';
        $tags['day_start']  = '<td';
        $tags['day_end']    = '</td>';
    
        $schedule = array();
    
        // Check orientation: when the first row contains the description of the days,
        // each row represents an hour. Otherwise, each row represents a day and each
        // column represents an hour
        $test = substr($content,strpos($content,$tags['row_start']),(strpos($content,$tags['row_end'])-strpos($content,$tags['row_start'])));
        $hoursOnRow = (strpos($test,'maandag')>0)?true:false;        

        if ($hoursOnRow){
          $cols = array(1=>'ignore',2=>'monday',3=>'tuesday',4=>'wednesday',5=>'thursday',6=>'friday',7=>'saturday',8=>'sunday'); 
          $rows = array();
        }
        else {
          $rows = array(1=>'monday',2=>'tuesday',3=>'wednesday',4=>'thursday',5=>'friday',6=>'saturday',7=>'sunday');
          $cols = array();
          $day = 1;
        } 

        $numrows = 0;
        while (strlen($content)>0) {
          if (strpos($content,$tags['row_end'])==0) {
            $content = '';
            break;
          }
          $row = substr($content,strpos($content,$tags['row_start']),(strpos($content,$tags['row_end'])-strpos($content,$tags['row_start'])));
          $content = substr($content,strpos($content,$tags['row_end'])+strlen($tags['row_end']));
          $numrows++;

          // Hours ar displayed on a row, each column represent a day
          if ($hoursOnRow) {
            for ($i=1; $i<=$this->_hoursPerDay; $i++) {
              if (strstr($row,($tags['hour_start'].$i.$tags['hour_end']))) {
                while (strlen($row)>0){
                  if (strpos($row,$tags['day_end'])==0) {
                    $row = '';
                    break;
                  }
                  // Loop through the days
                  for ($c=1; $c<=count($cols); $c++){
                    if ($cols[$c]!='ignore'){
                      $rows[$i][$cols[$c]] = strip_tags(substr($row,strpos($row,$tags['day_start']),strpos($row,$tags['day_end'])-strpos($row,$tags['day_start'])));
                      $schedule[$cols[$c]][$i] = $rows[$i][$cols[$c]];
                    }
                    $row = substr($row,strpos($row,$tags['day_end'])+strlen($tags['day_end']));
                  }
                }
              }
            }
          }

          // Hours are displayed in a column
          else {
            // The top row contains the hour labels. Skip it.
            //if (!strstr($row,($tags['hour_start'].'1'.$tags['hour_end']))){
            if ($numrows>1) {
              for ($i=1; $i<=$this->_hoursPerDay+1; $i++) {
                // Skip the name of the day
                if ($i>1){
                  $schedule[$rows[$day]][$i-1] = strip_tags(substr($row,strpos($row,$tags['day_start']),strpos($row,$tags['day_end'])-strpos($row,$tags['day_start'])));
                  $schedule[$rows[$day]][$i-1] = str_replace('&nbsp;','',$schedule[$rows[$day]][$i-1]);
                }
                $row = substr($row,strpos($row,$tags['day_end'])+strlen($tags['day_end']));
              }
              $day++;
            }
          }
        }
        return $schedule;
      default:
        break;
    }
  }
}
?>