<?php
/**
 * Selector class
 *
 * $Author: jebbol $
 * $Revision: 1.4 $
 * $Date: 2006/03/08 16:32:39 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: selector.class.php,v $
 * Revision 1.4  2006/03/08 16:32:39  jebbol
 * *** empty log message ***
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
if (!isset($SPL_CFG['dirroot'])) {include_once('../inc/config.php');}

//=========================================================================
// Class definition
//=========================================================================

/**
 * Multiple selection list
 *
 * This user interface class creates a multiple-selection list 
 */
class selector {
  
  var $_entireList = array();

  function selector() {
  }
  
  //=========================================================================
  // Public methods
  //=========================================================================

  /** 
   * Retrieves the HTML formatted code for the selector
   *
   * @param  string $name The name of the formfields (the one you want to see in $_POST). Defaults to 'selector_id'
   * @return string The selector code
   * @access public
   */
  function getSelector($readonly=false,$name='selector_id') {
    
    global $SPL_UI;
    
    $iCurrentRow = 0;
    $_html = $SPL_UI['selector_start'];
    foreach ($this->_entireList as $key => $item){
      
      $iCurrentRow ++;
      
      $_html .= (($iCurrentRow % 2) == 0)?$SPL_UI['selector_roweven_start']:$SPL_UI['selector_rowodd_start'];
      $_html .= (isset($SPL_UI['selector_label_start'])?$SPL_UI['selector_label_start']:$SPL_UI['selector_column_start']);
      $_html .= $readonly?$SPL_UI['selector_check_disabled']:$SPL_UI['selector_check_enabled'];
      $_html .= $SPL_UI['selector_column_end'];
      $_html .= (isset($SPL_UI['selector_field_start'])?$SPL_UI['selector_field_start']:$SPL_UI['selector_column_start']);
      $_html .= $readonly?$SPL_UI['selector_desc_disabled']:$SPL_UI['selector_desc_enabled'];
      $_html .= $SPL_UI['selector_column_end'];
      $_html .= $SPL_UI['selector_row_end'];

      // Replace placeholders
      $_html = str_replace('{SELECTOR_CHECK_NAME}',$name.'['.$key.']',$_html);
      $_html = str_replace('{SELECTOR_CHECK_CHECKED}',$item['sel']?'checked="checked"':'',$_html);
      $_html = str_replace('{SELECTOR_DESC}',$item['desc'],$_html);
    }
    $_html .= $SPL_UI['selector_end'];
    
    return $_html;
  }

  /** 
   * Instantiates the object
   *
   * @param  array $allItems An array containing all items to be displayed in the selector (key => description)
   * @param  array $selItems An array the items already selected (key => description)
   * @return boolean         Succes or Failure
   * @access public
   */
  function init($allItems,$selItems=NULL) {
    
    // Merge both arrays into one array
    // This array will contain item arrays ('id' => id, 'desc' => decsription, 'sel' => true/false)
    
    if (!$selItems){
      $selItems = array();
    }
    
    foreach ($allItems as $item){
      foreach ($item as $key => $desc) {
        $this->_entireList[$key]['desc'] = $desc;
        $this->_entireList[$key]['sel']  = (bool)false;
      }
    }

    foreach ($selItems as $item){
      foreach ($item as $key => $desc) {
        $this->_entireList[$key]['desc'] = $desc;
        $this->_entireList[$key]['sel']  = (bool)true;
      }
    }

  }
  
  //=========================================================================
  // Public methods
  //=========================================================================
  
}
?>