<?php 	
/** 
 * Creates an html table structure with data from a
 *
 * $Author: jebbol $
 * $Revision: 1.29 $
 * $Date: 2006/08/08 12:28:58 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * @credits   Based upon TableView by Elliott Edwards (eedwards@hachisoft.com)
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
if (!isset($SPL_CFG['dirroot'])) {include_once('../inc/config.php');}

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

// System setting
include_once($SPL_CFG['dirroot'].'/inc/settings.sys.php');

// Human language translations
if (!isset($_SESSION['usp_lang'])) {$_SESSION['usp_lang'] = 'en';}
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/spl.lang.php');

// Get encryption support
include_once($SPL_CFG['dirroot'].'/class/rc4crypt.class.php');

//=========================================================================
// Class definition
//=========================================================================

class table {

  var $_tblFormat = array (); // formatting
  var $_tblQuery = array ();  // the query
  var $_tblMeta = array();    // Metadata overruling $SPL_META
  var $_scripts;              // Javascripts
  var $_rowSelectionEnabled;  // Can the user select the rows?
  var $_CurrentOrder;         // the current sorting order
  var $_CurrentDir;           // the current sorting direction
  var $_ImageDir;             // the path to the images
  var $_callbackScript;       // the name of the script to call from a selected row
  var $_kickOut;              // kick out of frameset
  var $_dataClass;            // The name of the class supplying the data
  var $_dateUntil;            // The name of the column containing a 'valid until' date
  var $_addNew;               // Add a 'new row' button
  var $_showInactive;         // Show or hide inactive rows
  var $_showMine;             // Show only rows created by myself
  var $_encodeURL;            // Must the URL parameters be encoded?
  var $_tableType;            // Type of table: 'paged' (default) or 'scroller'
  
  // Constructor
  function table($tblQuery) {
    
    global $SPL_CFG, $SPL_UI;

    // Set the user's preferred table type
    if (isset($SPL_UI['table_type'])) {
      $this->_tableType = $SPL_UI['table_type'];
    }
    else {
      $this->_tableType = 'paged';
    }
    
    // Build the query
    $this->_tblQuery['columns']   = (isset ($tblQuery['columns']) ? $tblQuery['columns'] : '*');
    $this->_tblQuery['tblName']   = (isset ($tblQuery['tblName']) ? $tblQuery['tblName'] : '');
    $this->_tblQuery['where']     = (isset ($tblQuery['where']) ? $tblQuery['where'] : '');
    $this->_tblQuery['orderBy']   = (isset ($tblQuery['orderBy']) ? $tblQuery['orderBy'] : '');
    $this->_tblQuery['orderDir']  = (isset ($tblQuery['orderDir']) ? $tblQuery['orderDir'] : 'ASC');
    $this->_tblQuery['viewStart'] = (isset ($tblQuery['viewStart']) ? $tblQuery['viewStart'] : '0');

    // Check if the skin sets a viewport
    if (!isset($tblQuery['viewSize'])) {
      if (isset($SPL_UI['table_viewsize'])) {
        $tblQuery['viewSize'] = $SPL_UI['table_viewsize'];
      }
    }
    if (isset($tblQuery['viewSize'])) {
      $this->_tblQuery['viewSize'] = $tblQuery['viewSize'];
    }
    else {
      $this->_tblQuery['viewSize']  = (isset ($_SESSION['usp_numrows']) ? $_SESSION['usp_numrows'] : $SPL_CFG['numrows']);
    }
    
    // The default parentid and childid to add to the URL 
    $this->_tblQuery['parentChild'] = (isset ($tblQuery['parentChild']) ? $tblQuery['parentChild'] : '');

    // Default ordering
    $this->_CurrentOrder = $this->_tblQuery['orderBy'];
    $this->_CurrentDir = $this->_tblQuery['orderDir'];

    // Default image path
    $this->_ImageDir = $this->_imageDir = $SPL_CFG['wwwroot']."/ui/skin/".$_SESSION['usp_skin']."/images/";
    
    // The viewport height for a scroller
    if (!isset($SPL_UI['table_rowheight'])) {
      $SPL_UI['table_rowheight'] = '1.9';
    }
    if (!isset($SPL_UI['table_rowheightunit'])) {
      $SPL_UI['table_rowheightunit'] = 'em';
    }
    if (!isset($SPL_UI['table_viewsize'])) {
      $SPL_UI['table_viewsize'] = 14;
    }
    // First check if a fixed height has been passed
    if (isset($tblQuery['fixedHeight'])) {
      $SPL_UI['table_viewsize'] = $tblQuery['fixedHeight'];
    }

    $this->_viewportHeight = ((float)$SPL_UI['table_viewsize']*(float)$SPL_UI['table_rowheight']);

    // Default formatting
    $this->_tblFormat['header'] = ''; //An Optional header for the table
    $this->_tblFormat['footer'] = ''; //An Optional footer for the table
    $this->_tblFormat['headingBegin'] = '<td class="header"'; //Column heading format prefix
    $this->_tblFormat['headingBegin_scroller'] = '<th class="header" scope="col"'; //Column heading format prefix for acrolling table
    $this->_tblFormat['headingOrderBegin'] = '<td class="headerOrder" nowrap'; //Column 'order-by' heading format prefix
    $this->_tblFormat['headingOrderBegin_scroller'] = '<th class="headerOrder" scope="col" nowrap'; //Column 'order-by' heading format prefix for scrolling table
    $this->_tblFormat['headingEnd'] = '</td>'; //Column heading format suffix
    $this->_tblFormat['headingEnd_scroller'] = '</th>'; //Column heading format suffix for scrolling table
    $this->_tblFormat['tblBegin'] = "\r\n".'<table class="browser" cellspacing="0" cellpadding="0" width="100%">'; //Table Format prefix
    $this->_tblFormat['tblBegin_scrollerOuter'] = "\r\n".'<table class="scrollerOuter">'; //Table Format prefix for scrolling table
    $this->_tblFormat['tblBegin_scrollerInner'] = '<div style="height:1%"><div class="scrollerInner" style="height:{VIEWPORT_HEIGHT}"><table class="scrollerInner">'; //Table Format prefix for scrolling table
    $this->_tblFormat['tblEnd'] = '</table>'."\r\n"; //Table Format suffix
    $this->_tblFormat['tblEnd_scrollerOuter'] = '</table>'."\r\n"; //Table Format suffix
    $this->_tblFormat['tblEnd_scrollerInner'] = '</table></div></div>'."\r\n"; //Table Format suffix
    $this->_tblFormat['captionBegin'] = 'default'; //Caption Format prefix, for example <CAPTION>
    $this->_tblFormat['captionText'] = ''; //Text to be displayed as a caption
    $this->_tblFormat['captionEnd'] = '</caption>'; //Caption Format suffix, for example </CAPTION>
    $this->_tblFormat['empty'] = 'empty table'; // Huma language text for 'empty table'
    $this->_tblFormat['rowBegin'] = '<tr>'; //Row Format prefix
    $this->_tblFormat['rowOddClass'] = ' class="elRow1"';
    $this->_tblFormat['rowOddClassChanged'] = ' class="elRow1_changed"';
    $this->_tblFormat['rowEvenClass'] = ' class="elRow2"';
    $this->_tblFormat['rowEvenClassChanged'] = ' class="elRow2_changed"';
    $this->_tblFormat['rowCursor'] = 'cursor:default;';
    $this->_tblFormat['rowCursorEnabled'] = 'cursor:pointer;';
    $this->_tblFormat['rowMouseOverOdd'] = 'default';
    $this->_tblFormat['rowMouseOutOdd'] = 'default';
    $this->_tblFormat['rowMouseOutOddChanged'] = 'default';
    $this->_tblFormat['rowMouseClickOdd'] = 'default';
    $this->_tblFormat['rowMouseOverEven'] = 'default';
    $this->_tblFormat['rowMouseOutEven'] = 'default';
    $this->_tblFormat['rowMouseOutEvenChanged'] = 'default';
    $this->_tblFormat['rowMouseClickEven'] = 'default';
    $this->_tblFormat['rowStyle'] = 'default';
    $this->_tblFormat['rowEnd'] = '</tr>'; //Row Format suffix
    $this->_tblFormat['colBegin']      = '<td class="elLabel">';      //Column format prefix normal cell
    $this->_tblFormat['colBeginFirst'] = '<td class="elLabelFirst">'; //Column format prefix first cell
    $this->_tblFormat['colBeginLast']  = '<td class="elLabelLast">';  //Column format prefix last cell
    $this->_tblFormat['colEnd'] = '</td>'; //Column Format suffix
    $this->_tblFormat['navBegin'] = '<div class="tableFooter">'; //Navigation format prefix
    $this->_tblFormat['navEnd'] = '</div>'; //Navigation format suffix
    $this->_tblFormat['nextCode'] = 'next'; //HTML inside the "Next Page" Link (for paging)
    $this->_tblFormat['prevCode'] = 'prev'; //HTML inside the "Prev Page" Link (for paging)
    $this->_tblFormat['newCode'] = 'new_item'; //HTML inside the "New" Link (for adding a row)
    $this->_tblFormat['ascendCode'] = 'v'; //HTML inside the "Ascend" Link for column sorting (can be IMG tag)
    $this->_tblFormat['descendCode'] = '^'; //HTML inside the "Descend" Link for column sorting (can be IMG tag)
    $this->_tblFormat['passedDateBegin'] = '<span style="text-decoration:line-through">';
    $this->_tblFormat['passedDateEnd'] = '</span>';
    $this->_tblFormat['inactiveBegin'] = '<span style="text-decoration:line-through;font-style:italic">';
    $this->_tblFormat['inactiveEnd'] = '</span>';

    // default scripting
    $this->_scripts = "<!-- {HEAD_SCRIPTS} -->\r\n";

    // Default row selection mode
    $this->_rowSelectionEnabled = (bool) false;
    
    // By default, do not add a 'new row' button
    $this->_addNew = (bool) false;
    
    // Pass on to the URL the value of the 'mine only' switch
    $this->_showMine = (isset ($tblQuery['showMine']) ? $tblQuery['showMine'] : false);

    // Pass on to the URL the value of the 'inactive' switch
    $this->_showInactive = (isset ($tblQuery['showInactive']) ? $tblQuery['showInactive'] : false);
    
    // Encode the URL parameters?
    $this->_encodeUrl = (isset ($tblQuery['encode']) ? $tblQuery['encode'] : false);
  }

  /** 
   * Adds a button for 'inserting a new row'
   *
   * @param (string) $text     The text to show in the button (optional)
   * @param (string) $action   The action to perform when clicking the button (optional)
   * @param (string) $overrule The class to overrule the authorization with 
   * @access public
   */
  function addNewButton($text=null,$action=null,$overrule=null){
    
    if ($this->_dataClass=='usa') {
      if (isset($_SESSION['usr_permission'])){
        if ($_SESSION['usr_permission']['admin']){
          $text = (empty($text)?$this->_tblFormat['newCode']:$text);
          $action = (empty($action)?$this->_dataClass.'.php?toolbar_button=new':$action);
          $this->_tblFormat['newCode'] = ' <a href="'.$action.'" accesskey="R">'.$this->translate($text).'</a>';
          $this->_addNew = (bool) true;
        }
      }
    }
    else {
      $auth = (empty($overrule)?$this->_dataClass:$overrule);
      if (isset($_SESSION[$auth.'_permission'])){
        if ($_SESSION[$auth.'_permission']['write']){
          $text = (empty($text)?$this->_tblFormat['newCode']:$text);
          $action = (empty($action)?$this->_dataClass.'.php?toolbar_button=new':$action);
          $this->_tblFormat['newCode'] = ' <a href="'.$action.'" accesskey="R">'.$this->translate($text).'</a>';
          $this->_addNew = (bool) true;
        }
      }
    }
  }

  // Returns the Javascripts to be included in the html page
  function getScripts() {
    return $this->_scripts;
  }

  function enableRowSelection() {
    
    global $SPL_CFG;
    
    // Add javascript
    $this->_scripts = $this->_scripts.'<script type="text/javascript" src="'.$SPL_CFG['wwwroot'].'/ui/js/rolltable.js"></script>';

    // Set the cursor
    if ($this->_tblFormat['rowStyle'] == 'default') {
      $this->_tblFormat['rowStyle'] = ' style="'.$this->_tblFormat['rowCursorEnabled'].'"';
    } else {
      $newStyle = ' style="'.$this->_tblFormat['rowCursorEnabled'];
      $this->_tblFormat['rowStyle'] = str_replace(' style="', $newStyle, $this->_tblFormat['rowStyle']);
    }

    // Add mouse support
    $this->_tblFormat['rowMouseOverOdd'] = ' onMouseover="MoO(this);"';
    $this->_tblFormat['rowMouseOutOdd'] = ' onMouseout="MoU(1,this);"';
    $this->_tblFormat['rowMouseOutOddChanged'] = ' onMouseout="MoU(\'1_changed\',this);"';
    $this->_tblFormat['rowMouseClickOdd'] = ' MoC(1,this);"';
    $this->_tblFormat['rowMouseOverEven'] = ' onMouseover="MoO(this);"';
    $this->_tblFormat['rowMouseOutEven'] = ' onMouseout="MoU(2,this);"';
    $this->_tblFormat['rowMouseOutEvenChanged'] = ' onMouseout="MoU(\'2_changed\',this);"';
    $this->_tblFormat['rowMouseClickEven'] = ' MoC(2,this);"';

    // Mark as selectable
    $this->_rowSelectionEnabled = (bool) true;
  }

  ///////////////////////////////
  //Purpose: to retrieve a table's data
  // Inputs: $tblFormat: The associative array of table formatting information	as described above.
  //		 $tblQuery:	 An associative array of the SQL query specifics driving this table as described above.
  // Usage:  Inclusion of this snippet defines the variable defaults ($tblFormat, $tblQuery, & $dbData)
  //         Manipulate these data items and then pass them to this function.
  //Outputs: NONE		
  function getTable() {

    global $SPL_CFG,$SPL_UI;

    //Verify Parameters
    $sOutput = '';

    //orderDir
    if (strcasecmp($this->_tblQuery['orderDir'], 'asc') == 0 or strcasecmp($this->_tblQuery['orderDir'], 'desc') == 0)
      $this->_tblQuery['orderDir'] = db_escape_string($this->_tblQuery['orderDir']);
    else {
      echo "<b>Error:</b> \"orderDir\" parameter must be either ASC or DESC";
      return;
    }
    //orderBy
    $this->_tblQuery['orderBy'] = db_escape_string($this->_tblQuery['orderBy']);

    //viewStart
    if (is_numeric($this->_tblQuery['viewStart'])) {
      $this->_tblQuery['viewStart'] = intval(db_escape_string($this->_tblQuery['viewStart']));
      if ($this->_tblQuery['viewStart'] < '0')
        $this->_tblQuery['viewStart'] = '0';
    } else {
      echo "<b>Error:</b> \"viewStart\" parameter must be an integer value";
      return;
    }

    $endIndex = $this->_tblQuery['viewStart'] + $this->_tblQuery['viewSize'];

    $sSQL = 'SELECT '.$this->_tblQuery['columns'].' FROM '.$SPL_CFG['prefix'].$this->_tblQuery['tblName'].' '.$this->_tblQuery['where'];

    if (!$result = db_query($sSQL)) {
      echo "<b>Error:</b><br />Could Not \"$sSQL\".\n";
      return;
    }

    $rowCount = db_num_rows($result);
    if (isset ($this->_tblQuery['orderBy']) and strlen($this->_tblQuery['orderBy']) > 0) {
      /* Jebbol removed this code on 2005-04-10
      $fcount = db_num_fields($result);
      $valid = false;

      for ($i = 0; $i < $fcount; $i ++) {
        if (strcmp(db_field_name($result, $i), $this->_tblQuery['orderBy']) == 0) {
          $valid = true;
          break;
        }
      }

      if (!$valid) {
        echo "<b>Error:</b>\"orderBy\" parameter must be a valid Column in this table";
        return;
      }
      */
      $orderBy = 'ORDER BY '.$this->_tblQuery['orderBy'].' '.$this->_tblQuery['orderDir'];
      $this->_CurrentOrder = $this->_tblQuery['orderBy'];
      $this->_CurrentDir = $this->_tblQuery['orderDir'];
    } else
      $orderBy = '';

    db_free_result($result);

    $sSQL  = 'SELECT '.$this->_tblQuery['columns'].' FROM '.$SPL_CFG['prefix'].$this->_tblQuery['tblName'].' '.$this->_tblQuery['where'].' '.$orderBy;
    if ($this->_tableType == 'paged') {
      $sSQL .= ' LIMIT '.$this->_tblQuery['viewStart'].', '.$this->_tblQuery['viewSize'];
    }

    if (!$result = db_query($sSQL)) {
      echo "<b>Error:</b><br />Could Not \"$sSQL\".\n";
      return;
    }

    $sOutput = $this->_tblFormat['header'];
    if ($this->_tableType == 'scroller') {
      $sOutput = $sOutput.$this->_tblFormat['tblBegin_scrollerOuter']."\r\n";
    }
    else {
      $sOutput = $sOutput.$this->_tblFormat['tblBegin']."\r\n";
    }
    if ($this->_tblFormat['captionBegin'] != 'default') {
      $sOutput = $sOutput.$this->_tblFormat['captionBegin'].$this->_tblFormat['captionText'].$this->_tblFormat['captionEnd']."\r\n";
    }

    // Add rows
    if ($rowCount == 0){
      $sOutput .= '<tr>'.$this->_tblFormat['headingBegin'].'>&nbsp;'.$this->_tblFormat['headingEnd'].'</tr>'."\r\n";
      $sOutput .= $this->_tblFormat['rowBegin'].$this->_tblFormat['colBegin'].$this->translate($this->_tblFormat['empty']);
      if ($this->_addNew){
        $sOutput .= $this->translate($this->_tblFormat['newCode']);
      }
      $sOutput .= $this->_tblFormat['colEnd'].$this->_tblFormat['rowEnd']."\r\n";
    }
    else
      $sOutput = $sOutput.$this->getRows($result);

    $sOutput = $sOutput.$this->_tblFormat['tblEnd']."\r\n";
    $sOutput = $sOutput.$this->_tblFormat['footer']."\r\n";
    $sStartedAt = $this->_tblQuery['viewStart'] + 1;


    if ($this->_tblQuery['viewStart']>0 && $this->_tableType == 'paged') {
      $prevIndex = $this->_tblQuery['viewStart'] - $this->_tblQuery['viewSize'];
      // Reset order direction to the current direction
      $this->_tblQuery['orderBy'] = $this->_CurrentOrder;
      $this->_tblQuery['orderDir'] = $this->_CurrentDir;

      $URL = $this->buildURL($this->_tblQuery, 'viewStart', $prevIndex);
      $sPrevText = $this->translate($this->_tblFormat['prevCode']);
      $prev = "<a href=\"$URL\">{$sPrevText}</a>";
    } else {
      $prev = '';
    }

    if ($endIndex < $rowCount && $this->_tableType == 'paged') {
      $nextIndex = $sStartedAt -1 + $this->_tblQuery['viewSize'];
      // Reset order direction to the current direction
      $this->_tblQuery['orderBy'] = $this->_CurrentOrder;
      $this->_tblQuery['orderDir'] = $this->_CurrentDir;

      $URL = $this->buildURL($this->_tblQuery, 'viewStart', $nextIndex);
      $sNextText = $this->translate($this->_tblFormat['nextCode']);
      $next = "<a href=\"$URL\">{$sNextText}</a>";
    } else {
      $endIndex = $rowCount;
      $next = '';
    }

    if ($rowCount != 0) {
      $sOutput .= $this->_tblFormat['navBegin'];
      if ($this->_tableType == 'paged') {
        $sOutput .= "$prev ({$sStartedAt}-{$endIndex}) ".$this->translate('of')." $rowCount $next";
      }
      else {
        $sOutput .= $this->translate('number_of_rows')." $rowCount ";
      }
      if ($this->_addNew){
        $sOutput .= $this->translate($this->_tblFormat['newCode']);
      }
      $sOutput .= $this->_tblFormat['navEnd'];
    }
    db_free_result($result);
    db_close();
    
    // Set the viewport height
    if (!isset($SPL_UI['table_rowheight'])) {
      $SPL_UI['table_rowheight'] = '1.9';
    }
    if (!isset($SPL_UI['table_rowheightunit'])) {
      $SPL_UI['table_rowheightunit'] = 'em';
    }
    if ($this->_viewportHeight > ($rowCount*$SPL_UI['table_rowheight'])) {
      $this->_viewportHeight = (string)((float)$rowCount*(float)$SPL_UI['table_rowheight']);
    }
    $sOutput = str_replace('{VIEWPORT_HEIGHT}',($this->_viewportHeight.$SPL_UI['table_rowheightunit']),$sOutput);
    
    return $sOutput;
  }

  //////////////////////////
  //Purpose: Keep track of current SQL query options
  //		 And build a self-referring URL with one additional option change.
  //  Input: $tblQ(uery):  The Table's SQL Query information as it is
  //                       currently and is defined above
  //		 $changeIndex: The associative array "index" of the item that would
  //                       be changed by this link.
  //         $value:       The new value of the item to be changed by this link.
  // Output: A string version of the new URL, complete with parameters			
  //         "myscript.php?orderBy=Name&viewStart=20" For example
  function buildURL($tblQ, $changeIndex, $value) {
    global $SPL_CFG;
    $this->_tblQuery = $tblQ;
    $this->_tblQuery[$changeIndex] = $value;
    //$URL = $_SERVER["SCRIPT_NAME"];
    $URL = $_SERVER["PHP_SELF"];
    $params = '';
    if ($this->_tblQuery['orderBy'] != '') {
      $params .= "&amp;orderBy={$this->_tblQuery['orderBy']}";
    }
    if (isset ($this->_tblQuery['viewStart'])) {
      $params .= "&amp;viewStart={$this->_tblQuery['viewStart']}";
    }
    if ($this->_tblQuery['orderDir'] != '') {
      $params .= "&amp;orderDir={$this->_tblQuery['orderDir']}";
    }
    if ($this->_showInactive){
      $params .= "&amp;search_show_inactive=on";
    }
    if ($this->_showMine){
      $params .= "&amp;search_show_mine=on";
    }
    if (isset ($params)) {
      if ($this->_encodeUrl) {
        $params = base64_encode(rc4crypt::encrypt($SPL_CFG['rc4key'], $this->_tblQuery['parentChild'].$params));
        $URL ='?spl='.$params;
      }
      else {
        $URL .= '?'.$this->_tblQuery['parentChild'].$params;
      }
    }
    return $URL;
  }

  /**
   * Takes a result set from an SQL query and iterate field information and data into a query
   * 
   * @param (resultset) $result A valid SQL resultset
   * @public
   */
  function getRows($result) {
    
    global $SPL_META,$SPL_UI,$SPL_CFG;

    $rows = db_fetch_array($result);
    $colCount = db_num_fields($result);
    $rowCount = db_num_rows($result);
    $i = 0;
    $visibleCols = 0;
    if ($this->_tableType == 'scroller') {
      $sRowOutput = '<thead><tr class="scrollerOuter">'."\r\n";
    }
    else {
      $sRowOutput = '<thead><tr>'."\r\n";
    }
    $orderLink = '';
    $_fieldInfo = array ();

    // Build column headers
    while ($i < $colCount) {

      // Get database field name
      $sField = db_field_name($result, $i);

      // Find additional formatting data to be used in displaying the rows with data
      $show = (!isset($SPL_META[$sField]['hidden']) || $SPL_META[$sField]['hidden']==false);
      if (isset($this->_tblMeta[$sField]['hidden'])&&$this->_tblMeta[$sField]['hidden']==true){
        $show = false;
      }
      if ($show) {

        $visibleCols += 1;

        // Add ordering info
        if ($sField == $this->_CurrentOrder) {
          if (strlen($this->_tblQuery['orderBy']) > 0) {
            if (strcmp($this->_tblQuery['orderDir'], 'ASC') == 0) {
              $sVoid = $this->buildURL($this->_tblQuery, 'orderBy', $this->_CurrentOrder);
              $orderDirURL = $this->buildURL($this->_tblQuery, 'orderDir', 'DESC');
              $sDescendText = $this->translate($this->_tblFormat['descendCode']);
              $orderLink = "<a href=\"$orderDirURL\">{$sDescendText}</a>";
            } else
              if (strcmp($this->_tblQuery['orderDir'], 'DESC') == 0) {
                $sVoid = $this->buildURL($this->_tblQuery, 'orderBy', $this->_CurrentOrder);
                $orderDirURL = $this->buildURL($this->_tblQuery, 'orderDir', 'ASC');
                $sAscendText = $this->translate($this->_tblFormat['ascendCode']);
                $orderLink = "<a href=\"$orderDirURL\">{$sAscendText}</a>";
              }
          }
        } else {
          $orderLink = '';
        }

        // Build URL for sorting the column
        $URL = $this->buildURL($this->_tblQuery, 'orderBy', $sField);

        // Build HTML
        $fname = $this->columnLabel($sField);
        if ($this->_tableType == 'scroller') {
          $sRowOutput .= (($sField == $this->_CurrentOrder) ? $this->_tblFormat['headingOrderBegin_scroller'] : $this->_tblFormat['headingBegin_scroller']);
        }
        else {
          $sRowOutput .= (($sField == $this->_CurrentOrder) ? $this->_tblFormat['headingOrderBegin'] : $this->_tblFormat['headingBegin']);
        }
        
        // Add field size
        if (isset($SPL_META[$sField]['colsize'])) {
          $sRowOutput .= ' style="width:'.$SPL_META[$sField]['colsize'].'em';
        }
        else if (isset($SPL_META[$sField]['size'])) {
          $sRowOutput .= ' style="width:'.$SPL_META[$sField]['size'].'em';
        }
        
        if (isset($SPL_META[$sField]['type']) && $SPL_META[$sField]['type']=='checkbox') {
          $sRowOutput .= ';text-align:center"';
        }
        else if (isset($SPL_META[$sField]['column_orientation']) && $SPL_META[$sField]['column_orientation']=='center') {
          $sRowOutput .= ';text-align:center"';
        }
        else if (isset($SPL_META[$sField]['colsize']) || isset($SPL_META[$sField]['size'])){
          $sRowOutput .= '"';
        }
        else {
          $sRowOutput .= '';
        }
        $sRowOutput .= "><a href=\"$URL\">$fname</a>";
        if (strcmp($sField, $this->_tblQuery['orderBy']) == 0) {
          $sRowOutput .= "&nbsp;$orderLink";
        }
        if ($this->_tableType == 'scroller') {
          $sRowOutput .= $this->_tblFormat['headingEnd_scroller']."\r\n";
        }
        else {
          $sRowOutput .= $this->_tblFormat['headingEnd']."\r\n";
        }
      } // Not a hidden field

      // Next column
      $i ++;
    }
    $sRowOutput .= '</tr></thead>'."\r\n".'<tbody>'."\r\n";

    if ($this->_tableType == 'scroller') {
      $sRowOutput .= '<tr><td colspan="'.$visibleCols.'"><div class="scrollerInner" style="height:{VIEWPORT_HEIGHT}"><table class="scrollerInner">'."\r\n";
    }
    
    // Repostion recordpointer
    db_data_seek($result, 0);

    // Build table row
    $iCurrentRow = 0;
    while ($row = db_fetch_array($result,MYSQL_BOTH)) {

      $iCurrentRow ++;

      // Prepare the start tag
      $startTag = $this->_tblFormat['rowBegin'];

      // class
      //var_dump($row);
      if (($iCurrentRow % 2) == 0) {
        $startTag = $this->_addToTag($startTag, (isset($row['is_changed'])&&$row['is_changed'])?$this->_tblFormat['rowEvenClassChanged']:$this->_tblFormat['rowEvenClass']);
      } else {
        $startTag = $this->_addToTag($startTag, (isset($row['is_changed'])&&$row['is_changed'])?$this->_tblFormat['rowOddClassChanged']:$this->_tblFormat['rowOddClass']);
      }

      // style
      $startTag = $this->_addToTag($startTag, $this->_tblFormat['rowStyle']);
      
      // mouse support
      if (($iCurrentRow % 2) == 0) {
        $startTag = $this->_addToTag($startTag, $this->_tblFormat['rowMouseOverEven']);
        $startTag = $this->_addToTag($startTag, (isset($row['is_changed'])&&$row['is_changed'])?$this->_tblFormat['rowMouseOutEvenChanged']:$this->_tblFormat['rowMouseOutEven']);
        $startTag = $this->_addToTag($startTag, ' onClick="'.$this->_kickOut.'location=\''.trim($row[1]). (strpos($row[1], '?') ? '&amp;' : '?').'id='.$row[0].'\';'.$this->_tblFormat['rowMouseClickEven']);
      } else {
        $startTag = $this->_addToTag($startTag, $this->_tblFormat['rowMouseOverOdd']);
        $startTag = $this->_addToTag($startTag, (isset($row['is_changed'])&&$row['is_changed'])?$this->_tblFormat['rowMouseOutOddChanged']:$this->_tblFormat['rowMouseOutOdd']);
        $startTag = $this->_addToTag($startTag, ' onClick="'.$this->_kickOut.'location=\''.trim($row[1]). (strpos($row[1], '?') ? '&amp;' : '?').'id='.$row[0].'\';'.$this->_tblFormat['rowMouseClickOdd']);
      }

      // Row start tag
      $sRowOutput = $sRowOutput.$startTag;

      // Check for an 'out of date' record
      $outOfDate = (bool) false;
      if (!empty($this->_dateUntil)){
        for ($i = 0; $i < $colCount; $i ++) {

          $fname = db_field_name($result, $i);
          if ($fname==$this->_dateUntil){
            if ($row[$i]>0 && $row[$i]<time()){
              $outOfDate = (bool) true;
            }
          }

        }
      }
      
      // Check for an 'inactive' record
      $inactive = (bool) false;
      for ($i = 0; $i < $colCount; $i ++) {
        $fname = db_field_name($result, $i);
        if ($fname=='is_active'){
          if (!$row[$i]){
            $inactive = (bool) true;
          }
        }
      }

      // Add columns
      $firstVisibleCell = (int)0;
      for ($i = 0; $i < $colCount; $i ++) {

        $fname = db_field_name($result, $i);
        $ftype = db_field_type($result, $i);
        $colFormatBegin = '';
        $colFormatEnd   = '';
        if (isset($SPL_UI['table_cellfirstlast'])&&($SPL_UI['table_cellfirstlast'])) {
          if ($i==$firstVisibleCell) {
            $colBegin = $this->_tblFormat['colBeginFirst'];
          }
          else if ($i==($visibleCols+$firstVisibleCell-1)) {
            $colBegin = $this->_tblFormat['colBeginLast'];
          }
          else {
            $colBegin = $this->_tblFormat['colBegin'];
          }
        }
        else {
          $colBegin = $this->_tblFormat['colBegin'];
        }

        $colEnd = $this->_tblFormat['colEnd'];
        $data = $row[$i];
        if ($outOfDate && !empty($data)){
          $colBegin .= $this->_tblFormat['passedDateBegin'];
          $colEnd = $this->_tblFormat['passedDateEnd'].$colEnd;
        }
        else if ($inactive){
          $colBegin .= $this->_tblFormat['inactiveBegin'];
          $colEnd = $this->_tblFormat['inactiveEnd'].$colEnd;
        }

        // Add field size
        if ($this->_tableType == 'scroller') {
          if (isset($SPL_META[$fname]['colsize'])) {
            $colBegin = str_replace('>',' style="width:'.$SPL_META[$fname]['colsize'].'em">',$colBegin);
          }
          else if (isset($SPL_META[$fname]['size'])) {
            $colBegin = str_replace('>',' style="width:'.$SPL_META[$fname]['size'].'em">',$colBegin);
          }
        }

        // Only visible columns
        $show = (!isset($SPL_META[$fname]['hidden']) || $SPL_META[$fname]['hidden']==false);
        if (isset($this->_tblMeta[$fname]['hidden'])&&$this->_tblMeta[$fname]['hidden']==true){
          $show = false;
        }
        if ($show) {
          // Checkboxes
          if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='checkbox') {
            //$data = (empty ($data)) ? 'no' : 'yes';
            $data = (empty ($data)) ? str_replace('{IMAGE_DIR}',$this->_ImageDir,$SPL_UI['table_boolfalse']) : str_replace('{IMAGE_DIR}',$this->_ImageDir,$SPL_UI['table_booltrue']);
          }

          // Timestamps
          if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='timestamp') {
            $data = ($data>0?strftime("%Y-%m-%d",$data):'&nbsp;');
          }
          
          // Simple bar chart. $data contains the percentage
          if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='simplebar') {
            $chart  = isset($SPL_UI['simple_chart_start'])?$SPL_UI['simple_chart_start']:'<table><tr>';
            $chart .= str_replace('{BAR_PERCENTAGE}',$data.'%',$SPL_UI['simple_chart_percentage']);
            $chart .= str_replace('{BAR_PERCENTAGE}',$data.'%',$SPL_UI['simple_chart_bar_default']);
            $chart .= isset($SPL_UI['simple_chart_end'])?$SPL_UI['simple_chart_end']:'</tr></table>';
            $data = $chart;
          }
          
          // fill an empty cell with a whitespace (IE6 doesn't support 'empty-cells: show' for tables) 
          if (empty ($data) || $data == " ") {
            $data = '&nbsp;';

          }

          // Not an empty cell 
          else {
            // format year
            if ($ftype == 'date' && (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='year')) {
              $year = sscanf($data, ("%04d"));
              $data = $year[0];
            }

            // Translate list values
            if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='list') {
              $data = $this->translate($data);
            }

            // Translate checkboxes
            if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='checkbox') {
              $data = $this->translate($data);
            }

            // Find referenced record
            if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='reference') {
              $refFields = $SPL_META[$fname]['referencedisplay'];
              $refTable = $SPL_META[$fname]['referencetable'];
              $refKey = $SPL_META[$fname]['referencekey'];

              $_query = "SELECT ".$refFields." FROM ".$SPL_CFG['prefix'].$refTable." WHERE ".$refKey." = '".$data."'";
              $_reference = db_retrieve(db_query($_query));
            }

          } // End Not an empty cell

          if (isset ($this->_tblFormat['colFormat']) && isset ($this->_tblFormat['colFormat'][$fname])) {
            if (isset ($this->_tblFormat['colFormat'][$fname]['formatBegin']))
              $colFormatBegin = $this->_tblFormat['colFormat'][$fname]['formatBegin'];

            if (isset ($this->_tblFormat['colFormat'][$fname]['formatEnd']))
              $colFormatEnd = $this->_tblFormat['colFormat'][$fname]['formatEnd'];

            if (isset ($this->_tblFormat['colFormat'][$fname]['colBegin']))
              $colBegin = $this->_tblFormat['colFormat'][$fname]['colBegin'];

            if (isset ($this->_tblFormat['colFormat'][$fname]['colEnd']))
              $colEnd = $this->_tblFormat['colFormat'][$fname]['colEnd'];

            if (isset ($this->_tblFormat['colFormat'][$fname]['callBack'])) {
              $callback = $this->_tblFormat['colFormat'][$fname]['callBack'];
              $data = $callback ($data);
            }
          } // End if isset
          
          // Jebbol 2005-08-11
          // preg_replace: patch to correct the & -> &amp; problem caused by htmlspecialchars. 
          // Courtesy of jspalletta at gmail dot com, published on php.net 
          //$data = (get_magic_quotes_gpc()?preg_replace("/&amp;(#[0-9]+|[a-z]+);/i", "&$1;", htmlspecialchars(stripslashes($data))):$data);
          $data = (get_magic_quotes_gpc()?(stripslashes($data)):$data);

          // Center the data
          if (isset($SPL_META[$fname]['column_orientation']) && $SPL_META[$fname]['column_orientation']=='center') {
            $data = '<center>'.$data.'</center>';
          }
          
          // Adjust the width
          if (isset($SPL_META[$fname]['type']) && $SPL_META[$fname]['type']=='text') {
            if (isset($SPL_META[$fname]['size'])) {
              if (isset($SPL_META[$fname]['chop']) && $SPL_META[$fname]['chop']) {
                // Chop string and compensate for em width
                $data = $this->_str_chop($data,(int)($SPL_META[$fname]['size']*1.6));
              }
            }
          }
          
          $sRowOutput .= $colBegin.$colFormatBegin.$data.$colFormatEnd.$colEnd;

        } // end Only visible columns
        else {
          $firstVisibleCell++;
        }

      } // End Add columns

      $sRowOutput .= $this->_tblFormat['rowEnd']."\r\n";
    }
    if ($this->_tableType == 'scroller') {
      $sRowOutput .= '</table></div></td></tr>';
    }
    $sRowOutput .= '</tbody>'."\r\n";

    $rows = db_fetch_array($result);
    return $sRowOutput;

  } // End function getRows

  /** 
   * Translates the given string and returns the column labeltranslation
   *
   * @param  (string) $property The name of the data to be returned
   * @return (string)           The translated property
   * @public
   */
  function columnLabel($property){
    
    global $SPL_TXT;
    
    if (array_key_exists(strtolower($property.'_clabel'), $SPL_TXT)) {
      return $SPL_TXT[strtolower($property.'_clabel')];
    } else {
      return $this->translate($property);
    }
  }

  /** 
   * Initializes the metadata, the translations and the default template
   * 
   * @param (string) $class        The name of the class supplying the data
   * @param (string) $translation  (optional) The name of the translation file
   * @param (string) $qTranslation (optional) Fully qualified path to the translation file
   * @param (string) $qMetadata    (optional) Fully qualified path to the metadata file
   * @public
   */
  function init($class,$translation='default',$qTranslation=NULL,$qMetadata=NULL) {
    
    // Set the name of the dataclass
    $this->_dataClass = $class;
    
    // Load translations
    if (!empty($qTranslation)){
      $this->_setTranslation($qTranslation,true);
    }
    else {
      $translation = ($translation=='default'?$class:$translation);
      $this->_setTranslation($translation);
    }
    
    // Meta data
    if (!empty($qMetadata)){
      $this->_setMetadata($qMetadata,true);
    }
    else {
      $this->_setMetadata($class);
    }
  }

  /**
   * Sets the caption text and options (style=, class=, etc)
   *
   * @param (string) $sText    the caption text
   * @param (string) $sOptions the list of options
   * @public
   */
  function setCaption($sText, $sOptions = 'default') {
    $this->_tblFormat['captionBegin'] = (($sOptions != 'default') ? "<caption ".$sOptions.">" : "<caption>");
    $this->_tblFormat['captionText'] = $sText;
  }

  /**
   * Sets the caption text and options (style=, class=, etc)
   *
   * @param (string) $sText    the caption text
   * @param (string) $sOptions the list of options
   * @public
   */
  function setEmptyText($sText='empty table') {
    $this->_tblFormat['empty'] = $sText;
  }

  /** 
   * Sets the name of the script to call on e selected row
   *
   * @param (string) $sAction The onClick action
   * @public
   */
  function setCallBackScript($sScript) {
    $this->_callbackScript = $sScript;
  }

  /** 
   * Sets the column name of the 'valid until' column
   * 
	 * @param (string) $column The name of the column
   * @public
   */
  function setDateUntil($column) {
    $this->_dateUntil = $column;
  }

  /** 
   * Sets the class for normal column headings
   *
   * @param $sClass  string the class name
   * @public
   */
  function setHeadingClass($sClass) {
    $this->_tblFormat['headingBegin'] = "<tr class='".$sClass."'>";
  }

  /** 
   * Sets the class for 'order-by' column headings
   *
   * @param (string) $sClass The class name
   * @access public
   */
  function setHeadingOrderClass($sClass) {
    $this->_tblFormat['headingOrderBegin'] = "<tr class='".$sClass."'>";
  }

  /** 
   * Sets the image representing 'ascending order'
   *
   * @param (string) $sImage The image name (no path)
   * @public
   */
  function setImageAscend($sImage='uparrow0.png') {
    $this->_tblFormat['ascendCode'] = "<img src='".$this->_ImageDir.$sImage."' alt='".$this->translate('ascend')."' border='0' />";
  }

  /** 
   * Sets the image representing 'descending order'
   *
   * @param (string) $sImage  The image name (no path)
   * @public
   */
  function setImageDescend($sImage='downarrow0.png') {
    $this->_tblFormat['descendCode'] = "<img src='".$this->_ImageDir.$sImage."' alt='".$this->translate('descend')."' border='0' />";
  }

  /** 
   * Sets the path to the images directory (including trailing slash)
   *
   * @param (string) $sPath The path to the images
   * @public
   */
  function setImageDir($sPath) {
    $this->_ImageDir = $sPath;
    $this->setImageAscend();
    $this->setImageDescend();
  }

  /** 
   * Sets the location for  a selected row to kick out of framesets
   *
   * @public
   */
  function setKickOut() {
    $this->_kickOut = 'top.';
  }

  /**
   * Overrules the metadata in the $SPL_META array
   * 
   * @param (string) $column The column to overrule
   * @param (array)  $meta   The metadata to use
   * @public
   */
  function setMetaOverrule($column, $meta) {
    
    $this->_tblMeta[$column] = $meta;
  }

 /** 
  * Translates the given string and returns the translation
  *
  * @param  (string) $sProperty the name of the data to be returned
  * @return (string) the translated property
  * @public
  */
  function translate($property) {
    
    global $SPL_TXT;

    if (array_key_exists(strtolower($property.'_top'), $SPL_TXT)) {
      return $SPL_TXT[strtolower($property.'_top')];
    }
    else if (array_key_exists(strtolower($property), $SPL_TXT)) {
      return $SPL_TXT[strtolower($property)];
    } else {
      return $property;
    }
  }

  //=========================================================================
  // Private functions
  //=========================================================================

  function _addToElement($sElement, $sToBeAdded) {
    if ($sToBeAdded != 'default') {
      $newElement = ';" '.$sToBeAdded;
      $sElement = str_replace(';"', $newElement, $sElement);
    }
    return $sElement;
  }

  function _addToTag($sTag, $sToBeAdded) {
    if ($sToBeAdded != 'default') {
      $newTag = $sToBeAdded.">";
      $sTag = str_replace(">", $newTag, $sTag);
    }
    return $sTag;
  }

  /** 
   * Loads the metadata
   * 
   * @param  (string)  $filename  The name of the metadata file
   * @param  (boolean) $qualified The filename give is a fully qualified path
   * @private
   */
  function _setMetadata($filename,$qualified=false) {
    
    global $SPL_CFG,$SPL_META;
    
    // Is a fully qualified path given?
    if ($qualified){
      include_once($filename);
    }
    // Otherwise use the default path
    else {    
      if (isset($SPL_CFG['dirroot'])) {
        include_once($SPL_CFG['dirroot'].'/ui/meta/'.$filename.'.metadata.php');
      }
      else {
        include_once('meta/'.$filename.'.metadata.php');
      }
    }
  }

  /** 
   * Sets the translation file to be used
   * 
   * @param (string)  $filename  The name of the translation file
   * @param (boolean) $qualified The filename give is a fully qualified path
   * @public
   */
  function _setTranslation($filename,$qualified=false) {
    
    global $SPL_CFG,$SPL_TXT;
    
    // Is a fully qualified path given?
    if ($qualified){
      include_once($filename);
    }
    // Otherwise use the default path
    else {    
      if (isset($SPL_CFG['dirroot'])) {
        include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/'.$filename.'.lang.php');
      }
      else {
        include_once('lang/'.$_SESSION['usp_lang'].'/'.$filename.'.lang.php');
      }
    }
  }

  /**
   * Chop a string into a smaller string.
   *
   * @author       Aidan Lister <aidan@php.net>
   * @version      1.1
   * @param        (mixed)  $string   The string you want to shorten
   * @param        (int)    $length   The length you want to shorten the string to
   * @param        (bool)   $center   If true, chop in the middle of the string
   * @param        (mixed)  $append   String appended if it is shortened
   */
  function _str_chop($string, $length = 33, $center = false, $append = null)
  {
    // Set the default append string
    if ($append === null) {
      $append = ($center === true) ? ' ... ' : ' ...';
    }

    // Get some measurements
    $len_string = strlen($string);
    $len_append = strlen($append);

    // If the string is longer than the maximum length, we need to chop it
    if ($len_string > $length) {
      // Check if we want to chop it in half
      if ($center === true) {
        // Get the lengths of each segment
        $len_start = $length / 2;
        $len_end = $len_start - $len_append;

        // Get each segment
        $seg_start = substr($string, 0, $len_start);
        $seg_end = substr($string, $len_string - $len_end, $len_end);

        // Stick them together
        $string = $seg_start . $append . $seg_end;
      } 
      else {
        // Otherwise, just chop the end off
        $string = substr($string, 0, $length - $len_append) . $append;
      }
    }
    return $string;
  }
  

}

/**
 * $Log: table.class.php,v $
 * Revision 1.29  2006/08/08 12:28:58  jebbol
 * Corrected a type in addNewButton, preventing new entries to be added
 *
 * Revision 1.28  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.27  2006/06/10 12:00:44  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.26  2006/04/14 12:41:21  jebbol
 * *** empty log message ***
 *
 */
 
?>
