<?php
/**
 * User interface for manipulating data in a country object
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/04/14 12:46:33 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: cou.php,v $
 * Revision 1.10  2006/04/14 12:46:33  jebbol
 * Added print support
 *
 * Revision 1.9  2006/02/11 18:05:14  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Data objects
$myclass = basename($_SERVER['PHP_SELF'],'.php');

// Sanitize
$sanitize = array(
  'cou_id'=>array('type'=>'int'),
  'cou_code'=>array('type'=>'char'),
  'cou_name'=>array('type'=>'char'),
  'cou_streetformat'=>array('type'=>'enum','values'=>'SN,NS'),
  'cou_cityformat'=>array('type'=>'enum','values'=>'PC,CP'),
  'cou_phoneprefix'=>array('type'=>'char'),
  'prd_valid_from'=>array('type'=>'date'),
  'prd_valid_until'=>array('type'=>'date'),
);

// Page handling
include_once($SPL_CFG['dirroot'].'/ui/inc/script.setup.inc.php');

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('cou');
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode,$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('cou_name',$object->getProperty('cou_name'),!$editMode);
      $page->addField('cou_code',$object->getProperty('cou_code'),!$editMode);
      $page->addField('cou_streetformat',$object->getProperty('cou_streetformat'),!$editMode);
      $page->addField('cou_cityformat',$object->getProperty('cou_cityformat'),!$editMode);
      $page->addField('cou_phoneprefix',$object->getProperty('cou_phoneprefix'),!$editMode);
      $page->addField('cou_valid_from',$object->getProperty('cou_valid_from'),!$editMode);
      $page->addField('cou_valid_until',$object->getProperty('cou_valid_until'),!$editMode);
      $page->addField('is_active',$object->getProperty('is_active'),!$editMode);
      $page->showFormButtons();
    $page->endSubsection();
  $page->endSection();
  $page->endAreaData();
$page->endForm();

include_once($SPL_CFG['dirroot'].'/ui/inc/script.showpage.inc.php');

?>
