<?php
/**
 * User interface for searching items in the denominations table
 *
 * $Author: jebbol $
 * $Revision: 1.6 $
 * $Date: 2006/02/11 18:06:21 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: dnm_search.php,v $
 * Revision 1.6  2006/02/11 18:06:21  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$query['columns']  = 'dnm_id AS id,"dnm.php'.(isset($_GET['from'])?'?from='.$_GET['from']:'').'" AS target,dnm_name,dnm_short,dnm_code';
$query['tblName']  = 'dnm';
$query['where']    = 'WHERE adm_id = "'.$_SESSION['adm_id'].'" AND is_active';
$query['orderBy']  = 'dnm_short';
$query['orderDir'] = 'ASC';

//=========================================================================
// Handling of POST and GET
//=========================================================================

if (isset($_POST['search_for'])) {
  $query['where'] .= ' AND '.$_POST['search_by'].' LIKE "'.$_POST['search_for'].'%"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 


//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('dnm');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->addNewButton();


// Create the page
$page = new page();
$page->init('dnm','default','template_search.htm');
$page->setHeadScripts($table->getScripts());
  $page->startForm("dnmsearchform");
  $page->startSection();
  $page->startColumn();
  $page->startAreaSeacrh();
  $page->addSearchbar(array('dnm_name','dnm_short','dnm_code'),(isset($_POST['search_by'])?$_POST['search_by']:''),isset($_POST['search_for'])?$_POST['search_for']:'');
  $page->endAreaSearch();
  $table->setImageDir($page->getImageDir());
  $page->startAreaData();
  $page->addContent($table->getTable());
  $page->endAreaData();
  $page->endColumn();
  $page->endSection();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

?>
