<?php
/**
 * User interface for manipulating data in a group object
 *
 * $Author: jebbol $
 * $Revision: 1.8 $
 * $Date: 2006/08/28 09:19:27 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Data objects
$myclass = basename($_SERVER['PHP_SELF'],'.php');

$sanitize = array(
  'grp_id'=>array('type'=>'int'),
  'grp_code'=>array('type'=>'char'),
  'grp_name'=>array('type'=>'char'),
  'grp_short'=>array('type'=>'char'),
  'grp_type'=>array('type'=>'char'),
  'ins_id'=>array('type'=>'int'),
  'ina_id'=>array('type'=>'int'),
  'tra_id'=>array('type'=>'int'),
  'ali_id'=>array('type'=>'int'),
  'sub_id'=>array('type'=>'int'),
  'sug_id'=>array('type'=>'int'),
  'prd_id'=>array('type'=>'int'),
  'cal_id'=>array('type'=>'int'),
  'grp_calyear'=>array('type'=>'int','min'=>0,'max'=>2100),
  'grp_courseyear'=>array('type'=>'int','min'=>0,'max'=>99)
);

// Core data objects
include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
include_once($SPL_CFG['dirroot'].'/class/ins.class.php');
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');

// Methodology classes
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/cat.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sug.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');

// Page handling
include_once($SPL_CFG['dirroot'].'/ui/inc/script.setup.inc.php');

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init($myclass);
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      
      // Name
      $page->addField('grp_name',$object->getProperty('grp_name'),!$editMode);
      
      // Short name
      $page->addField('grp_short',$object->getProperty('grp_short'),!$editMode);
      
      // Code
      $page->addField('grp_code',$object->getProperty('grp_code'),!$editMode);
      
      // Type
      $page->addField('grp_type',$object->getProperty('grp_type'),!$editMode);
      
      // Institution
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ins_id.inc.php');

      // Institution address
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ina_id.inc.php');

      // Training
      require ($SPL_CFG['dirroot'].'/ui/inc/field.tra_id.inc.php');
      
      // Alignment
      require ($SPL_CFG['dirroot'].'/ui/inc/field.ali_id.inc.php');
      
      // Subject
      require ($SPL_CFG['dirroot'].'/ui/inc/field.sub_id.inc.php');
      
      // Suggestion
      require ($SPL_CFG['dirroot'].'/ui/inc/field.sug_id.inc.php');
      
      // Courseyear
      $page->addField('grp_courseyear',$object->getProperty('grp_courseyear'),!$editMode);

      // Period
      // require ($SPL_CFG['dirroot'].'/ui/inc/field.prd_id.inc.php');

      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');

      $page->showFormButtons();
    $page->endSubsection();
    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $tabs = array(array('name'=>'apl_tab1','title'=>'stu','tabaction'=>'../ui/apl_search.php?parent=grp&amp;parent_id='.$object->getProperty('grp_id').'&amp;child=stu'),
                      array('name'=>'apl_tab2','title'=>'tea','tabaction'=>'../ui/apl_search.php?parent=grp&amp;parent_id='.$object->getProperty('grp_id').'&amp;child=tea'),
                      array('name'=>'apl_tab3','title'=>'men','tabaction'=>'../ui/apl_search.php?parent=grp&amp;parent_id='.$object->getProperty('grp_id').'&amp;child=men')
                      );
        $selected = (!isset($clean['selected_tab'])?'apl_tab1':$clean['selected_tab']);
        $page->addTabbar($selected, 'subframe',$tabs,false,'id='.$object->getProperty('grp_id'));
        $page->addIFrame('apl_search.php?parent=grp&amp;parent_id='.$object->getProperty('grp_id').'&amp;child=stu','subframe','default','no','36em');
      $page->endSubsection();
    }
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

include_once($SPL_CFG['dirroot'].'/ui/inc/script.showpage.inc.php');

/**
 * $Log: grp.php,v $
 * Revision 1.8  2006/08/28 09:19:27  jebbol
 * *** empty log message ***
 *
 * Revision 1.7  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.6  2006/06/10 10:54:01  jebbol
 * Added grp_courseyear
 *
 * Revision 1.5  2006/04/14 12:46:33  jebbol
 * Added print support
 *
 * Revision 1.4  2006/02/11 18:12:30  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
