<?php
/**
 * User interface for manipulating data in a institution address object
 *
 * $Author: jebbol $
 * $Revision: 1.19 $
 * $Date: 2006/08/24 17:37:40 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Data objects
$myclass = basename($_SERVER['PHP_SELF'],'.php');

// Sanitize
$sanitize = array(
  'ina_id'=>array('type'=>'int'),
  'adr_id'=>array('type'=>'int'),
  'ina_type'=>array('type'=>'enum','values'=>'M,V,L,O'),
  'ina_code'=>array('type'=>'char'),
  'ina_email'=>array('type'=>'email'),
  'ina_name'=>array('type'=>'char'),
  'ina_alerttext'=>array('type'=>'char'),
  'ina_schoolyear_start'=>array('type'=>'date'),
  'ina_schoolyear_end'=>array('type'=>'date'),
  'ina_methodology'=>array('type'=>'char'),
  'ina_valid_from'=>array('type'=>'date'),
  'ina_valid_until'=>array('type'=>'date'),
);
if (isset($SPL_CFG['scheduler'])&&($SPL_CFG['scheduler']!='none')){
  $sanitize['ina_url_schedule_group']   = array('type'=>'char');
  $sanitize['ina_url_schedule_teacher'] = array('type'=>'char');
  $sanitize['ina_url_schedule_student'] = array('type'=>'char');
  $sanitize['ina_url_schedule_room']    = array('type'=>'char');
}

// Page handling
include_once($SPL_CFG['dirroot'].'/ui/inc/script.setup.inc.php');
$m = getMethodologies();

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('ina');
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode,$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('ina_name',$object->getProperty('ina_name'),!$editMode);
      $page->addField('ina_short',$object->getProperty('ina_short'),!$editMode);
      $page->addField('ina_code',$object->getProperty('ina_code'),!$editMode);
      $page->addField('ina_email',$object->getProperty('ina_email'),!$editMode);
      $page->addField('ina_type',$object->getProperty('ina_type'),!$editMode);
      // Only show methodologies when there's more than one
      if (is_array($m)&&count($m)>1){
        $page->addField('ina_methodology',$object->getProperty('ina_methodology'),!$editMode,false,false,$m);
      }
      $page->addField('ina_schoolyear_start',$object->getProperty('ina_schoolyear_start'),!$editMode);
      $page->addField('ina_schoolyear_end',$object->getProperty('ina_schoolyear_end'),!$editMode);
      if (isset($SPL_CFG['scheduler'])&&($SPL_CFG['scheduler']!='none')){
      $page->addField('ina_url_schedule_group',$object->getProperty('ina_url_schedule_group'),!$editMode);
      $page->addField('ina_url_schedule_teacher',$object->getProperty('ina_url_schedule_teacher'),!$editMode);
      $page->addField('ina_url_schedule_student',$object->getProperty('ina_url_schedule_student'),!$editMode);
      $page->addField('ina_url_schedule_room',$object->getProperty('ina_url_schedule_room'),!$editMode);
      }
      $page->addField('ina_valid_from',$object->getProperty('ina_valid_from'),!$editMode);
      $page->addField('ina_valid_until',$object->getProperty('ina_valid_until'),!$editMode);
      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
      $page->showFormButtons();
    $page->endSubsection();
    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $selected = (!isset($clean['selected_tab'])?'apl_tab1':$clean['selected_tab']);
        if ($object->getProperty('ina_methodology')=='traditional') {
          $tabs = array(array('name'=>'apl_tab1','title'=>'prd','tabaction'=>'apl_search.php?child=ina&parent=prd','newaction'=>'apl.php'),
                        array('name'=>'apl_tab2','title'=>'tra','tabaction'=>'apl_search.php?child=tra&parent=ina&parent_id='.$object->getProperty('ina_id').'&code='.$object->getProperty('ina_code')),
                        /* array('name'=>'apl_tab3','title'=>'ina_alerttext','widget'=>'tab_alerttext'), */
                       );
          $page->addTabbar($selected, 'subframe',$tabs,false,'id='.$object->getProperty('ina_id'));
        }
        else {
          $page->addTabbar($selected, 'subframe',null,false,'id='.$object->getProperty('ina_id'));
        }
        //$page->addField('ina_alerttext',$object->getPropertyFormatted('ina_alerttext'),!$editMode,false,false,false,NULL,true,' id="tab_alerttext"'.($selected=='apl_tab3'?'':' style="display:none"'));
        $page->addIFrame('apl_search.php?child=ina&id='.$object->getProperty('ina_id').'&parent=prd&code='.$object->getProperty('ina_code'),'subframe','default','no','36em');
      $page->endSubsection();
    }
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

include_once($SPL_CFG['dirroot'].'/ui/inc/script.showpage.inc.php');

/** 
 * $Log: ina.php,v $
 * Revision 1.19  2006/08/24 17:37:40  jebbol
 * Added email and alerttext
 *
 * Revision 1.18  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.17  2006/04/14 12:46:33  jebbol
 * Added print support
 *
 * Revision 1.16  2006/02/11 18:14:10  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
