<?php
/**
 * User interface for searching items in the institution addresses table
 *
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/02/11 18:13:17 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: ina_search.php,v $
 * Revision 1.10  2006/02/11 18:13:17  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================
$query['columns']  = 'ina_id AS id,"ina.php'.(isset($clean['from'])?'?from='.$clean['from']:'').'" AS target,ina_name,ina_short,ina_code,ina_methodology'.(isset($clean['search_show_inactive'])&&$clean['search_show_inactive']==true?',is_active':'');
$query['tblName']  = 'ina';
$query['where']    = 'WHERE adm_id = "'.$_SESSION['adm_id'].'"'.((!isset($clean['search_show_inactive'])||(isset($clean['search_show_inactive'])&&$clean['search_show_inactive']==false))?' AND is_active':'');
$query['orderBy']  = 'ina_name';
$query['orderDir'] = 'ASC';

//=========================================================================
// Handling of POST and GET
//=========================================================================

if (isset($clean['search_for'])) {
  $query['where'] .= ' AND '.$clean['search_by'].' LIKE "'.$clean['search_for'].'%"';
}

//The column to orderBy
if (isset ($clean['orderBy'])) $query['orderBy'] = $clean['orderBy'];

//The starting offset for record paging 
if (isset ($clean['viewStart'])) $query['viewStart'] = $clean['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($clean['orderDir']))  $query['orderDir'] = $clean['orderDir']; 

// Add inactive switch
if (isset($clean['search_show_inactive'])) $query['showInactive'] = $clean['search_show_inactive'];

// Encode URL
$query['encode'] = false;

//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('ina');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->addNewButton();

// Create the page
$page = new page();
$page->init('ina','default','template_search.htm');
$page->setHeadScripts($table->getScripts());
$table->setMetaOverrule('is_active', array('hidden'=>true));
$page->startForm("inasearchform");
  $page->startSection();
  $page->startColumn();
  $page->startAreaSearch();
  $page->addSearchbar(array('ina_name','ina_short','ina_code'),(isset($clean['search_by'])?$clean['search_by']:''),isset($clean['search_for'])?$clean['search_for']:'',null,$clean['search_show_inactive']);
  $page->endAreaSearch();
  $table->setImageDir($page->getImageDir());
  $page->startAreaData();
  $page->addContent($table->getTable());
  $page->endAreaData();
  $page->endColumn();
  $page->endSection();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

?>
