<?php
/**
 * Add an alignment field to a page
 *
 * $Author: jebbol $
 * $Revision: 1.3 $ 
 * $Date: 2006/08/08 08:09:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * @assumes   $object refers to the object manipulated
 * @assumes   $page   refers to the page object displaying the page
 * @assumes   $new    indicates if this is a new (unsaved) object or not
 */ 


// Make sure we have a valid instance
if (!isset($ali)) {
  include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');
}

$ali = new ali();
$single = $ali->isSingle();

if ($editMode){
  $ali_values = $ali->getKeyValues('tra',$object->getProperty('tra_id'));
  // When there is only one alignment, hide it
  if ($single && $editMode){
    $object->setProperty('ali_id',$single);
  }
  else if ((isset($new)&&$new) && !isset($clean['ali_id']) && isset($usd)) {
    // Find user defaults
    $tmp = $usd->getDefault($usd_script,'ali_id');
    if ($tmp) {
      $object->setProperty('ali_id',$tmp);
    }
  }
  $page->addField('ali_id',$object->getProperty('ali_id'),!$editMode,false,(isset($overrule)?$overrule:false),$ali_values);
  // In a new object, the first item in the listbox is displayed. Bring the object data in sync with the listbox
  if ((isset($new)&&$new) && !isset($clean['ali_id']) && ((int)$object->getProperty('ali_id')==0)){
    if (isset($ali_values[0])) {
      $ali_keys = array_keys($ali_values[0]);
      $object->setProperty('ali_id',$ali_keys[0]);
    }
  }
}
else {
  $page->addField('ali_id',$object->getProperty('ali_id'),!$editMode,false,(isset($overrule)?$overrule:false));
}

/**
 * $Log: field.ali_id.inc.php,v $
 * Revision 1.3  2006/08/08 08:09:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.2  2006/04/14 11:20:49  jebbol
 * Bug #1467590: Added check on single instance
 */

?>
