<?php
/**
 * Add an institution address field to a page
 *
 * $Author: jebbol $
 * $Revision: 1.2 $ 
 * $Date: 2006/08/08 08:09:19 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * @assumes   $object refers to the object manipulated
 * @assumes   $page   refers to the page object displaying the page
 * @assumes   $new    indicates if this is a new (unsaved) object or not
 */

// Find out if there is only one instance
if (!isset($ina)) {
  include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
}

$ina = new ina();
$single = $ina->isSingle();
if ($editMode){
  $ina_values = $ina->getKeyValues('ins',$object->getProperty('ins_id'));
  if ($single){
    $object->setProperty('ina_id',$single);
  }
  else if ((isset($new)&&$new) && !isset($clean['ina_id']) && isset($usd)){
    // Find user defaults
    $tmp = $usd->getDefault($usd_script,'ina_id');
    if ($tmp) {
      $object->setProperty('ina_id',$tmp);
    }
  }
  $page->addField('ina_id',$object->getProperty('ina_id'),!$editMode,false,(isset($overrule)?$overrule:false),$ina_values,null,true,false,$single);
  // In a new object, the first item in the listbox is displayed. Bring the object data in sync with the listbox
  if ((isset($new)&&$new) && !isset($clean['ina_id']) && ((int)$object->getProperty('ina_id')==0)){
    if (isset($ina_values[0])) {
      $ina_keys = array_keys($ina_values[0]);
      $object->setProperty('ina_id',$ina_keys[0]);
    }
  }
}
else {
  $page->addField('ina_id',$object->getProperty('ina_id'),!$editMode,false,(isset($overrule)?$overrule:false),false,null,true,false,$single);
}

/**
 * $Log: field.ina_id.inc.php,v $
 * Revision 1.2  2006/08/08 08:09:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 */
?>
