<?php
/**
 * Add an subject field to a page
 *
 * $Author: jebbol $
 * $Revision: 1.4 $ 
 * $Date: 2006/08/21 18:42:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * @assumes   $object refers to the object manipulated
 * @assumes   $page   refers to the page object displaying the page
 * @assumes   $new    indicates if this is a new (unsaved) object or not

 */

// Make sure we have a valid instance
if (!isset($sub)) {
  include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/sub.class.php');
}
// Make sure we have a valid instance
if (!isset($ina)) {
  include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
  $ina = new ina();
}

$sub = new sub();
$single = $sub->isSingle();

if ($editMode){
  $sub_values = $ina->getKeyValues('ali',$object->getProperty('ali_id'));
  if ($single){
    $object->setProperty('sub_id',$single);
  }
  else if ((isset($new)&&$new) && !isset($clean['sub_id']) && isset($usd)) {
    // Find user defaults
    $tmp = $usd->getDefault($usd_script,'sub_id');
    if ($tmp) {
      $object->setProperty('sub_id',$tmp);
    }
  }
  $page->addField('sub_id',$object->getProperty('sub_id'),!$editMode,false,(isset($overrule)?$overrule:false),$sub->getKeyValues('ali',$object->getProperty('ali_id'),'sub_code','ASC'));
  // In a new object, the first item in the listbox is displayed. Bring the object data in sync with the listbox
  if ((isset($new)&&$new) && !isset($clean['sub_id']) && ((int)$object->getProperty('sub_id')==0)){
    if (isset($sub_values[0])) {
      $sub_keys = array_keys($sub_values[0]);
      $object->setProperty('sub_id',$sub_keys[0]);
    }
  }
}
else {
  $page->addField('sub_id',$object->getProperty('sub_id'),!$editMode,false,(isset($overrule)?$overrule:false));
}

/**
 * $Log: field.sub_id.inc.php,v $
 * Revision 1.4  2006/08/21 18:42:19  jebbol
 * Changed default sort order to sub_code ASC
 *
 * Revision 1.3  2006/08/08 08:09:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.2  2006/04/14 11:22:04  jebbol
 * Bug #1467590: Added check on single instance
 */
 
?>
