<?php
/**
 * Add a training field to a page
 *
 * $Author: jebbol $
 * $Revision: 1.2 $ 
 * $Date: 2006/08/08 08:09:19 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * @assumes   $object refers to the object manipulated
 * @assumes   $page   refers to the page object displaying the page
 * @assumes   $new    indicates if this is a new (unsaved) object or not
 */

// Make sure we have a valid instance
if (!isset($tra)) {
  include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');
}

$tra = new tra();
$single = $tra->isSingle();

if ($editMode){
  $tra_values = $tra->getKeyValues('ina',$object->getProperty('ina_id'));
  if ($single){
    $object->setProperty('tra_id',$single);
  }
  else if ((isset($new)&&$new) && !isset($clean['tra_id']) && isset($usd)) {
    // Find user defaults
    $tmp = $usd->getDefault($usd_script,'tra_id');
    if ($tmp) {
      $object->setProperty('tra_id',$tmp);
    }
  }
  $page->addField('tra_id',$object->getProperty('tra_id'),!$editMode,false,(isset($overrule)?$overrule:false),$tra_values);
  // In a new object, the first item in the listbox is displayed. Bring the object data in sync with the listbox
  if ((isset($new)&&$new) && !isset($clean['tra_id']) && ((int)$object->getProperty('tra_id')==0)){
    if (isset($tra_values[0])) {
      $tra_keys = array_keys($tra_values[0]);
      $object->setProperty('tra_id',$tra_keys[0]);
    }
  }
}
else {
  $page->addField('tra_id',$object->getProperty('tra_id'),!$editMode,false,(isset($overrule)?$overrule:false));
}

/**
 * $Log: field.tra_id.inc.php,v $
 * Revision 1.2  2006/08/08 08:09:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 */
?>
