<?php
/**
 * Setup logic for maintenance scripts
 * 
 * $Author: jebbol $
 * $Revision: 1.2 $
 * $Date: 2006/08/08 08:09:19 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl, all rights reserved 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Page generation support
//=========================================================================

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Must have access rights
include_once($SPL_CFG['dirroot'].'/ui/inc/permissioncheck.inc.php');

// User defaults
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');
$usd = new usd();
$usd_script = $myclass;

//=========================================================================
// Setup
//=========================================================================

// Create object
include_once($SPL_CFG['dirroot'].'/class/'.$myclass.'.class.php');
$evalstr = "\$object = new ".$myclass."();";
@eval("$evalstr");

$editMode = (bool)false;

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($clean['from'])){
  $from_id = $clean['id'];
}
    
// Populate the object
if (isset($clean['id'])) {
  if ($object->init($clean['id'])){
    $_SESSION[$myclass.'_id'] = $clean['id'];
  }
}

// Get the 'current' object
else {
  if (isset($_SESSION[$myclass.'_id'])) {
    $object->init($_SESSION[$myclass.'_id']);
  }
  // if there is no current object, start a search
  else if (!isset($clean['button_action']))  {
    redirect($SPL_CFG['wwwroot'].'/ui/'.$myclass.'_search.php');
  }
}

// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      $object->delete($object->getProperty('is_active')=='1');
      $evalstr = "\$object = new ".$myclass."();";
      @eval("$evalstr");
      unset($_SESSION[$myclass.'_id']);
      redirect($SPL_CFG['wwwroot'].'/ui/'.$myclass.'_search.php');
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      save();
      redirect($SPL_CFG['wwwroot'].'/ui/'.$myclass.'_search.php');
      break;
    case 'help':
      if (!isset($SPL_CFG['helproot'])) {$SPL_CFG['helproot'] = 'http://doc.studiewijzer.org';}
      redirect($SPL_CFG['helproot'].'?code='.$myclass.(isset($_SESSION['usp_lang'])?'&lang='.$_SESSION['usp_lang']:'').(isset($_SESSION['usp_skin'])?'&skin='.$_SESSION['usp_skin']:''));
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    case 'new':
      $evalstr = "\$object = new ".$myclass."();";
      @eval("$evalstr");
      $editMode = (bool)true;
      unset($_SESSION[$myclass.'_id']);
      break;
    case 'print':
      if ($editMode){
        $object->save();
      }
      redirect($SPL_CFG['wwwroot'].'/ui/print.php?class='.$myclass);
      break;
    case 'save':
      $editMode = (bool)true;
      if (!save()) {
        // Retrieve message
        $tmp = $object->getMessages();
        if (is_array($tmp)&&count($tmp)>0) {
          $_SESSION['msg']                 = array_pop($tmp);
          $_SESSION['referred_from']       = $_SERVER['PHP_SELF'];
          $_SESSION['messagebox_icontype'] = 'disappointed';
          redirect($SPL_CFG['wwwroot'].'/ui/message.php');
        }
      }
      $editMode = (bool)false;
      break;
    default:
      break;
  }
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION[$myclass.'_id']){
    $object->setProperty($clean['from'],$from_id);
  }
}

// Is this a new object?
$new = $object->isNew();

//=========================================================================
// Functions
//=========================================================================

/**
 * Save object state
 */
function save(){
  
  global $object,$editMode,$clean,$myclass;

  if (!$editMode){
    return;
  }

  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();

  $_SESSION[$myclass.'_id'] = $object->getProperty($myclass.'_id');
}

/**
 * Set object attributes
 */
function set(){
  
  global $object,$clean,$myclass,$m;
  
  foreach ($clean as $key => $value) {
    // Ignore the housekeeping stuff
    if ($key=='id'||$key=='button_action'||$key=='toolbar_button'||$key=='search_show_inactive') {
      continue;
    }
    // Some ugly class specific hacks
    if ($key=='ina_methodology') {
      // When there is more than one methodology, set the users choice
      if (isset ($clean['ina_methodology'])) {$object->setProperty('ina_methodology', $clean['ina_methodology']);}
      // Otherwise set the first one available (should be the only one)
      else if (is_array($m)) {
        $object->setProperty('ina_methodology',current($m[0]));
      }
      continue;
    }
    
    $object->setProperty($key, $clean[$key]);
  }
  
  if (isset ($clean['is_active'])) {$object->setProperty('is_active', $clean['is_active']);}
  
}

/** 
 * $Log: script.setup.inc.php,v $
 * Revision 1.2  2006/08/08 08:09:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.1  2006/04/14 12:19:10  jebbol
 * *** empty log message ***
 *
 */

?>
