<?php

/**
 * Display system info
 *
 * $Author: jebbol $
 * $Revision: 1.6 $ 
 * $Date: 2006/09/03 18:56:00 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once ('../inc/config.php');

// Page generation
include_once ($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once ($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

//=========================================================================
// Sanitize request variables
//=========================================================================

require_once ($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once ($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Must be an administrator
include_once ($SPL_CFG['dirroot'].'/ui/inc/admincheck.inc.php');

//=========================================================================
// Build the page
//=========================================================================
$page = new page();
$page->init('spl', 'default', 'template_iframe.htm', false);
$page->startScrollableArea();
$page->startForm();
$page->startTable('none','width="99%"');
$page->startRow();
$page->startColumn();
$page->startPane('Studiewijzer '.get_config('spl_version_major').'.'.get_config('spl_version_minor').get_config('spl_version_patch'), 'noclose','menu');
$page->startTable();
$page->startRow();
$page->startColumn();
$page->startTable();
$page->addContent('<tr><td class="e">Licentie</td><td class="v"><a href="http://www.gnu.org/licenses/gpl.html" target="_blank">GNU General Public License</a></td></tr>', 'yes');
$page->addContent('<tr><td class="e">Copyright</td><td class="v"><a href="http://www.studiewijzer.nl" target="_blank">Imai BV, Hoefbladhof 4a, 3991 GH HOUTEN</a></td></tr>', 'yes');
$page->endTable();
$page->endColumn();
$page->startColumn('none','style="width:62px;"');
$page->addContent('<img src="'.$SPL_CFG['wwwroot'].'/ui/skin/osi-certified.jpg" title="OSI Certified Open Source Software" alt="OSI Certified" />');
$page->endColumn();
$page->endRow();
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->startRow();
$page->startColumn();
$page->startPane('Configuratie', 'noclose','menu');
$page->startTable();
$page->addContent('<tr><td class="e">ELO</td><td class="v">'. ($SPL_CFG['elo'] == 'none' ? 'Niet in gebruik' : ucwords($SPL_CFG['elo'])).'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Portfolio</td><td class="v">'. ($SPL_CFG['portfolio'] == 'none' ? 'Niet in gebruik' : ucwords($SPL_CFG['portfolio'])).'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Rooster</td><td class="v">'. ($SPL_CFG['scheduler'] == 'none' ? 'Niet in gebruik' : ucwords($SPL_CFG['scheduler'])).'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Leerstijl</td><td class="v">'. ($SPL_CFG['learning_style'] == 'false' ? 'Niet in gebruik' : 'Ja').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Studielast</td><td class="v">'. ($SPL_CFG['learning_load'] == 'false' ? 'Niet in gebruik' : 'Ja').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Studiepunten</td><td class="v">'. ($SPL_CFG['learning_reward'] == 'false' ? 'Niet in gebruik' : 'Ja').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Persoons gegevens</td><td class="v">'. ($SPL_CFG['person_details'] == 'false' ? 'Nee' : 'Ja').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Hits bijhouden</td><td class="v">'. ($SPL_CFG['hit_statistics'] == 'false' ? 'Nee' : $SPL_CFG['hit_statistics_days'].' dagen').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Docent widgets</td><td class="v">'. ($SPL_CFG['teacher_statistics'] == 'false' ? 'Niet ondersteund' : 'Wordt ondersteund').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Editor</td><td class="v">'. ($SPL_CFG['editor'] == 'none' ? 'Niet in gebruik' : ucwords($SPL_CFG['editor'])).'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Lijstgrootte</td><td class="v">'.$SPL_CFG['max_listitems'].'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Input validatie</td><td class="v">'. ($SPL_CFG['client_validate'] == 'default' ? 'Op zowel de client als de server' : 'Alleen op de server').'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Skin</td><td class="v">'.ucwords($SPL_CFG['skin']).'</td></tr>', 'yes');
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->startRow();
$page->startColumn();
$page->startPane('Systeem', 'noclose','menu');
$page->startTable();
$page->addContent('<tr><td class="e">Browser</td><td class="v">'.get_browsername().' op '.get_os().'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Server</td><td class="v">'.get_server_software().' op '.@ php_uname().'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Web adres</td><td class="v">'.$SPL_CFG['wwwroot'].'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Directory</td><td class="v">'.$SPL_CFG['dirroot'].'</td></tr>', 'yes');
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->startRow();
$page->startColumn();
$page->startPane('Database', 'noclose','menu');
$page->startTable();
$page->addContent('<tr><td class="e">Type</td><td class="v">'.ucwords($SPL_CFG['dbtype']).'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Versie</td><td class="v">'.db_server_info().'</td></tr>', 'yes');
$page->addContent('<tr><td class="e">Schema</td><td class="v">'.get_config('db_version').'</td></tr>', 'yes');
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->startRow();
$page->startColumn();
$page->startPane('PHP '.phpversion(), 'noclose','menu');
$page->startTable('none','style="table-layout:fixed"');
$page->addContent('<tr><td width="40em">'.get_phpinfo().'</td></tr>', 'yes');
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->startRow();
$page->startColumn();
$page->startPane('Credits', 'noclose','menu');
$page->startTable();
$page->addContent('<tr><td style="width:20em;font-weight:bold">Component</td><td style="width:15em;font-weight:bold">Auteur</td><td style="width:6em;font-weight:bold">Versie</td><td style="width:5em;font-weight:bold">Licentie</td></tr>', 'yes');
$page->addContent('<tr><td style="width:20em">ezPDF</td><td style="width:15em"><a href="http://www.ros.co.nz/pdf" target="_blank">Wayne Munro</a></td><td style="width:6em">'.get_config('ezpdf_version').'</td><td style="width:5em"></td></tr>', 'yes');
$page->addContent('<tr><td>Form Validation</td><td><a href="http://www.xs4all.nl/~sbpoley/webmatters/formval.html" target="_blank">Stephen Poley</a></td><td>Modified</td><td><a href="http://www.gnu.org/copyleft/lesser.html" target="_blank">LGPL</a></td></tr>', 'yes');
$page->addContent('<tr><td>Jax Calendar</td><td><a href="http://www.jtr.de/scripting/php/calendar/index_eng.html" target="_blank">Andreas John</a></td><td>'.get_config('jaxcalendar_version').'</td><td><a href="http://www.fsf.org/copyleft/gpl.html" target="_blank">GPL</a></td></tr>', 'yes');
$page->addContent('<tr><td>RC4Crypt</td><td><a href="http://mjsabby.com/" target="_blank">Mukul Sabharwal</a></td><td>'.get_config('rc4crypt_version').'</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>Session Handler</td><td><a href="http://www.cheetahsoft.com" target="_blank">Joe Penn</a></td><td>Modified</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>Shortstat hit statistics</td><td><a href="http://www.shauninman.com" target="_blank">Shaun Inman</a></td><td>0.2b</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>Shortstat widget gateway</td><td><a href="http://www.keeganjones.com" target="_blank">Keegan Jones</a></td><td>Modified</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>TableView</td><td><a href="http://www.hachisoft.com/" target="_blank">Elliott Edwards</a></td><td>Modified</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>Text Formatting</td><td>Chung Leong</a></td><td>Modified</td><td></td></tr>', 'yes');
$page->addContent('<tr><td>TinyMCE Editor</td><td><a href="http://tinymce.moxiecode.com/" target="_blank">Moxiecode Systems AB</a></td><td>'.get_config('tinymce_version').'</td><td><a href="http://www.gnu.org/copyleft/lesser.html" target="_blank">LGPL</a></td></tr>', 'yes');
$page->endTable();
$page->endPane('menu');
$page->endColumn();
$page->endRow();

$page->endTable();
$page->endForm();
$page->endScrollableArea();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->setRowStatistics();
$page->showPage();

//=========================================================================
// Show the page
//=========================================================================

/**
 * Retrieve server software
 * Kindly borrowed from Mambo
 */
function get_server_software() {
  if (isset ($_SERVER['SERVER_SOFTWARE'])) {
    return $_SERVER['SERVER_SOFTWARE'];
  } else
    if (($sf = getenv('SERVER_SOFTWARE'))) {
      return $sf;
    } else {
      return 'n/a';
    }
}

function get_php_setting($val) {
  $r = (ini_get($val) == '1' ? 1 : 0);
  return $r ? 'Aan' : 'Uit';
}

function get_config($name) {
  global $SPL_CFG;
  $query = 'SELECT cfg_value FROM '.$SPL_CFG['prefix'].'cfg WHERE cfg_name = "'.$name.'" LIMIT 1';
  $result = db_retrieve(db_query($query));
  return (isset ($result['cfg_value']) ? $result['cfg_value'] : false);
}

function get_phpinfo() {
  $output = '';
  ob_start();
  phpinfo(INFO_GENERAL | INFO_CONFIGURATION);
  $phpinfo = ob_get_contents();
  ob_end_clean();
  preg_match_all('#<body[^>]*>(.*)</body>#siU', $phpinfo, $output);
  $output = preg_replace('#<table#', '<table class="adminlist" align="center"', $output[1][0]);
  $output = preg_replace('#(\w),(\w)#', '\1, \2', $output);
  $output = preg_replace('#border="0" cellpadding="3" width="600"#', 'border="0" cellspacing="1" cellpadding="4" width="95%"', $output);
  $output = preg_replace('#<hr />#', '', $output);
  $output = preg_replace('#<h1#', '<!-- <h1', $output);
  $output = preg_replace('#</h1>#', '</h1> -->', $output);
  $output = preg_replace('#<h2#', '<!-- <h2', $output);
  $output = preg_replace('#</h2>#', '</h2> -->', $output);
  return $output;
}

/**
 * Get browsername and version
 * @param string user agent  
 * @return string browser name and version or false if unrecognized
 * @static 
 * @access public
 */
function get_browsername($useragent = null) {
  $mathes = null;

  if (!isset ($useragent)) {
    $useragent = phpversion() <= "4.2.1" ? getenv("HTTP_USER_AGENT") : $_SERVER["HTTP_USER_AGENT"];
  }

  //check for most popular browsers first
  //unfortunately that's ie. We also ignore opera and netscape 8 
  //because they sometimes send msie agent
  if (strpos($useragent, "MSIE") !== false && strpos($useragent, "Opera") === false && strpos($useragent, "Netscape") === false) {
    //deal with IE
    $found = preg_match("/MSIE ([0-9]{1}\.[0-9]{1,2})/", $useragent, $mathes);
    if ($found) {
      return "Internet Explorer ".$mathes[1];
    }
  }
  elseif (strpos($useragent, "Gecko")) {
    //deal with Gecko based

    //if Flock (based on gecko)
    $found = preg_match("/Flock\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Flock ".$mathes[1];
    }

    //if firefox
    $found = preg_match("/Firefox\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Mozilla Firefox ".$mathes[1];
    }

    //if Netscape (based on gecko)
    $found = preg_match("/Netscape\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Netscape ".$mathes[1];
    }

    //if Safari (based on gecko)
    $found = preg_match("/Safari\/([0-9]{2,3}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Safari ".$mathes[1];
    }

    //if Galeon (based on gecko)
    $found = preg_match("/Galeon\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Galeon ".$mathes[1];
    }

    //if Konqueror (based on gecko)
    $found = preg_match("/Konqueror\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Konqueror ".$mathes[1];
    }

    //if Epiphany (based on gecko)
    $found = preg_match("/Epiphany\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Epiphany ".$mathes[1];
    }

    //no specific Gecko found
    //return generic Gecko
    return "Gecko based";
  }

  elseif (strpos($useragent, "Opera") !== false) {
    //deal with Opera
    $found = preg_match("/Opera[\/ ]([0-9]{1}\.[0-9]{1}([0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Opera ".$mathes[1];
    }
  }
  elseif (strpos($useragent, "Lynx") !== false) {
    //deal with Lynx      
    $found = preg_match("/Lynx\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Lynx ".$mathes[1];
    }

  }
  elseif (strpos($useragent, "Netscape") !== false) {
    //NN8 with IE string
    $found = preg_match("/Netscape\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/", $useragent, $mathes);
    if ($found) {
      return "Netscape ".$mathes[1];
    }
  } else {
    //unrecognized, this should be less than 1% of browsers (not counting bots like google etc)!
    return false;
  }
}

/**
 * Get browsername and version
 * @param string user agent  
 * @return string os name and version or false in unrecognized os
 * @static 
 * @access public
 */
function get_os($useragent = null) {
  if (!isset ($useragent)) {
    $useragent = phpversion() <= "4.2.1" ? getenv("HTTP_USER_AGENT") : $_SERVER["HTTP_USER_AGENT"];
  }

  $useragent = strtolower($useragent);

  //check for (aaargh) most popular first   
  //winxp
  if (strpos("$useragent", "windows nt 5.1") !== false) {
    return "Windows XP";
  }
  elseif (strpos("$useragent", "windows 98") !== false) {
    return "Windows 98";
  }
  elseif (strpos("$useragent", "windows nt 5.0") !== false) {
    return "Windows 2000";
  }
  elseif (strpos("$useragent", "windows nt 5.2") !== false) {
    return "Windows 2003 server";
  }
  elseif (strpos("$useragent", "windows nt 6.0") !== false) {
    return "Windows Vista";
  }
  elseif (strpos("$useragent", "windows nt") !== false) {
    return "Windows NT";
  }
  elseif (strpos("$useragent", "win 9x 4.90") !== false && strpos("$useragent", "win me")) {
    return "Windows ME";
  }
  elseif (strpos("$useragent", "win ce") !== false) {
    return "Windows CE";
  }
  elseif (strpos("$useragent", "win 9x 4.90") !== false) {
    return "Windows ME";
  }
  elseif (strpos("$useragent", "mac os x") !== false) {
    return "Mac OS X";
  }
  elseif (strpos("$useragent", "macintosh") !== false) {
    return "Macintosh";
  }
  elseif (strpos("$useragent", "ubuntu") !== false) {
    return "Ubuntu";
  }
  elseif (strpos("$useragent", "suse") !== false) {
    return "Suse";
  }
  elseif (strpos("$useragent", "linspire") !== false) {
    return "Linspire";
  }
  elseif (strpos("$useragent", "linux") !== false) {
    return "Linux";
  }
  elseif (strpos("$useragent", "freebsd") !== false) {
    return "Free BSD";
  }
  elseif (strpos("$useragent", "symbian") !== false) {
    return "Symbian";
  } else {
    return false;
  }
}

/**
 * $Log: info.php,v $
 * Revision 1.6  2006/09/03 18:56:00  jebbol
 * *** empty log message ***
 *
 * Revision 1.5  2006/09/03 18:24:51  jebbol
 * Changed label_readonly into e and field into v
 *
 * Revision 1.4  2006/04/18 15:37:44  jebbol
 * Removed the style from the table (width:100%)
 *
 * Revision 1.3  2006/02/11 18:17:51  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 */

?>

