<?php
/**
 * User interface for manipulating data in a institution object
 *
 * $Author: jebbol $
 * $Revision: 1.11 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Data objects
$myclass = basename($_SERVER['PHP_SELF'],'.php');

// Sanitize
$sanitize = array(
  'ins_id'=>array('type'=>'int'),
  'ins_name'=>array('type'=>'char'),
  'ins_short'=>array('type'=>'char'),
  'ins_code'=>array('type'=>'char'),
  'ins_schoolyear_start'=>array('type'=>'date'),
  'ins_schoolyear_end'=>array('type'=>'date'),
  'ins_methodology'=>array('type'=>'char'),
);

// Page handling
include_once($SPL_CFG['dirroot'].'/ui/inc/script.setup.inc.php');
$m = getMethodologies();


//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('ins');
$page->startForm(null,'default',true);
  $page->addToolbar(!$editMode,!$editMode&&$object->isLoaded(),$editMode,!$editMode,$editMode,!$editMode);
  $page->startAreaData();
  $page->startSection();
    $page->startSubsection('subsection1');
      $page->addField('ins_name',$object->getProperty('ins_name'),!$editMode);
      $page->addField('ins_short',$object->getProperty('ins_short'),!$editMode);
      $page->addField('ins_code',$object->getProperty('ins_code'),!$editMode);
      // Only show methodologies when there's more than one
      if (is_array($m)&&count($m)>1){
        $page->addField('ins_methodology',$object->getProperty('ins_methodology'),!$editMode,false,false,getMethodologies());
      }
      //$page->addField('ins_schoolyear_start',$object->getProperty('ins_schoolyear_start'),!$editMode);
      //$page->addField('ins_schoolyear_end',$object->getProperty('ins_schoolyear_end'),!$editMode);
      // Active
      require ($SPL_CFG['dirroot'].'/ui/inc/field.is_active.inc.php');
      $page->showFormButtons();
    $page->endSubsection();

    if ($object->isLoaded()){
      $page->startSubsection('subsection2');
        $selected = (!isset($clean['selected_tab'])?'apl_tab1':$clean['selected_tab']);
        $tabs = array(array('name'=>'apl_tab1','title'=>'ina','tabaction'=>'apl_search.php?child=ina&parent=ins&parent_id='.$object->getProperty('ins_id'),'newaction'=>'apl.php')
                      );
        $page->addTabbar($selected, 'subframe',$tabs,false,'id='.$object->getProperty('ina_id'));
        $page->addIFrame('apl_search.php?child=ina&parent_id='.$object->getProperty('ins_id').'&parent=ins&code='.$object->getProperty('ins_code'),'subframe','default','no','36em');
      $page->endSubsection();
    }
    
  $page->endSection();
  $page->endAreaData();
  $page->addFootbar();
$page->endForm();

include_once($SPL_CFG['dirroot'].'/ui/inc/script.showpage.inc.php');

/**
 * $Log: ins.php,v $
 * Revision 1.11  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.10  2006/04/14 12:46:33  jebbol
 * Added print support
 *
 * Revision 1.9  2006/02/11 18:20:08  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
