/**
 * Execute JavaScript on page load
 *
 * @author    Simon Willison
 * @link      http://simon.incutio.com/archive/2004/05/26/addLoadEvent
 *
 * Example: 
 * addLoadEvent(function() {
 *  document.body.style.backgroundColor = 'yellow';
 * })
 *
 */

function addLoadEvent(func) {
    var oldonload = window.onload;
    if (typeof window.onload != 'function') {
        window.onload = func;
    } else {
        window.onload = function() {
            oldonload();
            func();
        }
    }
}

