/**
 * Javascript code to capture from events
 *
 * @author    Jebbol
 * @category  core
 * @package   spl
 * @version   1.0
 * @release   $Id: processkey.js,v 1.3 2005/08/23 14:05:00 jebbol Exp $
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

// Flag any changes made to the screen data
var dirtyFlag = false;

/**
 * Captures a keystroke
 *
 * @param string theEvent the event that occurred
 */
function doKey (theEvent) {

  var nav4 = window.Event ? true : false;
  var evt = null;
  
  if (nav4) {
    evt  = (theEvent) ? theEvent : ((window.Event) ? window.Event : null);
  } 
  else {
    evt  = (theEvent) ? theEvent : ((event) ? event : null);
  }

  // Netscape
  if (nav4) {
	
	// Tranform ENTER into TAB
    // if(evt.which==13) evt.which=9;

		//ESC
	if(evt.which==27){
	  confirm("Weet u zeker dat u wilt annuleren?");
	}

	// PgUp
    else if(evt.which==33){
	  // Previous record
	}

    else if(evt.which==34){
	  // Next record
	}

	// Left-arrow
    else if(evt.which==37){
	  // Previous character
	}
		
	// Up-arrow
    else if(evt.which==38){
	  // Up one line
	}

	// Right-arrow
    else if(evt.which==39){
	  // Next character
	}

	// Down-arrow
    else if(evt.which==40){
	  // Down one line
	}

	else {
	  if (dirtyFlag==false) {
		  // set Flag to the 'modified' state
		  setDirtyFlag();
	  }
	}
  }
	
  // Internet Explorer
  else {
  
    //if(evt.keyCode==13) evt.keyCode=9;

	//ESC
	if(evt.keyCode==27){
	  // Annuleren
	  if (confirm("Weet u zeker dat u wilt annuleren?")){
		  document.location.reload();
		}
	}

	// PgUp
    else if(evt.keyCode==33){
	  // Previous record
	}

	// PgDn
    else if(evt.keyCode==34){
	  // Next record
	}

	// Left-arrow
    else if(evt.keyCode==37){
	  // Previous character
	}
		
	// Up-arrow
    else if(evt.keyCode==38){
	  // Up one line
	}

	// Right-arrow
    else if(evt.keyCode==39){
	  // Next character
	}

	// Down-arrow
    else if(evt.keyCode==40){
	  // Down one line
	}

	else {
	  if (dirtyFlag==false) {
	    // set Flag to the 'modified' state
		setDirtyFlag();
	  }
	}
  }
}

/**
 * Sets the dirtyFlag and enables/disbales buttons
 */
function setDirtyFlag() {
  dirtyFlag = true;
  disableItem('add');
  disableItem('del');
  enableItem('save');
  enableItem('cancelled');
  disableItem('prev_record');
  disableItem('next_record');
}

function resetDirtyFlag() {
  dirtyFlag = false;
  enableItem('add');
  enableItem('del');
  disableItem('save');
  disableItem('cancelled');
  enableItem('prev_record');
  enableItem('next_record');
}

/**
 * Changes the visibility of an item and its associated text to 'grayed'
 */
function disableItem(whichItem){
  if (document.getElementById(whichItem)) {
	  document.getElementById(whichItem).disabled = true;
    if(document.getElementById(whichItem).className.indexOf('Disabled') < 0){
      document.getElementById(whichItem).className = document.getElementById(whichItem).className+'Disabled';
	  }
	}
}

/**
 * Changes the visibility of an item 'un-grayed'
 */
function enableItem(whichItem){

  var newItemClass;
  var posItem;

  if (document.getElementById(whichItem)) {
	  document.getElementById(whichItem).disabled = false;

    newItemClass = document.getElementById(whichItem).className;
    posItem      = newItemClass.indexOf('Disabled');
  
    if (posItem > 0) {
     newItemClass = newItemClass.substring(0,posItem);
     	document.getElementById(whichItem).className = newItemClass;
    }
	}
}

if (window.Event) // Navigator 4.0x
  document.captureEvents(Event.KEYDOWN);

// Attach key handler to the entire document
document.onkeydown = doKey;
