<?php
/**
 * login.php
 *
 * $Author: jebbol $
 * $Revision: 1.14 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: login.php,v $
 * Revision 1.14  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.13  2006/04/14 12:46:50  jebbol
 * *** empty log message ***
 *
 * Revision 1.12  2006/03/13 10:37:56  jebbol
 * Cleaned up HTML validation errors
 *
 * Revision 1.11  2006/02/11 18:22:20  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 *
 * Revision 1.10  2006/01/23 18:20:45  jebbol
 * Changed Imai BV into Studiewijzer.nl
 *
 */

// Reset session
include_once('../inc/unset.inc.php');

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Translations
include_once($SPL_CFG['dirroot'].'/lang/'.$SPL_CFG['language'].'/usr.lang.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'from'=>array('type'=>'char'),
  'msg'=>array('type'=>'char'),
  'usr_login'=>array('type'=>'char'),
  'usr_psswd'=>array('type'=>'char')
);
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

// Check for messages to be displayed
$msg  = (isset($clean['msg']) ? $clean['msg'] : (bool)false);

// Check for a script to return to
$from = (bool)false;
if (isset($_SESSION['referred_from'])){
  $from = $_SESSION['referred_from'];
  unset ($_SESSION['referred_from']);
}
 
// Check submitted user data
$usr="";
if (isset($clean['usr_login'])&&isset($clean['usr_psswd'])) {
  $usr = $clean['usr_login'];
  $pwd = $clean['usr_psswd'];
  $from = isset($clean['from'])?$clean['from']:(bool)false;
    
  // Create a usr object
  if (isset($SPL_CFG['dirroot'])) {include_once($SPL_CFG['dirroot'].'/class/usr.class.php');}
  else {include_once('../class/usr.class.php');}

  $object = new usr();
  if ($object->login($usr,$pwd)) {
      
    // Is hit statistics enabled?
    if (isset($SPL_CFG['hit_statistics']) && $SPL_CFG['hit_statistics']=='true') {
      // When the user is not a system administrator, increase the hit counter
      if (!$object->isSysAdm()){
        include_once($SPL_CFG['dirroot'].'/integration/shortstat/inc.stats.php');
      }
    }
      
    // redirect user to where he came from
    if ($from){redirect($from);}

    // redirect user to his start page
    if (!isset($_SESSION['usp_startpage'])) {
      redirect($SPL_CFG['wwwroot'].'/ui/menu.php');
    }
    redirect($SPL_CFG['wwwroot'].'/'.$_SESSION['usp_startpage']);
  }
  else {
    $msg = (isset($SPL_TXT['usr_unknown'])?$SPL_TXT['usr_unknown']:'Sorry, you require a valid login');
  }
}

// Create login page
$page = new page();
$page->init('spl','default','template_login.htm',$SPL_CFG['appname'],false);
$page->startTable('loginTable');
  $page->startRow();
    
    $page->startColumn('none','style="width:30%;height:14em"');
    $page->endColumn();
    
    $page->startColumn();
    $page->endColumn();

    $page->startColumn('copyright');
      $page->addContent('&copy; <a href="http://www.studiewijzer.nl">www.studiewijzer.nl</a>');
    $page->endColumn();
    $page->endRow();

    $page->startRow();

    $page->startColumn('none','style="width:30%"');
    $page->endColumn();

    $page->startColumn();
      $page->startForm("loginform");
      $page->addContent('<input type="hidden" name="cookieexists" value="false" />','yes');

      // Add hidden field to preserve where the user came from
      if ($from){ $page->addField('from',$from); }
        if ($msg) {
          $page->startTable();
          $page->addContent('<tr><td class="alert"><img src="'.$SPL_CFG['wwwroot'].'/ui/skin/'.$SPL_CFG['skin'].'/images/error.gif" alt="" /><br />'.$msg.'<br /><input name="submitted" id="submitted" type="submit" size="8em" class="button" style="width:8em" value="Opnieuw" /></td></tr>');
          $page->endTable();
        }
        else {
          // Login box
          $page->addContent('<script type="text/javascript">document.write(\'<table cellspacing="0" cellpadding="0"><tr><td class="label" style="padding-right:1em">Login<\/td><td class="field"><input type="text" class="text_required" name="usr_login" id="usr_login" value="";" /><\/td><\/tr><tr><td class="label" style="padding-right:1em">Toegangscode<\/td><td class="field"><input type="password" class="password_required" name="usr_psswd" id="usr_psswd" value="";" /><\/td><\/tr><tr><td><\/td><td><input name="submitted" id="submitted" type="submit" size="8" style="width:8em" class="button" value="Aanmelden" /><\/td><\/tr><\/table>\');</script>','yes');
          // No javascript alert
          $page->addContent('<noscript><table cellspacing="0" cellpadding="0"><tr><td class="alert"><br /><img src="'.$SPL_CFG['wwwroot'].'/ui/skin/'.$SPL_CFG['skin'].'/images/error.gif" alt="" /><br />Studiewijzer maakt gebruik van Javascript.<br />Uw browser instellingen laten dat echter niet toe.<br />Als u Studiewijzer wilt gebruiken, dan raden wij u aan het gebruik van Javascript toe te staan.</td></tr></table></noscript>');
        }    
      $page->endForm();
    $page->endColumn();
    $page->startColumn();
    $page->endColumn();
  $page->endRow();
  $page->startRow();            
    $page->startColumn('alert','colspan="3"');
      $page->addContent('<div id="no_cookies" style="display:none"><br /><img src="'.$SPL_CFG['wwwroot'].'/ui/skin/'.$SPL_CFG['skin'].'/images/error.gif" alt="" /><br />Om goed te kunnen functioneren dient Studiewijzer een &quot;cookie&quot; op uw computer te plaatsen.<br />Uw browser instellingen laten dat echter niet toe.<br />Als u Studiewijzer wilt gebruiken, dan raden wij u aan het gebruik van &quot;cookies&quot; toe te staan.</div>');
    $page->endColumn();
  $page->endRow();
$page->endTable();
$page->_focus='';
$page->setContent();
$page->createPage();
$page->showPage();

?>
