<?php
/**
 * User interface for manipulating data in a teacher object
 *
 * $Author: jebbol $
 * $Revision: 1.1 $
 * $Date: 2006/04/14 12:45:28 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: men_subjects.php,v $
 * Revision 1.1  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/'.$_SESSION['methodology'].'/class/men.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object = new men();
$editMode = (bool)true;

//=========================================================================
// Methodology
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($_GET['from'])){
  $from_id = $_GET['id'];
  unset ($_GET['id']);
}
    
// Populate the object
if (isset ($_GET['id'])) {
  if ($object->init($_GET['id'])){
    $_SESSION['men_id'] = $_GET['id'];
  }
  unset ($_GET['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['men_id'])) {
    $object->init($_SESSION['men_id']);
  }
}

// Delete
if (isset($_POST['del'])) {
  $object->setProperty('is_active', false);
  $object->save();
  $object = new men();
  unset($_SESSION['men_id']);
}
// Edit
if (isset($_POST['edit'])) {
  $editMode = (bool)true;
}
// New
if (isset($_POST['new'])||isset($_GET['new'])) {
  $object = new men();
  if (isset($_GET['parent_id']) || isset($_POST['parent_id'])){
    if (isset($_GET['parent_id'])){
      $object->setUser($_GET['parent_id']);
    }
    else if (isset($_POST['parent_id'])){
      $object->setUser($_POST['parent_id']);
    }
  }
  $editMode = (bool)true;
  unset($_SESSION['men_id']);
}
// Save
if (isset($_POST['save'])) {
  $editMode = (bool)true;
  save();
  $editMode = (bool)false;
}
// Cancel
if (isset($_POST['cancel'])) {
  $editMode = (bool)false;
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['men_id']){
    $object->setProperty($_GET['from'],$from_id);
  }
  unset($_GET['from']);
}

//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('men','default','template_iframeplain.htm',false);
$page->startScrollableArea();
$page->startAreaData();
$page->startForm();
  $page->startTable('none','style="width:100%"');
  $page->endTable();
  $page->startTable('detail');
    $page->startRow();
      $page->startColumn('none', 'style="vertical-align:top;width:60%"');
        $page->startTable();

          // Include methodology related fields
          $m_inc = $m->getMentorSubjectsEditScript();
          if ($m_inc){
            include_once ($m_inc);
          }
   
          // Start buttons
          $page->startRow();
            $page->startAreaButton();
            // Buttons
            $page->startColumn();
              if ($editMode){
                $page->addButton('save','toolbar_save','submit','default','8','button');
                $page->addButton('cancel','toolbar_cancel','submit','default','8','button');
              }
              else {
                if ($_SESSION['men_permission']['write']) {
                  $page->addButton('new','toolbar_new','submit','default','8','button');
                }
                if ($_SESSION['men_permission']['change']) {
                  $page->addButton('edit','toolbar_edit','submit','default','8','button');
                }
                if ($_SESSION['men_permission']['delete']) {
                  $page->addButton('del','toolbar_del','submit','default','8','button');
                }
              }
            $page->endColumn();
            $page->endAreaButton();
          $page->endRow();
          // End buttons
        $page->endTable();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
$page->endForm();
$page->endAreaData();
$page->endScrollableArea();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object, $m;
  
  // Include methodology related fields
  $m_inc = $m->getMentorSubjectsSetScript();
  if ($m_inc){
    include_once ($m_inc);
  }
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }
  set();
  $object->save();
  $_SESSION['men_id'] = $object->getProperty('men_id');
}

?>
