<?php
/**
 * Menu pane for data maintenance
 * 
 * $Author: jebbol $
 * $Revision: 1.10 $
 * $Date: 2006/02/11 18:35:39 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: menu_data.php,v $
 * Revision 1.10  2006/02/11 18:35:39  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

// Set this pane as the session default
$_SESSION['usp_startpane'] = 'menu_data.php';

$usr = new usr();
$usr->init($_SESSION['usr_id']);

$m = new methodology();
$m->init($_SESSION['methodology']);

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('spl','default','template_iframe.htm',false);
$page->startForm();
  $page->startTable();
    // System administrators menu
    if ($_SESSION['is_admin']){
      $page->startRow();
        $page->startColumn();
          $page->startPane($SPL_TXT['menu_data_general'],'noclose','menu');
            $page->startTable();
            $page->startMenu();
              $iNumItems = 0;
              $iItemsOnRow = 0;
              foreach ($SPL_CFG['classes'] as $class) {
                if ($class=='usr'&&!$_SESSION['is_admin']){ continue;}
                if (!isset($_SESSION[$class.'_permission'])){
                  $_SESSION[$class.'_permission'] = $usr->_getPermissions($class);
                }
                if ($_SESSION[$class.'_permission']['write']||$_SESSION[$class.'_permission']['change']||$_SESSION[$class.'_permission']['delete']||$_SESSION[$class.'_permission']['admin']) {
                  $page->addMenuItem($class);
                  $iNumItems++;
                  $iItemsOnRow++;
                }
                // Display a maximum of 5 objects on a row
                if ($iItemsOnRow==6){
                  $page->endMenu();
                  $page->startMenu();
                  $iItemsOnRow = 1;
                }
              }
              if ($iNumItems==0) {
                $page->addContent($SPL_UI['menubar_empty']);
              }
            $page->endMenu();
            $page->endTable();
          $page->endPane('menu');
        $page->endColumn();
      $page->endRow();
    }
    // Methodology based classes
    $m_classes = explode(',',$m->getClasses());
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['menu_methodology'],'noclose','menu');
          $page->startTable();
          $page->startMenu();
            $iNumItems = 0;
            $iItemsOnRow = 0;
            foreach ($m_classes as $class) {
              if (!isset($_SESSION[$class.'_permission'])){
                $_SESSION[$class.'_permission'] = $usr->_getPermissions($class);
              }
              if ($class!='sgd' && ($_SESSION[$class.'_permission']['write']||$_SESSION[$class.'_permission']['change']||$_SESSION[$class.'_permission']['delete']||$_SESSION[$class.'_permission']['admin'])) {
                $page->addMenuItem($class,'../methodology/'.$_SESSION['methodology'].'/ui');
                $iNumItems++;
                $iItemsOnRow++;
              }
              // Display a maximum of 5 objects on a row
              if ($iItemsOnRow==5){
                $page->endMenu();
                $page->startMenu();
                $iItemsOnRow = 1;
              }
            }
            if ($iNumItems==0) {
              $page->addContent($SPL_UI['menubar_empty']);
            }
          $page->endMenu();
        $page->endTable();
        $page->endPane('menu');
      $page->endColumn();
    $page->endRow();
    
  $page->endTable();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

?>
