<?php
/**
 * Menu pane containing a parents dashboard
 * 
 * $Author: jebbol $
 * $Revision: 1.1 $
 * $Date: 2006/04/14 12:45:28 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: menu_parent.php,v $
 * Revision 1.1  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

//=========================================================================
// Data objects
//=========================================================================
include_once($SPL_CFG['dirroot'].'/class/par.class.php');
include_once($SPL_CFG['dirroot'].'/class/prd.class.php');
include_once($SPL_CFG['dirroot'].'/class/usd.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Default methodology must be known
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Make sure this is only seen by parents
if (!isset($_SESSION['is_parent'])) {
  redirect('../ui/menu.php');
} 

//=========================================================================
// Local variables
//=========================================================================

// Set this pane as the session default
$_SESSION['usp_startpane'] = 'menu_parent.php';

/**
 * A comma-separated list of student id's (stu_id)
 */
$studentIds = '';

/**
 * The name of the selected students
 */
$studentName = '';

/**
 * The students subjects
 */
$subjects = array();

//=========================================================================
// Methodology
//=========================================================================
$m = new methodology();
$m->init($_SESSION['methodology']);

// Human language translations
$m_trans = $m->getDashboardTranslation();
if (!$m_trans){
  echo 'Translations not found';
}
include_once ($m_trans);

// Metadata
$m_meta = $m->getDashboardMetadata();
if (!$m_meta){
  echo 'Metadata not found';
}

//=========================================================================
// Defaults
//=========================================================================
$usd = new usd();
$usd_script = 'menu_parent.php';

// Find the preferred student
$usd_item = 'dash_search_students';
include($SPL_CFG['dirroot'].'/ui/inc/value.usd.inc.php');
$prefStu = $usd_value;

//=========================================================================
// Build data
//=========================================================================

$par = new par();
$par->init($_SESSION['my_par_id']);
$students = $par->getChildren();

// Selection area
if (count($students)>1) {
  if ($students){
    $area = '<table style="margin-bottom:3px"><tr><td>'."\r\n";
    $area .= $SPL_TXT['stu_dispname'].' <select class="listbox" id="dash_search_students" name="dash_search_students" style="width:12em" onChange="document.dashform.submit();"><option value="0">'.$SPL_TXT['list_all'].'</option>';
    foreach ($students as $record){
      foreach ($record as $key => $item) {
        $studentIds .= (strlen($studentIds)>0?',':'').$key;
        $area .= '<option value="'.$key.'"';
        if ($prefStu>0){
          if ((int)$prefStu==(int)$key){
            $area .= ' selected="selected"';
            $studentName = $item;
          }
        }
        $area .= '>'.$item.'</option>';
      }
    }
    $area .= '</select>'."\r\n";
    $area .= '</select></td></tr></table>'."\r\n";
  }
}
else {
  // Only one child
  if (is_array($students)) {
    if (!empty($students)) {
      $studentIds  = key($students[0]);
      $studentName = $students[0][$studentIds];
    }
  }
  $prefStu     = $studentIds;
}

$query['columns']  = 'spt.spt_id AS id,"#" AS target,sub.sub_short';
$query['columns'] .= ',ROUND(SUM(spt_number_done)/IF(SUM(spt_number_total)>0,SUM(spt_number_total),1)*100) AS spt_perc_complete';
if ($SPL_CFG['learning_load'] == 'true'){
  $query['columns'] .= ',ROUND(SUM(spt_load_done)/IF(SUM(spt_load_total)>0,SUM(spt_load_total),1)*100) AS spt_perc_load';
}
if ($SPL_CFG['learning_reward'] == 'true'){
  $query['columns'] .= ',ROUND(SUM(spt_reward_done)/IF(SUM(spt_reward_total)>0,SUM(spt_reward_total),1)*100) AS spt_perc_reward';
}

$query['tblName']  = 'spt spt';
$query['tblName'] .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sub sub ON sub.sub_id = spt.sub_id';

$query['where']    = 'WHERE spt.adm_id = "'.$_SESSION['adm_id'].'" AND spt.is_active AND spt.stu_id = "'.$prefStu.'"';
$query['where']   .= ' GROUP BY spt.sub_id';

$query['orderBy']  = 'sub.sub_short';

$query['orderDir'] = 'ASC';

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 


//=========================================================================
// Definition of the page
//=========================================================================

$table = new table($query);
$table->init('spt','',$m_trans,$m_meta);
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);

$page = new page();
$page->init('dash','default','template_iframe.htm',false,false,$m_trans,$m_meta);
$page->setHeadScripts($table->getScripts());
$table->setImageDir($page->getImageDir());
$page->startForm();
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($studentName,'noclose');
          $page->startTable();
            $page->startRow();
              $page->startColumn();
                if (isset($area)){
                  $page->startAreaSearch();
                    $page->addContent($area);
                  $page->endAreaSearch();
                }
              $page->endColumn();
            $page->endRow();
            $page->startRow();
              $page->startColumn();
                $page->startAreaData();
                  $page->addContent($table->getTable());
                $page->endAreaData();
              $page->endColumn();
            $page->endRow();
          $page->endTable();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();


?>
