<?php
/**
 * Menu pane containing the personalized study guide
 * 
 * $Author: jebbol $
 * $Revision: 1.13 $
 * $Date: 2006/02/11 18:36:55 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: menu_sgd.php,v $
 * Revision 1.13  2006/02/11 18:36:55  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');


//=========================================================================
// Local variables
//=========================================================================

// Set this pane as the session default
$_SESSION['usp_startpane'] = 'menu_sgd.php';

//=========================================================================
// Methodology
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);

// Human language translations
$m_trans = $m->getStudyguideTranslation();
if (!$m_trans){
  echo 'Translations not found';
}
include_once ($m_trans);

// Metadata
$m_meta = $m->getStudyguideMetadata();
if (!$m_meta){
  echo 'Metadata not found';
}

// Include script
$m_inc = $m->getStudyguideBrowseScript();
if (!$m_inc){
  echo 'Studyguide browse script not found';
}
include_once ($m_inc);

?>
