<?php
/**
 * Metadata for the 'user' user interface.
 *
 * $Author: jebbol $
 * $Revision: 1.12 $
 * $Date: 2006/08/21 19:43:38 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: usr.metadata.php,v $
 * Revision 1.12  2006/08/21 19:43:38  jebbol
 * Added column sizes for the search script
 *
 * Revision 1.11  2006/08/08 08:07:20  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.10  2006/04/14 12:07:27  jebbol
 * Added support for mentors and parents
 *
 */

$SPL_META['from'] = array('type'=>'text','hidden'=>true);

$SPL_META['usr_id'] = array('type'=>'numeric','size'=>'6','required'=>true,'displayonly'=>true);
$SPL_META['usr_login'] = array('type'=>'text','size'=>'15','required'=>true,'colsize'=>'10');
$SPL_META['usr_psswd'] = array('type'=>'password','size'=>'15','required'=>true);
$SPL_META['usr_psswd_old'] = array('type'=>'password','size'=>'15','required'=>true);
$SPL_META['usr_psswd_new'] = array('type'=>'password','size'=>'15','required'=>true);
$SPL_META['usr_psswd_again'] = array('type'=>'password','size'=>'15','required'=>true);
$SPL_META['usr_psswd_exp'] = array('type'=>'timestamp','size'=>'16');
$SPL_META['usr_psswd_retry'] = array('type'=>'numeric','size'=>'2');
$SPL_META['usr_name'] = array('type'=>'text','size'=>'20','colsize'=>'15');
$SPL_META['usr_email'] = array('type'=>'email','size'=>'20','colsize'=>'15');
$SPL_META['usr_msn'] = array('type'=>'msn','size'=>'20');
$SPL_META['usr_skype'] = array('type'=>'text','size'=>'20');
$SPL_META['usr_phone'] = array('type'=>'text','size'=>'20','colsize'=>'10');
$SPL_META['per_id'] = array('type'=>'reference','referencetable'=>'per','referencekey'=>'per_id','referencedisplay'=>'per_surname','size'=>'20');
$SPL_META['usr_login_count'] = array('type'=>'numeric','size'=>'2','displayonly'=>true,'colsize'=>'5');
$SPL_META['usr_login_date_first'] = array('type'=>'timestamp','size'=>'16','displayonly'=>true);
$SPL_META['usr_login_date_prev'] = array('type'=>'timestamp','size'=>'16','displayonly'=>true,'colsize'=>'10');
$SPL_META['usr_login_date_last'] = array('type'=>'timestamp','size'=>'16','displayonly'=>true,'colsize'=>'10');
$SPL_META['usr_allow_date_from'] = array('type'=>'timestamp','size'=>'16');
$SPL_META['usr_allow_date_until'] = array('type'=>'timestamp','size'=>'16');
$SPL_META['usr_allow_time_from'] = array('type'=>'time','size'=>'8');
$SPL_META['usr_allow_time_until'] = array('type'=>'time','size'=>'8');
$SPL_META['usr_log'] = array('type'=>'checkbox');
$SPL_META['is_sysadm'] = array('type'=>'checkbox');
$SPL_META['login_date_last'] = array('type'=>'text','size'=>'16','displayonly'=>true,'colsize'=>'12');

$SPL_META['usp_lang'] = array('type'=>'list','size'=>'15','required'=>true);
$SPL_META['usp_skin'] = array('type'=>'list','size'=>'15','required'=>true);
$SPL_META['usp_nameformat'] = array('type'=>'list','size'=>'40','required'=>true);
$SPL_META['usp_numrows'] = array('type'=>'numeric','size'=>'3');
$SPL_META['usp_ina_id'] = (isset($SPL_META['ina_id'])?$SPL_META['ina_id']:array('type'=>'reference','referencetable'=>'ina','referencekey'=>'ina_id','referencedisplay'=>'ina_name','referencescript'=>'ina_search.php','size'=>'15','submitonchange'=>true));
$SPL_META['usp_ins_id'] = (isset($SPL_META['ins_id'])?$SPL_META['ins_id']:array('type'=>'reference','referencetable'=>'ins','referencekey'=>'ins_id','referencedisplay'=>'ins_name','referencescript'=>'ins_search.php','size'=>'15','submitonchange'=>true));
$SPL_META['usp_tra_id'] = (isset($SPL_META['tra_id'])?$SPL_META['tra_id']:array('type'=>'reference','referencetable'=>'tra','referencekey'=>'tra_id','referencedisplay'=>'tra_name','referencescript'=>'tra_search.php','size'=>'15','submitonchange'=>true));
$SPL_META['usp_ali_id'] = (isset($SPL_META['ali_id'])?$SPL_META['ali_id']:array('type'=>'reference','referencetable'=>'ali','referencekey'=>'ali_id','referencedisplay'=>'ali_name','referencescript'=>'ali_search.php','size'=>'15','submitonchange'=>true));
$SPL_META['usp_startpage'] = array('type'=>'list','size'=>'15','required'=>true,'valuelist'=>array(array('ui/menu.php'=>'default')));
$SPL_META['usp_startpane'] = array('type'=>'list','size'=>'15','required'=>true,'valuelist'=>array(array('menu_dash.php'=>'menu_dash'),array('menu_data.php'=>'menu_data'),array('menu_sgd.php'=>'menu_sgd'),array('menu_tsk.php'=>'menu_tsk')));
$SPL_META['usp_calmode'] = array('type'=>'list','size'=>'15','required'=>true,'valuelist'=>array(array('none'=>'none'),array('calendardate'=>'calendardate'),array('schooldate'=>'schooldate')));
$SPL_META['usp_menumode'] = array('type'=>'list','size'=>'15','required'=>true,'valuelist'=>array(array('none'=>'none'),array('normal'=>'normal'),array('small'=>'small')));
$SPL_META['usp_fontsize'] = array('type'=>'list','size'=>'15','required'=>true,'valuelist'=>array(array('smallest'=>'smallest'),array('small'=>'small'),array('normal'=>'normal'),array('larger'=>'larger'),array('largest'=>'largest'),array('huge'=>'huge')));

// Tabs
$SPL_META['usr_tabs'] = array(
                          array('name'=>'usr_tab1','title'=>'usa','tabaction'=>'usa_search.php?parent=usr','newaction'=>'usa.php'),
                          array('name'=>'usr_tab2','title'=>'stu','tabaction'=>'stu.php?parent=usr','newaction'=>'stu.php'),
                          array('name'=>'usr_tab3','title'=>'tea','tabaction'=>'tea.php?parent=usr','newaction'=>'tea.php')
                        );

?>
