<?php
/**
 * Prints a report
 * 
 * $Author: jebbol $
 * $Revision: 1.2 $
 * $Date: 2006/08/08 14:25:10 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl, all rights reserved 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: print_pdf.php,v $
 * Revision 1.2  2006/08/08 14:25:10  jebbol
 * Added support for methodology related printing
 *
 * Revision 1.1  2006/04/14 12:46:33  jebbol
 * Added print support
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// PDF class
include_once($SPL_CFG['dirroot'].'/class/pdf/pdf.class.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

// Human language translations
if (!isset($_SESSION['usp_lang'])) {$_SESSION['usp_lang'] = 'en';}
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/spl.lang.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'class'=>array('type'=>'char','minlength'=>1,'maxlength'=>3),
);
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Get data
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);
$m_classes = explode(',',$m->getClasses());

// Get class
if (in_array($clean['class'],$m_classes)) {
  // It's a methodology class'
  include_once($SPL_CFG['dirroot'].'/methodology/'.$_SESSION['methodology'].'/class/'.$clean['class'].'.class.php');
  include_once($SPL_CFG['dirroot'].'/methodology/'.$_SESSION['methodology'].'/ui/lang/'.$_SESSION['usp_lang'].'/'.$clean['class'].'.lang.php');
}
else {
  include_once($SPL_CFG['dirroot'].'/class/'.$clean['class'].'.class.php');
  include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/'.$clean['class'].'.lang.php');
}

$data = array();
$col  = array(); 

// Create object
$evalstr = "\$object = new ".$clean['class']."();";
@eval("$evalstr");

// Get data
$data = $object->getReportData();

if (is_array($data[0])) {
  array_walk($data[0],'setHeading');
}

//=========================================================================
// Initialize report
//=========================================================================

$opts = array('width' => 800);

$pdf =& new Cezpdf('a4','landscape');
$pdf->selectFont($SPL_CFG['dirroot'].'/class/pdf/fonts/Helvetica');
$pdf->addJpegFromFile($SPL_CFG['dirroot'].'/ui/skin/studiewijzer_logo.jpg',15,$pdf->y-10,82,20);

//=========================================================================
// Print the report
//=========================================================================

$pdf->ezTable($data,$cols,getTitle(),$opts);
$pdf->stream();

//=========================================================================
// Functions
//=========================================================================

function getTitle() {
  global $clean, $SPL_TXT;
  return ((isset($SPL_TXT[$clean['class'].'_report_title'])?$SPL_TXT[$clean['class'].'_report_title']:$SPL_TXT[$clean['class']]).' '.$SPL_TXT['asof'].' '.strftime("%Y-%m-%d"));
}

function setHeading ($value, $key) {
  global $cols, $SPL_TXT;
  $cols[$key] = $SPL_TXT[$key];
}

?>
