<?php
/**
 * Prints a studiewijzer
 * 
 * $Author: jebbol $
 * $Revision: 1.3 $
 * $Date: 2006/08/21 06:51:20 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl, all rights reserved 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'sgd_search_user'     => array('type'=>'int'),
  'sgd_search_subjects' => array('type'=>'int'),
  'sgd_search_periods'  => array('type'=>'int'),
  'sgd_search_week'     => array('type'=>'int'),
  'sgd_search_status'   => array('type'=>'int'),
);
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Methodology
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);

// Human language translations
$m_trans = $m->getStudyguideTranslation();
if (!$m_trans){
  echo 'Translations not found';
}
include_once ($m_trans);

// Metadata
$m_meta = $m->getStudyguideMetadata();
if (!$m_meta){
  echo 'Metadata not found';
}

$page = new page();
$page->init('sgd','default','template.htm',true,false,$m_trans,$m_meta);
$page->startForm();
  $page->startTable('none','style="background-image:url('.$page->getImageDir().'loading.gif) no-repeat center"');
    $page->addIFrame('sgd_pdf.php?sgd_search_user='.(isset($clean['sgd_search_user'])?$clean['sgd_search_user']:'0').'&amp;sgd_search_subjects='.(isset($clean['sgd_search_subjects'])?$clean['sgd_search_subjects']:'0').'&amp;sgd_search_periods='.(isset($clean['sgd_search_periods'])?$clean['sgd_search_periods']:'0').'&amp;sgd_search_week='.(isset($clean['sgd_search_week'])?$clean['sgd_search_week']:'0').'&amp;sgd_search_status='.(isset($clean['sgd_search_status'])?$clean['sgd_search_status']:'0'),'subframe','default','no','46em');
  $page->endTable();
$page->endForm();
$page->setContent();
$page->createPage();
$page->showPage();

/**
 * $Log: sgd_print.php,v $
 * Revision 1.3  2006/08/21 06:51:20  jebbol
 * Added the inclusion of defaults.inc.php
 *
 * Revision 1.2  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.1  2006/04/17 10:58:56  jebbol
 * Added to print a studyguide inside a pane
 *
 */

?>
