<?php
/**
 * Definition of screen elements.
 *
 * $Author: jebbol $
 * $Revision: 1.4 $
 * $Date: 2006/08/08 08:07:21 $
 * 
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

/* 
=========================================================================
 Settings
=========================================================================
*/

// The layout of all pages 
$SPL_UI['layout_mode']    = 'columns'; // columns=display multiple columns, full=display fullscreen
$SPL_UI['layout_columns'] = array('left'   => array('calendar','schedule','tasklist'),
                                  'center' => array('data'),
                                  'right'  => array());

/**
 * The position if the class icon
 * 'title'   = show icon left of the title
 * 'toolbar' = show icon on the left of the toolbar (default)
 * 'none'    = do not show a class icon
 */  
$SPL_UI['icon_position']  = 'title';

/**
 * The size of the class icon
 * 'small'  = use small icons (icons named 'xxx_small.png')
 * 'normal' = use normal sized icons (icons named 'xxx.png') (default)
 * 'large'  = use large icons (icons named xxx_large.png)
 */
$SPL_UI['icon_size'] = 'small';

// The mainmenu setting
// 'top' = place the menu at the top
$SPL_UI['layout_menu_position'] = 'top';
// Is the user allowed to change the menu settings?
$SPL_UI['layout_menu_settable'] = false; 

/**
 * iframe settings
 */
$SPL_UI['iframe_height'] = '52em';

/** 
 * Preferences settings
 */
$SPL_UI['preference_show_menuselection'] = (bool)false;

/* 
=========================================================================
 Skin
=========================================================================
*/

/* Border */
$SPL_UI['border'] = '';

/* Calendar */
$SPL_UI['calendar_navbar_style'] = 'font-family:Arial;color:#000000';
$SPL_UI['calendar_daybar_style'] = 'background-color:#D0D0D0;font-family:Arial;color:#000000';
$SPL_UI['calendar_start'] = '<table width="100%" cellspacing="0" cellpadding="0" class="overview">';
$SPL_UI['calendar_end'] = '</table>';
$SPL_UI['calendar_dayheader_start'] = '<tr>';
$SPL_UI['calendar_dayheader'] = '<td class="dayname">{DAYNAME}</td>';
$SPL_UI['calendar_dayheader_end'] = '</tr>';
$SPL_UI['calendar_month_header'] = '<span style="margin-right:3px;"><a href="'.$_SERVER['PHP_SELF'].'?calendar=prevyear&amp;caldate={CALENDAR_DATE}" title="'.$SPL_TXT['calendar_prevyear'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/prevyear.gif" style="width:18px;height:7px" alt="<<"<!-- {SPL_ENDTAG} -->></a></span><span style="margin-right:3px;"><a href="'.$_SERVER['PHP_SELF'].'?calendar=prevmonth&amp;caldate={CALENDAR_DATE}" title="'.$SPL_TXT['calendar_prevmonth'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/prevmonth.gif" style="width:10px;height:7px" alt="<"<!-- {SPL_ENDTAG} -->></a></span><span style="margin-right:3px;">{CALENDAR_TITLE}</span><span style="margin-right:3px;"><a href="'.$_SERVER['PHP_SELF'].'?calendar=nextmonth&amp;caldate={CALENDAR_DATE}" title="'.$SPL_TXT['calendar_nextmonth'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/nextmonth.gif" style="width:10px;height:7px" alt=">"<!-- {SPL_ENDTAG} -->></a></span><span style="margin-right:3px;"><a href="'.$_SERVER['PHP_SELF'].'?calendar=nextyear&amp;caldate={CALENDAR_DATE}" title="'.$SPL_TXT['calendar_nextyear'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/nextyear.gif" style="width:18px;height:7px" alt=">>"<!-- {SPL_ENDTAG} -->></a></span>';

/* Simple charts */
$SPL_UI['simple_chart_start'] = '<table><tr>';
$SPL_UI['simple_chart_label'] = '<td class="simplechartlabel">{BAR_LABEL}</td>';
$SPL_UI['simple_chart_percentage'] = '<td class="simplechartpercentage">{BAR_PERCENTAGE}</td>';
$SPL_UI['simple_chart_bar_default'] = '<td class="simplechartbar"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/bar.gif" height="12" width="{BAR_PERCENTAGE}" alt=""<!-- {SPL_ENDTAG} -->>';
$SPL_UI['simple_chart_bar_alert'] = '<td class="simplechartbar"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/red.gif" height="12" width="{BAR_PERCENTAGE}" alt=""<!-- {SPL_ENDTAG} -->>';
$SPL_UI['simple_chart_bar_ok'] = '<td class="simplechartbar"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/green.gif" height="12" width="{BAR_PERCENTAGE}" alt=""<!-- {SPL_ENDTAG} -->>';
$SPL_UI['simple_chart_end'] = '</tr></table>';

/* Checkbox */
$SPL_UI['checkbox'] = '<td class="label"></td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID}{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->><span class="label">{LABEL_VALUE}{FIELD_SUFFIX}</span></td>';
$SPL_UI['checkbox_disabled'] = '<td class="label_disabled"></td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->><span class="label_disabled">{LABEL_VALUE}{FIELD_SUFFIX}</span></td>';
$SPL_UI['checkbox_nolabel'] = '<td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID}{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->> <span class="label">{LABEL_VALUE}{FIELD_SUFFIX}</span></td>';
$SPL_UI['checkbox_readonly'] = '<td class="label_readonly"></td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->><span class="label_readonly">{LABEL_VALUE}{FIELD_SUFFIX}</span></td>';
$SPL_UI['checkbox_required'] = '<td class="label_required"></td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID}{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->> {LABEL_VALUE}{FIELD_SUFFIX}</td>';

/* Datetime */
$SPL_UI['datetime'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['datetime_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['datetime_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="datetime_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['datetime_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* E-mail */
$SPL_UI['email'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['email_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['email_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="email_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['email_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* Footer */
$SPL_UI['footer'] = '';

/* Form */
$SPL_UI['form_start']       = '<form name="{FORM_NAME}" id="{FORM_ID}" action="{FORM_ACTION}" method="{FORM_METHOD}"><table cellspacing="0" cellpadding="0"><tr><td class="marginLeft">&nbsp;</td><td>';
$SPL_UI['form_end']         = '</td><td class="marginRight">&nbsp;</td></tr></table></form>';
$SPL_UI['form_start_wide']  = '<form name="{FORM_NAME}" id="{FORM_ID}" action="{FORM_ACTION}" method="{FORM_METHOD}"><table cellspacing="0" cellpadding="0"><tr><td>';
$SPL_UI['form_end_wide']    = '</td></tr></table></form>';
$SPL_UI['form_start_plain'] = '<form name="{FORM_NAME}" id="{FORM_ID}" action="{FORM_ACTION}" method="{FORM_METHOD}">';
$SPL_UI['form_end_plain']   = '</form>';

// Help
$SPL_UI['help'] = 'style="font-weight:normal;border-bottom:1px dashed;cursor:help"'; 

/* Icons */
$SPL_UI['icon_calendar'] = 'calendar.gif';
$SPL_UI['icon_mail'] = 'mail.png';

/* Images */
$SPL_UI['image_compliment'] = '<td style="width:55px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/cool_ani.gif" border="0" title="Cool!" alt=":)"<!-- {SPL_ENDTAG} -->></td>';

/* List (single-selection) */
$SPL_UI['list'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<select{FIELD_NAME}{FIELD_ID} class="listbox" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{LIST_MULTIPLE}{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</select>{FIELD_SUFFIX}</td>';
$SPL_UI['list_item'] = '<option value="{LIST_ITEM_KEY}"{LIST_ITEM_SELECTED}>{LIST_ITEM_VALUE}</option>';
$SPL_UI['list_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="listbox_disabled">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['list_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="listbox_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['list_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<select{FIELD_NAME}{FIELD_ID} class="listbox" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{LIST_MULTIPLE}{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</select>{FIELD_SUFFIX}</td>';
$SPL_UI['list_light'] = '<select{FIELD_NAME}{FIELD_ID} class="listbox"{LIST_STYLE}>{LIST_ITEMS}</select>';

/* List (multiple-selection) */
$SPL_UI['checklist'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<ul{FIELD_NAME}{FIELD_ID} class="checklist" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</ul>{FIELD_SUFFIX}</td>';
$SPL_UI['checklist_item'] = '<li><label for="{LIST_ITEM_KEY}"><input name="{LIST_ITEM_KEY}" id="{LIST_ITEM_KEY}" type="checkbox" {LIST_ITEM_DISABLED}/>{LIST_ITEM_VALUE}</label></li>';
$SPL_UI['checklist_disabled'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<ul{FIELD_NAME}{FIELD_ID} class="checklist" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</ul>{FIELD_SUFFIX}</td>';
$SPL_UI['checklist_readonly'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<ul{FIELD_NAME}{FIELD_ID} class="checklist" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</ul>{FIELD_SUFFIX}</td>';
$SPL_UI['checklist_required'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<ul{FIELD_NAME}{FIELD_ID} class="checklist" onChange="javascript:setDirtyFlag();{LIST_ONCHANGE}"{FIELD_SIZE}{FIELD_STYLE}{FIELD_TABINDEX}>{LIST_ITEMS}</ul>{FIELD_SUFFIX}</td>';

/* Menu */
$SPL_UI['menubar_start'] = '<tr>';
$SPL_UI['menubar_end'] = '</tr>';
$SPL_UI['menubar_content'] = '<td><table><tr><td style="text-align:center"><a href="{MENU_SCRIPT}.php" target="fixedframe"><img src="{MENU_ICON}.png" alt=""<!-- {SPL_ENDTAG} -->></a></td></tr><tr><td style="text-align:center"><a href="{MENU_SCRIPT}.php" target="fixedframe">{MENU_TEXT}</a></td></tr></table></td>';
$SPL_UI['menubar_allowed'] = 'adm,ali,cat,cou,dnm,fmt,grp,ina,ins,lan,lst,per,prd,rol,sgd,src,sts,sub.sug,tra,usr';
$SPL_UI['menubar_empty'] = '<td><table><tr><td style="text-align:center">'.$SPL_TXT['empty_menu'].'</td></tr></table></td>';

/* Numeric */
$SPL_UI['numeric'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['numeric_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['numeric_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="numeric_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['numeric_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* Object ID */
$SPL_UI['object_id'] = '<input class="id" name="id" id="id" value="{ID}" style="width:8em" accesskey="#" onBlur="document.{FORM_NAME}.submit();"<!-- {SPL_ENDTAG} -->>';

/* Panes */
$SPL_UI['pane_top']         = '<div class="panetitlebar"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panetitle">{PANE_TITLE}</td><td style="width:10px" class="panetitle"><a href="<!-- {SPL_WWWROOT} -->/ui/menu.php" title="'.$SPL_TXT['close'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/close.gif" alt=""<!-- {SPL_ENDTAG} -->></a></td><td style="width:8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";
$SPL_UI['pane_top_larger']  = '<div class="panetitle"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/{ICON_NAME}" border="0" alt=""> {PANE_TITLE}</div>';
$SPL_UI['pane_top_noclose'] = '<div class="panetitlebar"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panetitle">{PANE_TITLE}</td><td style="width:8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";
$SPL_UI['pane_top_smaller'] = '<div class="panetitle"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/{ICON_NAME}" border="0" alt=""<!-- {SPL_ENDTAG} -->> {PANE_TITLE}</div>';
$SPL_UI['pane_left']        = '<div class="pane">';
$SPL_UI['pane_right']       = '';
$SPL_UI['pane_bottom']      = '</div><div class="panefooterbar"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftbottom.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panefooter"></td><td style="width:8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightbottom.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";

$SPL_UI['assessmentpane_top']         = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['assessmentpane_top_larger']  = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['assessmentpane_top_noclose'] = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['assessmentpane_top_smaller'] = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['assessmentpane_left']        = '<div class="assessmentpane">';
$SPL_UI['assessmentpane_right']       = '';
$SPL_UI['assessmentpane_bottom']      = '</div>';

$SPL_UI['calendarpane_top']         = '<div class="calendarpanetitle">{PANE_TITLE}</div>';
$SPL_UI['calendarpane_top_larger']  = '<div class="calendarpanetitle">{PANE_TITLE}</div>';
$SPL_UI['calendarpane_top_noclose'] = '<div class="calendarpanetitle">{PANE_TITLE}</div>';
$SPL_UI['calendarpane_top_smaller'] = '<div class="calendarpanetitle">{PANE_TITLE}</div>';
$SPL_UI['calendarpane_left']        = '<div class="calendarpane">';
$SPL_UI['calendarpane_right']       = '';
$SPL_UI['calendarpane_bottom']      = '</div>';

$SPL_UI['menupane_top']         = '<div class="menupanetitle">{PANE_TITLE}</div>';
$SPL_UI['menupane_top_larger']  = '<div class="menupanetitle">{PANE_TITLE}</div>';
$SPL_UI['menupane_top_noclose'] = '<div class="panetitlebar"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="menupanetitle"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/{ICON_NAME}" border="0" alt=""<!-- {SPL_ENDTAG} -->> {PANE_TITLE}</td><td width="8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";
//$SPL_UI['menupane_top_noclose'] = '<div class="menupanetitle">{PANE_TITLE}</div>';
$SPL_UI['menupane_top_smaller'] = '<div class="menupanetitle">{PANE_TITLE}</div>';
$SPL_UI['menupane_left']        = '<div class="menupane">';
$SPL_UI['menupane_right']       = '';
$SPL_UI['menupane_bottom']      = '</div>';

$SPL_UI['notespane_top']         = '<div class="panetitlebar" style="margin-top:1em"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panetitle">{PANE_TITLE}</td><td width="10" class="panetitle"><a href="<!-- {SPL_WWWROOT} -->/ui/menu.php" title="'.$SPL_TXT['close'].'"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/close.gif" alt=""<!-- {SPL_ENDTAG} -->></a></td><td width="8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";
$SPL_UI['notespane_top_larger']  = '<div class="panetitle" style="margin-top:1em"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/{ICON_NAME}" border="0" alt=""<!-- {SPL_ENDTAG} -->> {PANE_TITLE}</div>';
$SPL_UI['notespane_top_noclose'] = '<div class="panetitlebar" style="margin-top:1em"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panetitle">{PANE_TITLE}</td><td width="8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightupper.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";
$SPL_UI['notespane_top_smaller'] = '<div class="panetitle" style="margin-top:1em"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/{ICON_NAME}" border="0" alt=""<!-- {SPL_ENDTAG} -->> {PANE_TITLE}</div>';
$SPL_UI['notespane_left']        = '<div class="pane">';
$SPL_UI['notespane_right']       = '';
$SPL_UI['notespane_bottom']      = '</div><div class="panefooterbar"><table cellspacing="0" cellpadding="0"><tr><td style="width:8px;"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/leftbottom.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td><td class="panefooter"></td><td width="8px"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/rightbottom.gif" border="0" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></div>'."\r\n";

$SPL_UI['schedulepane_top']         = '<div class="schedulepanetitle">{PANE_TITLE}</div>';
$SPL_UI['schedulepane_top_larger']  = '<div class="schedulepanetitle">{PANE_TITLE}</div>';
$SPL_UI['schedulepane_top_noclose'] = '<div class="schedulepanetitle">{PANE_TITLE}</div>';
$SPL_UI['schedulepane_top_smaller'] = '<div class="schedulepanetitle">{PANE_TITLE}</div>';
$SPL_UI['schedulepane_left']        = '<div class="schedulepane">';
$SPL_UI['schedulepane_right']       = '';
$SPL_UI['schedulepane_bottom']      = '</div>';

$SPL_UI['taskpane_top']         = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['taskpane_top_larger']  = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['taskpane_top_noclose'] = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['taskpane_top_smaller'] = '<div class="assessmentpanetitle">{PANE_TITLE}</div>';
$SPL_UI['taskpane_left']        = '<div class="assessmentpane">';
$SPL_UI['taskpane_right']       = '';
$SPL_UI['taskpane_bottom']      = '</div>';


/* Password */
$SPL_UI['password'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['password_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['password_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="password_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['password_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['password_light'] = '<input type="text"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" class="text">';

/* Reference */
$SPL_UI['reference'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['reference_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="reference_disabled">{FIELD_SUFFIX}</span></td>';
$SPL_UI['reference_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="reference_readonly">{FIELD_SUFFIX}</span></td>';
$SPL_UI['reference_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* Row tags */
$SPL_UI['fieldrow_start'] = '<tr{FIELDROW_OPTIONS}>';
$SPL_UI['fieldrow_end'] = '</tr>';

/* Row statistics */
$SPL_UI['row_statistics'] = '{ROW_CREATED}, {ROW_UPDATED}';

/* Scrollable area */
$SPL_UI['scroller_start'] = '<div class="scrollable" style="height:100%;background-color:transparent;border:none">';
$SPL_UI['scroller_end']   = '</div>';

/* Searchbar */
$SPL_UI['searchbar'] = '<table class="searchbar" cellpadding="0" cellspacing="0" border="0"><tr class="searchbar">{SEARCH_ITEMS}</tr></table>';
$SPL_UI['searchbar_by'] = '<td style="vertical-align:bottom;padding-top:6px;padding-bottom:6px;padding-left:6px">{SEARCH_BY}';
$SPL_UI['searchbar_for'] = '&nbsp;{SEARCH_FOR}</span>';
$SPL_UI['searchbar_options'] = '{SEARCH_OPTIONS}';
$SPL_UI['searchbar_button'] = '&nbsp;<input type="submit" name="search_button" id="search_button" class="button" style="width:8em" value="{SEARCH_BUTTON}"{SEARCH_ACCESSKEY}<!-- {SPL_ENDTAG} -->></td>'; 

/* Sections */
$SPL_UI['section_start'] = '<div class="{SECTION_CLASS}" id="{SECTION_CLASS}"><table class="section" cellspacing="0" cellpadding="0"><tr>';
$SPL_UI['section_end'] = '</tr></table></div>';
$SPL_UI['subsection_start'] = '<td class="{SUBSECTION_CLASS}"{TD_STYLE}><table class="subsection" cellspacing="0" cellpadding="0"{TABLE_STYLE}>';
$SPL_UI['subsection_end'] = '</table></td>';
$SPL_UI['content_start'] = '<div class="{SECTION_CLASS}"><table class="section" cellspacing="0" cellpadding="0"><tr>';
$SPL_UI['content_end'] = '</tr></table></div>';

/* Selector */
$SPL_UI['selector_start'] = '<div class="selector"><table class="selector" cellspacing="0" cellpadding="0">';
$SPL_UI['selector_end'] = '</table></div>';
$SPL_UI['selector_roweven_start'] = '<tr class="elRow2">';
$SPL_UI['selector_rowodd_start'] = '<tr class="elRow1">';
$SPL_UI['selector_row_end'] = '</tr>';
$SPL_UI['selector_column_start'] = '<td>';
$SPL_UI['selector_column_end'] = '</td>';
$SPL_UI['selector_label_start'] = '<td class="selectorLabel">';
$SPL_UI['selector_field_start'] = '<td class="selectorField">';
$SPL_UI['selector_check_enabled'] = '<input type="checkbox" class="checkbox" id="{SELECTOR_CHECK_NAME}" name="{SELECTOR_CHECK_NAME}" '.'{SELECTOR_CHECK_CHECKED}'.'>';
$SPL_UI['selector_check_disabled'] = '<input type="checkbox" class="checkbox_disabled" id="{SELECTOR_CHECK_NAME}" name="{SELECTOR_CHECK_NAME}" '.'{SELECTOR_CHECK_CHECKED}'.' disabled="disabled">';
$SPL_UI['selector_desc_enabled'] = '{SELECTOR_DESC}';
$SPL_UI['selector_desc_disabled'] = '{SELECTOR_DESC}';

/* Signs */
$SPL_UI['sign_calendar']  = 'date_small.png';
$SPL_UI['sign_mail']      = 'email_small.png';
$SPL_UI['sign_messenger'] = 'comment_small.png';
$SPL_UI['sign_search']    = 'search_small.png';

/* Tabbar */
$SPL_UI['subtab_start'] = '<tr><td><div id="subtab"><ul>';
$SPL_UI['subtab_ruler'] = '';
$SPL_UI['tabsheetsubtab_start'] = '<tr><td><div id="tabsheetsubtab"><ul>';
$SPL_UI['tabsheetsubtab_ruler'] = '';
$SPL_UI['tab_start'] = '<tr><td><div id="tab"><ul>';
$SPL_UI['tab_end']   = '</ul></div></td></tr>';
$SPL_UI['tab'] = '<li {TAB_NAME}><a href="{TAB_ACTION}"{TAB_TARGET}>{TAB_TITLE}</a></li>';
$SPL_UI['tab_current'] = '<li class="current" {TAB_NAME}><a href="{TAB_ACTION}"{TAB_TARGET}>{TAB_TITLE}</a></li>';
$SPL_UI['tab_ruler'] = '';
$SPL_UI['tab_empty_start'] = '<span style="text-decoration:line-through">';
$SPL_UI['tab_empty_end'] = '</span>';

/* Table */
$SPL_UI['table_booltrue']  = '<center><img src="{IMAGE_DIR}booltrue.gif" border="0"></center>';
$SPL_UI['table_boolfalse'] = '<center><img src="{IMAGE_DIR}boolfalse.gif" border="0"></center>';
$SPL_UI['table_end']       = '</table>';
$SPL_UI['table_start']     = '<table{TABLE_CLASS}{TABLE_OPTIONS} cellspacing="0" cellpadding="0">'; 

/* Text */
$SPL_UI['text'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['text_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['text_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="text_readonly"{FIELD_STYLE}>{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['text_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['text_light'] = '<input type="text"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" class="text">';

/* Textarea */
$SPL_UI['textarea'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME}{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME} disabled="disabled"{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span{FIELD_NAME}{FIELD_ID} class="scrollable"{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}>{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME}{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_nolabel'] = '<td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME}{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_disabled_nolabel'] = '<td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME} disabled="disabled"{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_readonly_nolabel'] = '<td class="field">{FIELD_PREFIX}<span{FIELD_NAME}{FIELD_ID} class="scrollable"{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}>{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['textarea_required_nolabel'] = '<td class="field">{FIELD_PREFIX}<textarea{FIELD_NAME}{FIELD_ID}{FIELD_ROWS}{FIELD_COLS}{FIELD_CLASS}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}>{FIELD_VALUE}</textarea>{FIELD_SUFFIX}</td>';

/* Time */
$SPL_UI['time']          = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['time_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['time_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="time_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['time_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* Timestamp */
$SPL_UI['timestamp']          = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['timestamp_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['timestamp_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="timestamp_readonly">{FIELD_VALUE}</span>{FIELD_SUFFIX}</td>';
$SPL_UI['timestamp_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';

/* Title */
//$SPL_UI['title'] = '<table><tr><td style="width:100px;"><span style="padding-left:6px;"><a href="http://www.studiewijzer.nl" title="http://www.studiewijzer.nl"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/studiewijzer.gif" border="0" width="123" height="31" alt=""<!-- {SPL_ENDTAG} -->></a></span></td><td class="topmenu"><span class="topicon"> <a href="'.$SPL_CFG['wwwroot'].'/ui/menu.php" accesskey="m" title="{MAINMENU_TOOLTIP}">{MAINMENU_TITLE}</a>{MENU_TOP} | <a href="'.$SPL_CFG['wwwroot'].'/ui/usp.php" target="fixedframe" title="{PREFERENCES_TOOLTIP}">{PREFERENCES_TITLE}</a> | <a href="'.$SPL_CFG['wwwroot'].'/ui/logoff.php" accesskey="q" title="{LOGOFF_TITLE}">{LOGOFF_TITLE}</a></span></td></tr></table>';
$SPL_UI['title'] = '<table><tr><td style="width:100px;"><span style="padding-left:6px;"><a href="http://www.studiewijzer.nl" title="http://www.studiewijzer.nl"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/studiewijzer.gif" border="0" width="123" height="31" alt=""<!-- {SPL_ENDTAG} -->></a></span></td><td class="topmenu"><span class="topicon"> {MENU_TOP} | <a href="'.$SPL_CFG['wwwroot'].'/ui/usp.php" target="fixedframe" title="{PREFERENCES_TOOLTIP}">{PREFERENCES_TITLE}</a> | <a href="'.$SPL_CFG['wwwroot'].'/ui/logoff.php" accesskey="q" title="{LOGOFF_TITLE}">{LOGOFF_TITLE}</a></span></td></tr></table>';
$SPL_UI['title_disabled'] = '';

/* Toolbar */
$SPL_UI['toolbar'] = '<table class="toolbar" cellpadding="0" cellspacing="0"><tr class="toolbar"><td style="width:8em">{OBJECT_ID}</td><td style="width:100%">{TOOLBAR_NEW}{TOOLBAR_EDIT}{TOOLBAR_SAVE}{TOOLBAR_DEL}{TOOLBAR_CANCEL}<td align="left" style="width:13px"><table style="width:13px"><tr><td style="text-align:center"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/blank.gif" style="width:13px" alt=""<!-- {SPL_ENDTAG} -->></td></tr></table></td>{TOOLBAR_FIND}{TOOLBAR_PRINT}{TOOLBAR_HELP}</tr></table>';
$SPL_UI['toolbar_cancel'] = '<td align="left" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'cancel\';document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/cancel.gif" alt="{TOOLBAR_CANCEL_TEXT}" id="cancel" class="toolbarbutton" title="{TOOLBAR_CANCEL_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_del']    = '<td align="left" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:if(confirm(\'{TOOLBAR_DEL_CONFIRM}\')){document.{FORM_NAME}.toolbar_button.value=\'del\';document.{FORM_NAME}.submit();}"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/delete.gif" alt="{TOOLBAR_DEL_TEXT}" id="del" class="toolbarbutton" title="{TOOLBAR_DEL_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_edit']   = '<td align="left" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'edit\';{TOOLBAR_PRESUBMIT}document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/edit.gif" alt="{TOOLBAR_EDIT_TEXT}" id="edit" class="toolbarbutton" title="{TOOLBAR_EDIT_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_find']   = '<td align="right" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'find\';{TOOLBAR_PRESUBMIT}document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/find.gif" alt="{TOOLBAR_FIND_TEXT}" id="find" class="toolbarbutton" title="{TOOLBAR_FIND_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_help']   = '<td align="right" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="'.$SPL_CFG['helproot'].'?code={DATA_CLASS}'.(isset($_SESSION['usp_lang'])?'&lang='.$_SESSION['usp_lang']:'').(isset($_SESSION['usp_skin'])?'&skin='.$_SESSION['usp_skin']:'').'" target="_blank"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/help.gif" alt="{TOOLBAR_HELP_TEXT}" id="help" class="toolbarbutton" title="{TOOLBAR_HELP_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_new']    = '<td align="left" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'new\';{TOOLBAR_PRESUBMIT}document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/new.gif" alt="{TOOLBAR_NEW_TEXT}" id="new" class="toolbarbutton" title="{TOOLBAR_NEW_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_print']  = '<td align="right" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'print\';document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/print.gif" alt="{TOOLBAR_PRINT_TEXT}" id="print" class="toolbarbutton" title="{TOOLBAR_PRINT_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_save']   = '<td align="left" style="width:26px"><table style="width:26px"><tr><td style="text-align:center"><a class="toolbar" href="javascript:document.{FORM_NAME}.toolbar_button.value=\'save\';{TOOLBAR_PRESUBMIT}document.{FORM_NAME}.submit();"><img src="<!-- {SPL_WWWROOT} -->/ui/skin/<!-- {SPL_SKIN_NAME} -->/images/save.gif" alt="{TOOLBAR_SAVE_TEXT}" id="save" class="toolbarbutton" title="{TOOLBAR_SAVE_TITLE}"<!-- {SPL_ENDTAG} -->></a></td></tr></table></td>';
$SPL_UI['toolbar_cancel_position'] = 'toolbar';
$SPL_UI['toolbar_del_position'] = 'toolbar';
$SPL_UI['toolbar_edit_position'] = 'toolbar';
$SPL_UI['toolbar_find_position'] = 'toolbar';
$SPL_UI['toolbar_new_position'] = 'toolbar';
$SPL_UI['toolbar_print_position'] = 'toolbar';
$SPL_UI['toolbar_save_position'] = 'toolbar';
$SPL_UI['toolbar_help_position'] = 'toolbar';


/* URL */
$SPL_UI['url'] = '<td class="label">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['url_disabled'] = '<td class="label_disabled">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" disabled="disabled"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['url_readonly'] = '<td class="label_readonly">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<span class="url_readonly"{FIELD_STYLE}></span>{FIELD_SUFFIX}</td>';
$SPL_UI['url_required'] = '<td class="label_required">{LABEL_VALUE}</td><td class="sign">{FIELD_SIGN}</td><td class="field">{FIELD_PREFIX}<input type="{FIELD_TYPE}"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}"{FIELD_CHECKED}{FIELD_CLASS}{FIELD_SIZE}{FIELD_MAXLENGTH}{FIELD_STYLE}{FIELD_TITLE}{FIELD_TABINDEX}{FIELD_ACCESSKEY}{FIELD_EVENT}<!-- {SPL_ENDTAG} -->>{FIELD_SUFFIX}</td>';
$SPL_UI['url_light'] = '<input type="text"{FIELD_NAME}{FIELD_ID} value="{FIELD_VALUE}" class="text">';

/**
 * $Log: elements.php,v $
 * Revision 1.4  2006/08/08 08:07:21  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.3  2006/04/14 12:01:46  jebbol
 * Restyled the subtabs
 *
 * Revision 1.2  2006/03/13 12:47:21  jebbol
 * Cleaned up HTML validation errors
 *
 * Revision 1.1  2006/03/08 16:18:48  jebbol
 * *** empty log message ***
 */

?>
