<?php
/**
 * Groups per teacher
 *
 * $Author: jebbol $
 * $Revision: 1.1 $
 * $Date: 2006/08/08 07:11:28 $
 * 
 * @copyright Copyright (c) 2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/'.$_SESSION['methodology'].'/class/tea.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object = new tea();
$editMode = (bool)true;

//=========================================================================
// Methodology
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);

//=========================================================================
// Event handling
//=========================================================================

// Populate the object
if (isset ($_GET['id'])) {
  if ($object->init($_GET['id'])){
    $_SESSION['tea_id'] = $_GET['id'];
  }
  unset ($_GET['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['tea_id'])) {
    $object->init($_SESSION['tea_id']);
  }
}

if (isset($_REQUEST['save'])) {
  // Delete old groups
  $object->deletegroups();
  
  // toBox contains the selected student ids
  foreach($_REQUEST['toBox'] as $key){
    $object->addGroup($key);
  }
}

//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('tea','default','template_iframeplain.htm',false);

// Include methodology related fields
$m_inc = $m->getTeacherGroupsEditScript();
if ($m_inc){
  include_once ($m_inc);
}

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================


/**
 * $Log: tea_groups.php,v $
 * Revision 1.1  2006/08/08 07:11:28  jebbol
 * Added in version 0.15
 *
 */

?>
