<?php
/**
 * Subjects per teacher
 *
 * $Author: jebbol $
 * $Revision: 1.3 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Defaults
include_once($SPL_CFG['dirroot'].'/inc/defaults.inc.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/class/methodology.class.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/methodology/'.$_SESSION['methodology'].'/class/tea.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object = new tea();
$editMode = (bool)true;

//=========================================================================
// Methodology
//=========================================================================

$m = new methodology();
$m->init($_SESSION['methodology']);

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
/*
$from_id = (bool)false;
if (isset($_GET['from'])){
  $from_id = $_GET['id'];
  unset ($_GET['id']);
}
*/
    
// Populate the object
if (isset ($_GET['id'])) {
  if ($object->init($_GET['id'])){
    $_SESSION['tea_id'] = $_GET['id'];
  }
  unset ($_GET['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['tea_id'])) {
    $object->init($_SESSION['tea_id']);
  }
}

/*
// Delete
if (isset($_POST['del'])) {
  $object->setProperty('is_active', false);
  $object->save();
  $object = new tea();
  unset($_SESSION['tea_id']);
}
// Edit
if (isset($_POST['edit'])) {
  $editMode = (bool)true;
}
// New
if (isset($_POST['new'])||isset($_GET['new'])) {
  $object = new tea();
  if (isset($_GET['parent_id']) || isset($_POST['parent_id'])){
    if (isset($_GET['parent_id'])){
      $object->setUser($_GET['parent_id']);
    }
    else if (isset($_POST['parent_id'])){
      $object->setUser($_POST['parent_id']);
    }
  }
  $editMode = (bool)true;
  unset($_SESSION['tea_id']);
}
// Save
if (isset($_POST['save'])) {
  $editMode = (bool)true;
  save();
  $editMode = (bool)false;
}
// Cancel
if (isset($_POST['cancel'])) {
  $editMode = (bool)false;
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['tea_id']){
    $object->setProperty($_GET['from'],$from_id);
  }
  unset($_GET['from']);
}
*/
//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('tea','default','template_iframeplain.htm',false);
$page->startScrollableArea();

 // Include methodology related fields
 $m_inc = $m->getTeacherSubjectsEditScript();
 if ($m_inc){
   include_once ($m_inc);
 }
   
$page->endScrollableArea();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object, $m;
  
  // Include methodology related fields
  $m_inc = $m->getTeacherSubjectsSetScript();
  if ($m_inc){
    include_once ($m_inc);
  }
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }
  set();
  $object->save();
  $_SESSION['tea_id'] = $object->getProperty('tea_id');
}

/**
 * $Log: tea_subjects.php,v $
 * Revision 1.3  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.2  2006/02/11 18:50:51  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
