<?php
/**
 * User interface for manipulating data in a user authorization object
 *
 * $Author: jebbol $
 * $Revision: 1.6 $
 * $Date: 2006/04/14 12:45:28 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: usa.php,v $
 * Revision 1.6  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.5  2006/02/11 18:57:13  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/class/usa.class.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

global $SPL_META;

$object = new usa();
$editMode = (bool)false;

//=========================================================================
// Event handling
//=========================================================================

// Are we returning from searching a reference field?
$from_id = (bool)false;
if (isset($_GET['from'])){
  $from_id = $_GET['id'];
  unset ($_GET['id']);
}
    
// Populate the object
if (isset ($_GET['id'])) {
  if ($object->init($_GET['id'])){
    $_SESSION['usa_id'] = $_GET['id'];
  }
  unset ($_GET['id']);
}

// Get the 'current' object
else {
  if (isset($_SESSION['usa_id'])) {
    $object->init($_SESSION['usa_id']);
  }
}

// Delete
if (isset($_POST['del'])) {
  $object->delete();
  $object = new usa();
  unset($_SESSION['usa_id']);
}
// Edit
if (isset($_POST['edit'])) {
  $editMode = (bool)true;
}
// New
if (isset($_POST['new'])||isset($_GET['new'])) {
  $object = new usa();
  if (isset($_GET['parent']) || isset($_POST['usa_usr_id'])){
    $object->setProperty('usr_id',(isset($_GET['parent'])?$_GET['parent']:$_POST['usa_usr_id']));
  }
  $editMode = (bool)true;
  unset($_SESSION['usa_id']);
}
// Save
if (isset($_POST['save'])) {
  $editMode = (bool)true;
  save();
  $editMode = (bool)false;
}
// Cancel
if (isset($_POST['cancel'])) {
  $editMode = (bool)false;
}

// Set the chosen reference field
if ($from_id){
  if ($from_id != $_SESSION['usa_id']){
    $object->setProperty($_GET['from'],$from_id);
  }
  unset($_GET['from']);
}

//=========================================================================
// Definition of the page
//=========================================================================
$page = new page();
$page->init('usa','default','template_iframetabbed.htm',false);
$page->startForm(null,'default',false,true);
  $page->startAreaTabSheet();
  $page->startTable();
    $page->addTabRuler();
  $page->endTable();
  $page->startTable('detail');
    $page->addField('usa_usr_id',$object->getProperty('usr_id'));
    $permissions = $object->getProperty('usa_permission');
    $page->addField('usa_key',$object->getProperty('usa_key'),((isset($_POST['new'])||isset($_GET['new']))?!$editMode:true));
    $page->addField('usa_read',$permissions['read'],!$editMode);
    $page->addField('usa_write',$permissions['write'],!$editMode);
    $page->addField('usa_change',$permissions['change'],!$editMode);
    $page->addField('usa_delete',$permissions['delete'],!$editMode);
    $page->addField('usa_admin',$permissions['admin'],!$editMode);
    // Start buttons
    $page->startRow();
      // Label
      $page->startColumn();
      $page->endColumn();
      // Sign
      $page->startColumn();
      $page->endColumn();
      // Buttons
      $page->startColumn();
        if ($editMode){
          $page->addButton('save','toolbar_save','submit','default','8','button');
          $page->addButton('cancel','toolbar_cancel','submit','default','8','button');
        }
        else {
          if ($_SESSION['usr_permission']['admin']) {
            $page->addButton('new','toolbar_new','submit','default','8','button');
          }
          if ($_SESSION['usr_permission']['admin']) {
            $page->addButton('edit','toolbar_edit','submit','default','8','button');
          }
          if ($_SESSION['usr_permission']['admin']) {
            $page->addButton('del','toolbar_del','submit','default','8','button');
          }
        }
      $page->endColumn();
    $page->endRow();
    // End buttons
  $page->endTable();
  $page->endAreaTabSheet();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object;

  if (isset ($_POST['usa_usr_id'])) {$object->setProperty('usr_id', $_POST['usa_usr_id']);}
  if (isset ($_POST['usa_key'])) {$object->setProperty('usa_key', $_POST['usa_key']);}
  if (isset ($_POST['usa_read'])) {$object->setProperty('read', true);}
  else {$object->setProperty('read', false);}
  if (isset ($_POST['usa_write'])) {$object->setProperty('write', true);}
  else {$object->setProperty('write', false);}
  if (isset ($_POST['usa_change'])) {$object->setProperty('change', true);}
  else {$object->setProperty('change', false);}
  if (isset ($_POST['usa_delete'])) {$object->setProperty('delete', true);}
  else {$object->setProperty('delete', false);}
  if (isset ($_POST['usa_admin'])) {$object->setProperty('admin', true);}
  else {$object->setProperty('admin', false);}
}

function save(){
  
  global $object,$editMode;

  if (!$editMode){
    return;
  }
  set();
  if ($object->save()){
    $_SESSION['usa_id'] = $object->getProperty('usa_id');
  }
  else {
    if (isset($object->_debug)&&count($object->_debug)>0&&!empty($object->_debug[count($object->_debug)-1]['result'])){
      $org = $object->_debug[count($object->_debug)-1]['result'];
      $object->init($org);
    }
  }
}

?>
