<?php
/**
 * User interface for manipulating user authorization
 *
 * $Author: jebbol $
 * $Revision: 1.13 $
 * $Date: 2006/08/28 09:17:57 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// HTML Table support
include_once($SPL_CFG['dirroot'].'/ui/class/table.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Translations
if (!isset($_SESSION['usp_lang'])) {$_SESSION['usp_lang'] = 'en';}
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$_SESSION['usp_lang'].'/usa.lang.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

// Must be authorized to view this information
if (!isset($_SESSION['usr_permission'])){
  return (bool) false;
}
if ($_SESSION['usr_permission']['read']==(bool)false) {
  return (bool) false;
}


//=========================================================================
// Local variables
//=========================================================================
$query['columns']  = 'usa_id AS id,"usa.php" AS target,IF(usa_key="apl","'.$SPL_TXT['apl'].'",IF(usa_key="adm","'.$SPL_TXT['adm'].'",IF(usa_key="adr","'.$SPL_TXT['adr'].'",IF(usa_key="ali","'.$SPL_TXT['ali'].'",IF(usa_key="cal","'.$SPL_TXT['cal'].'",IF(usa_key="cat","'.$SPL_TXT['cat'].'",IF(usa_key="cou","'.$SPL_TXT['cou'].'",IF(usa_key="dnm","'.$SPL_TXT['dnm'].'",IF(usa_key="fmt","'.$SPL_TXT['fmt'].'",IF(usa_key="grp","'.$SPL_TXT['grp'].'",IF(usa_key="ina","'.$SPL_TXT['ina'].'",IF(usa_key="ins","'.$SPL_TXT['ins'].'",IF(usa_key="lst","'.$SPL_TXT['lst'].'",IF(usa_key="men","'.$SPL_TXT['men'].'",IF(usa_key="par","'.$SPL_TXT['par'].'",IF(usa_key="per","'.$SPL_TXT['per'].'",IF(usa_key="prd","'.$SPL_TXT['prd'].'",IF(usa_key="rol","'.$SPL_TXT['rol'].'",IF(usa_key="sgd","'.$SPL_TXT['sgd'].'",IF(usa_key="src","'.$SPL_TXT['src'].'",IF(usa_key="sts","'.$SPL_TXT['sts'].'",IF(usa_key="stu","'.$SPL_TXT['stu'].'",IF(usa_key="sub","'.$SPL_TXT['sub'].'",IF(usa_key="sug","'.$SPL_TXT['sug'].'",IF(usa_key="tea","'.$SPL_TXT['tea'].'",IF(usa_key="tra","'.$SPL_TXT['tra'].'",IF(usa_key="usr","'.$SPL_TXT['usr'].'",usa_key))))))))))))))))))))))))))) AS application,';
$query['columns'] .= 'IF(usa_permission="1","'.$SPL_TXT['p_1'].'",IF(usa_permission="3","'.$SPL_TXT['p_3'].'",IF(usa_permission="5","'.$SPL_TXT['p_5'].'",IF(usa_permission="7","'.$SPL_TXT['p_7'].'",IF(usa_permission="9","'.$SPL_TXT['p_9'].'",IF(usa_permission="11","'.$SPL_TXT['p_11'].'",IF(usa_permission="13","'.$SPL_TXT['p_13'].'",IF(usa_permission="15","'.$SPL_TXT['p_15'].'",IF(usa_permission="23","'.$SPL_TXT['p_23'].'",IF(usa_permission="31","'.$SPL_TXT['p_31'].'",usa_permission)))))))))) AS permission';
$query['tblName']  = 'usa';
$query['where']    = 'WHERE '.$SPL_CFG['prefix'].'usa.adm_id = "'.$_SESSION['adm_id'].'"';
$query['orderBy']  = 'application';
$query['orderDir'] = 'ASC';
$query['viewSize'] = (isset($_SESSION['usp_numrows'])&&(int)$_SESSION['usp_numrows']<=20?$_SESSION['usp_numrows']:'16');
$query['fixedHeight'] = 16;

//=========================================================================
// Handling of POST and GET
//=========================================================================

// Data to link to the child data
if (isset ($_GET['id'])){
  $query['where'] .= ' AND usr_id = "'.addslashes($_GET['id']).'"';
  $query['parentChild'] = 'id='.$_GET['id'];
}

if (isset($_POST['search_for'])) {
  $query['where'] .= ' AND '.$_POST['search_by'].' LIKE "'.$_POST['search_for'].'%"';
}

//The column to orderBy
if (isset ($_GET['orderBy'])) $query['orderBy'] = $_GET['orderBy'];

//The starting offset for record paging 
if (isset ($_GET['viewStart'])) $query['viewStart'] = $_GET['viewStart'];

//Sort ascending or descending ('ASC' or 'DESC') 
if (isset ($_GET['orderDir']))  $query['orderDir'] = $_GET['orderDir']; 

//=========================================================================
// Definition of the page
//=========================================================================

// Create the HTML table
$table = new table($query);
$table->init('usa');
$table->enableRowSelection();
$table->setCallbackScript($_SERVER['PHP_SELF']);
$table->addNewButton(NULL,'usa.php?parent='.$_GET['id'].'&amp;new');

// Create the page
$page = new page();
$page->init('usa','default','template_iframetabbed.htm',false);
$page->setHeadScripts($table->getScripts());
$page->startForm("usasearchform",'default',false,true);
  $page->startAreaGrid();
  $page->startSection('','content_start');
  $page->addTabRuler();
  $page->startColumn();
  $table->setImageDir($page->getImageDir());
  $page->addContent($table->getTable());
  $page->endColumn();
  $page->endSection('content_end');
  $page->endAreaGrid();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->showPage();

/** 
 * $Log: usa_search.php,v $
 * Revision 1.13  2006/08/28 09:17:57  jebbol
 * Added support for permission 23
 *
 * Revision 1.12  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.11  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.10  2006/03/13 12:50:18  jebbol
 * Cleaned up HTML validation errors
 *
 * Revision 1.9  2006/02/11 18:55:52  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 */

?>
