<?php
/**
 * usp.php
 *
 * $Author: jebbol $
 * $Revision: 1.18 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: usp.php,v $
 * Revision 1.18  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.17  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 * Revision 1.16  2006/02/11 18:59:51  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Core object
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
include_once($SPL_CFG['dirroot'].'/class/ins.class.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'usp_id'=>array('type'=>'int'),
  'usr_id'=>array('type'=>'int'),
  'usp_lang'=>array('type'=>'char'),
  'usp_skin'=>array('type'=>'char'),
  'usp_nameformat'=>array('type'=>'enum','values'=>'UIS,FIS,NIS,SNI,SUI,SFI'),
  'usp_locale'=>array('type'=>'char'),
  'usp_startpage'=>array('type'=>'enum','values'=>'ui/menu.php'),
  'usp_startpane'=>array('type'=>'enum','values'=>'menu_data.php,menu_dash.php,menu_sgd.php,menu_tsk.php'),
  'usp_numrows'=>array('type'=>'int'),
  'usp_calmode'=>array('type'=>'enum','values'=>'calendardate,schooldate'),
  'usp_menumode'=>array('type'=>'enum','values'=>',normal,small,none'),
  'usp_fontsize'=>array('type'=>'enum','values'=>'smallest,small,normal,larger,largest,huge'),
  'usp_ins_id'=>array('type'=>'int'),
  'usp_ina_id'=>array('type'=>'int'),
  'usp_tra_id'=>array('type'=>'int'),
  'usp_ali_id'=>array('type'=>'int'),
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new usr();
$editMode = (bool)true;

//=========================================================================
// Handling of POST and GET
//=========================================================================

// User requested a specific object
if (isset ($clean['usr_id'])) {
  $object->init($clean['usr_id']);
}
else {
  $object->init($_SESSION['usr_id']);
}

// Capture the search on reference fields
if (isset($clean['search_button'])) {
  // Save the form data
  save();
  // Redirect browser to the search page
  if ($clean['search_button']=='usp_ins_id'){
    redirect($SPL_CFG['wwwroot'].'/ui/ins_search.php?from=ins_id');
  }
  if ($clean['search_button']=='usp_ina_id'){
    redirect($SPL_CFG['wwwroot'].'/ui/ina_search.php?from=ina_id');
  }
  // Methodology
  if ($clean['search_button']=='usp_tra_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/tra_search.php?from=tra_id');
  }
  if ($clean['search_button']=='usp_ali_id'){
    redirect($SPL_CFG['wwwroot'].'/methodology/traditional/ui/ali_search.php?from=ali_id');
  }
}
 
// Events from the Toolbar buttons
if (isset($clean['button_action']) && $clean['button_action']){  
  switch ($clean['button_action']) {
    case 'cancel':
      break;
    case 'del':
      // Not applicable
      break;
    case 'edit':
      $editMode = (bool)true;
      break;
    case 'find':
      // Not applicable
      break;
    case 'new':
      // Not applicable
      break;
    case 'save':
      $editMode = (bool)true;
      save();
      $editMode = (bool)false;
      redirect ('menu.php');
      break;
    case 'list':
      set();
      $editMode = (bool)true;
      break;
    default:
      break;
  }
}
 
//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('usr','default','template_iframeedit.htm',false);
$page->startForm();
  $page->addContent('<div class="hidden"><input type="hidden" name="toolbar_button" id="toolbar_button" value="" /></div>',true);
  $page->startTable();
    $page->startRow();
      $page->startColumn();
        $page->startPane($SPL_TXT['preferences'],$SPL_CFG['wwwroot'].'/ui/menu.php');

          // Tab area
          $page->startAreaTab();
          $tabs[] = array('name'=>'usp_tab1','title'=>'usp_general','widget'=>'usp_contact','tabaction'=>'usp_contact.php','empty'=>false,'target'=>'iframe_contact');
          $tabs[] = array('name'=>'usp_tab4','title'=>'menu_password','widget'=>'usp_password','tabaction'=>'usp_password.php','empty'=>false,'target'=>'iframe_password');
          if ($object->isTeacher()){
            $tabs[] = array('name'=>'usp_tab3','title'=>'my_subjects','widget'=>'usp_subjects','tabaction'=>'tea_subjects.php?id='.$object->getProperty('tea_id'),'empty'=>false,'target'=>'iframe_subjects');
            $tabs[] = array('name'=>'usp_tab6','title'=>'my_groups','widget'=>'usp_groups','tabaction'=>'tea_groups.php?id='.$object->getProperty('tea_id'),'empty'=>false,'target'=>'iframe_groups');
            $tabs[] = array('name'=>'usp_tab7','title'=>'my_students','widget'=>'usp_students','tabaction'=>'tea_students.php?id='.$object->getProperty('tea_id'),'empty'=>false,'target'=>'iframe_students');
          }
          if ($object->isMentor()){
            $tabs[] = array('name'=>'usp_tab8','title'=>'my_mentorgroups','widget'=>'usp_mentorgroups','tabaction'=>'men_groups.php?id='.$object->getProperty('men_id'),'empty'=>false,'target'=>'iframe_mentorgroups');
            $tabs[] = array('name'=>'usp_tab9','title'=>'my_mentorstudents','widget'=>'usp_mentorstudents','tabaction'=>'men_students.php?id='.$object->getProperty('men_id'),'empty'=>false,'target'=>'iframe_mentorstudents');
          }
          //$tabs[] = array('name'=>'usp_tab5','title'=>'menu_statistics','widget'=>'usp_statistics','tabaction'=>'usr_stats.php','empty'=>false,'target'=>'iframe_statistics');
          $selected = (!isset($clean['selected_tab'])?'usp_tab1':$clean['selected_tab']);
          $page->startTable();
          $page->addTabbar($selected,NULL,$tabs,true,null);
          $page->endTable();
          $page->endAreaTab();

          // Data area
          $page->startAreaData();

          // Contact
          $page->startTable('none','name="usp_contact" id="usp_contact"');
          $page->addIFrame('usp_contact.php','iframe_contact','width:100%;height:30em');
          $page->endTable();
          // Password
          $page->startTable('none','name="usp_password" id="usp_password" style="display:none"');
          $page->addIFrame('wait.php','iframe_password','width:100%;height:12em');
          $page->endTable();
          // Subjects
          $page->startTable('none','name="usp_subjects" id="usp_subjects" style="display:none"');
          $page->addIFrame('wait.php','iframe_subjects','width:100%;height:42em');
          $page->endTable();
          // Groups
          $page->startTable('none','name="usp_groups" id="usp_groups" style="display:none"');
          $page->addIFrame('wait.php','iframe_groups','width:100%;height:42em');
          $page->endTable();
          // Students
          $page->startTable('none','name="usp_students" id="usp_students" style="display:none"');
          $page->addIFrame('wait.php','iframe_students','width:100%;height:42em');
          $page->endTable();
          // Mentorgroups
          $page->startTable('none','name="usp_mentorgroups" id="usp_mentorgroups" style="display:none"');
          $page->addIFrame('wait.php','iframe_mentorgroups','width:100%;height:42em');
          $page->endTable();
          // Mentorstudents
          $page->startTable('none','name="usp_mentorstudents" id="usp_mentorstudents" style="display:none"');
          $page->addIFrame('wait.php','iframe_mentorstudents','width:100%;height:42em');
          $page->endTable();
          // Statistics
          $page->startTable('none','name="usp_statistics" id="usp_statistics" style="display:none"');
          $page->addIFrame('wait.php','iframe_statistics','width:100%;height:7em');
          $page->endTable();
          $page->endAreaData();
          $page->addFootbar();
        $page->endPane();
      $page->endColumn();
    $page->endRow();
  $page->endTable();

$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
if ($object->isLoaded()) {
  $page->setRowStatistics($object->getPrimary(),$object->getProperty('create_date'),$object->getProperty('create_usr_id'),$object->getProperty('create_src_id'),$object->getProperty('update_date'),$object->getProperty('update_usr_id'),$object->getProperty('update_src_id'));
}
else {
  $page->setRowStatistics();
}
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean;

  if (isset ($clean['usp_lang']))       {$object->setPreference('usp_lang', $clean['usp_lang']);}
  if (isset ($clean['usp_skin']))       {$object->setPreference('usp_skin', $clean['usp_skin']);}
  if (isset ($clean['usp_nameformat'])) {$object->setPreference('usp_nameformat', $clean['usp_nameformat']);}
  if (isset ($clean['usp_locale']))     {$object->setPreference('usp_locale', $clean['usp_locale']);}
  if (isset ($clean['usp_startpage']))  {$object->setPreference('usp_startpage', $clean['usp_startpage']);}
  if (isset ($clean['usp_startpane']))  {$object->setPreference('usp_startpane', $clean['usp_startpane']);}
  if (isset ($clean['usp_numrows']))    {$object->setPreference('usp_numrows', $clean['usp_numrows']);}
  if (isset ($clean['usp_calmode']))    {$object->setPreference('usp_calmode', $clean['usp_calmode']);}
  if (isset ($clean['usp_menumode']))   {$object->setPreference('usp_menumode', $clean['usp_menumode']);}
  if (isset ($clean['usp_fontsize']))   {
    $object->setPreference('usp_fontsize', $clean['usp_fontsize']);
    $_SESSION['usp_fontsize'] = $clean['usp_fontsize'];
  }
  if (isset ($clean['usp_ins_id']))     {$object->setPreference('usp_ins_id', $clean['usp_ins_id']);}
  if (isset ($clean['usp_ina_id']))     {$object->setPreference('usp_ina_id', $clean['usp_ina_id']);}
  if (isset ($clean['usp_tra_id']))     {$object->setPreference('usp_tra_id', $clean['usp_tra_id']);}
  if (isset ($clean['usp_ali_id']))     {$object->setPreference('usp_ali_id', $clean['usp_ali_id']);}
}

function save(){
  
  global $object,$editMode,$clean;
  
  if (!$editMode){
    return;
  }
  
  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();
}

?>
