<?php
/**
 * User interface for contact data
 *
 * $Author: jebbol $
 * $Revision: 1.2 $
 * $Date: 2006/08/08 08:07:19 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: usp_contact.php,v $
 * Revision 1.2  2006/08/08 08:07:19  jebbol
 * Changed repository (cvs.sourceforge.net -> splanner.cvs.sourceforge.net)
 *
 * Revision 1.1  2006/04/14 12:45:28  jebbol
 * Added support for mentors and parents
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Translations
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$SPL_CFG['language'].'/usr.lang.php');

// Core object
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');
include_once($SPL_CFG['dirroot'].'/class/ina.class.php');
include_once($SPL_CFG['dirroot'].'/class/ins.class.php');

// Methodology
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/tra.class.php');
include_once($SPL_CFG['dirroot'].'/methodology/traditional/class/ali.class.php');

//=========================================================================
// Sanitize request variables
//=========================================================================
$sanitize = array(
  'usr_id'=>array('type'=>'int'),
  'usp_lang'=>array('type'=>'char'),
  'usp_skin'=>array('type'=>'char'),
  'usp_calmode'=>array('type'=>'char'),
  'usp_menumode'=>array('type'=>'char'),
  'usp_nameformat'=>array('type'=>'char'),
  'usp_startpane'=>array('type'=>'char'),
  'usp_numrows'=>array('type'=>'int'),
  'usp_fontsize'=>array('type'=>'char'),
  'usp_ins_id'=>array('type'=>'int'),
  'usp_ina_id'=>array('type'=>'int'),
  'usp_tra_id'=>array('type'=>'int'),
  'usp_ali_id'=>array('type'=>'int'),
  'usr_email'=>array('type'=>'email'),
  'usr_msn'=>array('type'=>'email'),
  'usr_skype'=>array('type'=>'char'),
  'usr_phone'=>array('type'=>'char'),
);
if (isset($_SESSION['is_admin'])&&$_SESSION['is_admin']==true) {
  $sanitize['is_active'] = array('type'=>'bool');
}
require_once($SPL_CFG['dirroot'].'/ui/inc/sanitize.inc.php');


//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new usr();
$editMode = (bool)true;
$newSkin = (bool) false;

// Get the 'current' user
$object->init($_SESSION['usr_id']);

// Determine if a widget key has to be shown
$show_widget_key = false;
// Administrator
if (isset($SPL_CFG['hit_statistics']) && $SPL_CFG['hit_statistics']=='true' && $object->isSysAdm()){
  $show_widget_key = true;
}
// Teacher
if (isset($SPL_CFG['teacher_statistics']) && $SPL_CFG['teacher_statistics']=='true' && $object->isTeacher()){
  $show_widget_key = true;
}

// Assemble the key
if ($show_widget_key) {

  // Get encryption support
  include_once($SPL_CFG['dirroot'].'/class/rc4crypt.class.php');
  
  $pwd = rc4crypt::decrypt($SPL_CFG['rc4key'], base64_decode($object->_data['usr_psswd']));
  $key = 'id='.$object->_data['usr_id'].',pwd='.$pwd;
  $widget_key = base64_encode(rc4crypt::encrypt($SPL_CFG['rc4key'], $key));
  
}

//=========================================================================
// Event handling
//=========================================================================

// Events from the Toolbar buttons
if (count($_POST)||count($_GET)) {
  include_once('inc/action.php');  
  switch ($action) {
    case 'cancel':
      break;
    case 'save':
      save();
      if ($newSkin) {
        redirect($SPL_CFG['wwwroot'].'/ui/menu.php');
      }
      break;
    default:
      break;
  }
  unset($_POST['toolbar_button']);
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('usr','default','template_iframeplain.htm',false);
$page->startForm();
  $page->startAreaData();
  $page->startTable('squeezed');
    $page->startRow();
      
      // Left column
      $page->startColumn('none','style="vertical-align:top;"');
          $page->startTable();
            // A key to use with desktop widgets
            if ($show_widget_key){
              $page->startRow();
                $page->startColumn('label_readonly');
                  $page->addContent($page->translate('widget_key'));
                $page->endColumn();
                $page->startColumn('sign');
                $page->endColumn();
                $page->startColumn('field');
                  $page->addContent('<span class="text_readonly">'.$widget_key.'</span>');
                $page->endColumn();
              $page->endRow();
            }
          
            $page->addField('usp_lang',(isset($_SESSION['usp_lang'])?$_SESSION['usp_lang']:''),!$editMode,false,false,getLanguages());
            $page->addField('usp_skin',(isset($_SESSION['usp_skin'])?$_SESSION['usp_skin']:''),!$editMode,false,false,getSkins());
            // Not yet implemented
            //$page->addField('usp_calmode',(isset($_SESSION['usp_calmode'])?$_SESSION['usp_calmode']:''),!$editMode);
            if (!isset($SPL_UI['preference_show_menuselection']) || (isset($SPL_UI['preference_show_menuselection'])&&($SPL_UI['preference_show_menuselection']))) {
              $page->addField('usp_menumode',(isset($_SESSION['usp_menumode'])?$_SESSION['usp_menumode']:''),!$editMode);
            }
            if ($SPL_CFG['person_details'] != 'false') {
              // Name format is only applicable when using person details
              $page->addField('usp_nameformat',(isset($_SESSION['usp_nameformat'])?$_SESSION['usp_nameformat']:''),!$editMode,false,false,getNameFormats());
            }
            // Startpage selection is not yet implemented
            //$page->addField('usp_startpage',(isset($_SESSION['usp_startpage'])?$_SESSION['usp_startpage']:''),!$editMode);
            if ($object->isSysAdm() || $object->isTeacher()) {
              $page->addField('usp_startpane',(isset($_SESSION['usp_startpane'])?$_SESSION['usp_startpane']:''),!$editMode);
            }
            if (!isset($SPL_UI['table_type']) && (isset($SPL_UI['table_type']) && $SPL_UI['table_type']!='scroller')) {
              $page->addField('usp_numrows',(isset($_SESSION['usp_numrows'])?$_SESSION['usp_numrows']:''),!$editMode);
            }
            $page->addField('usp_fontsize',(isset($_SESSION['usp_fontsize'])?$_SESSION['usp_fontsize']:'normal'),!$editMode);
            // Calendar mode in not yet implemented
            // $page->addField('usp_calmode',(isset($_SESSION['usp_calmode'])?$_SESSION['usp_calmode']:''),!$editMode);
            
            // The following fields are used as a default.
            // They can only be changed when the user is an administrator.
            // For students and teachers, the defaults from the stu or tea will be used instead.
            if ($object->isSysAdm()){

              // Institution
              $ins = new ins();
              $singleIns = $ins->isSingle();
              if ($singleIns){
                $_SESSION['usp_ins_id'] = $singleIns;
                $object->setPreference('usp_ins_id', $singleIns);
                $object->save();
                $page->addContent('<input type="hidden" name="usp_ins_id" id="usp_ins_id" value="'.$singleIns.'" />');
              }
              else {
                $page->addField('usp_ins_id',(isset($_SESSION['usp_ins_id'])?$_SESSION['usp_ins_id']:''),!$editMode);
              }

              // Address
              $ina = new ina();
              $singleIna = $ina->isSingle(isset($_SESSION['usp_ins_id'])?$_SESSION['usp_ins_id']:0);
              if ($singleIna) {
                $_SESSION['usp_ina_id'] = $singleIna;
                $object->setPreference('usp_ina_id', $singleIna);
                $object->save();
                $page->addContent('<input type="hidden" name="usp_ina_id" id="usp_ina_id" value="'.$singleIna.'" />');
              }
              else {
                if ($editMode && isset($_SESSION['usp_ins_id'])){
                  $page->addField('usp_ina_id',(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:''),!$editMode,false,false,$ina->getKeyValues('ins',$_SESSION['usp_ins_id']));
                }
                else {
                  $page->addField('usp_ina_id',(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:''),!$editMode);
                }
              }

              // Training
              $tra = new tra();
              $singleTra = $tra->isSingle(isset($_SESSION['usp_ina_id'])?$_SESSION['usp_ina_id']:0);
              if ($singleTra) {
                $_SESSION['usp_tra_id'] = $singleTra;
                $object->setPreference('usp_tra_id', $singleTra);
                $object->save();
                $page->addContent('<input type="hidden" name="usp_tra_id" id="usp_tra_id" value="'.$singleTra.'" />');
              }
              else {
                if ($editMode && isset($_SESSION['usp_ina_id'])){
                  $page->addField('usp_tra_id',(isset($_SESSION['usp_tra_id'])?$_SESSION['usp_tra_id']:''),!$editMode,false,false,$tra->getKeyValues('ina',$_SESSION['usp_ina_id']));
                }
                else {
                  $page->addField('usp_tra_id',(isset($_SESSION['usp_tra_id'])?$_SESSION['usp_tra_id']:''),!$editMode);
                }
              }
              
              // Alignment
              if ($editMode && isset($_SESSION['usp_tra_id'])){
                $ali = new ali();
                $page->addField('usp_ali_id',(isset($_SESSION['usp_ali_id'])?$_SESSION['usp_ali_id']:''),!$editMode,false,false,$ali->getKeyValues('tra',$_SESSION['usp_tra_id']));
              }
              else {
                $page->addField('usp_ali_id',(isset($_SESSION['usp_ali_id'])?$_SESSION['usp_ali_id']:''),!$editMode);
              }
            }
            if ($editMode){
              $page->_formButtons[] = 'save';
              $page->showFormButtons();
            }
          $page->endTable();
      $page->endColumn();
      
      // Right column
      $page->startColumn('none','style="vertical-align:top;"');
          $page->startTable();
            $page->addField('usr_email',$object->getProperty('usr_email'),false);
            $page->addField('usr_msn',$object->getProperty('usr_msn'),false);
            $page->addField('usr_skype',$object->getProperty('usr_skype'),false);
            $page->addField('usr_phone',$object->getProperty('usr_phone'),false);
          $page->endTable();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
  $page->endAreaData();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->setRowStatistics();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function set(){
  
  global $object,$clean,$newSkin;
  
  $newSkin = ($clean['usp_skin']!=$_SESSION['usp_skin']);

  // Preferences
  if (isset ($clean['usp_lang']))       {$object->setPreference('usp_lang', $clean['usp_lang']);}
  if (isset ($clean['usp_skin']))       {$object->setPreference('usp_skin', $clean['usp_skin']);}
  if (isset ($clean['usp_nameformat'])) {$object->setPreference('usp_nameformat', $clean['usp_nameformat']);}
  if (isset ($clean['usp_locale']))     {$object->setPreference('usp_locale', $clean['usp_locale']);}
  if (isset ($clean['usp_startpage']))  {$object->setPreference('usp_startpage', $clean['usp_startpage']);}
  if (isset ($clean['usp_startpane']))  {$object->setPreference('usp_startpane', $clean['usp_startpane']);}
  if (isset ($clean['usp_numrows']))    {$object->setPreference('usp_numrows', $clean['usp_numrows']);}
  if (isset ($clean['usp_calmode']))    {$object->setPreference('usp_calmode', $clean['usp_calmode']);}
  if (isset ($clean['usp_menumode']))   {$object->setPreference('usp_menumode', $clean['usp_menumode']);}
  if (isset ($clean['usp_fontsize']))   {
    $object->setPreference('usp_fontsize', $clean['usp_fontsize']);
    $_SESSION['usp_fontsize'] = $clean['usp_fontsize'];
  }
  if (isset ($clean['usp_ins_id']))     {$object->setPreference('usp_ins_id', $clean['usp_ins_id']);}
  if (isset ($clean['usp_ina_id']))     {$object->setPreference('usp_ina_id', $clean['usp_ina_id']);}
  if (isset ($clean['usp_tra_id']))     {$object->setPreference('usp_tra_id', $clean['usp_tra_id']);}
  if (isset ($clean['usp_ali_id']))     {$object->setPreference('usp_ali_id', $clean['usp_ali_id']);}

  // Contactdata
  if (isset ($clean['usr_email'])) {$object->setProperty('usr_email', $clean['usr_email']);}
  if (isset ($clean['usr_msn']))   {$object->setProperty('usr_msn',   $clean['usr_msn']);}
  if (isset ($clean['usr_skype'])) {$object->setProperty('usr_skype', $clean['usr_skype']);}
  if (isset ($clean['usr_phone'])) {$object->setProperty('usr_phone', $clean['usr_phone']);}
}

function save(){
  
  global $object,$clean;
  
  if (isset($clean['button_action'])){
    if ($clean['button_action']=='cancel'){
      return;
    }
  }
  set();
  $object->save();
}


?>
