<?php
/**
 * User interface for changing a users password
 *
 * $Author: jebbol $
 * $Revision: 1.3 $
 * $Date: 2006/02/11 18:58:28 $
 * 
 * @copyright Copyright (c) 2005-2006 Studiewijzer.nl 
 * @link      http://www.studiewijzer.nl
 * @license   http://www.gnu.org/copyleft/gpl.html
 * 
 * $Log: usp_password.php,v $
 * Revision 1.3  2006/02/11 18:58:28  jebbol
 * Renamed ui/inc/util.php -> ui/inc/util.inc.php
 * Added UI areas to support multiple skins
 *
 */

//=========================================================================
// Includes
//=========================================================================

// Configuration
include_once('../inc/config.php');

// Page generation
include_once($SPL_CFG['dirroot'].'/ui/class/page.class.php');

// Utility functions
include_once($SPL_CFG['dirroot'].'/ui/inc/util.inc.php');

// Data objects
include_once($SPL_CFG['dirroot'].'/class/usr.class.php');

// Translations
include_once($SPL_CFG['dirroot'].'/ui/lang/'.$SPL_CFG['language'].'/usr.lang.php');

//=========================================================================
// Prerequisites
//=========================================================================

// Must be logged in
include_once($SPL_CFG['dirroot'].'/ui/inc/logincheck.php');

//=========================================================================
// Local variables
//=========================================================================

$object = new usr();
$editMode = (bool)false;

//=========================================================================
// Event handling
//=========================================================================

// Get the 'current' user
$object->init($_SESSION['usr_id']);

// Events from the Toolbar buttons
if (count($_POST)||count($_GET)) {
  include_once('inc/action.php');  
  switch ($action) {
    case 'cancel':
      break;
    case 'save':
      save();
      if (isset($_SESSION['usp_startpane'])) {
        redirect($_SESSION['usp_startpane']);
      }
      break;
    default:
      break;
  }
  unset($_POST['toolbar_button']);
}

//=========================================================================
// Definition of the page
//=========================================================================

$page = new page();
$page->init('usr','default','template_iframeplain.htm',false);
$page->startForm();
  $page->startAreaData();
  $page->startTable('none','style="width:100%"');
    $page->startRow();
      $page->startColumn();
          $page->startTable();
            $page->addField('usr_psswd_old','',false);
            $page->addField('usr_psswd_new','',false);
            $page->addField('usr_psswd_again','',false);
            $page->startRow();
              $page->startColumn();
              $page->endColumn();
              $page->startColumn();
              $page->endColumn();
              $page->startColumn();
                $page->addButton('save','psswd_btn','submit','default','12');
              $page->endColumn();
            $page->endRow();
          $page->endTable();
      $page->endColumn();
    $page->endRow();
  $page->endTable();
  $page->endAreaData();
$page->endForm();

//=========================================================================
// Show the page
//=========================================================================

$page->setContent();
$page->createPage();
$page->setRowStatistics();
$page->showPage();

//=========================================================================
// Functions
//=========================================================================

function save(){
  
  global $SPL_TXT,$object;
  
  $msg='';
  if (isset($_POST['usr_psswd_old'])&&isset($_POST['usr_psswd_new'])&&isset($_POST['usr_psswd_again'])){
    $result = $object->setPassword($_POST['usr_psswd_old'],$_POST['usr_psswd_new'],$_POST['usr_psswd_again']);
    if (!is_bool($result)) {
      $msg = $result;
    }
  }
  else {
    if (!isset($SPL_TXT['psswd_entries'])) {
      $SPL_TXT['psswd_entries'] = 'Please enter a value in all fields!';
    }
    $msg = $SPL_TXT['psswd_entries'];
  }
  
  // Save the new password
  if (empty($msg)) {
    if ($object->save()) {
      if (!isset($SPL_TXT['psswd_updated'])) {
        $SPL_TXT['psswd_updated'] = 'Your password has been updated.';
      }
      $msg = $SPL_TXT['psswd_updated'];
      $_SESSION['messagebox_icontype'] = 'success';
      $_SESSION['referred_from'] = (isset($_SESSION['usp_startpane'])?$_SESSION['usp_startpane']:$_SERVER['PHP_SELF']);
    }
  }
  
  // Display an error message
  if ($msg) {
    $_SESSION['msg'] = $msg;
    $_SESSION['messagebox_style'] = 'pane';
    if (!isset($_SESSION['referred_from'])) {
      $_SESSION['referred_from'] = $_SERVER['PHP_SELF'];
    }
    if (!isset($_SESSION['messagebox_icontype'])) {
      $_SESSION['messagebox_icontype'] = 'disappointed';
    }
    if (isset($SPL_CFG['wwwroot'])) {
      redirect($SPL_CFG['wwwroot'].'/ui/message.php');
    }
    else {
      redirect('message.php');
    }
  }
  
}

?>
