<?php
/**
 * Konfabulator widget gateway for system administrators
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: gateway_admin.php,v 1.2 2005/09/18 19:39:22 jebbol Exp $
 * @package   spl
 * @category  core
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

include_once("../../integration/shortstat/configuration.php");
include_once("../../integration/shortstat/functions.php");

// Get encryption support
include_once($SPL_CFG['dirroot'].'/class/rc4crypt.class.php');

$admin = false;
$sitename = 'vul code in!';

// Find out which teacher is using this gateway
if (isset($_GET['id'])) {
  // The teacher id must be encrypted. A teacher can obtain his (or hers) id by 
  // logging into studyplanner and querying the encrypted id at the 'statistics' page
  // When unecrypted, the id has the format: 'id=nnnn,pwd=xxxxx'
  $u = rc4crypt::decrypt($SPL_CFG['rc4key'],base64_decode($_GET['id']));
  $admin = substr(strstr($u,'id='),3,strpos($u,',')-3);
  $pwd = substr($u,strpos($u,'pwd=')+4);
}

if ($admin) {
  // Set the sitename
  if (isset($_SESSION['adm_id'])) {
    $query = 'SELECT adm_short FROM '.$SPL_CFG['prefix'].'adm adm WHERE adm_id = "'.$_SESSION['adm_id'].'" LIMIT 1';
  }
  else {
    // Get the default administration
    $query = 'SELECT adm_short FROM '.$SPL_CFG['prefix'].'adm adm WHERE adm_is_default LIMIT 1';
  }
  $result = db_retrieve(db_query($query));
  if (!isset($result['adm_short'])) {
    // Just get the first one
    $query = 'SELECT adm_short FROM '.$SPL_CFG['prefix'].'adm adm LIMIT 1';
    $result = db_retrieve(db_query($query));
  }
  $sitename=isset($result['adm_short'])?$result['adm_short']:'Studiewijzer';
}

// Make sure the browser knows that this is an xml file
header("Content-Type: application/xhtml+xml; charset=UTF-8");

echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<shortstat>
	<websiteinfo>
		<name><?php echo $sitename; ?></name>
    <url><?php echo $SPL_CFG['wwwroot'].'/index.php'; ?></url>
	</websiteinfo>
	<statstoday lastupdate="<?php echo gmdate("G:i",time()+(((gmdate('I'))?($tz_offset+1):$tz_offset)*3600));?>">
		<totalhits><?php echo $admin?SI_getTodaysHits():0; ?></totalhits>
		<uniquehits><?php echo $admin?SI_getTodaysUniqueHits():0; ?></uniquehits>
		<recentreferrers>
<?php
if ($admin) {
  // Find todays users
  $thismorning  = mktime (0, 0, 0, date("m"), date("d"), date("Y"));
  $query  = 'SELECT stats.usr_id,stats.dt,usr.usr_login,usr.usr_name,stu.stu_dispname';
  $query .= ' FROM '.$tables['stats'].' stats';
  $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = stats.usr_id';
  $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = usr.stu_id';
  $query .= ' WHERE stats.usr_id > 0 AND stats.dt > '.$thismorning.' ORDER BY dt DESC LIMIT 0,7';
  if ($result = db_query($query)) {
	  while ($r = db_fetch_array($result)) {
      if (isset($r['stu_dispname']) && empty($r['stu_dispname'])) {
        $user = $r['stu_dispname'];
      }
      else if (isset($r['usr_name']) && !empty($r['usr_name'])) {
        $user = $r['usr_name'];
      }
      else if (isset($r['usr_login']) && !empty($r['usr_login'])) {
        $user = $r['usr_login'];
      }
      else {
        $user = 'Onbekend';
      }
		  $when = ($r['dt'] >= strtotime(date("G:i",time())))?gmdate("G:i",$r['dt']+(((gmdate('I'))?($tz_offset+1):$tz_offset)*3600)):gmdate("M j",$r['dt']+(((gmdate('I'))?($tz_offset+1):$tz_offset)*3600));
		  echo "<referrer time=\"" . $when . "\" url=\"" . "\">" . $user . "</referrer>";
	  }
  }
}
?>
		</recentreferrers>
	</statstoday>
</shortstat>