<?php
/**
 * Konfabulator widget gateway for teachers
 *
 * @author    Jebbol
 * @version   1.0
 * @revision  $Id: gateway_teacher.php,v 1.2 2006/01/02 19:12:56 jebbol Exp $
 * @package   spl
 * @category  core
 * @copyright Copyright (c) 2005 Studiewijzer.nl 
 * @link      http://www.studiewijzer.net
 * @license   http://www.gnu.org/copyleft/gpl.html
 */

// Configuration
include_once("../../inc/config.php");

// Database functions
if (!isset($SPL_CFG['dbtype'])) {$SPL_CFG['dbtype'] = 'mysql';}
include_once($SPL_CFG['dirroot'].'/db/'.$SPL_CFG['dbtype'].'/db.inc.php');

// Get encryption support
include_once($SPL_CFG['dirroot'].'/class/rc4crypt.class.php');

$tz_offset=2;

$teacher = false;
$teachername = 'vul code in!';
$teacherid = 0;
$new = 0;
$changed = 0;

// Find out which teacher is using this gateway
if (isset($_GET['id'])) {
  // The teacher id must be encrypted. A teacher can obtain his (or hers) id by 
  // logging into studyplanner and querying the encrypted id at the 'statistics' page
  // When unecrypted, the id has the format: 'id=nnnn,pwd=xxxxx'
  $u = rc4crypt::decrypt($SPL_CFG['rc4key'],base64_decode($_GET['id']));
  $teacher = substr(strstr($u,'id='),3,strpos($u,',')-3);
  $pwd = substr($u,strpos($u,'pwd=')+4);
}

 
// Show data only to known teachers
if ($teacher){
  // Get the teacher name
  $query = 'SELECT usr_login,usr_name,tea_id FROM '.$SPL_CFG['prefix'].'usr usr WHERE usr_id = "'.$teacher.'" LIMIT 1';
  $result = db_retrieve(db_query($query));
  if (isset($result['usr_login'])) {
    $teachername = (isset($result['usr_name'])&&!empty($result['usr_name']))?$result['usr_name']:$result['usr_login'];
    $teacherid = $result['tea_id'];
  }

  // Calculate total of new notifications
  $query = 'SELECT COUNT(*) FROM '.$SPL_CFG['prefix'].'tes WHERE tea_id = "'.$teacherid.'" AND is_new';
  $result = db_retrieve(db_query($query));
  $new = isset($result['COUNT(*)'])?$result['COUNT(*)']:0;

  // Calculate total of changed notifications
  $query = 'SELECT COUNT(*) FROM '.$SPL_CFG['prefix'].'tes WHERE tea_id = "'.$teacherid.'" AND NOT is_new';
  $result = db_retrieve(db_query($query));
  $changed = isset($result['COUNT(*)'])?$result['COUNT(*)']:0;
}

// Make sure the browser knows that this is an xml file
header("Content-Type: application/xhtml+xml; charset=UTF-8");

echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
?>
<shortstat>
	<websiteinfo>
		<name><?php echo $teachername; ?></name>
		<url><?php echo $SPL_CFG['wwwroot'].'/index.php'; ?></url>
	</websiteinfo>
	<statstoday lastupdate="<?php echo gmdate("G:i",time()+(((gmdate('I'))?($tz_offset+1):$tz_offset)*3600));?>">
		<totalhits><?php echo $new; ?></totalhits>
		<uniquehits><?php echo $changed; ?></uniquehits>
		<recentreferrers>
<?php
if ($teacher) {
  $today = date("d-m-Y");
  // Find student
  $query  = 'SELECT usr.usr_login,usr.usr_name,stu.stu_dispname,tes.update_date';
  $query .= ' FROM '.$SPL_CFG['prefix'].'tes tes';
  $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'sgd sgd ON sgd.sgd_id = tes.sgd_id';
  $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'usr usr ON usr.usr_id = sgd.usr_id';
  $query .= ' LEFT JOIN '.$SPL_CFG['prefix'].'stu stu ON stu.stu_id = usr.stu_id';
  $query .= ' WHERE tes.tea_id = "'.$teacherid.'" ORDER BY tes.update_date DESC LIMIT 0,7';
  if ($result = db_query($query)) {
	  while ($r = db_fetch_array($result)) {
      if (isset($r['stu_dispname']) && empty($r['stu_dispname'])) {
        $user = $r['stu_dispname'];
      }
      else if (isset($r['usr_name']) && !empty($r['usr_name'])) {
        $user = $r['usr_name'];
      }
      else if (isset($r['usr_login']) && !empty($r['usr_login'])) {
        $user = $r['usr_login'];
      }
      else {
        $user = 'Unknown';
      }
      if (date("d-m-Y",$r['update_date'])==$today){
        $user = date("H:i",$r['update_date']).' '.$user;
      }
      else {
        $user = '('.date("d-m",$r['update_date']).') '.$user;
      }
		  echo "<referrer time=\"" . date("G:i",$r['update_date']) . "\" url=\"" . "\">" . $user . "</referrer>";
	 }
  }
}
?>
		</recentreferrers>
	</statstoday>
</shortstat>